// FILE:  api_obj.h

#define	TERMINATE(s)		((char *)s.elements)[s.length]='\0'

class APIObject {

#define	NO_OBJECT 		0x00
#define	PRIVATE			0x01
#define	PUBLIC			0x02
#define	NO_PRIVATE		0xFE
#define	NO_PUBLIC		0xFD
#define	MAX_ATTRIBUTES		100	// MODIFY THIS, 100 IS A GUESS!

	OM_workspace		workspace;
	OM_private_object	api_private;
	OM_descriptor		*api_public;
	OM_descriptor		public_desc[ MAX_ATTRIBUTES ];
	OM_value_position	api_total;
	char			timebuf[ MAX_TIME_BUF ];
	int			object_to_delete;
	int			put_index;
	int			get_index;
	int			log_index;
	Log			*log;
	
public:

	APIObject( OM_workspace ws, Log *l ); 
	APIObject( APIObject *obj ); 

	Log		   *api_log()	  { return log; 	  	       }
	OM_workspace 	   api_workspace(){ return workspace;	  	       }
	OM_private_object  pri_object()	  { return api_private;  	       }
	OM_descriptor 	   *pub_object()  { return &api_public[get_index];     }
	OM_type  	   type()   	  { return api_public[get_index].type; }
	OM_value 	   value()  	  { return api_public[get_index].value;}
	void		   save_index()   { log_index = get_index;             }
	void		   reset_index()  { get_index = log_index;             }
	char 		   *time_buf()    { return timebuf;                    }

	void	get_next_type() 			 { get_index++;	       }
	void	set_api_private( OM_private_object pri ) { api_private = pri;  }
	void	set_api_public( OM_public_object pub )   { api_public  = pub;  }

	BOOL APIObject::more_types()  { 
		return ( type() != OM_NO_MORE_TYPES ) ? TRUE : FALSE;
	}

	STATUS		   api_create( char * );
	void		   api_delete();	
	STATUS		   api_get( OM_exclusions, OM_type_list );
	STATUS		   api_get( OM_exclusions );
	STATUS		   api_put();
	STATUS		   api_put( OM_type_list );

	void		   make_class( void * );
	void		   end_object();
	void		   put_desc( OM_type, OM_syntax, OM_integer );
	void		   put_desc( OM_type, OM_syntax, char * );
	void		   put_desc( OM_type, OM_syntax, APIObject * );
	void		   put_desc( OM_type, OM_public_object );
	BOOL		   is_class( char * );
};
