// FILE:  config.h

// EDI Bodypart type attributes
#define E_ISO646		0
#define E_T61			1
#define E_OCTET			2
#define X12_ISO646              3
#define X12_T61			4	
#define X12_OCTECT 		5
#define X12_EBCDIC		6
#define U_ISO646  		7 
#define U_T61			8
#define U_OCTECT		9 
#define P_OCTECT		10
#define UNDEF_OCTECT		11 


class Config {

	char	edi_user_output_dir[ MAX_LINE ];
	char	trans_input_dir[ MAX_LINE ];
	char	ftam_ic_dir[ MAX_LINE ];
	char	ftam_ctl_dir[ MAX_LINE ];
	char	van_ic_dir[ MAX_LINE ];
	char	van_ctl_dir[ MAX_LINE ];
	char	van_scr_dir[ MAX_LINE ];
	Queue	*edi_user_list;

	Queue	*read_edi_user_list( ifstream * );
	BOOL	end_of_config_file( ifstream * );	// inline
	void	delete_edi_user();
	EDIUser	*add_edi_user();
	void	get_local_user_data();
	void  	write_configuration( ofstream * );

public:

	Config() {
		strcpy( edi_user_output_dir, "." );
		strcpy( trans_input_dir, "." );
		strcpy( ftam_ctl_dir, "." );
		strcpy( ftam_ic_dir, "." );
		strcpy( van_ic_dir, "." );
		strcpy( van_ctl_dir, "." );
		strcpy( van_scr_dir, "." );
		edi_user_list = NULL;
	}

	~Config() {
		if ( edi_user_list != NULL )
			delete edi_user_list;
	}

	Queue	*edi_users()			{ return edi_user_list;       }
	char	*edi_user_directory_name() 	{ return edi_user_output_dir; }
	char	*transmission_directory_name()	{ return trans_input_dir;     }
	char	*ftam_control_directory_name() 	{ return ftam_ctl_dir;	      }
	char	*van_control_directory_name()	{ return van_ctl_dir;	      }
	char	*van_script_directory_name()	{ return van_scr_dir;	      }
	char	*van_interchange_directory_name()  { return van_ic_dir;	      }
	char	*ftam_interchange_directory_name() { return ftam_ic_dir;      }
	EDIUser	*get_local_user( char *, char * );
	EDIUser	*get_local_user( ORName * );
	STATUS	read_configuration_file();
	STATUS	configure();

#ifdef	DEBUG
	void	display_configuration();
#endif
};



//
// PRIVATE:  Return whether the end of the configuration file has been reached.
//

inline BOOL Config::end_of_config_file( ifstream *config_file ) {
	char	ch;
	
	ch = config_file->get();
	if ( ch == EOF )
		return TRUE;
	else {
		config_file->seekg( -1, ios::cur );
		return FALSE;
	}
}
