/*				FILE = dial.h				*/

#define	MDMINF	struct mdminf

MDMINF	{	/* structure for modem-specific information */
    int		dial_time;	/* time modem allows for dialing (secs) */
    char	*pause_chars;	/* character(s) to tell modem to pause */
    int		pause_time;	/* time associated with pause chars (secs) */
    char	*wake_str;	/* string to wakeup modem & put in cmd mode */
    int		wake_rate;	/* delay between wake_str characters (msecs) */
    char	*wake_prompt;	/* string prompt after wake_str */
    char	*dmode_str;	/* string to put modem in dialing mode */
    char	*dmode_prompt;	/* string prompt for dialing mode */
    char	*dial_str;	/* dialing string, with "%s" for number */
    int		dial_rate;	/* delay between dialing characters (msecs) */
};

/* Keyword Table Template */
struct keytab {				/* Keyword table		*/
    char *kwd;				/* Pointer to keyword string	*/
    int val;				/* Associated value		*/
    int flgs;				/* Flags - not used		*/
};

/*
 * Define symbolic modem numbers.
 *
 * The numbers MUST correspond to the ordering of entries
 * within the ptrtab array, and start at one (1).
 *
 * It is assumed that there are relatively few of these
 * values, and that the high(er) bytes of the value may
 * be used for modem-specific mode information.
 *
 * REMEMBER that only the first eight characters of these
 * names are guaranteed to be unique.
 */

#define		n_CERMETEK	 1
#define		n_DF03		 2
#define		n_DF100		 3
#define		n_DF200		 4
#define		n_GDC		 5
#define		n_HAYES		 6
#define		n_NBSNET	 7
#define		n_RV831		 8
#define		n_PENRIL	 9
#define		n_RACAL		10
#define		n_UNKNOWN	11
#define		n_USROBOT	12
#define		n_VENTEL	13

/*
 * Declare modem "variant" numbers for any of the above for which it is
 * necessary to note various operational modes, using the second byte
 * of a modem number.
 *
 * It is assumed that such modem modes share the same modem-specific
 * information (see MDMINF structure) but may differ in some of the actions
 * that are performed.
 */
#define	n_HAYESNV	(n_HAYES + (1<<8))

#define DIALING 	4	/* for ttvt parameter */
#define CONNECT		5

#define CONNECTED	1	/* for completion status */
#define FAILED		2

/*
 * Failure reasons for use with the 'longjmp' exit.
 */
#define	F_time		1	/* timeout */
#define F_int		2	/* interrupt */
#define	F_modem		3	/* modem-detected failure */
#define	F_minit		4	/* cannot initialize modem */

extern	char	*exempt_numbers[];
extern	char	*hayes_reset;

