/*				FILE = dial_allocate.h			*/

/*
 * Declare structures containing modem-specific information.
 *
 * REMEMBER that only the first SEVEN characters of these
 * names are guaranteed to be unique.
 */

static
MDMINF CERMETEK = {	/* information for "Cermetek Info-Mate 212 A" modem */
	20,		/* dial_time	*/
	"BbPpTt",	/* pause_chars	*/
	0,		/* pause_time, unknown -- DS */
	"  XY\016R\r",	/* wake_str	*/
	200,		/* wake_rate	*/
	"",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"\016D '%s'\r",	/* dial_str	*/
	200		/* dial_rate	*/
};

static
MDMINF DF03 =	{	/* information for "DEC DF03-AC" modem */
    27,			/* dial_time	*/
    "=",		/* pause_chars, wait for second dial tone */
    15,			/* pause_time	*/
    "\001\002",		/* wake_str	*/
    0,			/* wake_rate	*/
    "",			/* wake_prompt	*/
    "",			/* dmode_str	*/
    "",			/* dmode_prompt	*/
    "%s",		/* dial_str	*/
    0			/* dial_rate	*/
};

static
MDMINF DF100 =	{	/* information for "DEC DF100-series" modem */
			/*
			 * The telephone "number" can include "P"s and/or "T"s
			 * within it to indicate that subsequent digits are
			 * to be dialed using pulse or tone dialing.  The
			 * modem defaults to pulse dialing.  You may modify
			 * the dial string below to explicitly default all
			 * dialing to pulse or tone, but doing so prevents
			 * the use of phone numbers that you may have stored
			 * in the modem's memory.
			 */
    30,			/* dial_time	*/
    "=",		/* pause_chars, wait for second dial tone */
    15,			/* pause_time	*/
    "\001",		/* wake_str	*/
    0,			/* wake_rate	*/
    "",			/* wake_prompt	*/
    "",			/* dmode_str	*/
    "",			/* dmode_prompt	*/
    "%s#",		/* dial_str	*/
    0			/* dial_rate	*/
};

static
MDMINF DF200 =	{	/* information for "DEC DF200-series" modem */
			/*
			 * The telephone "number" can include "P"s and/or "T"s
			 * within it to indicate that subsequent digits are
			 * to be dialed using pulse or tone dialing.  The
			 * modem defaults to pulse dialing.  You may modify
			 * the dial string below to explicitly default all
			 * dialing to pulse or tone, but doing so prevents
			 * the use of phone numbers that you may have stored
			 * in the modem's memory.
			 */
	30,		/* dial_time	*/
	"=W",		/* pause_chars, =: second tone; W: 5 secs */
	15,		/* pause_time, worst case */
	"\002",		/* wake_str, allow stored number usage */
	0,		/* wake_rate	*/
	"",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"%s!",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF GDC =	{	/* information for "GeneralDataComm 212A/ED" modem */
	32,		/* dial_time	*/
	"%",		/* pause_chars	*/
	3,		/* pause_time	*/
	"\r\r",		/* wake_str	*/
	500,		/* wake_rate	*/
	"$",		/* wake_prompt	*/
	"D\r",		/* dmode_str	*/
	":",		/* dmode_prompt	*/
	"T%s\r",	/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF HAYES =	{	/* information for "Hayes" modem */
	35,		/* dial_time	*/
	",",		/* pause_chars	*/
	2,		/* pause_time	*/
	"ATE0Q0V0X4\r",	/* wake_str (Return numeric status) */
	50,		/* wake_rate	*/
	"0\r",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"ATD%s\r",	/* dial_str	*/
	50		/* dial_rate	*/
};

static
MDMINF NBSNET =	{	/* information for "NBSNET" */
	40,		/* dial_time	*/
	"",		/* pause_chars	*/
	0,		/* pause_time	*/
	"",		/* wake_str	*/
	0,		/* wake_rate	*/
	"",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/	
	"",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF RV831 =	{	/* information for Racal-Vadic 831 dialer */
	30,		/* dial_time	*/
	"",		/* pause_chars	*/
	0,		/* pause_time	*/
	"",		/* wake_str	*/
	0,		/* wake_rate	*/
	"",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF PENRIL =	{	/* information for "Penril" modem */
	50,		/* dial_time	*/
	"",		/* pause_chars, unknown -- HF */
	0,		/* pause_time	*/
	"\r\r",		/* wake_str	*/
	300,		/* wake_rate	*/
	">",		/* wake_prompt	*/
	"k\r",		/* dmode_str	*/
	":",		/* dmode_prompt	*/
	"%s\r",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF RACAL =	{	/* information for "Racal Vadic" modem */
	35,		/* dial_time	*/
	"Kk",		/* pause_chars	*/
	5,		/* pause_time	*/
	"\005\r",	/* wake_str	*/
	50,		/* wake_rate	*/
	"*",		/* wake_prompt	*/
	"D\r",		/* dmode_str	*/
	"?",		/* dmode_prompt	*/
	"%s\r",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF UNKNOWN = {	/* information for "Unknown" modem */
	30,		/* dial_time	*/
	"",		/* pause_chars	*/
	0,		/* pause_time	*/
	"",		/* wake_str	*/
	0,		/* wake_rate	*/
	"",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"%s\r",		/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF USROBOT = {	/* information for "US Robotics 212A" modem */
	30,		/* dial_time	*/
	",",		/* pause_chars	*/
	2,		/* pause_time	*/
	"ATS2=01\r",	/* wake_str	*/
	0,		/* wake_rate	*/
	"OK\r",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"ATTD%s\r",	/* dial_str	*/
	0		/* dial_rate	*/
};

static
MDMINF VENTEL =	{	/* information for "Ventel" modem */
	20,		/* dial_time	*/
	"%",		/* pause_chars	*/
	5,		/* pause_time	*/
	"\r\r\r",	/* wake_str	*/
	300,		/* wake_rate	*/
	"$",		/* wake_prompt	*/
	"",		/* dmode_str	*/
	"",		/* dmode_prompt	*/
	"<K%s'r>",	/* dial_str	*/
	0		/* dial_rate	*/
};

/*
 * Declare table for converting modem numbers to information pointers.
 *
 * The entries MUST be in ascending order by modem number, without any
 * "gaps" in the numbers, and starting from one (1).
 *
 * This table should NOT include entries for the "variant" modem numbers,
 * since it is assumed that they share the same information as the normal
 * value.
 */
static
MDMINF *ptrtab[] =	{
	&CERMETEK,
	&DF03,
	&DF100,
	&DF200,
	&GDC,
	&HAYES,
	&NBSNET,
	&RV831,
	&PENRIL,
	&RACAL,
	&UNKNOWN,
	&USROBOT,
	&VENTEL
};

/*
 * Declare modem names and associated pointers for command parsing,
 * and also for doing number-to-name translation.
 *
 * The entries MUST be in alphabetical order by modem name.
 */
struct keytab mdmtab[] =	{
	"cermetek",		n_CERMETEK,	0,
	"df03-ac",		n_DF03,		0,
	"df100-series",		n_DF100,	0,
	"df200-series",		n_DF200,	0,
	"direct",		0,		0,
	"gendatacomm",		n_GDC,		0,
	"hayes",		n_HAYES,	0,
	"nbsnet",		n_NBSNET,	0,
	"rv831",		n_RV831,	0,
	"penril",		n_PENRIL,	0,
	"racalvadic",		n_RACAL,	0,
	"unknown",		n_UNKNOWN,	0,
	"usrobotics-212a",	n_USROBOT,	0,
	"ventel",		n_VENTEL,	0
};

int nmdm = (sizeof(mdmtab) / sizeof(struct keytab));	/* number of modems */

char	*exempt_numbers[] =
	{ "12155743629", "14049947303", 0 };

/*	soft reset and load stored user profile 0	*/
char	*hayes_reset = "ATZ0\r";
