// FILE:  edi_user.h

class EDIUser {

	char	code[ INTERCHANGE_ID_SIZE ];
	char	code_qual[ ID_QUALIFIER_SIZE ];
	char	input_dir[ MAX_LINE ];
	char	add_dir[ MAX_LINE ];
	BOOL	tsds;
	BOOL	use_ua;
	BOOL	use_pedi;
	BOOL	rej_copy;
	BOOL	rej_incomplete;
	BOOL	test_send;
	BOOL	test_stds;
	ORName	*x400_addr;
	Queue	*syntaxes;
	int	syntax_count;
	BOOL	edi_stds[ MAX_EDI_STANDARDS ];

	Queue	*read_syntax_ids( ifstream * );
	Queue	*build_syntax_ids();
	void	write_syntax_ids( ofstream * );

#ifdef	DEBUG
	void	display_syntax_ids();
#endif	

public:

	EDIUser() { 
		code[0]=code_qual[0]=NULL;
		input_dir[0]=add_dir[0]= '.';
		input_dir[1]=add_dir[1]= NULL;
		use_ua=use_pedi=tsds=test_send=test_stds = FALSE;
		rej_copy=rej_incomplete = TRUE;
		syntaxes = NULL;
		x400_addr = NULL;
		syntax_count = 0;
	}

	~EDIUser() {
		if ( x400_addr != NULL )
			delete x400_addr;
		if ( syntaxes != NULL )
			delete syntaxes;
	}

	void	set_id_code( char *x )		     { strcpy( code,x );      }
	void	set_id_code_qualifier( char *x )     { strcpy( code_qual,x);  }
	void	set_input_directory( char *x )       { strcpy( input_dir,x ); }
	void	set_additional_directory( char *x )  { strcpy( add_dir, x );  }
	void	set_tsds_queue( char x )	     { tsds = x-0x30;         }
	void	set_use_x400( char x )	     	     { use_ua = x-0x30;       }
	void	set_use_x435( char x )	     	     { use_pedi = x-0x30;     }
	void	set_reject_copy( char x )	     { rej_copy = x-0x30;     }
	void	set_reject_incomplete_copy( char x ) { rej_incomplete=x-0x30; }
	void	set_test_sender( char x )	     { test_send = x-0x30;    }
	void	set_test_edi_standards( char x )     { test_stds = x-0x30;    }
	void	set_x400_address( ORName *x )        { x400_addr = x;         }
	void	set_syntax_ids( Queue *x )	     { syntaxes = x;          }
	void	set_number_syntax_ids( int x )       { syntax_count = x;      }
	void	set_edi_standards ( char * );
	
	char	*id_code()		    	     { return code; 	      } 
	char	*id_code_qualifier()	    	     { return code_qual;      } 
	char	*input_directory()	    	     { return input_dir;      } 
	char	*additional_directory()	 	     { return add_dir;        } 
	BOOL	tsds_queue()			     { return tsds;           }
	BOOL	use_x400()			     { return use_ua;         }
	BOOL	use_x435()			     { return use_pedi;       }
	BOOL	reject_copy()			     { return rej_copy;       }
	BOOL	reject_incomplete_copy()	     { return rej_incomplete; }
	BOOL	test_sender()			     { return test_send;      }
	BOOL	test_edi_standards()		     { return test_stds;      }
	ORName	*x400_address()			     { return x400_addr;      }
	Queue	*syntax_ids()			     { return syntaxes;       }
	int	number_syntax_ids()		     { return syntax_count;   }
	BOOL	edi_standard( int x )		     { return edi_stds[ x ];  }
        
	BOOL    validate_syntax_id( char *, char * );
	void	build_edi_user();
	void	read_edi_user( ifstream * );
	void	write_edi_user( ofstream * );

#ifdef	DEBUG
	void	display_user();
#endif	
};
