/*				FILE = control_file.h			*/

#define	MAX_CTRL_SIZE	8192
#define	MAX_STRINGS	256

/*	The control file is a series of type=value statements, one per	*/
/*	line.  A '#' in column one signals a comment line.		*/

/* These are the strings that identify the 'type' of value that follows	*/
#define	SOURCE_DIRNAME			"SOURCE_DIRNAME="
#define	SOURCE_DIRECTORY		"SOURCE_DIRECTORY="
#define	DESTINATION_DIRNAME		"DESTINATION_DIRNAME="
#define	DESTINATION_DIRECTORY		"DESTINATION_DIRECTORY="
#define	SOURCE_INIT_ID			"SOURCE_INIT_ID="
#define	SOURCE_FILESTORE_PW		"SOURCE_FILESTORE_PW="
#define	SOURCE_ACCOUNT			"SOURCE_ACCOUNT="
#define	SOURCE_PW_READ			"SOURCE_PW_READ="
#define	SOURCE_PW_INSERT		"SOURCE_PW_INSERT="
#define	SOURCE_PW_REPLACE		"SOURCE_PW_REPLACE="
#define	SOURCE_PW_EXTEND		"SOURCE_PW_EXTEND="
#define	SOURCE_PW_ERASE			"SOURCE_PW_ERASE="
#define	SOURCE_PW_READ_ATTR		"SOURCE_PW_READ_ATTR="
#define	SOURCE_PW_CHANGE_ATTR		"SOURCE_PW_CHANGE_ATTR="
#define	SOURCE_PW_DELETE_FILE		"SOURCE_PW_DELETE_FILE="
#define	DESTINATION_INIT_ID		"DESTINATION_INIT_ID="
#define	DESTINATION_FILESTORE_PW	"DESTINATION_FILESTORE_PW="
#define	DESTINATION_ACCOUNT		"DESTINATION_ACCOUNT="
#define	DESTINATION_PW_READ		"DESTINATION_PW_READ="
#define	DESTINATION_PW_INSERT		"DESTINATION_PW_INSERT="
#define	DESTINATION_PW_REPLACE		"DESTINATION_PW_REPLACE="
#define	DESTINATION_PW_EXTEND		"DESTINATION_PW_EXTEND="
#define	DESTINATION_PW_ERASE		"DESTINATION_PW_ERASE="
#define	DESTINATION_PW_READ_ATTR	"DESTINATION_PW_READ_ATTR="
#define	DESTINATION_PW_CHANGE_ATTR	"DESTINATION_PW_CHANGE_ATTR="
#define	DESTINATION_PW_DELETE_FILE	"DESTINATION_PW_DELETE_FILE="
#define	CREATE_FILE_PW			"CREATE_FILE_PW="

/*	These are the default values, if not specified by a 		*/
/*	'type=value' statement in the control file.			*/
#define	DEF_SRC_DIRNAME			""
#define	DEF_DEST_DIRNAME		"/O=org_name/OU=org_unit/OU=OSIMAIL/AP=ftam/AE=resp/"

#define	DEF_SRC_INIT_ID			"src_id"
#define	DEF_SRC_FILESTORE_PW		"filestore"
#define	DEF_SRC_ACCOUNT			"account"
#define	DEF_SRC_PW_READ			"read"
#define	DEF_SRC_PW_INSERT		"insert"
#define	DEF_SRC_PW_REPLACE		"replace"
#define	DEF_SRC_PW_EXTEND		"extend"
#define	DEF_SRC_PW_ERASE		"erase"
#define	DEF_SRC_PW_READ_ATTR		"readattr"
#define	DEF_SRC_PW_CHANGE_ATTR		"changattr"
#define	DEF_SRC_PW_DELETE_FILE		"delete"

#define	DEF_DEST_INIT_ID		"src_id"
#define	DEF_DEST_FILESTORE_PW		"filestore"
#define	DEF_DEST_ACCOUNT		"account"
#define	DEF_DEST_PW_READ		"read"
#define	DEF_DEST_PW_INSERT		"insert"
#define	DEF_DEST_PW_REPLACE		"replace"
#define	DEF_DEST_PW_EXTEND		"extend"
#define	DEF_DEST_PW_ERASE		"erase"
#define	DEF_DEST_PW_READ_ATTR		"readattr"
#define	DEF_DEST_PW_CHANGE_ATTR		"changattr"
#define	DEF_DEST_PW_DELETE_FILE		"delete"

#define	DEF_CREATE_FILE_PW		"create"

