//				FILE = msg_defs.h

#include	"com_defs.h"

// defines for the system msgsnd/msgrcv message facility

#define	MSG_DEFAULT_TEXT	81
#define	MSG_LONG_TEXT		133
#define	MSG_MAX_TEXT		513
#define	TYPE_NULL		0
#define	MSG_RMID		1

// format of message sent/received using msg_snd/msg_rcv
struct	msg_cmd	{
	long	msg_type;
	pid_t	msg_snd_pid;
	long	msg_snd_type;
	int	msg_cmd;
	int	msg_sub_cmd;
	char	msg_text[1];
};

// define one instance of this class for each msg_qid
class ipc_msg	{
private:
	int	msg_max_text;
	pid_t	msg_my_pid;
	long	msg_my_type;
	key_t	msg_key;
	int	msg_flags;
	int	msg_qid;
	struct	msg_cmd *msgp;

public:
	ipc_msg(key_t key, long type, int max_text = MSG_DEFAULT_TEXT, int flags = MSG_RMID);
//	ipc_msg(key_t key, long type, int max_text);
//	ipc_msg(key_t key, long type);
	~ipc_msg();
	int	msg_rm(), msg_snd(long type, int cmd, char *text = 0, int sub_cmd = 0);
	int	msg_print(), msg_print_cmd(), msg_rcv(long type);
	int	msg_get_cmd(), msg_get_sub_cmd(), msg_get_type();
	char	*msg_get_text();

private:
	int	msg_print_ds(), msg_print_ipc(struct ipc_perm *perm);
	void	ipc_init(key_t key, long type, int max_text, int flags);
};
