// FILE:  platfile.h

class PlatformFile {

	char	*contents;
	struct	dirent *dirent;
	char	*dirname;
	DIR	*dirp;	
	char	file_name[MAX_FILENAME];
	long	file_size;

	void	set_filesize( ifstream * );

protected:

	char	full_file_name[ MAX_FILENAME ];

public:

	PlatformFile( char *d ) {
		dirname = d;
		file_size = 0;
		file_name[0] = NULL;
		full_file_name[0] = NULL;
		contents = NULL;
	}

	~PlatformFile() 		{ if ( contents ) delete contents;  }

	void	close_file_directory() 	{ closedir( dirp );      }
	void	set_dir_name( char *d ) { dirname = d;		 }
	char	*file_contents() 	{ return contents;       }
	char	*filename()		{ return file_name;      }
	char	*dir_name()		{ return dirname;        }
	char	*full_filename()	{ return full_file_name; }
	int	filesize()		{ return file_size;      }

	STATUS	delete_file();		// inline 
	STATUS	open_file_directory();	// inline 
	STATUS	move_file( char * );
	STATUS	read_file_directory();
	STATUS	read_file();
};
	

//
// PUBLIC:  open the file directory referenced by 'dirname'.
//

inline STATUS PlatformFile::open_file_directory() {
	
	if ( (dirp = opendir( dirname ) ) == NULL) 
		return ERROR;
	else 
		return SUCCESS;
}


//
// PUBLIC:  When a file is read, its contents is stored in 'contents'. 
// Delete the memory allocated for the contents, and unlink the file.
//

inline STATUS PlatformFile::delete_file() {
	delete contents;
	if ( unlink( full_file_name ) == -1 )
		return ERROR;
	else
		return SUCCESS;
}
