// FILE: platform.h

#define	DEBUG	1

//
// File Information
//

#define	ERROR_DIR		"../error"
#define	TP_DIR			"../partners"
#define	VAN_DIR			"../van/scripts"
#define	CONFIG_FILE		"platform.cfg"
#define	STOP_FILE		"platform.stp"
#define LOG_FILE        	"platform.log"
#define	LOG_MOD_FILE		"platform.mod"
#define	X400_ADDR_FILE 		"addresses.tp"
#define	TRACE_FILE  		"trace.api"


//
// Status information.
//

typedef	int			STATUS;
#define	SUCCESS			0x01
#define	ERROR			0x02
#define	UNSUCCESSFUL		0x02
#define	DIRECTORY_EMPTY		0x04
#define	ACTIVITY_OCCURRED	0x08
#define	OK(s)			(!(s&ERROR))
#define MESSAGE_NOT_ACCEPTED    0x10 
#define	ACTIVITY(s)		(s&ACTIVITY_OCCURRED||s&ERROR)


//
// Pragmatic constraints.
//

#define	MAX_FILENAME		256
#define	MAX_LINE		80
#define	MAX_GETLINE		MAX_LINE-1
#define	MAX_EDI_STANDARDS	12
#define	MESSAGE_TYPE_LEN	7
#define	MAX_TIME_BUF		20
#define	MAX_ID_STRING		65


//
// General Definitions.
//

#define	FALSE			0
#define	TRUE			1

#define	NOT_SUPPORTED		0
#define	TAB			"\t"
typedef	short			BOOL;
typedef	enum 			{MHS_EDI=10, MHS_IPM, FTAM, DIAL_UP} PROT_ID;
typedef	enum			{NO_SECURITY=20, SIGN, SIGN_ENCRYPT, SEC_ERR} SECURITY;

#define	EDI_NOTIFICATION	11
#define	DELIVERY_REPORT		12
#define	NONDELIVERY_REPORT	13
#define	IPM_MESSAGE		14
#define	EDI_MESSAGE		15
#define	LOG_SUBOBJECTS		16
#define	LOG_NO_SUBOBJECTS	17

#define	NO_REASON		( OM_enumeration ) -2
#define	NO_DIAGNOSTIC		( OM_enumeration ) -3

#define	MAKE_OM_STRING(oms,s,l)	oms.length=l; oms.elements=(void *)s

#define	LOWER_CASE(i)		i|=0x20

#define	GET_BOOL(b)		{ char buf[ 5 ];			\
				  cin.getline( buf, 6 );		\
				  b=((LOWER_CASE(buf[0]))=='y')?1:0; 	}


//
// EDI Syntax Identification List (structure is defined in X.435).
//

#define	ID_STRING_LEN		5
#define	ID_VERSION_LEN		6

typedef struct syntax_id {
	
	char	id_string[ 5 ];  // even though defined in interchange.h, use
	char	id_version[ 6 ]; // number's since this file must be compiled
				 // before interchange.h
				 // The numeric values will never change!
} SYNTAX_ID;

#define	ERR_NOT_EXPECTED_OBJECT	"Received unsupported object from MTA"

#define	EDIFACT_ISO646		0
#define	EDIFACT_T61		1
#define	EDIFACT_OCTET		2
#define	ANSIX12_ISO646		3
#define	ANSIX12_T61		4
#define	ANSIX12_OCTET		5
#define	ANSIX12_EBCDIC		6
#define	UNTDI_ISO646		7
#define	UNTDI_T61 		8
#define	UNTDI_OCTET		9
#define	PRIVATE_OCTET		10
#define	UNDEFINED_OCTET		11

#define	ADMD_NAME_LEN		17
#define	COMMON_NAME_LEN		65
#define	COUNTRY_NAME_LEN	4
#define	DDA_TYPE_LEN		9
#define	DDA_VALUE_LEN		129
#define	GENERATION_LEN		4
#define	GIVEN_NAME_LEN		17
#define	INITIALS_LEN		6
#define	ORG_NAME_LEN		65
#define	ORG_UNIT_LEN		33
#define	PRMD_NAME_LEN		17
#define	SURNAME_LEN		41

#define	USER_DELIMITER		'%'
#define	ADDR_DELIMITER		'/'

#define	TAG_SIZE		3
#define	MAX_COUNT		5	// allows up to 9999 + \0 instances
					// when reading with getline()

