class SubjectMessage {

	OM_public_object	actual_rcpt;
	void			*arr_time;
	OM_public_object	cnt_correlator;
	void			*cnt_identifier;
	OM_integer		cnt_type;
	OM_enumeration		diag;
	OM_public_object	edi_orig;
	OM_boolean      	resp_forwarded;
	OM_public_object	inter_sender;
	OM_public_object	edin_receiver;
	OM_public_object	ext_trace;
	OM_public_object	first_rcpt;
	OM_public_object	intended_rcpt;
	OM_public_object	last_exp;
	OM_boolean		mta_resp;
	OM_public_object	mts_id;
	OM_public_object	orig;
	OM_public_object	orig_content;
	OM_public_object	orig_edim;
	OM_integer		prior;
	OM_enumeration		reason;
	OM_integer		recip_num;
	OM_public_object	redir_history;
	OM_enumeration		report_req;
	OM_public_object	this_edim;

	OM_boolean		pos_notif;
	OM_boolean		neg_notif;
	OM_boolean		forw_notif;

public:

SubjectMessage() {
	actual_rcpt=cnt_correlator=edin_receiver=ext_trace=first_rcpt=
	intended_rcpt=inter_sender=last_exp=mts_id=orig=orig_edim=redir_history=
	this_edim=NULL;
	arr_time=cnt_identifier=NULL;
	cnt_type = -1;
	prior=recip_num=0;
	report_req=MH_RQ_NEVER;
	mta_resp=OM_TRUE;
	diag = NO_DIAGNOSTIC;
	reason = NO_REASON;
}
	
void set_actual_recipient( OM_public_object p )     { actual_rcpt = p;    }
void set_arrival_time( void *t )		    { arr_time = t;	  }
void set_content_correlator( OM_public_object p )   { cnt_correlator = p; }
void set_content_identifier( void *i )   	    { cnt_identifier = i; }
void set_content_type( OM_integer t ) 	    	    { cnt_type = t;       }
void set_diagnostic( OM_enumeration t ) 	    { diag = t;           }
void set_edi_originator( OM_public_object p )       { edi_orig = p;       }
void set_edi_resp_forwarded( OM_boolean b )	    { resp_forwarded = b; }
void set_edin_receiver( OM_public_object p )        { edin_receiver = p;  }
void set_external_trace_info( OM_public_object p )  { ext_trace = p;      }
void set_first_recipient( OM_public_object p )      { first_rcpt = p;     }
void set_intended_recipient( OM_public_object p )   { intended_rcpt = p;  }
void set_interchange_sender( OM_public_object p )   { inter_sender = p;   }
void set_last_expansion( OM_public_object p )       { last_exp = p;  	  }
void set_mta_responsibility( OM_boolean b )	    { mta_resp = b;	  }
void set_mts_identifier( OM_public_object p ) 	    { mts_id = p;  	  }
void set_orig_content( OM_public_object p )	    { orig_content = p;   }
void set_original_edim_id( OM_public_object p )	    { orig_edim = p; 	  }
void set_originator( OM_public_object p ) 	    { orig = p; 	  }
void set_priority( OM_integer p ) 	    	    { prior = p; 	  }
void set_reason_code( OM_enumeration t ) 	    { reason = t;         }
void set_recipient_number( OM_integer n )	    { recip_num = n;	  }
void set_redirection_history( OM_public_object p )  { redir_history = p;  }
void set_report_request( OM_enumeration p )  	    { report_req = p;     }
void set_this_edim_id( OM_public_object p )  	    { this_edim = p;      }

void set_edi_pos_notif( OM_boolean b )	    	    { pos_notif = b;	  }
void set_edi_neg_notif( OM_boolean b )	    	    { neg_notif = b;	  }
void set_edi_forw_notif( OM_boolean b )	    	    { forw_notif = b;	  }


OM_public_object actual_recipient()	{ return actual_rcpt;		  }
void *arrival_time()			{ return arr_time;		  }
OM_public_object content_correlator()	{ return cnt_correlator;	  }
void *content_identifier()		{ return cnt_identifier;	  }
OM_integer content_type()		{ return cnt_type;		  }
OM_enumeration diagnostic()		{ return diag;		  	  }
OM_public_object edin_receiver_name()	{ return edin_receiver;		  }
OM_public_object external_trace_info()	{ return ext_trace;		  }
OM_public_object first_recipient()	{ return first_rcpt;		  }
OM_public_object intended_recipient()	{ return intended_rcpt;		  }
OM_public_object interchange_sender()	{ return inter_sender;		  }
OM_public_object last_expansion()	{ return last_exp;		  }
OM_boolean mta_responsibility()		{ return mta_resp;		  }
OM_public_object mts_identifier()	{ return mts_id;		  }
OM_public_object original_edim_id()	{ return orig_edim;		  }
OM_public_object originator()		{ return orig;			  }
OM_integer priority()			{ return prior; 		  }
OM_enumeration reason_code()		{ return reason;	  	  }
OM_integer recipient_number()		{ return recip_num;		  }
OM_public_object redirection_history()	{ return redir_history; 	  }
OM_enumeration report_request()		{ return report_req;	 	  }
OM_public_object this_edim_id()		{ return this_edim; 	  	  }

OM_boolean edi_pos_notif()	    	{ return pos_notif;		  }
OM_boolean edi_neg_notif()	    	{ return neg_notif;		  }
OM_boolean edi_forw_notif()	    	{ return forw_notif;		  }
};
