// FILE:  x400api.h

#define	OMP_O_MH_FE_EDI		"\x56\x06\x01\x02\x07\x01"
#define	MAX_CLIENT		INTERCHANGE_ID_SIZE+ID_QUALIFIER_SIZE
#define	MAX_FEATURES		7
#define	WAIT_TIME		1000	// 1 sec in milli secs

class X400Message {

	MH_interval		interval;
	OM_workspace		workspace;
	OM_private_object	session;
	MH_feature		feature_list[ MAX_FEATURES ];
	char			id_string[ MAX_ID_STRING ];
	OM_string		identifier;
	char			client[ MAX_CLIENT ];
	SubjectMessage		subject_message;
	Interchange		*interchange;
	TradingPartnerFile	*tp_entry;
	ORName			*local_user;
	Log			*log;
	ofstream		*log_file;
	LOGLEVEL		log_level;
	char			cur_time[ DATE_LEN ];

	void	log_class( OM_descriptor *, char *, int );
	void	log_any_syntax( OM_syntax, OM_value );
	void	log_action( OM_enumeration );
	void	log_builtin_eits( OM_enumeration );
	void	log_delivery_mode( OM_enumeration );
	void	log_delivery_point( OM_enumeration );
	void	log_diagnostic( OM_enumeration );
	void	log_explicit_conversion( OM_enumeration );
	void	log_priority( OM_enumeration );
	void	log_reason( OM_enumeration );
	void	log_redirection_reason( OM_enumeration );
	void	log_report_request( OM_enumeration );
	void	log_content_type( OM_integer );
	void	log_content_type( char * );
	void	log_external_eits( char * );
	void	log_desc( OM_descriptor *, char *prefix = "" );

	void	log_act_request( char * );
	void	log_bodypart_type( char * );
	void	log_edin_initiator( OM_enumeration );
	
	void	log_attributes( OM_descriptor *, char *, char *, int );

        // Methods used in x400cntout.
	utc_time build_prep_date_and_time( Interchange * ); 
	void     build_this_EDIM( APIObject *, APIObject * );
        void     build_edi_notif_requests( APIObject * );
	void     build_interchange_recipient( APIObject * );
	void     build_recipient_ref( APIObject * );
	void     build_authorization_info( APIObject * );
	void     build_recipients( APIObject *, APIObject *, APIObject *, 
				   APIObject *, APIObject *, APIObject * );
	void     build_edin_receiver( APIObject *, APIObject * );
	void     build_service_string_advice( APIObject * );
        void     build_syntax_identifier( APIObject * );
        void     build_interchange_sender( APIObject * );
        void     build_edi_heading( APIObject *, APIObject *, APIObject *, 
				    APIObject *, APIObject *, APIObject *, 
				    APIObject *, APIObject *, APIObject *, 
				    APIObject *, APIObject *, APIObject *,
				    APIObject *, APIObject * );
        void     build_primary_bodypart( APIObject * );
        void     content( APIObject * );

#ifdef	POSTAL
	void	log_postal_mode( OM_enumeration );
	void	log_postal_report( OM_enumeration );
	void	log_registration( OM_enumeration );
	void	log_rendition_attributes( char * );
#endif

#ifdef	SECURITY
	void	log_security_classification( OM_enumeration );
#endif

#ifdef	ADDRESS_FORMS
	void	log_terminal_type( OM_enumeration );
#endif


	STATUS	parse_inbound_mhs_object( Config * );
	STATUS	parse_mts_report( APIObject * );
	STATUS	parse_edi_object( APIObject *, Config * );
	STATUS	parse_extension( OM_public_object );
	void	parse_expansion_history( OM_public_object );
	void	parse_external_trace( OM_public_object );
	void	parse_redirection_history( OM_public_object );
	EDIUser *parse_rd( OM_public_object, ORName *, Config * );
	STATUS	parse_content( APIObject *, Config * );
	
	STATUS	build_mts_report( int, OM_enumeration reason = NO_REASON, 
				       OM_enumeration diag = NO_DIAGNOSTIC );
	STATUS	build_report_public( APIObject *, APIObject *, APIObject *,
				     int, OM_enumeration, OM_enumeration );
	void	build_recipient_public( APIObject *, APIObject *, 
					OM_enumeration, OM_enumeration );

	void	session_attributes( APIObject * );
	void  	external_trace( APIObject *, APIObject * );
	void  	mts_identifier( APIObject *, APIObject * );
	void  	original_eits( APIObject *, APIObject *, int );
	void  	rd( APIObject *, APIObject *, APIObject *, int );
	STATUS 	build_message( int, APIObject *, APIObject *, APIObject * );
	STATUS	build_ipm_content( APIObject *, APIObject *, APIObject *, 
				   APIObject *, APIObject *, APIObject *,
				   APIObject *, APIObject * );
	void  	build_edi_content( APIObject *, APIObject *, APIObject *,
				   APIObject *, APIObject *, APIObject *,
				   APIObject *, APIObject *, APIObject *,
				   APIObject *, APIObject *, APIObject *,
				   APIObject *, APIObject *, APIObject *,
				   APIObject * );
	void  	current_time( char * );
	void  	timestamp( char * );
	void  	or_name( ORName *, void *, APIObject * );
	void  	or_descriptor( APIObject *, APIObject * );
	void	add_or_attributes( APIObject *, ORName * );

	STATUS	build_nn();
	STATUS	build_pn();
	STATUS	build_notif_content( APIObject *, char *, APIObject * );
	STATUS	nn_reason_code( APIObject *, APIObject * );

	STATUS 	build_this_ipm( APIObject *, APIObject *, APIObject * );
	STATUS 	build_ia5_bodypart( APIObject *, APIObject * );
	STATUS 	build_ipm_recipient( APIObject *, APIObject *, 
				     APIObject *, APIObject * );
	STATUS 	build_ipm_content( APIObject * );

	STATUS parse_ipm_bodypart( OM_public_object, EDIUser * );
	STATUS parse_ipm_content( APIObject *, EDIUser * );
	STATUS parse_edim_bodypart( APIObject *, EDIUser * );
	STATUS parse_edi_bodypart( APIObject *, EDIUser * );
	STATUS parse_edi_message( APIObject *, EDIUser * );
	STATUS parse_recipients(  APIObject *, EDIUser * );
	STATUS parse_edi_extension( APIObject * );
	STATUS parse_edi_application_security_elements( APIObject * );
	STATUS parse_edi_primary_bodypart( APIObject *, EDIUser * );
	STATUS parse_edi_additional_bodyparts( APIObject *, EDIUser * );
	STATUS parse_edi_heading( APIObject *, EDIUser * );
	STATUS parse_edi_notif_requests( OM_public_object, APIObject * );
	void   parse_edi_syntax_id( APIObject *, char *, char * );
        STATUS test_message_type( char * );
        STATUS syntax_id( APIObject * );

	void	public_to_or_name( APIObject *, ORName * );
public:

	X400Message( Log * ); 
	X400Message( TradingPartnerFile *, ORName *, Log *, Interchange * ); 
	
	STATUS	x400_open();
	STATUS	x400_close();
	STATUS	x400_transfer_out( APIObject * );
	STATUS 	x400_start_transfer_in( APIObject * );
	STATUS 	x400_finish_transfer_in( APIObject * );
	STATUS 	x400_wait();
	STATUS 	x400_wait( BOOL * );
	STATUS	x400_size( int * );

	STATUS	build_edi_message( int );
	void	set_user( EDIUser * );
	STATUS	receive( STATUS *, Config * );
	void	log_object( APIObject *, int flg=LOG_NO_SUBOBJECTS );
};
