 
class X500Entry {

	//
	// Attributes common to all transmission media.
	//
	
	PROT_ID		protocol_id;
	char		*send_id_code;
	char		*send_id_code_qualifier;
	char		*rcpt_id_code;
	char		*rcpt_id_code_qualifier;
	
	// 
	// X.400 Attributes.
	//

	ORName		*this_recip;
	ORName		*edin_receiver;
	SECURITY	orig_security;
	BOOL		positive_notif;
	BOOL		negative_notif;
	BOOL		forwarded_notif;
	BOOL		proof_of_notif;
	BOOL		nonrepud_of_notif;
	BOOL		proof_of_rcpt;
	BOOL		nonrepud_of_rcpt;
	BOOL		resp_passing;
	OM_enumeration	prior;

	// 
	// FTAM Attributes.  Change the constraints as appropriate!!!!
	//

	char		name[ MAX_LINE ];
	char		password[ MAX_LINE ];
	char		x500_name[ MAX_LINE ];
	char		dir_name[ MAX_LINE ];

	// 
	// VAN Attributes.  Change the constraints as appropriate!!!!
	//

	char		vanname[ MAX_LINE ];
	
public:

	X500Entry::X500Entry() {

		protocol_id = MHS_EDI;
		send_id_code=send_id_code_qualifier = NULL;
		rcpt_id_code=rcpt_id_code_qualifier = NULL;
		this_recip = edin_receiver = NULL;
		positive_notif=negative_notif=forwarded_notif = FALSE;
		proof_of_notif=nonrepud_of_notif = FALSE;
		proof_of_rcpt=nonrepud_of_rcpt = FALSE;
		resp_passing = FALSE;
		prior = MH_PTY_NORMAL;
		orig_security = NO_SECURITY;
	}

	PROT_ID	  transmission_medium()	           { return protocol_id;       }
	
	//
	// Function to return X.400 Attributes.
	//
	
	ORName	  *this_recipient() 	           { return this_recip;        }
	ORName	  *edin_receiver_name()	           { return edin_receiver;     }
	SECURITY  origination_security()	   { return orig_security;     }
	BOOL	  positive_notification()	   { return positive_notif;    }
	BOOL	  negative_notification()	   { return negative_notif;    }
	BOOL	  forwarded_notification()         { return forwarded_notif;   }
	BOOL	  nonrepudiation_of_notification() { return nonrepud_of_notif; }
	BOOL	  proof_of_notification()          { return proof_of_notif;    }
	BOOL	  nonrepudiation_of_reception()    { return nonrepud_of_rcpt;  }
	BOOL	  proof_of_reception()             { return proof_of_rcpt;     }
	BOOL	  resp_passing_allowed()	   { return resp_passing;      }
	OM_enumeration	priority()	           { return prior; 	       }
	
	//
	// Function to return FTAM Attributes.
	//
	
	char	*user_name()			{ return name;		}
	char	*user_password()		{ return password;	}
	char	*x500_dirname()			{ return x500_name;	}
	char	*file_dirname()			{ return dir_name;	}

	//
	// Function to return VAN Attributes.
	//
	
	char	*van_name()			{ return vanname;	}
	
	
	//
	// Query the Directory.
	//
	
	STATUS 		read_communication_attributes( char *, char *,
						       char *, char * );
	BOOL		validate_partner( ORName * );
	BOOL		validate_partner( char *, char * );
};
