//
// xdsedup.h : EDI Directory user constants
//

#define dsP_EDIobjectClass(X)   ("\x56\x7\xf\x0" #X)
                                    //
                                    // joint-iso-ccitt mhs-motis(6) edims(7)
                                    // id-dir(15) id-doc(0)
                                    //
#define dsP_EDIattributeType(X) ("\x56\x7\xf\x1" #X)
                                    //
                                    // joint-iso-ccitt mhs-motis(6) edims(7)
                                    // id-dir(15) id-dat(1)
                                    //
#define dsP_EDIrecAttributeType(X) ("\x56\x7\x7" #X)
                                    //
                                    // joint-iso-ccitt mhs-motis(6) edims(7)
                                    // id-rat(7)
                                    //
#define dsP_EDInotAttributeType(X) ("\x56\x7\x9" #X)
                                    //
                                    // joint-iso-ccitt mhs-motis(6) edims(7)
                                    // id-nat(9)
                                    //

//
// EDI Trading Partner object classes
//
#define OMP_O_DS_O_EDI_TP           		dsP_EDIobjectClass(\x10)
#define OMP_O_DS_O_EDI_TP_MHS_IPM           dsP_EDIobjectClass(\x11)
#define OMP_O_DS_O_EDI_TP_MHS_EDI           dsP_EDIobjectClass(\x12)
#define OMP_O_DS_O_EDI_TP_FTAM              dsP_EDIobjectClass(\x13)
#define OMP_O_DS_O_EDI_TP_VAN               dsP_EDIobjectClass(\x14)

//
// EDI attribute types
//
#define OMP_O_DS_A_EDI_NAME                 dsP_EDIattributeType(\x0)
#define OMP_O_DS_A_EDI_TR                   dsP_EDIrecAttributeType(\x0)
#define OMP_O_DS_A_EDI_N_RFTR               dsP_EDIrecAttributeType(\x2)
#define OMP_O_DS_A_EDI_RPA_FTR              dsP_EDIrecAttributeType(\x3)
#define OMP_O_DS_A_EDI_N_SFTR               dsP_EDIrecAttributeType(\xb)
#define OMP_O_DS_A_EDI_R_SFTR               dsP_EDIrecAttributeType(\xc)
//
// Local attributes
//
#define OMP_O_DS_A_EDI_MHS_ORIG_SEC     dsP_EDIattributeType(\x31)
#define OMP_O_DS_A_EDI_EDIN_REC_NAME    dsP_EDInotAttributeType(\x32)
// Make this one private for the time being...
#define OMP_O_DS_A_EDI_PRIORITY         dsP_EDIattributeType(\x33)
#define OMP_O_DS_A_EDI_FTAM_CONN_ADDR   dsP_EDIattributeType(\x34)
#define OMP_O_DS_A_EDI_FTAM_X500_NAME   dsP_EDIattributeType(\x35)
#define OMP_O_DS_A_EDI_FTAM_PASSWORD    dsP_EDIattributeType(\x36)
#define OMP_O_DS_A_EDI_FTAM_DIR_NAME    dsP_EDIattributeType(\x37)
#define OMP_O_DS_A_EDI_VAN_NAME         dsP_EDIattributeType(\x38)
#define OMP_O_DS_A_EDI_ENRFTR_PN        dsP_EDIattributeType(\x39)
#define OMP_O_DS_A_EDI_ENRFTR_NN        dsP_EDIattributeType(\x3a)
#define OMP_O_DS_A_EDI_ENRFTR_FN        dsP_EDIattributeType(\x3b)
#define OMP_O_DS_A_EDI_ENSFTR_PR        dsP_EDIattributeType(\x3c)
#define OMP_O_DS_A_EDI_ENSFTR_N_R       dsP_EDIattributeType(\x3d)
#define OMP_O_DS_A_EDI_ERSFTR_PR        dsP_EDIattributeType(\x3e)
#define OMP_O_DS_A_EDI_ERSFTR_N_R       dsP_EDIattributeType(\x3f)
//
// OM attribute names
//
#define DS_EDI_CP_ID					((OM_type) 1000)
#define DS_EDI_NAME						((OM_type) 1001)
#define DS_EDI_N_RFTR					((OM_type) 1002)
#define DS_EDI_N_SFTR					((OM_type) 1003)
#define DS_EDI_R_SFTR					((OM_type) 1004)
#define DS_EDI_RPA_FTR					((OM_type) 1005)
#define DS_EDI_EDIN_REC_NAME			((OM_type) 1006)
#define DS_EDI_MHS_ORIG_SEC				((OM_type) 1007)
#define DS_EDI_PRIORITY					((OM_type) 1008)
#define DS_EDI_TR						((OM_type) 1009)
#define DS_FTAM_CONN_ADDR				((OM_type) 1010)
#define DS_FTAM_PASSWORD				((OM_type) 1011)
#define DS_FTAM_X500_NAME				((OM_type) 1012)
#define DS_FTAM_DIR_NAME				((OM_type) 1013)
#define DS_VAN_NAME						((OM_type) 1014)

