/* EDI SYMBOLIC CONSTANTS */

/* Class */

#define EDI_C_AUTHORIZATION_INFO                           "\x56\x06\x01\x02\x07\x01\x00"              
#define EDI_C_CROSS_REF_INFO                               "\x56\x06\x01\x02\x07\x01\x01"              
#define EDI_C_EDI_APP_SECUR_ELTS                           "\x56\x06\x01\x02\x07\x01\x02"              
#define EDI_C_EDI_BODYPART                                 "\x56\x06\x01\x02\x07\x01\x03"              
#define EDI_C_EDI_EXTENSION                                "\x56\x06\x01\x02\x07\x01\x04"              
#define EDI_C_EDI_HEADING                                  "\x56\x06\x01\x02\x07\x01\x05"              
#define EDI_C_EDI_NOTIF                                    "\x56\x06\x01\x02\x07\x01\x06"              
#define EDI_C_EDI_NOTIF_REQUESTS                           "\x56\x06\x01\x02\x07\x01\x07"              
#define EDI_C_EDIM                                         "\x56\x06\x01\x02\x07\x01\x08"              
#define EDI_C_EDIM_BODYPART                                "\x56\x06\x01\x02\x07\x01\x09"              
#define EDI_C_EDIM_EX_DF_BODYPART                          "\x56\x06\x01\x02\x07\x01\x0A"              
#define EDI_C_EDIM_ID                                      "\x56\x06\x01\x02\x07\x01\x0B"              
#define EDI_C_EDIN_RECEIVER                                "\x56\x06\x01\x02\x07\x01\x0C"              
#define EDI_C_FN_PDAU_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x0D"              
#define EDI_C_FN_REASON_CODE                               "\x56\x06\x01\x02\x07\x01\x0E"              
#define EDI_C_FN_UAMS_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x0F"              
#define EDI_C_FN_USER_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x10"              
#define EDI_C_FORWARD_NOTIF                                "\x56\x06\x01\x02\x07\x01\x11"                
#define EDI_C_INTER_SENDER_RECIP                           "\x56\x06\x01\x02\x07\x01\x12"              
#define EDI_C_NEGATIVE_NOTIF                               "\x56\x06\x01\x02\x07\x01\x13"              
#define EDI_C_NN_PDAU_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x14"              
#define EDI_C_NN_REASON_CODE                               "\x56\x06\x01\x02\x07\x01\x15"              
#define EDI_C_NN_UAMS_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x16"              
#define EDI_C_NN_USER_REASON_CODE                          "\x56\x06\x01\x02\x07\x01\x17"              
#define EDI_C_POSITIVE_NOTIF                               "\x56\x06\x01\x02\x07\x01\x18"              
#define EDI_C_PRIMARY_BODYPART                             "\x56\x06\x01\x02\x07\x01\x19"              
#define EDI_C_REASON_CODE                                  "\x56\x06\x01\x02\x07\x01\x1A"              
#define EDI_C_RECIP_REFERENCE                              "\x56\x06\x01\x02\x07\x01\x1B"              
#define EDI_C_RECIPS                                       "\x56\x06\x01\x02\x07\x01\x1C"              
#define EDI_C_SECUR_ELEMENTS                               "\x56\x06\x01\x02\x07\x01\x1D"              
#define EDI_C_SERV_STRING_ADVICE                           "\x56\x06\x01\x02\x07\x01\x1E"              
#define EDI_C_SYNTAX_ID                                    "\x56\x06\x01\x02\x07\x01\x1F"              

/* Enumeration */

      /* EDIN Initiator */
#define EDI_EI_INTERNAL_UA                                 (  (OM_enumeration)  0 )
#define EDI_EI_INTERNAL_MS                                 (  (OM_enumeration)  1 )
#define EDI_EI_EX_UA                                       (  (OM-enumeratoin)  2 )

/* Integer */

     /* Content Type */
/* Note:  this constant may be used as a value of the Content Type   */
/*        attribute of the Communique class defined in the X.400 API */
#define EDI_CONTENT_TYPE                                   (  (OM_integer)  35 )

    /* FN PDAU Basic Code */
#define EDI_FPB_UNSPECIFIED                                (  (OM_integer)  0 )
#define EDI_FPB_FORWARD_FOR_PD_AND_REND                    (  (OM_integer)  1 )

   /* FN UAMS Basic Code */
#define EDI_FUMB_UNSPECIFIED                               (  (OM_integer)  0 )
#define EDI_FUMB_ONWARD_ROUTING                            (  (OM_integer)  1 )
#define EDI_FUMB_RECIP_UNKNOWN                             (  (OM_integer)  2 )
#define EDI_FUMB_ORIG_UNKNOWN                              (  (OM_integer)  3 )
#define EDI_FUMB_FORWARD_BY_EDI_MS                         (  (OM_integer)  4 )

  /* FN UAMS Diagnostic Code */
#define EDI_FUMB_RECIP_NAME_CHANGED                        (  (OM_integer)  1 )
#define EDI_FUMB_RECIP_NAME_DELETED                        (  (OM_integer)  2 )
  
  /* FN User Basic Code */
#define EDI_FUB_UNSPECIFIED                                (  (OM_integer)  0 )
#define EDI_FUB_FORWARD_FOR_ARCHIVING                      (  (OM_integer)  1 )
#define EDI_FUB_FORWARD_FOR_INFO                           (  (OM_integer)  2 )
#define EDI_FUB_FORWARD_FOR_ADD_INFO                       (  (OM_integer)  3 )
#define EDI_FUB_SUB_UNCHANGED                              (  (OM_integer)  4 )
#define EDI_FUB_HEADING_FIELD_NOT_SUPP                     (  (OM_integer)  5 )
#define EDI_FUB_BODYPART_TYPE_NOT_SUPP                     (  (OM_integer)  6 )
#define EDI_FUB_MSG_TYPE_NOT_SUPP                          (  (OM_integer)  7 )
#define EDI_FUB_SYNTAX_ID_NOT_SUPP                         (  (OM_integer)  8 )
#define EDI_FUB_INTER_SENDER_UNKNOWN                       (  (OM_integer)  9 )
#define EDI_FUB_USER_DEFINED_REASON                        (  (OM_integer)  10 )

  /* NN PDAU Basic Code */
#define EDI_NPB_UNSPECIFIED                                (  (OM_integer)  0 )
#define EDI_NPB_UNDELIV_MAIL                               (  (OM_integer)  1 )
#define EDI_NPB_P_REND_NOT_PERFORMED                       (  (OM_integer)  2 )

  /* NN NP Diagnostic Code */
#define EDI_NPD_P_REND_ATTS_NOT_SUPP                       (  (OM_integer)  31 )
#define EDI_NPD_PD_ADDRESS_INCORRECT                       (  (OM_integer)  32 )
#define EDI_NPD_PD_OFFICE_I_OR_INVALID                     (  (OM_integer)  33 )
#define EDI_NPD_PD_ADDRESS_INC                             (  (OM_integer)  34 )
#define EDI_NPD_RECIP_UNKNOWN                              (  (OM_integer)  35 )
#define EDI_NPD_RECIP_DECEASED                             (  (OM_integer)  36 )
#define EDI_NPD_ORGANIZATION_EXPIRED                       (  (OM_integer)  37 )
#define EDI_NPD_RECIP_REFUSED_TO_ACCEPT                    (  (OM_integer)  38 )
#define EDI_NPD_RECIP_DID_NOT_CLAIM                        (  (OM_integer)  39 )
#define EDI_NPD_RECIP_CHANGED_ADDRESS_P                    (  (OM_integer)  40 )
#define EDI_NPD_RECIP_CHANGED_ADDRESS_T                    (  (OM_integer)  41 )
#define EDI_NPD_RECIP_CHANGED_T_ADDRESS                    (  (OM_integer)  42 )
#define EDI_NPD_NEW_ADDRESS_UNKNOWN                        (  (OM_integer)  43 )
#define EDI_NPD_RECIP_NOT_WANT_FORWARD                     (  (OM_integer)  44 )
#define EDI_NPD_ORIG_PROHIBITED_FORWARD                    (  (OM_integer)  45 )

  /* NN UAMS Basic Code */
#define EDI_NUMB_UNSPECIFIED                               (  (OM_integer)  0 )
#define EDI_NUMB_CANNOT_DELIV_TO_USER                      (  (OM_integer)  1 )
#define EDI_NUMB_DELIV_TIMEOUT                             (  (OM_integer)  2 )
#define EDI_NUMB_MSG_DISCARED                              (  (OM_integer)  3 )
#define EDI_NUMB_SUB_TERMINATED                            (  (OM_integer)  4 )
#define EDI_NUMB_FORWARDING_ERROR                          (  (OM_integer)  5 )
#define EDI_NUMB_SECUR_ERROR                               (  (OM_integer)  6 )
  /* NN NUM Diagnostic Code */
#define EDI_NUMB_PROTOCOL_VIOLATION                        (  (OM_integer)  1 )
#define EDI_NUMB_EDIM_ORIG_UNKNOWN                         (  (OM_integer)  2 )
#define EDI_NUMB_EDIM_RECIP_UNKNOWN                        (  (OM_integer)  3 )
#define EDI_NUMB_EDIM_RECIP_AMBIGUOUS                      (  (OM_integer)  4 )
#define EDI_NUMB_ACT_REQUEST_NOT_SUPP                      (  (OM_integer)  5 )
#define EDI_NUMB_EDIM_EXPIRED                              (  (OM_integer)  6 )
#define EDI_NUMB_EDIM_OBSOLETED                            (  (OM_integer)  7 )
#define EDI_NUMB_DUPLICATE_EDIM                            (  (OM_integer)  8 )
#define EDI_NUMB_UNSUPP_EXTENSION                          (  (OM_integer)  9 )
#define EDI_NUMB_INC_COPY_REJECTED                         (  (OM_integer)  10 )
#define EDI_NUMB_EDIM_TOO_LARGE_FOR_APP                    (  (OM_integer)  11 )
#define EDI_NUMB_FORWARD_EDIM_NOT_DELIV                    (  (OM_integer)  12 )
#define EDI_NUMB_FORWARD_EDIM_D_TIME                       (  (OM_integer)  13 )
#define EDI_NUMB_FORWARD_LOOP_DETECTED                     (  (OM_integer)  14 )
#define EDI_NUMB_UNABLE_TO_ACCEPT_RESP                     (  (OM_integer)  15 )
#define EDI_NUMB_INTER_SENDER_UNKNOWN                      (  (OM_integer)  16 )
#define EDI_NUMB_INTER_RECIP_UNKNOWN                       (  (OM_integer)  17 )
#define EDI_NUMB_INVALID_HEADING_FIELD                     (  (OM_integer)  18 )
#define EDI_NUMB_INVALID_BODYPART_TYPE                     (  (OM_integer)  19 )
#define EDI_NUMB_INVALID_MSG_TYPE                          (  (OM_integer)  20 )
#define EDI_NUMB_INVALID_SYNTAX_ID                         (  (OM_integer)  21 )
#define EDI_NUMB_MSG_INTEG_FAIL                            (  (OM_integer)  22 )
#define EDI_NUMB_FORWARD_MSG_INTEG_FAIL                    (  (OM_integer)  23 )
#define EDI_NUMB_UNSUPP_ALGORITHM                          (  (OM_integer)  24 )
#define EDI_NUMB_DECRYPTION_FAILED                         (  (OM_integer)  25 )
#define EDI_NUMB_TOKEN_ERROR                               (  (OM_integer)  26 )
#define EDI_NUMB_UNABLE_TO_SIGN_NOTIF                      (  (OM_integer)  27 )
#define EDI_NUMB_UNABLE_TO_SIGN_MSG_R                      (  (OM_integer)  28 )
#define EDI_NUMB_AUTHENTICATION_FAIL                       (  (OM_integer)  29 )
#define EDI_NUMB_SECUR_CONTEXT_FAIL                        (  (OM_integer)  30 )
#define EDI_NUMB_MSG_SEQUENCE_FAIL                         (  (OM_integer)  31 )
#define EDI_NUMB_MSG_SECUR_LABEL_FAIL                      (  (OM_integer)  32 )
#define EDI_NUMB_REPUDIATION_FAIL                          (  (OM_integer)  33 )
#define EDI_NUMB_PROOF_OF_FAIL                             (  (OM_integer)  34 )

  /* NN User Basic Code */
#define EDI_NUB_UNSPECIFIED                                (  (OM_integer)  0 )
#define EDI_NUB_SYNTAX_ERROR                               (  (OM_integer)  1 )
#define EDI_NUB_INTER_SENDER_UNKNOWN                       (  (OM_integer)  2 )
#define EDI_NUB_INTER_RECIP_UNKNOWN                        (  (OM_integer)  3 )
#define EDI_NUB_INVALID_HEADING_FIELD                      (  (OM_integer)  4 )
#define EDI_NUB_INVALID_BODYPART_TYPE                      (  (OM_integer)  5 )
#define EDI_NUB_INVALID_MSG_TYPE                           (  (OM_integer)  6 )
#define EDI_NUB_FUNCT_GROUP_NOT_SUPP                       (  (OM_integer)  7 )
#define EDI_NUB_SUB_TERMINATED                             (  (OM_integer)  8 )
#define EDI_NUB_NO_BILATERAL_AGREEMENT                     (  (OM_integer)  9 )
#define EDI_NUB_USER_DEFINED_REASON                        (  (OM_integer)  10 )

/* Object Identifier */

  /* EDI Package */
#define EDI_PACKAGE                                        "\x56\x06\x01\x02\x07\x01"

  /*EDI Body Part Type Attribute */
#define EDI_BPO_EDIFACT_ISO646                             "\x56\x06\x07\x0B\x00"
#define EDI_BPO_EDIFACT_T61                                "\x56\x06\x07\x0B\x01"
#define EDI_BPO_EDIFACT_OCTET                              "\x56\x06\x07\x0B\x02"
#define EDI_BPO_ANSIX12_ISO646                             "\x56\x06\x07\x0B\x03"
#define EDI_BPO_ANSIX12_T61                                "\x56\x06\x07\x0B\x04"
#define EDI_BPO_ANSIX12_OCTET                              "\x56\x06\x07\x0B\x05"
#define EDI_BPO_ANSIX12_EBCDIC                             "\x56\x06\x07\x0B\x06"
#define EDI_BPO_UNTDI_ISO646                               "\x56\x06\x07\x0B\x07"
#define EDI_BPO_UNTDI_T61                                  "\x56\x06\x07\x0B\x08"
#define EDI_BPO_UNTDI_OCTET                                "\x56\x06\x07\x0B\x09"
#define EDI_BPO_PRIVATE_OCTET                              "\x56\x06\x07\x0B\x0A"
#define EDI_BPO_UNDEFINED_OCTET                            "\x56\x06\x07\x0B\x0B"

  /* Action Request Attribute */
#define EDI_ARO_FOR_ACTION                                 "\x56\x06\x07\x0D\x00"
#define EDI_ARO_COPY                                       "\x56\x06\x07\x0D\x01"

/* Type */

#define EDI_ACKNOWLEDGEMENT_REQUEST                        (  (OM_type) 0 )
#define EDI_ACT_REQUEST                                    (  (OM_type) 1 )
#define EDI_ADD_BODYPARTS                                  (  (OM_type) 2 )
#define EDI_APP_CROSS_REFERENCE                            (  (OM_type) 3 )
#define EDI_APP_REFERENCE                                  (  (OM_type) 4 )
#define EDI_APP_SECUR_ELEMENT                              (  (OM_type) 5 )
#define EDI_APP_SECUR_ELEMENTS                             (  (OM_type) 6 )
#define EDI_APP_SECUR_EXTENSIONS                           (  (OM_type) 7 )
#define EDI_AUTHORIZATION_INFO                             (  (OM_type) 8 )
#define EDI_AUTHORIZATION_INFO_Q                           (  (OM_type) 9 )
#define EDI_BASIC_CODE                                     (  (OM_type) 10 )
#define EDI_BODY                                           (  (OM_type) 11 )
#define EDI_BODYPART_REFERENCE                             (  (OM_type) 12 )
#define EDI_COMMS_AGREEMENT_ID                             (  (OM_type) 13 )
#define EDI_COMPONENT_DATA_ELEMENT_SEP                     (  (OM_type) 14 )
#define EDI_CROSS_REFERENCING_INFO                         (  (OM_type) 15 )
#define EDI_DATA_ELEMENT_SEPARATOR                         (  (OM_type) 16 )
#define EDI_DATE_AND_TIME_OF_PREP                          (  (OM_type) 17 )
#define EDI_DECIMAL_NOTATION                               (  (OM_type) 18 )
#define EDI_DELIV_ENVELOPE                                 (  (OM_type) 19 )
#define EDI_DIAGNOSTIC                                     (  (OM_type) 20 )
#define EDI_EDI_APP_SECUR_ELEMENTS                         (  (OM_type) 21 )
#define EDI_EDI_BODYPART_TYPE                              (  (OM_type) 22 )
#define EDI_EDI_MSG_TYPE                                   (  (OM_type) 23 )
#define EDI_EDI_NOTIF_REQUESTS                             (  (OM_type) 24 )
#define EDI_EDI_SUPPLEMENTARY_INFO                         (  (OM_type) 25 )
#define EDI_EDIN_INITIATOR                                 (  (OM_type) 26 )
#define EDI_EDIN_ORIG                                      (  (OM_type) 27 )
#define EDI_EDIN_RECEIVER                                  (  (OM_type) 28 )
#define EDI_EDIN_RECEIVER_NAME                             (  (OM_type) 29 )
#define EDI_ENCRYPTED_PRIMARY_BODYPART                     (  (OM_type) 30 )
#define EDI_EXPIRY_TIME                                    (  (OM_type) 31 )
#define EDI_EX_BODYPART                                    (  (OM_type) 32 )
#define EDI_FIRST_RECIP                                    (  (OM_type) 33 )
#define EDI_FN_REASON_CODE                                 (  (OM_type) 34 )
#define EDI_FN_SECUR_CHECK                                 (  (OM_type) 35 )
#define EDI_FORWARD_NOTIF                                  (  (OM_type) 36 )
#define EDI_FORWARD_TO                                     (  (OM_type) 37 )
#define EDI_HEADING                                        (  (OM_type) 38 )
#define EDI_HEADING_EXTENSIONS                             (  (OM_type) 39 )
#define EDI_IDENTIFICATION_CODE                            (  (OM_type) 40 )
#define EDI_IDENTIFICATION_CODE_Q                          (  (OM_type) 41 )
#define EDI_INC_COPY                                       (  (OM_type) 42 )
#define EDI_INTER_CONTROL_REFERENCE                        (  (OM_type) 43 )
#define EDI_INTER_RECIP                                    (  (OM_type) 44 )
#define EDI_INTER_SENDER                                   (  (OM_type) 45 )
#define EDI_MSG_REFERENCE                                  (  (OM_type) 46 )
#define EDI_NEGATIVE_NOTIF                                 (  (OM_type) 47 )
#define EDI_NN_REASON_CODE                                 (  (OM_type) 48 )
#define EDI_NON_REPUD_OF_RECEPTION                         (  (OM_type) 49 )
#define EDI_NOTIF_EXTENSIONS                               (  (OM_type) 50 )
#define EDI_NOTIF_TIME                                     (  (OM_type) 51 )
#define EDI_OBSOLETED_EDIMS                                (  (OM_type) 52 )
#define EDI_ORIG                                           (  (OM_type) 53 )
#define EDI_ORIGINAL_CONTENT                               (  (OM_type) 54 )
#define EDI_ORIGINAL_CONTENT_INTEG_CK                      (  (OM_type) 55 )
#define EDI_ORIGINAL_EDIM_ID                               (  (OM_type) 56 )
#define EDI_POSITIVE_NOTIF                                 (  (OM_type) 57 )
#define EDI_PRIMARY_BODYPART                               (  (OM_type) 58 )
#define EDI_PROCESSING_PRIORITY_CODE                       (  (OM_type) 59 )
#define EDI_PROOF_OF_RECEPTION                             (  (OM_type) 60 )
#define EDI_RECIP                                          (  (OM_type) 61 )
#define EDI_RECIP_EXTENSIONS                               (  (OM_type) 62 )
#define EDI_RECIP_REFERENCE                                (  (OM_type) 63 )
#define EDI_RECIP_REFERENCE_Q                              (  (OM_type) 64 )
#define EDI_RECIPS                                         (  (OM_type) 65 )
#define EDI_RELATED_EDI_MSGS                               (  (OM_type) 66 )
#define EDI_RELATED_NON_EDI_MSGS                           (  (OM_type) 67 )
#define EDI_RELEASE_INDICATOR                              (  (OM_type) 68 )
#define EDI_RESERVED                                       (  (OM_type) 69 )
#define EDI_RESPONS_FORWARD                                (  (OM_type) 70 )
#define EDI_RESPONS_PASSING_ALLOWED                        (  (OM_type) 71 )
#define EDI_ROUTING_ADDRESS                                (  (OM_type) 72 )
#define EDI_SECUR_ELEMENTS                                 (  (OM_type) 73 )
#define EDI_SEGMENT_TERMINATOR                             (  (OM_type) 74 )
#define EDI_SERVICE_STRING_ADVICE                          (  (OM_type) 75 )
#define EDI_SUBJECT_EDIM                                   (  (OM_type) 76 )
#define EDI_SUPPLEMENTARY_INFO                             (  (OM_type) 77 )
#define EDI_SYNTAX_ID                                      (  (OM_type) 78 )
#define EDI_SYNTAX_ID_STRING                               (  (OM_type) 79 )
#define EDI_SYNTAX_VERSION                                 (  (OM_type) 80 )
#define EDI_TEST_INDICATOR                                 (  (OM_type) 81 )
#define EDI_THIS_EDIM                                      (  (OM_type) 82 )
#define EDI_USER                                           (  (OM_type) 83 )
#define EDI_USER_RELATIVE_ID                               (  (OM_type) 84 )

// Added to EDI Message Package because not defined???   -JJG 3/8/93
#define EDI_PROOF_OF_NOTIF                                 (  (OM_type) 85 )
#define EDI_NON_REPUD_OF_NOTIF                             (  (OM_type) 86 )
/* Value Length */

#define EDI_VL_APP_REFERENCE                               (  (OM_value_length) 14 )
#define EDI_VL_APP_SECUR_ELEMENT                           (  (OM_value_length) 8191 )
#define EDI_VL_AUTHORIZATION_INFO                          (  (OM_value_length) 10 )
#define EDI_VL_AUTHORIZATION_INFO_Q                        (  (OM_value_length) 2 )
#define EDI_VL_COMMS_AGREEMENT_ID                          (  (OM_value_length) 35 )
#define EDI_VL_EDI_MSG_TYPE                                (  (OM_value_length) 6 )
#define EDI_VL_IDENTIFICATION_CODE                         (  (OM_value_length) 35 )
#define EDI_VL_IDENTIFICATION_CODE_Q                       (  (OM_value_length) 4 )
#define EDI_VL_INTER_CONTROL_REFERENCE                     (  (OM_value_length) 14 )
#define EDI_VL_RECIP_REFERENCE                             (  (OM_value_length) 14 )
#define EDI_VL_RECIP_REFERENCE_Q                           (  (OM_value_length) 2 )
#define EDI_VL_ROUTING_ADDRESS                             (  (OM_value_length) 14 )
#define EDI_VL_SYNTAX_ID_STRING                            (  (OM_value_length) 4 )
#define EDI_VL_SYNTAX_VERSION                              (  (OM_value_length) 5 )
#define EDI_VL_USER_RELATIVE_ID                            (  (OM_value_length) 64 )
