/*				FILE = xmit_file.h			*/

/* define one the following on the compile command for the operating	*/
/* system compiling on HPUX or SUNOS (e.g. cc -DHPUX *.c)		*/

#include	"com_defs.h"

struct	host	*get_tty();
extern	char	err_msg[], log_str[], *sys_errlist[];
extern	int	log_fd, this_host_index, static_host, static_tt;
extern  struct  host		*hostp;
extern  struct  tt_struct	*ttp;
extern	jmp_buf	sjbuf;

#define	EXCEPT_LOG	"xlog__"	/* skip files starting with this */

#define	NONFATAL	2

#define	NULL_FILE	2
#define	FLAG_DIALING	1
#define	FLAG_XMIT	2
#define	FLAG_XMODEM	3
#define	FLAG_INIT	4

#define	MAX_ERROR_MSG	256
#define	MAX_LOG_MSG	256
#define	MAX_FLAGS	32
#define	QUIET_LINE_TIME	10

#define	DEFAULT_XTRANSFER_FLAGS	"+clt-x"

#define	DEFAULT_XFER_MODE	XMIT_BOTH
#define	DEFAULT_XGET_FILENAME	"xmodem_get.txt"
#define	DEFAULT_XPUT_FILENAME	"xmodem_put.txt"
#define	DEFAULT_XGET_DIRECTORY	"/home/osi/guests/ediuser/dirin"
#define	DEFAULT_XPUT_DIRECTORY	"/home/osi/guests/ediuser/dirout"
#define	DEFAULT_XGET_PROTO	"xget__XXXXXX"
#define	DEFAULT_XPUT_PROTO	"xput__XXXXXX"
#define	PROTO_LOG_NAME		"xlog__XXXXXX"
#define	DEFAULT_XFER_RESPONSE	"xtransfer started\n"
#define	RESULT_FILE		"result_file.edi"
#define	TIMEOUT_STRING		"TIMEOUT_FUNCTION"

/*	actions when no response or alternate1/2 received	*/
#define	ACTION_OK		0	/* accept no response, continue	*/
#define	ACTION_EXIT		1	/* exit with value ERROR	*/
#define	ACTION_DONE		2	/* exit with value TRUE		*/
#define	ACTION_IGNORE		4	/* ignore response, attempts++	*/
#define	ACTION_RESET_TIME	8	/* wait again, no cmd sent	*/
#define	ACTION_RESTART		16	/* restart from first cmd	*/
#define	ACTION_SKIP		32	/* exit with value NONFATAL	*/
#define	ACTION_ASCII_DONE	64	/* receive ASCII file and done	*/
#define	ACTION_ASCII_IGNORE	128	/* receive ASCII file and ignore*/
#define	ACTION_ASCII_RESET	256	/* receive ASCII file, reset time*/

#define	RESTART_LIMIT		2

#define	CONNECTED_PROG		1
#define	CONNECTED_HOST		2
#define	CONNECTED_MODEM		4
#define	CONNECTED_TTY		8

/*	define host respond structs	*/
#define	RESPOND_LOGIN		1
#define	RESPOND_START		2
#define	RESPOND_PUT_START	3
#define	RESPOND_PUT_BTWN	4
#define	RESPOND_PUT_END		5
#define	RESPOND_GET_START	6
#define	RESPOND_GET_BTWN	7
#define	RESPOND_GET_END		8
#define	RESPOND_END		9
#define	RESPOND_EXIT		10
#define	RESPOND_USER_CMDS	11

/*	host.default flags	*/
#define	XMIT_NEITHER		0	/* don't get or put a file	*/
#define	XMIT_GET		1	/* get (receive) a file		*/
#define	XMIT_PUT		2	/* put (send) a file		*/
#define	XMIT_BOTH		3	/* get and put file(s)		*/
#define	MOD_G_ST		4	/* change the g_st response	*/
#define	MOD_P_ST		8	/* change the p_st response	*/
#define	SET_REMOTE_MODE		16	/* set remote mode, get/put/both*/
#define	SPLIT_BOTH		32	/* local BOTH => GET+PUT remote	*/
#define	P_ASCII			64	/* put protocol is ASCII	*/
#define	P_XMODEM		128	/* put protocol is XMODEM	*/
#define	G_ASCII			256	/* get protocol is ASCII	*/
#define	G_XMODEM		512	/* get protocol is XMODEM	*/
#define	PUT_DEFAULT_FILE	1024	/* DEFAULT_XPUT_FILE else mktemp*/
#define	GET_DEFAULT_FILE	2048	/* DEFAULT_XGET_FILE else mktemp*/
#define	ALL_IN_ONE_FILE		4096	/* GET/PUT to one file - T/F	*/

/*	respond.respond_flags entries	*/
#define	REMOTE_ECHO		1
#define	NO_FLUSH		2
#define	QUIET_LINE		4
#define	MOD_CMD			8

#define	INIT_STAT	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
#define	INIT_TERMIO	{0, 0, 0, 0, 0, 0}

struct	host	{
	char	*host_id;	/* host identifier string		*/
	char	*def_flags;	/* default flags for transfer protocol	*/
	char	*pdir;		/* directory to send (put) files from	*/
	char	*gdir;		/* directory to retrieve (get) files to	*/
	char	*separator;	/* parm separator on p_st/g_st cmd_str	*/
	char	*terminator;	/* cmd terminator on p_st/g_st cmd_str	*/
	char	*null_file;	/* string to indicate no data, get/put	*/
	int	rec_len;	/* record len of retrieve XMODEM packet	*/
	int	connected;	/* connected to modem | host | program	*/
	int	calling;	/* calling (T) or called (F) program	*/
	int	defaults;	/* modify g/p_st, protocol, mode allowed*/
	int	remote_echo;	/* does remote echo - TRUE/FALSE/UNKNOWN*/
	/* send-responses, commands to remote host and remote responses	*/
	struct	respond	*login;	/* [] of host login cmds		*/
	struct	respond *start;	/* [] of progam startup cmds		*/
	struct	respond	*p_st;	/* [] of sending (put) startup cmds	*/
	struct	respond	*p_btwn;/* [] of sending cmds between files	*/
	struct	respond	*p_end;	/* [] of sending (put) finish cmds	*/
	struct	respond	*g_st;	/* [] of retrieving (get) startup cmds	*/
	struct	respond	*g_btwn;/* [] of retreiving cmds between files	*/
	struct	respond	*g_end;	/* [] of retreiving (get) finish cmds	*/
	struct	respond *end;	/* [] of program ending cmds		*/
	struct	respond	*exit;	/* [] of host exiting cmds		*/
	char	*telnbr;	/* telephone number, 0 => direct connect*/
	int	tt_index;	/* index into array of tt_struct structs*/
};

struct	tt_struct	{
	int	tty_fd;		/* input/output tty file descriptor	*/
	char	*ttname;	/* tty name				*/
	int	in_use;		/* tty in use - T/F			*/
	int	tty_modes;	/* are the tty modes valid - T/F	*/
	struct	termio tty_old;	/* saved tty modes			*/
	struct	termio tty_new;	/* new tty modes			*/
	struct	stat statbuf;	/* for st_mode field			*/
	int	wason;		/* tty read/write modes (st_mode & 022)	*/
	int	host_index;	/* index into array of host structs	*/
	int	default_speed;	/* max tty speed (e.g. B2400), -1 => ?	*/
	int	real_speed;	/* actual tty speed, -1 => ?		*/
	short	oflags;		/* additional sgttyb flags for setmodes	*/
	int	mdm_index;	/* index into array of mdminf structs	*/
	char	*host_id;	/* host identifier, links to host struct*/
};

struct	respond	{		/* cmd-responses			*/
	char	*cmd_str;	/* string to send to the remote system	*/
	int	respond_flags;	/* flags for this cmd, e.g. REMOTE_ECHO	*/
	int	respond_time;	/* time to wait for response		*/
	int	no_response;	/* action where no response received	*/
	char	*response;	/* remote response to cmd_str		*/
	char	*alternate1;	/* first alternate response to cmd_str	*/
	int	alt1_action;	/* action to take if alternate1 received*/
	char	*alternate2;	/* second alternate response to cmd_str	*/
	int	alt2_action;	/* action to take if alternate2 received*/
	char	*reresponse;	/* reply to alt1/2, ACTION_RESET_TIME	*/
	int	attempts;	/* # of times to send before aborting	*/
	int	lower;		/* force host response in lower case ?	*/
};

