//				FILE = xfer_stop.C

#include	"msg_defs.h"
#include	"msg_edi.h"
#include	"functions.h"
#include	"edi_control_defs.h"

ipc_msg	edi_daemon((key_t)KEY_EDI,(long)TYPE_DAEMON,(int)MSG_LONG_TEXT,0);

main(int argc, char *argv[])
{
	int	i,cmd;
	long	type = TYPE_NULL;
	char	*p,*p1,*p2,*p3,*p4;

	if (argc < 2)	{
		logit("Usage: xfer_stop cmd/host_list[=options]\n");
		exit(0);
	}
	if ((argc == 2) && (strcmp(argv[1],"help") == 0))	{
		logit("Usage: xfer_stop cmd/host_list[=options]\n");
		logit("	cmd is one of:\n");
		logit("		ABORT, SHUTDOWN or CMD\n\n");
		logit("	host_list is a slash separated list of\n");
		logit("	EDI programs to receive the 'options'\n");
		logit("	host_list is one of:\n");
		logit("		ftam_out, xmodem_out, x25_out, or platform\n\n");
		logit("	'options' is a program specific string\n");
		exit(0);
	}

	for (i = 1; i < argc; i++)	{
		type = NULL;
		cmd = NULL;
		p = argv[i];
		if ((p2 = strchr(p,'=')) != 0)
			*p2 = '\0';	/* make cmd/host_list a string	*/
		if (!p2 || (*(p2+1) == '\0'))	{
			sprintf(log_str,"No option for command = %s\n",p);
			logit(log_str);
		}

		if ((p1 = strchr(p,'/')) == 0)	{
			if (p2)	*p2 = '=';
			sprintf(log_str,"no host specified, '%s' skipped\n",p);
			logit(log_str);
			continue;
		}
		*p1 = '\0';

		if (strcmp(p,"ABORT") == 0)		cmd = ABORT;
		else	if (strcmp(p,"SHUTDOWN") == 0)	cmd = SHUTDOWN;
		else	if (strcmp(p,"MSG") == 0)	cmd = COMMAND;
		else	{
			*p1 = '/';
			if (p2)	*p2 = '=';
			sprintf(log_str,"unrecognized command = %s, skipped\n",p);
			logit(log_str);
			continue;
		}

		p3 = p1 + 1;

		while (p3 && *p3)	{
			/* find start of next parameter		*/
			if (p4 = strchr(p3,'/'))	*p4 = '\0';
			if (*p3 == 0)	goto	next;  /* skip null string	*/
			type = TYPE_NULL;
			if (strcmp(p3,NAME_FTAM_OUT) == 0)
				type = TYPE_FTAM_OUT;
			else	if (strcmp(p3,NAME_XMODEM_IN) == 0)
				type = TYPE_XMODEM_IN;
			else	if (strcmp(p3,NAME_XMODEM_OUT) == 0)
				type = TYPE_XMODEM_OUT;
			else	if (strcmp(p3,NAME_X25_IN) == 0)
				type = TYPE_X25_IN;
			else	if (strcmp(p3,NAME_PLATFORM) == 0)
				type = TYPE_PLATFORM;
			else	if (strcmp(p3,NAME_X25_OUT) == 0)
				type = TYPE_X25_OUT;

			if (type == TYPE_NULL)
				logit("Invalid program name\n");
			else	if (prog_exists((int)type,1) != TRUE)
				logit("Program not running - message not sent\n");
			else	if (!edi_daemon.msg_snd(type,cmd,p2))
				logit("Unable to send message\n");

next:			if (p4)	{
				*p4 = '/';
				p3 = p4 + 1;
			}	else	break;
		}
	}
}
