#include <xom.h>
#include <ximp.h>
#include <xmh.h>
#include <xmhp.h>
#include <xedip.h>
#include <om_class.h>
#include <climport.h>


#define EXPAND(oid)	\
	{ OMP_LENGTH(oid), OMP_O_##oid }
#define OMP_O_OM_C_EXTERNAL_PACK		"\x56\x06\x01\x02\x04"

/* 
 * Note: the MH package not yet include the Name class as defined in XDS
 *			KDH 4/15/91
 */

/* Class */

#define _C_BILAT_DEF_BD_PRT		(int) 0x0
#define _C_BD_PRT				(int) 0x1
#define _C_EXTERN_DEF_BD_PRT	(int) 0x2
#define _C_G3_FAX_BD_PRT		(int) 0x3
#define _C_G4_CLASS_1_BD_PRT	(int) 0x4
#define _C_IA5_TEXT_BD_PRT		(int) 0x5
#define _C_INTERPERSONAL_MSG	(int) 0x6
#define _C_INTERPERSONAL_NOTIF	(int) 0x7
#define _C_IPM_IDENTIFIER		(int) 0x8
#define _C_ISO_6937_TEXT_BD_PRT	(int) 0x9
#define _C_MESSAGE_BD_PRT		(int) 0xA
#define _C_MIXED_MODE_BD_PRT	(int) 0xB
#define _C_NATIONAL_DEF_BD_PRT	(int) 0xC
#define _C_NON_RECEIPT_NOTIF	(int) 0xD
#define _C_OR_DESCRIPTOR		(int) 0xE
#define _C_RECEIPT_NOTIF		(int) 0xF
#define _C_RECIPIENT_SPECIFIER	(int) 0x10	
#define _C_TELETEX_BD_PRT		(int) 0x11
#define _C_VIDEOTEX_BD_PRT		(int) 0x12
#define _C_CONTENT_IN_IM		(int) 0x13

omp_class	im_package[] =	{
	{	_C_BILAT_DEF_BD_PRT, 	OM_TRUE,	_C_BD_PRT, 	0 	},
	{	_C_BD_PRT, 				OM_FALSE, 	TOPCLASS, 	0 	},
	{	_C_EXTERN_DEF_BD_PRT, 	OM_TRUE, 	_C_BD_PRT, 	0 	},
	{	_C_G3_FAX_BD_PRT,		OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_G4_CLASS_1_BD_PRT,	OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_IA5_TEXT_BD_PRT,		OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_INTERPERSONAL_MSG,	OM_TRUE, _C_CONTENT_IN_IM, 0},
	{	_C_INTERPERSONAL_NOTIF,	OM_FALSE,_C_CONTENT_IN_IM,0},
	{	_C_IPM_IDENTIFIER,		OM_TRUE, TOPCLASS, 		0 	},
	{	_C_ISO_6937_TEXT_BD_PRT,OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_MESSAGE_BD_PRT,		OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_MIXED_MODE_BD_PRT,	OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_NATIONAL_DEF_BD_PRT,	OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_NON_RECEIPT_NOTIF,	OM_TRUE, _C_INTERPERSONAL_NOTIF,  0 	},
	{	_C_OR_DESCRIPTOR,		OM_TRUE, TOPCLASS,		0	},
	{	_C_RECEIPT_NOTIF,		OM_TRUE, _C_INTERPERSONAL_NOTIF,  0 	},
	{	_C_RECIPIENT_SPECIFIER,	OM_TRUE, TOPCLASS,		0	},
	{	_C_TELETEX_BD_PRT,		OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_VIDEOTEX_BD_PRT,		OM_TRUE, _C_BD_PRT, 	0 	},
	{	_C_CONTENT_IN_IM,		OM_FALSE, TOPCLASS,		&MH_C_CONTENT }
};

#define _C_EXTERNAL		(int) 0x2

omp_class	om_package[] =	{
	{	_C_EXTERNAL, 	OM_TRUE,	_C_EXTERN_DEF_BD_PRT, 	0 }
	                        };

#define _C_ALGORITHM 			0x00
#define _C_ALGORITHM_AND_RESULT 0x01
#define _C_ASYMMETRIC_TOKEN     0x02
#define _C_BILATERAL_INFO       0x03
#define _C_COMMUNIQUE           0x04
#define _C_CONTENT              0x05
#define _C_DELIV_MESSAGE        0x06
#define _C_DELIV_PER_RECIP_DR   0x07
#define _C_DELIV_PER_RECIP_NDR  0x08
#define _C_DELIV_PER_RECIP_REP  0x09
#define _C_DELIV_REPORT         0x0A
#define _C_DELIVERY_CONFIRM     0x0B
#define _C_DELIV_ENVELOPE       0x0C
#define _C_EITS                 0x0D
#define _C_EXPANSION_RECORD     0x0E
#define _C_EXTENSIBLE_OBJECT    0x0F
#define _C_EXTENSION            0x10
#define _C_EXTERNAL_TRACE_ENTRY 0x11
#define _C_G3_FAX_NBPS          0x12
#define _C_GENERAL_CONTENT      0x13
#define _C_INTERNAL_TRACE_ENTRY 0x14
#define _C_LOCAL_DELIVERY_CONFIRM  0x15
#define _C_LOCAL_DELIVERY_CONFIRMS 0x16
#define _C_LOCAL_NDR            0x17
#define _C_LOCAL_PER_RECIP_NDR  0x18
#define _C_MESSAGE              0x19
#define _C_MESSAGE_RD           0x1A
#define _C_MTS_IDENTIFIER       0x1B
#define _C_OR_ADDRESS           0x1C
#define _C_OR_NAME              0x1D
#define _C_PER_RECIP_DR         0x1E
#define _C_PER_RECIP_NDR        0x1F
#define _C_PER_RECIP_REPORT     0x20
#define _C_PROBE                0x21
#define _C_PROBE_RD             0x22
#define _C_RD                   0x23
#define _C_REDIRECTION_RECORD   0x24
#define _C_REPORT               0x25
#define _C_SECURITY_LABEL       0x26
#define _C_SESSION              0x27
#define _C_SUBMISSION_RESULTS   0x28
#define _C_SUBMITTED_COMMUNIQUE 0x29
#define _C_SUBMITTED_MESSAGE    0x2A
#define _C_SUBMITTED_MESSAGE_RD 0x2B
#define _C_SUBMITTED_PROBE      0x2C
#define _C_SUBMITTED_PROBE_RD   0x2D
#define _C_TELETEX_NBPS         0x2E
#define _C_DELIVERY_REPORT		0x2F

omp_class	mh_package[]= {
	{ _C_ALGORITHM 			, OM_TRUE, TOPCLASS, 0},
	{ _C_ALGORITHM_AND_RESULT , OM_TRUE, _C_ALGORITHM, 0},
	{ _C_ASYMMETRIC_TOKEN     , OM_TRUE, TOPCLASS, 0},
	{ _C_BILATERAL_INFO       , OM_TRUE, TOPCLASS, 0},
	{ _C_COMMUNIQUE           , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_CONTENT              , OM_FALSE, TOPCLASS, 0},
	{ _C_DELIV_MESSAGE        , OM_TRUE, TOPCLASS, 0 },
	{ _C_DELIV_PER_RECIP_DR   , OM_TRUE, _C_DELIV_PER_RECIP_REP, 0},
	{ _C_DELIV_PER_RECIP_NDR  , OM_TRUE, _C_DELIV_PER_RECIP_REP, 0},
	{ _C_DELIV_PER_RECIP_REP  , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_DELIV_REPORT         , OM_TRUE, _C_DELIVERY_REPORT, 0},
	{ _C_DELIVERY_CONFIRM        , OM_TRUE, TOPCLASS, 0},
	{ _C_DELIV_ENVELOPE       , OM_TRUE, _C_EXTENSIBLE_OBJECT,	0},
	{ _C_EITS                 , OM_TRUE, TOPCLASS, 0},
	{ _C_EXPANSION_RECORD     , OM_TRUE, TOPCLASS, 0},
	{ _C_EXTENSIBLE_OBJECT    , OM_TRUE, TOPCLASS, 0},
	{ _C_EXTENSION            , OM_TRUE, TOPCLASS, 0},
	{ _C_EXTERNAL_TRACE_ENTRY , OM_TRUE, TOPCLASS, 0},
	{ _C_G3_FAX_NBPS          , OM_TRUE, TOPCLASS, 0},
	{ _C_GENERAL_CONTENT      , OM_TRUE, _C_CONTENT, 0},
	{ _C_INTERNAL_TRACE_ENTRY , OM_TRUE, TOPCLASS, 0},
	{ _C_LOCAL_DELIVERY_CONFIRM  , OM_TRUE, _C_DELIVERY_CONFIRM, 0},
	{ _C_LOCAL_DELIVERY_CONFIRMS , OM_TRUE, TOPCLASS, 0},
	{ _C_LOCAL_NDR            , OM_TRUE, TOPCLASS, 0},
	{ _C_LOCAL_PER_RECIP_NDR  , OM_TRUE, TOPCLASS, 0},
	{ _C_MESSAGE              , OM_TRUE, _C_COMMUNIQUE, 0},
	{ _C_MESSAGE_RD           , OM_TRUE, _C_SUBMITTED_MESSAGE_RD, 0},
	{ _C_MTS_IDENTIFIER       , OM_TRUE, TOPCLASS, 0},
	{ _C_OR_ADDRESS           , OM_TRUE, TOPCLASS, 0},
	{ _C_OR_NAME              , OM_TRUE, _C_OR_ADDRESS, 0},
	{ _C_PER_RECIP_DR         , OM_TRUE, _C_PER_RECIP_REPORT, 0},
	{ _C_PER_RECIP_NDR        , OM_TRUE, _C_PER_RECIP_REPORT, 0},
	{ _C_PER_RECIP_REPORT     , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_PROBE                , OM_TRUE, _C_COMMUNIQUE, 0},
	{ _C_PROBE_RD             , OM_TRUE, _C_SUBMITTED_PROBE_RD, 0},
	{ _C_RD                   , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_REDIRECTION_RECORD   , OM_TRUE, TOPCLASS, 0},
	{ _C_REPORT               , OM_TRUE, _C_DELIVERY_REPORT, 0},
	{ _C_SECURITY_LABEL       , OM_TRUE, TOPCLASS, 0},
	{ _C_SESSION              , OM_TRUE, TOPCLASS, 0},
	{ _C_SUBMISSION_RESULTS   , OM_TRUE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_SUBMITTED_COMMUNIQUE , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0},
	{ _C_SUBMITTED_MESSAGE    , OM_TRUE},
	{ _C_SUBMITTED_MESSAGE_RD , OM_TRUE, _C_SUBMITTED_PROBE_RD, 0},
	{ _C_SUBMITTED_PROBE      , OM_TRUE, _C_SUBMITTED_COMMUNIQUE, 0},
	{ _C_SUBMITTED_PROBE_RD   , OM_FALSE, _C_RD, 0},
	{ _C_TELETEX_NBPS         , OM_TRUE, TOPCLASS, 0},
	{ _C_DELIVERY_REPORT	  , OM_FALSE, _C_EXTENSIBLE_OBJECT, 0}
};

/* EDI Classes */

#define _EDI_C_AUTHORIZATION_INFO		0x00
#define _EDI_C_CROSS_REFERENCING_INFO   0x01	
#define _EDI_C_EDI_APP_SECUR_ELEMENTS   0x02	
#define _EDI_C_EDI_BODYPART	            0x03	
#define _EDI_C_EDI_NOTIF		        0x04	
#define _EDI_C_EDI_NOTIF_REQUESTS	    0x05	
#define _EDI_C_EDIM		                0x06	
#define _EDI_C_EDIM_BODYPART	        0x07	
#define _EDI_C_EDIM_EX_DEFINED_BODYPART 0x08	
#define _EDI_C_EDIM_ID		            0x09	
#define _EDI_C_EDIN_RECEIVER		    0x0A
#define _EDI_C_EXTENSIONS			    0x0B
#define _EDI_C_FN_PDAU_REASON_CODE		0x0C
#define _EDI_C_FN_REASON_CODE		    0x0D
#define _EDI_C_FN_UAMS_REASON_CODE		0x0E
#define _EDI_C_FN_USER_REASON_CODE		0x0F
#define _EDI_C_FORWARD_NOTIF		    0x10
#define _EDI_C_HEADING			        0x12
#define _EDI_C_INTER_SENDER_RECIP		0x13
#define _EDI_C_NEGATIVE_NOTIF		    0x14
#define _EDI_C_NN_PDAU_REASON_CODE		0x15
#define _EDI_C_NN_REASON_CODE		    0x16
#define _EDI_C_NN_UAMS_REASON_CODE		0x17
#define _EDI_C_NN_USER_REASON_CODE		0x18
#define _EDI_C_POSITIVE_NOTIF		    0x19
#define _EDI_C_PRIMARY_BODYPART		    0x1A
#define _EDI_C_REASON_CODE			    0x1B
#define _EDI_C_RECIP_REFERENCE		    0x1C
#define _EDI_C_RECIPS			        0x1D
#define _EDI_C_SECUR_ELEMENTS		    0x1E
#define _EDI_C_SERVICE_STRING_ADVICE	0x1F
#define _EDI_C_SYNTAX_ID			    0x20   

omp_class	edi_package[] =	{
{_EDI_C_AUTHORIZATION_INFO, OM_TRUE, TOPCLASS, 0},
{_EDI_C_CROSS_REFERENCING_INFO, OM_TRUE, TOPCLASS, 0},
{_EDI_C_EDI_APP_SECUR_ELEMENTS, OM_TRUE, TOPCLASS, 0},
{_EDI_C_EDI_BODYPART, OM_TRUE, _EDI_C_PRIMARY_BODYPART, 0}, 		
{_EDI_C_EDI_NOTIF, OM_FALSE, TOPCLASS, &MH_C_CONTENT }, 	
{_EDI_C_EDI_NOTIF_REQUESTS, OM_TRUE, TOPCLASS, 0},	
{_EDI_C_EDIM, OM_TRUE, TOPCLASS, &MH_C_CONTENT },	
{_EDI_C_EDIM_BODYPART, OM_TRUE, _EDI_C_PRIMARY_BODYPART, 0},
{_EDI_C_EDIM_EX_DEFINED_BODYPART, OM_TRUE, TOPCLASS, 0},	
{_EDI_C_EDIM_ID, OM_TRUE, TOPCLASS, 0},
{_EDI_C_EDIN_RECEIVER, OM_TRUE, TOPCLASS, 0},
{_EDI_C_EXTENSIONS, OM_TRUE, TOPCLASS, 0},	
{_EDI_C_FN_PDAU_REASON_CODE, OM_TRUE, _EDI_C_FN_REASON_CODE, 0},
{_EDI_C_FN_REASON_CODE, OM_FALSE, _EDI_C_REASON_CODE, 0}, 
{_EDI_C_FN_UAMS_REASON_CODE, OM_TRUE, _EDI_C_FN_REASON_CODE, 0},
{_EDI_C_FN_USER_REASON_CODE, OM_TRUE, _EDI_C_FN_REASON_CODE, 0},	
{_EDI_C_FORWARD_NOTIF, OM_TRUE, _EDI_C_EDI_NOTIF, 0},
{_EDI_C_HEADING, OM_TRUE, TOPCLASS, 0},		
{_EDI_C_INTER_SENDER_RECIP, OM_TRUE, TOPCLASS, 0},
{_EDI_C_NEGATIVE_NOTIF, OM_TRUE, _EDI_C_EDI_NOTIF, 0},	
{_EDI_C_NN_PDAU_REASON_CODE, OM_TRUE, _EDI_C_NN_REASON_CODE, 0},	
{_EDI_C_NN_REASON_CODE, OM_FALSE, _EDI_C_REASON_CODE, 0},	
{_EDI_C_NN_UAMS_REASON_CODE, OM_TRUE, _EDI_C_NN_REASON_CODE, 0},	
{_EDI_C_NN_USER_REASON_CODE, OM_TRUE, _EDI_C_NN_REASON_CODE, 0},
{_EDI_C_POSITIVE_NOTIF, OM_TRUE, _EDI_C_EDI_NOTIF, 0},	
  {_EDI_C_PRIMARY_BODYPART, OM_TRUE, TOPCLASS, 0},
  {_EDI_C_REASON_CODE	, OM_TRUE, TOPCLASS, 0},
/*{_EDI_C_PRIMARY_BODYPART, OM_FALSE, TOPCLASS, 0},
{_EDI_C_REASON_CODE	, OM_FALSE, TOPCLASS, 0},
*/{_EDI_C_RECIP_REFERENCE, OM_TRUE, TOPCLASS, 0},	
{_EDI_C_RECIPS, OM_TRUE, TOPCLASS, 0},		
{_EDI_C_SECUR_ELEMENTS, OM_TRUE, TOPCLASS, 0},		
{_EDI_C_SERVICE_STRING_ADVICE, OM_TRUE, TOPCLASS, 0},
{_EDI_C_SYNTAX_ID, OM_TRUE, TOPCLASS, 0}	

};

omp_package	X4omp_packages[]={
	{ 	EXPAND(MH_FE_IM_88), im_package},
	{	EXPAND(MH_FE_MH_88), mh_package},
	{	EXPAND(OM_C_EXTERNAL_PACK), om_package},
	{   EXPAND(EDI_PACKAGE), edi_package},
	{  {0, 0}, 0}
};

