/************************
#ifndef lint
static char rcsid[]="$Header: format.c,v 3.27 93/05/13 14:50:30 campbell Exp $";
#endif

/*
 * $Header: format.c,v 3.27 93/05/13 14:50:30 campbell Exp $
 * $Revision: 3.27 $
 * $Locker: timble $
 * $Log:	format.c,v $
 * Revision 3.27  93/05/13  14:50:30  14:50:30  campbell
 * Modified mhp_f_orname to add 88 attributes; all 88 OR names attributes
 * are now handled correctly, except Presentation Address.  This needs to
 * be added after a new package file containing the needed XDS class is
 * added.
 * Also modified mt_encode_address_ext to malloc extensions buffer as well
 * as ext buffer, to avoid repeating code in mhp_f_orname.
 * 
 * Revision 3.26  93/03/26  14:24:43  14:24:43  khiem (Khiem D. Ho)
 * roll in fix C03_00_06. khiem.
 * 
 * Revision 3.25  93/03/24  19:33:16  19:33:16  khiem ()
 * hook for Pedi support. Corresponding name changes for ext.c,
 * handle_nonp22_content to x4g_process_generic_content. "expand -4" for
 * tabs in number of places. Pedi hook includes (1) check for object id
 * in CONTENT: attribute, (2) call mhp_f_edi(). Khiem
 * 
 * Revision 3.24.1.2  93/03/23  20:59:58  20:59:58  khiem ()
 * format BUILTIN_edi content, and some name changes in ext.c "x4g_type_of_".
 * Khiem
 * 
 * Revision 3.24.1.1  93/03/22  15:23:34  15:23:34  khiem ()
 * Start to support Pedi/P35 for NIST. Khiem 3/22/93.
 * 
 * Revision 3.24  92/11/11  16:56:24  16:56:24  trang
 * fix for check of criticality fields not being null
 * 
 * Revision 3.23  92/10/22  10:38:33  10:38:33  khiem ()
 * Fix checking for ivalue==NULL in multiple values in mhp_f_orname(). kdh.
 * 
 * Revision 3.22  92/10/20  11:25:38  11:25:38  khiem ()
 * Add Latest Delivery Time. kdh.
 * 
 * Revision 3.21  92/10/20  00:25:24  00:25:24  khiem ()
 * Fixed f_internal1988: set mask correctly for Attempted DomainName 
 * and Attempted MTAName. kdh.
 * 
 * Revision 3.20  92/10/16  20:20:04  20:20:04  khiem ()
 * Add proper handling for Teletex CommonName and other Teletex attributes.kdh
 * 
 * Revision 3.19  92/10/15  13:16:30  13:16:30  trang (Trang Tran)
 * Fixed one more uninitiliased variable "OM_boolean bureau_fax"
 * shekhar
 * 
 * Revision 3.18  92/10/12  18:33:41  18:33:41  trang (Trang Tran)
 * added missing initialisation for "postal_mode" parameter.
 * shekhar
 * 
 * Revision 3.17  92/10/08  11:20:48  11:20:48  khiem ()
 * Add PerRecipient Message Transfer Fields extensions (or Message RD class):
 * Bureau Fax, Postal Mode, Forwarding Request/Prohibited, etc. KDH.
 * 
 * Revision 3.16  92/10/07  17:09:29  17:09:29  khiem ()
 * Fix minor bugs for Preferred Delivery Modes: initialize value_num/ivalue.kdh
 * 
 * Revision 3.15  92/10/06  18:31:09  18:31:09  trang (Trang Tran)
 * Added MH_T_PREFERRED_DELIVERY_MODES for mhp_f_recipient.
 * Added code to suppress generation of extensions if they just have default values.
 * shekhar
 * 
 * Revision 3.14  92/10/06  13:18:54  13:18:54  trang (Trang Tran)
 * took out ifdef _1988_GTWAPI; added 
 *  mhp_is84MH for some cases.
 * 
 * Revision 3.13  92/10/06  12:47:16  12:47:16  khiem ()
 * Add criticality functions. KDH
 * 
 * Revision 3.12  92/10/01  10:52:10  10:52:10  trang (Trang Tran)
 * pls ignore rev 3.10 and 3.11;
 * added converted eits within internal trace.
 * 
 * Revision 3.11  92/10/01  10:05:25  10:05:25  trang (Trang Tran)
 * added converted eits within internal trace.
 * 
 * Revision 3.9  92/09/18  00:44:32  00:44:32  khiem ()
 * Fix Expansion History in Internal Trace 1988.
 * Add priority for mt_transfer_out() to get file prefix correctly.
 * 
 *
 */

/*
 * These changes are required to compile format.c  NIST-PM 7/30/93
 */

#define	_INCLUDE_POSIX_SOURCE	1
#define	NO_FILE					0
#define	MAXFILE					80
#define	FREE_BODY_CACHE			0x4

/* Must fix MH_T_CONTENT_TYPE */

void itoa (int n, char s[] ) {
int i=0;
do {
 s[i++] = n%10+'0';
 } while ((n/=10) > 0 );
 s[i] = '\0';
}



#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/conf.h>
#include <p1p2.h>
#include <xom.h>
#include <xmhp.h>
#include <ximp.h>
#include <xomhp.h>
#include <x4apifp.h>
#include <climport.h>
#include <x4cat.h> 
#include <xedip.h>
#include <climportedi.h>
/* #include <clexportedi.h> */

os_Jmpbuf xenv;			/* need to check this */
/* aaListPointer bp_files; /* to be seen whether this should be used */
extern boolean list_append();
extern boolean list_alloc();
extern void	log_error();
extern char *omp_hexme(OM_string);
extern void mhp_set_default_criticality();
extern void mhp_set_attr_criticality();


extern int asncode;		/* aaerror code and msg */
extern char *asnmsg;
extern char *_MH_BodyPart_dir;
extern int save_ct;
extern int x4g_type_of_content_to_be_formatted;  
			/* defined in ext.c and is used to convey the  */
			/* content type to formatter.                */
extern boolean mhp_is84MH;
extern boolean mhp_is88MH;
extern	int priority;

/* tell ext.c to handle P0 binary content*/
extern	int	x4g_process_generic_content_flag; 
static P1ExtensionAttribute 
    *mt_encode_address_ext();


#define IS_CLASS(string1, string2)	\
 ( sl_bcmp((string1)->elements, (string2)->elements, (int) (string1)->length) \
 ?FALSE:TRUE)


/*********************************************************************
** int mhp_format(session, object_header, filename, tmpdir)
** 		this function takes a message, a probe or a report object and
** 		encodes it into ASN.1.
**	    NOTE: the following no longer applies:
**		A list of temporary files created in this module is stored
**		in "bp_files" in order to unlink them later. These files
**		are created to store bodypart memory string (size less than
** 		specified in MAX_STRLEN) for use by the formatter function, 
**		fP1MTS_APDU().
**
**		This is due to os_free() twice by clrmem and clrbp().
**		Hence, if memory value then create new files (unlinked by clrmem).
**		Otherwise, create a new filename and link to existing: thus
**		one unlinked by clrmem(), the other by delete_object(). KDH
**   
**
** Input:
**     session: current session (will be used for cn/admd/prmd
**              if a trace record must be generated automatically)
**    object: 	pointer to message, probe or report object.
**    filename: name of the file where ASN1-coded message should be 
**              deposited
**	  tmpdir: 	the temp directory for body part files to be created
**				by this function.
** Output:
**		None
** Result:
**		success (OM_SUCCESS) or error
**		file now contains the ASN1 p1 or report PDU.
** Called by:
**		mt_transfer_out()
** Calling:
**		mhp_f_im_ipm()
**		
**
** To Do: memory management: free memory of objects ?
**							 free retix memory if errors?
**		P2 notification, general content.
**		Need to pass on tmp directory for body part as well
**********************************************************************/

int mhp_format(session, object_header, filename, tmpdir)
OM_private_object  session;
OM_int_private_object_header	*object_header;
char *filename;
char *tmpdir;

{
    extern int mhp_f_im_ipm();
    extern int mhp_f_report(); 
    OM_int_descriptor *object;   /* list of attributes in object */
    OM_string *class;
    int status;
    P1MTS_APDU *mpdu;
    int clrmem_flg = 0;
    int pdulen;

    if ((mpdu = (P1MTS_APDU *)os_calloc(sizeof(P1MTS_APDU))) == NULL)
    {
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }

    object = (OM_int_descriptor *)object_header->context.descriptor_list;
    class = (OM_string *) &object[CLASS_POS].attr_value->value.string;

    if (IS_CLASS(class, &MH_C_MESSAGE))
    {
            mpdu->t = MTS_APDU_message;
            status = mhp_f_msg(session, object_header, mpdu);
            if (status != OM_SUCCESS) {
                return(status);
            }
    }
    else if (IS_CLASS(class, &MH_C_PROBE))
    {
            mpdu->t = MTS_APDU_probe;
            mhp_f_probe(session, object_header, mpdu);
    }
    else if (IS_CLASS(class, &MH_C_REPORT))
    {
            mpdu->t = MTS_APDU_report;
            if ((status = mhp_f_report(session, object_header, 
                mpdu)) != OM_SUCCESS)
            {
                return(status);
            }
    }
    else {      /*invalid object error*/
            os_free(mpdu);
            /* os_free(bp_files); */
            log_error(OM_NO_SUCH_CLASS, OMP_DF_NO_SUCH_CLASS, 
                                omp_hexme(*class));
            return(OM_NO_SUCH_CLASS); /* */
    } /**/  

    /* start formatting */
    clrmem_flg |= (FREE_P22 | FREE_BODY_FILES | FREE_BODY_CACHE);
    setdf(filename);
    if (os_setjmp(xenv) == 0) {
        pdulen = (int) fP1MTS_APDU(mpdu);
        if ( enddf() == EOF )
            aaerror(NO_FILE);
        /* assuming p22 is in memory, and body part files to be
         * deleted by calling program */
        clr_mem(mpdu, clrmem_flg); 
        os_free(mpdu);
        if (pdulen == 0){ /* no formatting was done ? */
            log_error(OM_TEMPORARY_ERROR, OMP_DF_TEMPORARY_ERROR, 
                   __FILE__, __LINE__, "ASN1 Formatting Error", asnmsg,
                   "Internal ASN1 Error Code", omp_int2str(asncode));
            return(OM_TEMPORARY_ERROR);
        } /* end if */
        else
            return(OM_SUCCESS);
    }

    else { /* */
        enddf();
        clr_mem(mpdu, clrmem_flg); 
        os_free(mpdu);
        /* don't need clr_bp() with FREE_BODY_FILES flag */
        /* clr_bp(bp_files); */
        /* log errors from formatting (aaerror() in asn1supp.c) */
        log_error( OM_TEMPORARY_ERROR, OMP_DF_TEMPORARY_ERROR, 
                   __FILE__, __LINE__, "ASN1 Formatting Error", asnmsg,
                   "Internal ASN1 Error Code", omp_int2str(asncode));
        return(OM_TEMPORARY_ERROR);
    }
} /* end i_format */



/************************************************************************** 
 *	mhp_f_msg() maps p1  object into data structure, including the 
 *		content (eg p2 content).
 *		Each bodypart is a file, the name which is the same as given in the 
 *		object, if it's there. Else if the body part was in memory in
 *		the object, then a new file is created. The tmp directory is passed
 *		from the caller.
 *
 * 
 *  Input: 
 *		session
 *		object_header
 * 		mpdu
 *	Output:
 *		none
 *  Result:
 *		success (OM_SUCCESS) or errors.
 *		If success the mpdu data structure is filled with data.
 *  added 1988 types - Trang (06/09/92)
 */ 

int mhp_f_msg(session, object_header, mpdu)
OM_private_object  session;
OM_int_private_object_header *object_header;
P1MTS_APDU *mpdu;

{
	extern int mhp_f_im_ipm();
	extern int mhp_f_im_edi();
	P1TraceInformationElement *trace;
	OM_int_descriptor *object;
	OM_int_private_object_header *subobject_header;
	OM_int_descriptor *attr;
	OM_descriptor *omattr;
	OM_uint16 i, value_num;
	OM_int_descriptor *attribute;
	OM_int_value *ivalue;
	OM_value value;
	struct any_type  *evalue;
	OM_string *class;
	int status;
	void *handle, *ptr;
	char *string; 
	OM_uint32 str_len;
	int *content;
    P1ExtensionMacroBody   *extdata;
    aaListType   *ext;
    P1ContentCorrelator  *correlate;
    P1DLExpansionHistory *ehist;
    OM_int_descriptor *criticality_delivery = NULL;
    OM_int_descriptor *criticality_submission = NULL;
    OM_int_descriptor *criticality_transfer = NULL;
char tmp[10];
log_error( (OM_return_code) 0, "**** IN mhp_f_msg() *****" );

	if (!mhp_is84MH)
	save_ct = BUILT_IN_interpersonal_messaging_1988; /* set default */

        else
	save_ct = BUILT_IN_interpersonal_messaging_1984; /* set default */

     
	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
	 	if ((value_num = object[i].count) == 0) continue; 
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;
		
        switch (attribute->attr_type) {
            case MH_T_ALTERNATE_RECIP_ALLOWED:
                if (value.boolean == OM_TRUE) {
                    mpdu->v.message.envelope.m |= 
                        MessageTransferEnvelope_per_message_indicators;
                    mpdu->v.message.envelope.per_message_indicators |= 
                        PER_MESSAGE_INDICATORS_alternate_recipient_allowed;
                }
                break;
            case MH_T_BILATERAL_INFORMATION:
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_per_domain_bilateral_information;
                while (value_num-- > 0) {
                    if (list_alloc(&( mpdu->v.message.envelope.
                            per_domain_bilateral_information),
                            sizeof(P1PerDomainBilateralInformation)) == FALSE)
                    {   
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    handle = (P1PerDomainBilateralInformation *) 
                                mpdu->v.message.envelope.
                                per_domain_bilateral_information.current->data;
                    /* attr points to 0-th descriptor, not -1-th desc */
                    omattr = (OM_descriptor *)value.object.object; 
                    subobject_header =(OM_int_private_object_header *) (--omattr);
                    if ((status = mhp_f_perdomain(subobject_header, handle)) 
                                                                != OM_SUCCESS)
                        return(status);

                    list_append(&mpdu->v.message.envelope.
                                 per_domain_bilateral_information);
                    ivalue = (OM_int_value *) ivalue->next;
                    if (ivalue != NULL)
                        value = ivalue->value;
                }
                break;

            case MH_T_CONTENT_IDENTIFIER:
                str_len = value.string.length;
                string = value.string.elements;
                if (str_len != NULL) { /* no content identifier */
                    mpdu->v.message.envelope.m |= 
                               MessageTransferEnvelope_content_identifier;
                    strncpy(mpdu->v.message.envelope.content_identifier, 
                                                            string,str_len);
                    if (str_len > CONTENT_ID_LEN)
                        mpdu->v.message.envelope.content_identifier[CONTENT_ID_LEN] = '\0';
                    else mpdu->v.message.envelope.content_identifier[str_len] = '\0';
                }
                break;
            case MH_T_CONTENT_TYPE:
            /* REMEMBER to change for 88; integer or object identifier string */
                mpdu->v.message.envelope.m |= MessageTransferEnvelope_content_type;
                mpdu->v.message.envelope.content_type.t = ContentType_built_in;
                switch (value.enumeration) {
                    case MH_CTI_P2_1984:
                        mpdu->v.message.envelope.content_type.v.built_in = 
                            BUILT_IN_interpersonal_messaging_1984;
                        break;
                    case MH_CTI_UNIDENTIFIED:
                        mpdu->v.message.envelope.content_type.v.built_in = 
                            BUILT_IN_unidentified;
                        break;
                    case MH_CTI_P2_1988:
                        mpdu->v.message.envelope.content_type.v.built_in = 
                            BUILT_IN_interpersonal_messaging_1988;
                        break;
                    case 35: /* NIST - fix this ! */
                        mpdu->v.message.envelope.content_type.v.built_in = 
                            BUILT_IN_edi;
                        break;
                    default:
                        mpdu->v.message.envelope.content_type.v.built_in = 
                            value.enumeration;
                        break;
                }
                x4g_type_of_content_to_be_formatted = 
                         mpdu->v.message.envelope.content_type.v.built_in;
                break;
            case MH_T_CONVERSION_PROHIBITED:
                if (value.boolean == OM_TRUE) {
                    mpdu->v.message.envelope.m |= 
                        MessageTransferEnvelope_per_message_indicators;
                    mpdu->v.message.envelope.per_message_indicators |= 
                        PER_MESSAGE_INDICATORS_implicit_conversion_prohibited;
                }
                break;
            case MH_T_EXTERNAL_TRACE_INFO:
                mpdu->v.message.envelope.m |=
                 MessageTransferEnvelope_trace_information;
                while (value_num-- > 0) {
                    /* attr points to 0-th descriptor, not -1-th desc */
                    omattr = (OM_descriptor *)value.object.object; 
                    subobject_header =(OM_int_private_object_header *) (--omattr);
                    if ((status = mhp_f_ext_trace(subobject_header, 
                                &mpdu->v.message.envelope.trace_information)) 
                                != OM_SUCCESS)
                        return (status);
                    ivalue = (OM_int_value *) ivalue->next;
                    if ( ivalue != NULL) /* value if next value present */
                        value = ivalue->value;
                } /* End while external trace info value number */
                break;

            case MH_T_INTERNAL_TRACE_INFO:
/* 
 * InternalTrace is mapped differently, depending on whether it's
 * 1988 X.400 (88 MH package) or 1984 X.400 (84 MH package). If the
 * former, then it's mapped to InternalTrace extension defined in
 * the Blue Book. If the latter, then it's mapped to P1Internal1984.
 * Since there's only one object, some interpretation needs to
 * be done as the two structures are different. See mta software,
 * or OIW/NIST profile.
 * The InternalTrace extension is an element in env.extensions. However
 * itself is a list containing P1InternalTraceInformationElement.
 */

            if (! mhp_is84MH)
            {
                /* first prepare the InternalTrace in env extension */
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                    log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                ext = mpdu->v.message.envelope.extensions.current;
                extdata = (P1ExtensionMacroBody *) ext->data;
                extdata->m |= ExtensionMacroBody_etype;
                extdata->etype = ETYPE_internal_trace_information;
                if ((ptr=os_calloc(sizeof(P1InternalTraceInformation)))
                        == NULL) 
                {
                    log_error(OM_MEMORY_INSUFFICIENT,
                            OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                /* the InternalTrace goes into extension*/
                extdata->extstruct = (char *)ptr;
                
                /* InternalTrace is list, so loop through each value */
                while (value_num-- > 0)
                {   
                    omattr = (OM_descriptor *)value.object.object; 
                    subobject_header =(OM_int_private_object_header*)
                                 (--omattr);
                    if ((status = mhp_f_internal1988
                                (subobject_header, ptr)) 
                                != OM_SUCCESS)
                        return(status);
                    ivalue = ivalue->next; /* next value */
                    if (ivalue != NULL)
                        value = ivalue->value;
                } /* while value_num */
                    
                /* must encode extension in asn1 first */
                evalue = (struct any_type *)encode_envelope_extensions
                         (extdata->extstruct, extdata->etype);
                if (evalue == NULL)
                {
                    log_error(OM_SYSTEM_ERROR, 
                            OMP_DF_SYSTEM_ERROR);
                    return(OM_SYSTEM_ERROR);
                }
                extdata->evalue = (int *)evalue; 
                extdata->refcnt = extdata->refcnt + 1;
                clr_envlext_mem (extdata->extstruct,
                                      extdata->etype);
                extdata->extstruct = NULL;
                extdata->m |= ExtensionMacroBody_evalue;
                list_append(&(mpdu->v.message.envelope.extensions)); 
            } /* isMH88 */

            else /* MH84: use P1Internal1984 */

            {
                mpdu->v.message.envelope.m |=
                 MessageTransferEnvelope_Internal1984;
                while (value_num-- > 0) {
                    /* attr points to 0-th descriptor, not -1-th desc */
                    omattr = (OM_descriptor *)value.object.object; 
                    subobject_header=(OM_int_private_object_header *)(--omattr);
                    if ((status = mhp_f_internal1984(subobject_header, 
                                &mpdu->v.message.envelope.internal1984)) 
                                != OM_SUCCESS)
                        return (status);

                    ivalue = (OM_int_value *) ivalue->next;
                    if (ivalue != NULL) /*value if next value present*/
                        value = ivalue->value;
                } /* End while internal1984 trace info value number */
            } /* else 1984 */
            break;

            case MH_T_MTS_IDENTIFIER:
                mpdu->v.message.envelope.m |=
                                 MessageTransferEnvelope_message_identifier;
                handle = NULL; /* init handle */

                /* attr points to 0-th descriptor, not -1-th desc */
                omattr = (OM_descriptor *)value.object.object; 
                subobject_header =(OM_int_private_object_header *) (--omattr);
                if ((status = mhp_f_mts_id(subobject_header, &handle)) 
                                           != OM_SUCCESS)
                    return(status);
                mpdu->v.message.envelope.message_identifier = (int *)handle;
                break;          
            case MH_T_ORIGINAL_EITS:
                mpdu->v.message.envelope.m |= 
                 MessageTransferEnvelope_original_encoded_information_types;
                handle = NULL; /* init handle */
                /* attr points to 0-th descriptor, not -1-th desc */
                omattr = (OM_descriptor *)value.object.object; 
                subobject_header =(OM_int_private_object_header *) (--omattr);
                if ((status = mhp_f_eits(subobject_header, &handle)) != OM_SUCCESS)
                    return(status);
                mpdu->v.message.envelope.original_encoded_information_types = (int *)handle;
                break;

            case MH_T_ORIGINATOR_NAME:
                mpdu->v.message.envelope.m |=
                 MessageTransferEnvelope_originator_name;
                    /* attr points to 0-th descriptor, not -1-th desc */
                handle = NULL; /* init handle */
                omattr = (OM_descriptor *)value.object.object; 
                subobject_header =(OM_int_private_object_header *) (--omattr);
                if ((status = mhp_f_orname(subobject_header, &handle)) != OM_SUCCESS)
                    return(status);
                mpdu->v.message.envelope.originator_name = (int *)handle;
                break;
            case MH_T_RECIPIENT_DESCRIPTORS:
                mpdu->v.message.envelope.m |=
                               MessageTransferEnvelope_per_recipient_fields;
                while (value_num-- > 0) {
                    if (list_alloc(&(mpdu->v.message.envelope.
                                   per_recipient_fields),
                                   sizeof(P1PerRecipientMessageTransferFields))
                                    == FALSE)
                    {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    handle = (P1PerRecipientMessageTransferFields *) 
                             mpdu->v.message.envelope.
                             per_recipient_fields.current->data;
                    /* attr points to 0-th descriptor, not -1-th desc */
                    omattr = (OM_descriptor *)value.object.object; 
                    subobject_header =(OM_int_private_object_header *) (--omattr);
                    if ((status = mhp_f_recipient(subobject_header, handle)) != OM_SUCCESS)
                        return(status);
                    list_append(&mpdu->v.message.envelope.per_recipient_fields);

                    ivalue = (OM_int_value *) ivalue->next;
                    if ( ivalue != NULL) /* value if next value present */
                        value = ivalue->value;
                    }
                break;  
            case MH_T_CONTENT: /* need to look at concrete subobject */ 
                /* the first att. value of subobject has the object class*/
                /* attr points to 0-th descriptor, not -1-th desc */
                omattr = (OM_descriptor *)value.object.object; 
                subobject_header = (OM_int_private_object_header *) (--omattr);
                class = &(subobject_header->context.descriptor_list[CLASS_POS].
                          attr_value->value.string);

                /* look at value of OM_CLASS type */
                if (IS_CLASS(class, &IM_C_INTERPERSONAL_MSG))
                {
                    if ((status = mhp_f_im_ipm(subobject_header, &content)) 
                                      != OM_SUCCESS)
                        return(status);
                }   
                else if (IS_CLASS(class, &EDI_C_EDIM) || 
			 IS_CLASS(class, &EDI_C_NEGATIVE_NOTIF) ||
			 IS_CLASS(class, &EDI_C_POSITIVE_NOTIF)  ||
			 IS_CLASS(class, &EDI_C_FORWARD_NOTIF) )
                {
log_error( (OM_return_code) 0, "**** Found EDIM/EDIN Class *****" );
/* NIST PM EDI addition */
                    if ((status = mhp_f_edi(subobject_header, &content)) 
                                      != OM_SUCCESS)
                        return(status);
                }
                else if (IS_CLASS(class, &IM_C_NON_RECEIPT_NOTIF))
                {
                    if ((status = mhp_f_im_notif(subobject_header, &content)) 
                                      != OM_SUCCESS)
                        return(status);
                }
                else if (IS_CLASS(class, & IM_C_RECEIPT_NOTIF))
                {
                    if ((status = mhp_f_im_notif(subobject_header, &content)) 
                                      != OM_SUCCESS)
                        return(status);
                 
                } /* content type */

                else if (IS_CLASS(class, &MH_C_GENERAL_CONTENT))
                {
                    if ((status = mhp_f_bcontent(subobject_header, & content))
                                    != OM_SUCCESS)
                        return(status);
                    save_ct = BUILT_IN_unidentified; /* P0 or binary content */
                }

/* 
 * The following is to support Pedi. Peek into the class object
 * identifier to check for the EDI class, and call a single function
 * which format EDIM and different EDI notificiations.
 */
                else if ( (IS_CLASS(class, &EDI_C_EDIM))
                         || (IS_CLASS(class, &EDI_C_FORWARD_NOTIF))
                         || (IS_CLASS(class, &EDI_C_NEGATIVE_NOTIF))
                         || (IS_CLASS(class, &EDI_C_POSITIVE_NOTIF)) )
                {
                    if ((status = mhp_f_edi(subobject_header, &content))
                                    !=OM_SUCCESS)
                        return(status);
                    save_ct = BUILT_IN_edi;
                }

                else 
                {
                    log_error(OM_NO_SUCH_CLASS, OMP_DF_NO_SUCH_CLASS, 
                                omp_hexme(*class));
                    return(OM_NO_SUCH_CLASS);
                }

                mpdu->v.message.content = (int *)content;
                break;
            case MH_T_CONTENT_RETURN_REQUESTED:
                if (value.boolean == OM_TRUE) {
                    mpdu->v.message.envelope.m |= 
                        MessageTransferEnvelope_per_message_indicators;
                    mpdu->v.message.envelope.per_message_indicators |= 
                        PER_MESSAGE_INDICATORS_content_return_request;
                }
                break;
            case MH_T_DEFERRED_DELIVERY_TIME:
                mpdu->v.message.envelope.m |=
                 MessageTransferEnvelope_deferred_delivery_time;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                if ((status = mhp_date_conv(&mpdu->v.message.envelope.
                        deferred_delivery_time, string, str_len))!=OM_SUCCESS){
                    if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
                break;
            case MH_T_DISCLOSURE_ALLOWED:
                if (value.boolean == OM_TRUE) {
                    mpdu->v.message.envelope.m |= 
                        MessageTransferEnvelope_per_message_indicators;
                    mpdu->v.message.envelope.per_message_indicators |= 
                        PER_MESSAGE_INDICATORS_disclosure_of_recipients;
                }
                break;
            case MH_T_PRIORITY:
                mpdu->v.message.envelope.m |= MessageTransferEnvelope_priority;
                if (value.enumeration <= 2) 
                    mpdu->v.message.envelope.priority = 
                        priority = (sint16)value.enumeration;
                else
                    mpdu->v.message.envelope.priority = 
                        priority = PRIORITY_normal; 
                break;

            case MH_T_CONTENT_CORRELATOR:
                if (value.string.length > 0)
                { /* skip if no value */
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                         ext = mpdu->v.message.envelope.extensions.current;
                     extdata = (P1ExtensionMacroBody *) ext->data;
                     if (extdata->extstruct == NULL)
                     {
                       extdata->extstruct =
                     os_calloc(sizeof(P1ContentCorrelator));
                       if (extdata->extstruct == NULL)
                       {
                               log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                               return(OM_MEMORY_INSUFFICIENT);
                       }
  
                     }

                     str_len = value.string.length;
                     string = (char *)value.string.elements;
                     correlate = (P1ContentCorrelator *)
                         extdata->extstruct;
                     correlate->ptr = (octet *) os_calloc (str_len);
                     if ((correlate->ptr) == NULL)
                     {
                               log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                               return(OM_MEMORY_INSUFFICIENT);
                     }
                     extdata->etype = ETYPE_content_correlator;

                     correlate->len = str_len;
                     memcpy(correlate->ptr, string,
                           str_len);
                     evalue = (struct any_type *)encode_envelope_extensions
                           (extdata->extstruct, extdata->etype);
                                     if (evalue == NULL)
                     {
                               log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                               return(OM_SYSTEM_ERROR);
                     }
                                     extdata->evalue = (int *)evalue; 
                                     clr_envlext_mem (extdata->extstruct,
                                      extdata->etype);
                                     extdata->extstruct = NULL;
                     extdata->m |= ExtensionMacroBody_evalue;
                     list_append(&(mpdu->v.message.envelope.extensions)); 
                     } /* skip if no value */
                                break;
            case MH_T_CONVERSION_LOSS_PROHIBITED:
	        if (value.boolean == OM_FALSE)
			break; /* Don't create extension unless we have to */
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                         ext = mpdu->v.message.envelope.extensions.current;
                     extdata = (P1ExtensionMacroBody *) ext->data;
                     if (extdata->extstruct == NULL)
                     {
                       extdata->extstruct =
                     os_calloc(sizeof(P1ConversionWithLossProhibited));
                       if (extdata->extstruct == NULL)
                       {
                               log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                               return(OM_MEMORY_INSUFFICIENT);
                       }
  
                     }
                                     if (value.boolean)
                                     *((P1ConversionWithLossProhibited *)
                     (extdata->extstruct))= value.boolean;
                     else
                     { /* default = OM_FALSE */
                                     *((P1ConversionWithLossProhibited *)
                     (extdata->extstruct))= OM_FALSE;
                     }

                     extdata->etype = ETYPE_conversion_with_loss_prohibited;

                     evalue = (struct any_type *)encode_envelope_extensions
                           (extdata->extstruct, extdata->etype);
                                     if (evalue == NULL)
                     {
                               log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                               return(OM_SYSTEM_ERROR);
                     }
                                     extdata->evalue = (int *)evalue; 
                                     clr_envlext_mem (extdata->extstruct,
                                      extdata->etype);
                                     extdata->extstruct = NULL;
                     extdata->m |= ExtensionMacroBody_evalue;
                     extdata->m |= ExtensionMacroBody_etype;
                     list_append(&(mpdu->v.message.envelope.extensions)); 
                break;

            case MH_T_EXPANSION_HISTORY: 

/* 
 * In the object, this attribute would have 0-512 values.
 * However, in asn1 data structure, it's a single extension
 * in the list. This extension, in turns, contains a data
 * structure (eg P1DLExpansionHistory) which contains an 
 * array of 512 elements, not a list, each points to DLExpansion.
 * So, we have add an extension element in the env.extension list first,
 * then loop through the values, each time call a function to put value
 * into P1DLExpansion, and then add the result into the array.
 * Note that if value_num=0, then we never reach here.
 */

                /* set the env.extension element first */
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                ext = mpdu->v.message.envelope.extensions.current;
                extdata = (P1ExtensionMacroBody *) ext->data;
                extdata->m |= ExtensionMacroBody_etype;
                extdata->etype = ETYPE_dl_expansion_history;
                if ((ehist = (P1DLExpansionHistory *) os_calloc(
                    sizeof(P1DLExpansionHistory))) == NULL)
                {
                    log_error(OM_MEMORY_INSUFFICIENT, 
                        OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                extdata->extstruct = (char *) ehist;

                /* Now, work with each value, Expansion Record */
                ehist->n = 0;/* index for history.v */
                while (value_num-- > 0)
                {
                omattr = (OM_descriptor *)value.object.object; 
                subobject_header =(OM_int_private_object_header *) (--omattr);
                if ((status = mhp_f_exp_record
                                   (subobject_header, &handle)) 
                           != OM_SUCCESS)
                         return(status);
                ehist->v[ehist->n++] = (int *)handle;
                ivalue = ivalue->next;
                if ( ivalue != NULL) /* value if next value present */
                    value = ivalue->value;
                }
            
                /* now format extension content first as 
                ** it requires extension in asn1 before format
                 */
                evalue = (struct any_type *)encode_envelope_extensions
                           (extdata->extstruct, extdata->etype);
                if (evalue == NULL)
                {
                               log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                               return(OM_SYSTEM_ERROR);
                }
                extdata->evalue = (int *)evalue; 
                clr_envlext_mem (extdata->extstruct,
                    extdata->etype);
                extdata->extstruct = NULL;
                extdata->m |= ExtensionMacroBody_evalue;
                list_append(&(mpdu->v.message.envelope.extensions)); 
                break;

            case MH_T_EXPANSION_PROHIBITED:
	        if (value.boolean == OM_FALSE)
			break; /* Don't create extension unless we have to */

                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                         ext = mpdu->v.message.envelope.extensions.current;
                     extdata = (P1ExtensionMacroBody *) ext->data;
                     extdata->extstruct =
                     os_calloc(sizeof(P1DLExpansionProhibited));
                       if (extdata->extstruct == NULL)
                   {
                               log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                               return(OM_MEMORY_INSUFFICIENT);
                   }
  
                               if (value.boolean)
                                    *((P1DLExpansionProhibited *)
                                 (extdata->extstruct))= value.boolean;
                   else
                                        *((P1DLExpansionProhibited *)
                         (extdata->extstruct))= OM_FALSE;

                   extdata->etype = ETYPE_dl_expansion_prohibited;

                   evalue = (struct any_type *)encode_envelope_extensions
                   (extdata->extstruct, extdata->etype);
                               if (evalue == NULL)
                   {
                        log_error(OM_SYSTEM_ERROR, 
                                  OMP_DF_SYSTEM_ERROR);
                            return(OM_SYSTEM_ERROR);
                   }
                               extdata->evalue = (int *)evalue; 
                               clr_envlext_mem (extdata->extstruct,
                                      extdata->etype);
                               extdata->extstruct = NULL;
                   extdata->m |= ExtensionMacroBody_evalue;
                   extdata->m |= ExtensionMacroBody_etype;
                   list_append(&(mpdu->v.message.envelope.extensions)); 
                break;
            case MH_T_ORIGIN_CHECK: 
                if (value_num > 0)
                {
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                         ext = mpdu->v.message.envelope.extensions.current;
                     extdata = (P1ExtensionMacroBody *) ext->data;
                     extdata->m |= ExtensionMacroBody_etype;
                     extdata->etype = ETYPE_message_origin_authentication_check;
                     omattr = (OM_descriptor *)value.object.object; 
                     subobject_header =(OM_int_private_object_header *) (--omattr);
                     if ((status = mhp_f_origin_check
                                   (subobject_header, extdata,
                            value_num)) 
                           != OM_SUCCESS)
                         return(status);

                     extdata->m |= ExtensionMacroBody_evalue;
                     list_append(&(mpdu->v.message.envelope.extensions)); 
                } /* encode if there is value */
                break;
            case MH_T_ORIGINATOR_CERTIFICATE:
                break;
                        case MH_T_REASSIGNMENT_PROHIBITED:
	        if (value.boolean == OM_FALSE)
			break; /* Don't create extension unless we have to */
                mpdu->v.message.envelope.m |=
                    MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                }
                         ext = mpdu->v.message.envelope.extensions.current;
                     extdata = (P1ExtensionMacroBody *) ext->data;
                     if (extdata->extstruct == NULL)
                     {
                       extdata->extstruct =
                     os_calloc(sizeof(P1RecipientReassignmentProhibited));
                       if (extdata->extstruct == NULL)
                       {
                               log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                               return(OM_MEMORY_INSUFFICIENT);
                       }
  
                     }
                                     if (value.boolean)
                                     *((P1RecipientReassignmentProhibited *)
                     (extdata->extstruct))= value.boolean;
                     else
                     { /* default = OM_FALSE */
                                     *((P1RecipientReassignmentProhibited *)
                     (extdata->extstruct))= OM_FALSE;
                     }

                     extdata->etype = ETYPE_recipient_reassignment_prohibited;

                     evalue = (struct any_type *)encode_envelope_extensions
                           (extdata->extstruct, extdata->etype);
                                     if (evalue == NULL)
                     {
                               log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                               return(OM_SYSTEM_ERROR);
                     }
                                     extdata->evalue = (int *)evalue; 
                                     clr_envlext_mem (extdata->extstruct,
                                      extdata->etype);
                                     extdata->extstruct = NULL;
                     extdata->m |= ExtensionMacroBody_evalue;
                     extdata->m |= ExtensionMacroBody_etype;
                     list_append(&(mpdu->v.message.envelope.extensions)); 
                break;
                        case MH_T_SECURITY_LABEL:
                break;
            case MH_T_CONFIDENTIALITY_ALGORITHM:
                break;
            case MH_T_LATEST_DELIVERY_TIME:
                if (value.string.length > 0 )
                {
                mpdu->v.message.envelope.m |=
                        MessageTransferEnvelope_extensions; 
                if (list_alloc(&(mpdu->v.message.
                                envelope.extensions), 
                         sizeof(P1ExtensionMacroBody)) == FALSE)
                {
                    log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                ext = mpdu->v.message.envelope.extensions.current;
                extdata = (P1ExtensionMacroBody *) ext->data;
                if (extdata->extstruct == NULL)
                {
                    extdata->extstruct = 
                              os_calloc(sizeof(P1LatestDeliveryTime));
                     if (extdata->extstruct == NULL)
                     {
                         log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                         return(OM_MEMORY_INSUFFICIENT);
                     }
  
                }

                extdata->etype = ETYPE_latest_delivery_time;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                if ((status = mhp_date_conv(extdata->extstruct,
                        string, str_len)) != OM_SUCCESS){
                    if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                                OMP_DF_WRONG_VALUE_MAKEUP,
                                attribute->attr_type, attribute->attr_syntax,
                                0, value.string.elements);
                    return(status);
                }

                evalue = (struct any_type *)encode_envelope_extensions
                           (extdata->extstruct, extdata->etype);
                if (evalue == NULL)
                {
                    log_error(OM_SYSTEM_ERROR, 
                              OMP_DF_SYSTEM_ERROR);
                    return(OM_SYSTEM_ERROR);
                }
                extdata->evalue = (int *)evalue; 
                clr_envlext_mem (extdata->extstruct, extdata->etype);
                extdata->extstruct = NULL;
                extdata->m |= ExtensionMacroBody_evalue;
                list_append(&(mpdu->v.message.envelope.extensions)); 
                } /* skip if no value */
                break;

            case MH_T_ORIGINATOR_RETURN_ADDRESS:
                break;

/* For the following three Criticality attributes, we will just save them
 * for processing at the end, when we have collected all extensions from
 * the message object into asn1 data structure.
 */
            case MH_T_CRITICAL_FOR_DELIVERY:
                criticality_delivery = attribute;
                break;
            case MH_T_CRITICAL_FOR_SUBMISSION:
                criticality_submission = attribute;
                break;
            case MH_T_CRITICAL_FOR_TRANSFER:
                criticality_transfer = attribute;
                break;
            case MH_T_EXTENSIONS:
                break;

            default:
                break;
        } /* switch attribute types */
	} /* for loop */

/*
 * set default criticality first. For 1984 P1, there's no criticality, 
 * so extensions would be empty, and this part will be skipped.
 * Then add specific criticality from object attributes later,
 * as specified in CRITALITY attributes for extensible objects,
 * by looping through each value of each criticality attribute.
 * Each value is an integer indicating the attribute type.
 */
    if ( (mpdu->v.message.envelope.m &
         MessageTransferEnvelope_extensions)) {
        mhp_set_default_criticality(& mpdu->v.message.envelope.extensions); 

        i = 0; 
		if (criticality_delivery)
        ivalue = criticality_delivery->attr_value;
        while ( (criticality_delivery) && (ivalue) &&
                (i++ < criticality_delivery->count))
        {
             mhp_set_attr_criticality(& mpdu->v.message.envelope.extensions,
                                      ivalue->value.integer, 
                                      CRITICALITY_for_delivery);      
             ivalue = ivalue->next;
             
        }

        i = 0; 
		if (criticality_submission)
        ivalue = criticality_submission->attr_value;
        while ( (criticality_submission) && (ivalue) &&
                (i++ < criticality_submission->count))
        {
             mhp_set_attr_criticality(& mpdu->v.message.envelope.extensions,
                                      ivalue->value.integer, 
                                      CRITICALITY_for_submission);      
             ivalue = ivalue->next;
             
        }

        i = 0; 
		if (criticality_transfer)
        ivalue = criticality_transfer->attr_value;
        while ( (criticality_transfer) && (ivalue) &&
                (i++ < criticality_transfer->count))
        {
             mhp_set_attr_criticality(& mpdu->v.message.envelope.extensions,
                                      ivalue->value.integer, 
                                      CRITICALITY_for_transfer);      
             ivalue = ivalue->next;
             
        }
    } /* criticality for extension */

/*
 * If no external trace record is present then add one based on the global
 * information about who we are.  Normally API users should always create
 * an external trace record, this is for those who don't.
 */
	if (!(mpdu->v.message.envelope.m &
		MessageTransferEnvelope_trace_information)) {
		mpdu->v.message.envelope.m |=
			MessageTransferEnvelope_trace_information;
		if (list_alloc(&(mpdu->v.message.envelope.trace_information), 
			sizeof(P1TraceInformationElement)) == FALSE) {
			log_error(OM_MEMORY_INSUFFICIENT, 
				OMP_DF_MEMORY_INSUFFICIENT);
			return(OM_MEMORY_INSUFFICIENT);
		}				
		omattr = (OM_descriptor *)session;
		subobject_header =(OM_int_private_object_header *)(--omattr);
		object = (OM_int_descriptor *)subobject_header->context.
			descriptor_list;

		trace = (P1TraceInformationElement *)(mpdu->v.message.
			envelope.trace_information.current->data);

		trace->m |= TraceInformationElement_global_domain_identifier;
		trace->global_domain_identifier.m |=
			GlobalDomainIdentifier_country_name;

		str_len = object[3].attr_value->value.string.length;
		string = (char *)(object[3].attr_value->value.string.elements);
		mhp_f_country(trace->global_domain_identifier.country_name,
			string, str_len);

		trace->global_domain_identifier.m |=
			GlobalDomainIdentifier_administration_domain_name;

		str_len = object[2].attr_value->value.string.length;
		string = (char *)(object[2].attr_value->value.string.elements);
		mhp_f_admdcpy(trace->global_domain_identifier.
			administration_domain_name, string, str_len);

		str_len = object[5].attr_value->value.string.length;
		string = (char *)(object[5].attr_value->value.string.elements);
		if (str_len > 0) {
			trace->global_domain_identifier.m |=
			GlobalDomainIdentifier_private_domain_identifier;
			mhp_f_prmdcpy(trace->global_domain_identifier.
				private_domain_identifier, string, str_len);
		}

		trace->m |= TraceInformationElement_domain_supplied_information;
		trace->domain_supplied_information.m |=
				DomainSuppliedInformation_routing_action;
		trace->domain_supplied_information.routing_action = 
			ROUTING_ACTION_relayed;
		trace->domain_supplied_information.m |= 
			DomainSuppliedInformation_arrival_time;
		os_currenttime(&trace->domain_supplied_information.arrival_time);
		list_append(&(mpdu->v.message.envelope.trace_information)); 
	}
	return(OM_SUCCESS);
} /* mhp_f_msg() */


int mhp_f_probe(session, object_header, mpdu)
OM_private_object  session;
OM_int_private_object_header *object_header;
P1MTS_APDU *mpdu;

{

	log_error(OM_NO_SUCH_CLASS, OMP_DF_NO_SUCH_CLASS, 
		omp_hexme(object_header->context.descriptor_list[1].
					attr_value->value.string));
	return(OM_NO_SUCH_CLASS);
}




/* create MTS Message Id and return its handle */
int mhp_f_mts_id(object_header, ret_handle)
OM_int_private_object_header *object_header;
P1MTSIdentifier **ret_handle;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_value ivalue;
	OM_value value;
	OM_uint16 value_num;
	int i, status;
	char *string;
	OM_uint32 str_len; 
	P1MTSIdentifier *mptr;

	if ((mptr = (P1MTSIdentifier *)os_calloc(sizeof(P1MTSIdentifier))) == NULL)
	{	
		log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		return(OM_MEMORY_INSUFFICIENT);
	}

	mptr->m |= MTSIdentifier_global_domain_identifier; /* must be there? */
	object = (OM_int_descriptor *)object_header->context.descriptor_list;

	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
	 	if ((value_num = object[i].count) == 0) continue ; 
		attribute = (OM_int_descriptor *) & object[i];
		value = attribute->attr_value->value;
		switch (attribute->attr_type) {
			case MH_T_ADMD_NAME:
				mptr->global_domain_identifier.m |=
					GlobalDomainIdentifier_administration_domain_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_admdcpy(
					mptr->global_domain_identifier.administration_domain_name,
					string,
					str_len);
				break;
			case MH_T_COUNTRY_NAME:
				mptr->global_domain_identifier.m |=
					GlobalDomainIdentifier_country_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_country(
					mptr->global_domain_identifier.country_name,
					string,
					str_len);
				break;
			case MH_T_LOCAL_IDENTIFIER:
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if (str_len) {   
					mptr->m = MTSIdentifier_local_identifier;
					xstrncpy(mptr->local_identifier, string, str_len);
				}
				break;
			case MH_T_PRMD_IDENTIFIER:
				mptr->global_domain_identifier.m |=
					GlobalDomainIdentifier_private_domain_identifier;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_prmdcpy(
					mptr->global_domain_identifier.private_domain_identifier,
					string,
					str_len);
				break;
			default:
				log_error(OM_NO_SUCH_TYPE, OMP_DF_NO_SUCH_TYPE, 
					attribute->attr_type, 
					omp_hexme(object[CLASS_POS].attr_value->value.string));
				return(OM_NO_SUCH_TYPE);
		}
	}

	*ret_handle = mptr;
	return(OM_SUCCESS);
}





/* mhp_f_eits(object_header, handle) puts EITS object into data 
 * structure, and returns handle to the structure.
 * Input: 
 *			object - pointer to object
 *          handle - address of pointer variable to the data structure
 * Output:
 *		    handle - contains the address of the EITS data structure
 */

int mhp_f_eits(object_header, handle)
OM_int_private_object_header *object_header;
P1EncodedInformationTypes **handle;
{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_private_object_header *subobject_header;
	OM_descriptor *omattr;
	OM_int_value *ivalue;
	OM_value value;
	OM_uint16 value_num;
	P1EncodedInformationTypes *p1eit;
	P1PresentationCapabilities *g4ptr;
	P1ExternalEncodedInformationTypes *external_eits;
	P1ExternalEncodedInformationType *ext_element;
	octet *buffer;
	int i, status; 

	if ((p1eit = (P1EncodedInformationTypes *)os_calloc(sizeof(P1EncodedInformationTypes))) == NULL) {
		log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		return(OM_MEMORY_INSUFFICIENT);
	}
	p1eit->m = 0;   /* init mask just in case */

	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
	 	if ((value_num = object[i].count) == 0) continue; 
		attribute = (OM_int_descriptor *)&object[i];
		ivalue = attribute->attr_value;
		value = ivalue->value;
		switch (attribute->attr_type) 
		{
			case MH_T_BUILTIN_EITS: /* built_in eit bit string */
				p1eit->m |= EncodedInformationTypes_built_in_encoded_information_types;
				p1eit->built_in_encoded_information_types = 0; /* init bit string */
				while (value_num-- > 0) {
					switch (value.enumeration) {
						case MH_BE_UNDEFINED:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_undefined ;
							break;
						case MH_BE_TELEX:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_telex; 
							break;
						case MH_BE_IA5_TEXT:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_ia5_text ;
							break;
						case MH_BE_G3_FAX:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_g3_facsimile ;
							break;
						case MH_BE_G4_CLASS1:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_g4_class_1;
							break;
						case MH_BE_TELETEX:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_teletex ;
							break;
						case MH_BE_VIDEOTEX:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_videotex ;
							break;
						case MH_BE_MIXED_MODE:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_mixed_mode ;
							break;
						case MH_BE_ISO_6937_TEXT:
							p1eit->built_in_encoded_information_types |=
							 BUILT_IN_ENCODED_INFORMATION_TYPES_iSO6937 ;
							break;
						default:
							log_error(OM_WRONG_VALUE_MAKEUP, 
									  OMP_DF_WRONG_VALUE_MAKEUP,
									  attribute->attr_type,
									  attribute->attr_syntax,
									  value.enumeration, 0);
							return(OM_WRONG_VALUE_MAKEUP);
							/*
							*/
							;
					} /* switch value.enumeration for built-in EITs */
				
					/* get next value of the attribute */
					ivalue = (OM_int_value *) ivalue->next;
					if (ivalue != NULL)
						value = ivalue->value;
				} /* while for built-in EITs */
				break;

			case MH_T_EXTERNAL_EITS:
				p1eit->m |= EncodedInformationTypes_external_encoded_information_types;
				if ((external_eits = (P1ExternalEncodedInformationTypes *)
						os_calloc(sizeof(P1ExternalEncodedInformationTypes))) 
						== NULL) {
					log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
					return(OM_MEMORY_INSUFFICIENT);
				}
				while (value_num-- > 0) {
					if ((list_alloc(external_eits, 
								sizeof(P1ExternalEncodedInformationType)))
								== FALSE) {
						log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
						return(OM_MEMORY_INSUFFICIENT);
					}
					ext_element = (P1ExternalEncodedInformationType *)
											external_eits->current->data;		
					mhp_getobj (value.string, MAX_OBJ_ID, ext_element);
					list_append(external_eits);
						/* get next value */
					ivalue = (OM_int_value *) ivalue->next;
					if (ivalue != NULL)
						value = ivalue->value;
				} /* while for external eits */
				p1eit->external_encoded_information_types=(int *)external_eits;
				break;

			case MH_T_G3_FAX_NBPS: /* G3 Fax Non Basic Parameters structure */
				p1eit->m |= EncodedInformationTypes_g3_facsimile;
					/* attr points to 0-th descriptor, not -1-th desc */
				omattr = (OM_descriptor *)value.object.object; 
				subobject_header =(OM_int_private_object_header *) (--omattr);
				if ((status = mhp_f_g3_fax_nbps(subobject_header, 
										p1eit->g3_facsimile)) != OM_SUCCESS)
					return(status);
				break;
			case MH_T_G4_FAX_NBPS:
				/* not supported. There is an error with new p1p2.c
				p1eit->m |= EncodedInformationTypes_g4_class_1_and_mixed_mode;
					/* ????length???? this is (int *), any_type? 
				if ((g4ptr = (P1PresentationCapabilities *) 
								os_calloc(sizeof(P1PresentationCapabilities))) 
																	== NULL){
					log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
					return(OM_MEMORY_INSUFFICIENT);
				}
				g4ptr->len = value.string.length; 
				if ((buffer = (octet *)os_calloc(sizeof(g4ptr->len))) == NULL){
					log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
					return(OM_MEMORY_INSUFFICIENT);
				}
				memcpy(buffer, value.string.elements, g4ptr->len);
				g4ptr->ptr = buffer;
				p1eit->g4_class_1_and_mixed_mode = (int *)g4ptr; 

				*/
				break;


			case MH_T_TELETEX_NBPS:
				p1eit->m |= EncodedInformationTypes_teletex;
					/* attr points to 0-th descriptor, not -1-th desc */
				omattr = (OM_descriptor *)value.object.object; 
				subobject_header =(OM_int_private_object_header *) (--omattr);
				if ((status = mhp_f_teletex_nbps(subobject_header, 
											&p1eit->teletex)) != OM_SUCCESS) 
					return(status);
				break;

		} /* end switch of attribute type */
	} /* end for */
	*handle = p1eit;
	return(OM_SUCCESS);
} /* mhp_f_eits() */



/* mhp_f_g3_fax_nbps(object_header, nbps)
 *   Object object;
 *   bool g3_facsimile[31];
 * puts G3_Fax_NBPs object into retix structure that is an array of
 * boolean values. nbps is the address to the structure to which to put
 * these NPBs values.
 */

int mhp_f_g3_fax_nbps(object_header, nbps)
OM_int_private_object_header *object_header;
bool *nbps;
{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_value value;
	OM_uint16 value_num;
	int i, status;


	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
	 	if ((value_num = object[i].count) == 0) continue; 
		attribute = (OM_int_descriptor *)&object[i];
		value = attribute->attr_value->value;
		switch(attribute->attr_type) 
		{
			case MH_T_A3_WIDTH:
				nbps[G3_FACSIMILE_a3_width] = value.boolean;
				break;
			case MH_T_B4_LENGTH:
				nbps[G3_FACSIMILE_b4_length] = value.boolean;
				break;
			case MH_T_B4_WIDTH:
				nbps[G3_FACSIMILE_b4_width] = value.boolean;
				break;
			case MH_T_FINE_RESOLUTION:
				nbps[G3_FACSIMILE_fine_resolution] = value.boolean;
				break;
			case MH_T_TWO_DIMENSIONAL:
				nbps[G3_FACSIMILE_two_dimensional] = value.boolean;
				break;
			case MH_T_UNCOMPRESSED:
				nbps[G3_FACSIMILE_uncompressed] = value.boolean;
				break;
			case MH_T_UNLIMITED_LENGTH:
				nbps[G3_FACSIMILE_unlimited_length] = value.boolean;
				break;
		} /* switch attribute type */
	} /* for loop */
	return(OM_SUCCESS);
} /* mhp_f_g3_fax_nbps() */



/* mhp_f_teletex_nbps() puts Teletex NBPS object into
 * P1TeletexNonBasicParameters data structure.
 * Input:
 *			object - Teletex NBPS.
 *			nbps - address of the Teletex nbps structure.
 * Output:
 *			pointer to structure in ret_handle.
 *
 */


int mhp_f_teletex_nbps(object_header, nbps)
OM_int_private_object_header *object_header;
P1TeletexNonBasicParameters *nbps;
{
	return(0);
}




/* 
 * mhp_f_recipient() puts a recipient descriptor object (MESSAGE RD class) 
 * into the P1PerRecipientMessageTransferFields. 
 */

int mhp_f_recipient(object_header, recipinfo)
OM_int_private_object_header *object_header;
P1PerRecipientMessageTransferFields *recipinfo;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_value value;
    OM_uint16 value_num;
    int i, status;
    void *handle;
    aaListType   *ext;
    P1ExtensionMacroBody   *extdata;
    struct any_type  *evalue;
    P1RequestedDeliveryMethod   *edelm;
    OM_int_value *ivalue;
    OM_boolean bureau_fax=0;
    OM_enumeration postal_mode=0;

    recipinfo->m = 0;

    object = (OM_int_descriptor *)object_header->context.descriptor_list;
    for (i=TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
    {
        if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        value_num = object[i].count;
        ivalue = attribute->attr_value;
        value = attribute->attr_value->value;
/*
 * MESSAGE RD object takes attributes in Message RD class, as well as
 * its superclasses: Submitted Message RD, Submitted Probe RD, and RD.
 */
        switch (attribute->attr_type) {

        case MH_T_ALTERNATE_RECIPIENT_NAME:  /* Submitted Probe RD */
       
            /* this is an 1988 extension. The extension is an (int *) to an 
            ** P1ORName struct: that is, current->data in the aaList struct 
            ** points to a pointer to an ORName (double indirection).
            */
            recipinfo->m |= PerRecipientMessageTransferFields_extensions;
            if (list_alloc(&(recipinfo->extensions),
                         sizeof(P1ExtensionMacroBody)) == FALSE)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            ext = recipinfo->extensions.current;
            extdata = (P1ExtensionMacroBody *) ext->data;
            extdata->m |= ExtensionMacroBody_etype;
            extdata->etype = ETYPE_originator_requested_alternate_recipient;
            extdata->extstruct = handle =
                   os_calloc(sizeof(P1OriginatorRequestedAlternateRecipient));
            if (extdata->extstruct == NULL)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }

            /* let's fill in the P1ORName first */
            omattr = (OM_descriptor *)value.object.object; 
            subobject_header =(OM_int_private_object_header *) (--omattr);
            if ((status = mhp_f_orname(subobject_header, handle))!=OM_SUCCESS)
                return(status);
      
            /* handle was a pointer to an int. mhp_f_orname() returns a 
             * pointer to P1ORName in the integer (ie int value is actually
             * a pointer, and extdata->extstruct has the handle that points 
             * to ORName.
             */
            evalue = (struct any_type *) encode_envelope_extensions
                                      (extdata->extstruct, extdata->etype);
            if (evalue == NULL)
            {
                 log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
                 return(OM_SYSTEM_ERROR);
            }
            extdata->evalue = (int *)evalue; 
            clr_envlext_mem (extdata->extstruct, extdata->etype);
            extdata->extstruct = NULL;
            extdata->m |= ExtensionMacroBody_evalue;
            list_append(&(recipinfo->extensions)); 
            break;

        case MH_T_EXPLICIT_CONVERSION: /* can also be used in case of Probe */
            if (value.enumeration == MH_EC_NO_CONVERSION) break; 
                                    /* no conversion */
            recipinfo->m |= PerRecipientMessageTransferFields_explicit_conversion;
            recipinfo->explicit_conversion = (sint16)value.enumeration;
            break;
        case MH_T_MTA_REPORT_REQUEST:
            recipinfo->m |= PerRecipientMessageTransferFields_per_recipient_indicators;

            switch (value.enumeration) {
                case MH_RQ_NON_DELIVERY:
                    recipinfo->per_recipient_indicators |= 
                        PER_RECIPIENT_INDICATORS_originating_MTA_non_delivery_report;
                    break;
                case MH_RQ_ALWAYS:
                    recipinfo->per_recipient_indicators |=
                        PER_RECIPIENT_INDICATORS_originating_MTA_report;
                    break;
                case MH_RQ_ALWAYS_AUDITED: /* both bits are set for audited */
                    recipinfo->per_recipient_indicators |=
                        PER_RECIPIENT_INDICATORS_originating_MTA_report;
                    recipinfo->per_recipient_indicators |=
                        PER_RECIPIENT_INDICATORS_originating_MTA_non_delivery_report;
                    break;
            } /* end switching value.enumeration of MTAReportRequest */
            break;
        case MH_T_MTA_RESPONSIBILITY:
            recipinfo->m |= PerRecipientMessageTransferFields_per_recipient_indicators;
            if (value.boolean == OM_TRUE)
                recipinfo->per_recipient_indicators |= 
                    PER_RECIPIENT_INDICATORS_responsibility;
            break;
        case MH_T_ORIGINATOR_REPORT_REQUEST:
            recipinfo->m |= PerRecipientMessageTransferFields_per_recipient_indicators;
            switch (value.enumeration) {
                case MH_RQ_NON_DELIVERY:
                    recipinfo->per_recipient_indicators |= 
                    PER_RECIPIENT_INDICATORS_originator_non_delivery_report;
                    break;
                case MH_RQ_ALWAYS:
                    recipinfo->per_recipient_indicators |= 
                     PER_RECIPIENT_INDICATORS_originator_report; 
                    break;
                /* case MH_RQ_NEVER: just zeros */
            }
            break;
        case MH_T_RECIPIENT_NAME:
            recipinfo->m |= PerRecipientMessageTransferFields_recipient_name;
                /* attr points to 0-th descriptor, not -1-th desc */
            omattr = (OM_descriptor *)value.object.object; 
            subobject_header =(OM_int_private_object_header *) (--omattr);
            if ((status = mhp_f_orname(subobject_header, &handle)) != OM_SUCCESS)
                return(status);
            recipinfo->recipient_name = (int *)handle;
            /*handle->refcnt = 1;*/
            break;

        case MH_T_RECIPIENT_NUMBER: 
            recipinfo->m |= PerRecipientMessageTransferFields_originally_specified_recipient_number;
            recipinfo->originally_specified_recipient_number = 
                       (sint16)value.integer;
            break;

        case MH_T_PREFERRED_DELIVERY_MODES:
        {    
        int i=0;    /* local variable. Don't be confused with 
                       i in the for loop */
        if (value_num <= 0)
            break;

        if ( ( value_num == 1 ) && (value.enumeration == MH_DM_ANY) )
            break; /* Don't create extension unless we have to */

        recipinfo->m |= PerRecipientMessageTransferFields_extensions;
        if (list_alloc(&(recipinfo->extensions),
                     sizeof(P1ExtensionMacroBody)) == FALSE)
        {
                 log_error(OM_MEMORY_INSUFFICIENT, 
                       OMP_DF_MEMORY_INSUFFICIENT);
                 return(OM_MEMORY_INSUFFICIENT);
        }
        ext = recipinfo->extensions.current;
        extdata = (P1ExtensionMacroBody *) ext->data;
        if (extdata->extstruct == NULL)
        {
            extdata->extstruct =
               os_calloc(sizeof(P1RequestedDeliveryMethod));
            if (extdata->extstruct == NULL)
            {
                    log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
            }
        }
        extdata->etype = ETYPE_requested_delivery_method;
  
        edelm = (P1RequestedDeliveryMethod *)extdata->extstruct;
        edelm->n = 0;
        while (value_num -- > 0)
        {
           edelm->v[i] = value.enumeration;
           switch(value.enumeration)
           {
            case MH_DM_ANY:
            case MH_DM_MTS:
            case MH_DM_PDS:
            case MH_DM_TELEX:
            case MH_DM_TELETEX:
            case MH_DM_G3_FAX:
            case MH_DM_G4_FAX:
            case MH_DM_IA5_TERMINAL:
            case MH_DM_VIDEOTEX:
            case MH_DM_TELEPHONE:
                break;
            default:
                edelm->v[i] = MH_DM_ANY;
                break;
            } /* end switch */
                        i = i + 1;
            if ( i > 16 ) 
            {
                    log_error(OM_TOO_MANY_VALUES, 
                           OMP_DF_TOO_MANY_VALUES);
                        return(OM_TOO_MANY_VALUES);
            }
            ivalue = (OM_int_value *) ivalue->next;
            if (ivalue != NULL) /*value if next value present*/
                value = ivalue->value;
        } /* end while */
        if (i > 0 )
        {
            edelm->n = i;
            evalue = (struct any_type *) encode_envelope_extensions
                                  (extdata->extstruct, extdata->etype);
            if (evalue == NULL)
            {
                log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
                return(OM_SYSTEM_ERROR);
            }
            extdata->evalue = (int *)evalue; 
            clr_envlext_mem (extdata->extstruct, extdata->etype);
            extdata->extstruct = NULL;
            extdata->m |= ExtensionMacroBody_etype;
            extdata->m |= ExtensionMacroBody_evalue;
            list_append(&(recipinfo->extensions)); 
         } /* end if */
        } /* case MH_T_PREFERRED_DELIVERY_MODES */
        break;

        case MH_T_BUREAU_FAX_DELIVERY:  /* Submitted Message RD */
            /* 
             * this is the 7-th bit in Physical Delivery Modes which
             * can be set together with mutual exclusive bits 0-6. 
             * See p346, X.411. Bits 0-6 of Physical Delivery Modes
             * are in XMHP Postal Mode attribute. Hence, must save
             * value until the end to process together with Postal Mode.
             * Also suppress default value not to generate extensions.
             */ 
            bureau_fax = value.boolean;
            break;

        case MH_T_FORWARDING_ADDR_REQUESTED:   /* submitted msg rd */
            if (value.boolean == OM_FALSE) 
               break;  /* don't send extensions if default */ 

            recipinfo->m |= PerRecipientMessageTransferFields_extensions;
            if (list_alloc(&(recipinfo->extensions),
                         sizeof(P1ExtensionMacroBody)) == FALSE)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            ext = recipinfo->extensions.current;
            extdata = (P1ExtensionMacroBody *) ext->data;
            extdata->m |= ExtensionMacroBody_etype;
            extdata->etype = ETYPE_physical_forwarding_address_request;
            extdata->extstruct = handle =
                   os_calloc(sizeof(P1PhysicalForwardingAddressRequest));
            if (extdata->extstruct == NULL)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }

            /* set the boolean value. Note p1p2.h has the value reversed:
             * from the X.411 p346: requested = 0, instead of 1. So
             * hardcode for now.
             */
            *(P1PhysicalForwardingAddressRequest *)extdata->extstruct = 1;

            evalue = (struct any_type *) encode_envelope_extensions
                                      (extdata->extstruct, extdata->etype);
            if (evalue == NULL)
            {
                 log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
                 return(OM_SYSTEM_ERROR);
            }
            extdata->evalue = (int *)evalue; 
            clr_envlext_mem (extdata->extstruct, extdata->etype);
            extdata->extstruct = NULL;
            extdata->m |= ExtensionMacroBody_evalue;
            list_append(&(recipinfo->extensions)); 
            break;

        case MH_T_FORWARDING_PROHIBITED:
            if (value.boolean == OM_FALSE) break;
            recipinfo->m |= PerRecipientMessageTransferFields_extensions;
            if (list_alloc(&(recipinfo->extensions),
                         sizeof(P1ExtensionMacroBody)) == FALSE)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            ext = recipinfo->extensions.current;
            extdata = (P1ExtensionMacroBody *) ext->data;
            extdata->m |= ExtensionMacroBody_etype;
            extdata->etype = ETYPE_physical_forwarding_prohibited;
            extdata->extstruct = handle =
                   os_calloc(sizeof(P1PhysicalForwardingProhibited));
            if (extdata->extstruct == NULL)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }

            *(P1PhysicalForwardingProhibited *)extdata->extstruct =
               PHYSICALFORWARDINGPROHIBITED_physical_forwarding_prohibited;

            evalue = (struct any_type *) encode_envelope_extensions
                                      (extdata->extstruct, extdata->etype);
            if (evalue == NULL)
            {
                 log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
                 return(OM_SYSTEM_ERROR);
            }
            extdata->evalue = (int *)evalue; 
            clr_envlext_mem (extdata->extstruct, extdata->etype);
            extdata->extstruct = NULL;
            extdata->m |= ExtensionMacroBody_evalue;
            list_append(&(recipinfo->extensions)); 
            break;

        case MH_T_POSTAL_MODE:  /* Submitted Message RD. See note Bureau Fax */
            postal_mode = value.enumeration;
            break;
            
        case MH_T_PROOF_OF_DELIV_REQUESTED: /* submitted msg rd */
            if (value.boolean == OM_FALSE) break; 
            recipinfo->m |= PerRecipientMessageTransferFields_extensions;
            if (list_alloc(&(recipinfo->extensions),
                         sizeof(P1ExtensionMacroBody)) == FALSE)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            ext = recipinfo->extensions.current;
            extdata = (P1ExtensionMacroBody *) ext->data;
            extdata->m |= ExtensionMacroBody_etype;
            extdata->etype = ETYPE_proof_of_delivery_request;
            extdata->extstruct = os_calloc(sizeof(P1ProofOfDeliveryRequest));
            if (extdata->extstruct == NULL)
            {
                log_error(OM_MEMORY_INSUFFICIENT, 
                             OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }

            *(P1ProofOfDeliveryRequest *)extdata->extstruct = 
                    PROOFOFDELIVERYREQUEST_proof_of_delivery_requested;
            evalue = (struct any_type *) encode_envelope_extensions
                                      (extdata->extstruct, extdata->etype);
            if (evalue == NULL)
            {
                 log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
                 return(OM_SYSTEM_ERROR);
            }
            extdata->evalue = (int *)evalue; 
            clr_envlext_mem (extdata->extstruct, extdata->etype);
            extdata->extstruct = NULL;
            extdata->m |= ExtensionMacroBody_evalue;
            list_append(&(recipinfo->extensions)); 
            break;

        } /* end switch attribute types */
    } /* for loops for attributes in object */


    /* process two attributes that share the same bit string, Physical 
     * Delivery Modes: Bureau Fax and Postal Mode.
     */
    if ( ! ((bureau_fax == OM_FALSE) && (!postal_mode))) 
    { /* there's extension */
        recipinfo->m |= PerRecipientMessageTransferFields_extensions;
        if (list_alloc(&(recipinfo->extensions),
                     sizeof(P1ExtensionMacroBody)) == FALSE)
        {
            log_error(OM_MEMORY_INSUFFICIENT, 
                       OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
        ext = recipinfo->extensions.current;
        extdata = (P1ExtensionMacroBody *) ext->data;
        extdata->m |= ExtensionMacroBody_etype;
        extdata->etype = ETYPE_physical_delivery_modes;
        extdata->extstruct = os_calloc(sizeof(P1PhysicalDeliveryModes));
        if (extdata->extstruct == NULL)
        {
            log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }

        switch (postal_mode){   /* bits 0-6 are mutually exclusive */
        case MH_PM_ORDINARY_MAIL:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                 PHYSICALDELIVERYMODES_ordinary_mail;
            break;
        case MH_PM_SPECIAL_DELIVERY:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                 PHYSICALDELIVERYMODES_special_delivery;
            break;
        case MH_PM_EXPRESS_MAIL:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                 PHYSICALDELIVERYMODES_express_mail;
            break;
        case MH_PM_CC:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                 PHYSICALDELIVERYMODES_counter_collection;
            break;
        case MH_PM_CC_WITH_TELEPHONE_ADVICE:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
            PHYSICALDELIVERYMODES_counter_collection_with_telephone_advice;
            break;
        case MH_PM_CC_WITH_TELEX_ADVICE:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                 PHYSICALDELIVERYMODES_counter_collection_with_telex_advice;
            break;
        case MH_PM_CC_WITH_TELETEX_ADVICE:
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
            PHYSICALDELIVERYMODES_counter_collection_with_teletext_advice;
            break;
        }
        if (bureau_fax)  /* bit 7 can be used with bits 0-6 */
            * (P1PhysicalDeliveryModes *)extdata->extstruct |= 
                    PHYSICALDELIVERYMODES_bureau_fax_delivery;

        evalue = (struct any_type *) encode_envelope_extensions
                                  (extdata->extstruct, extdata->etype);
        if (evalue == NULL)
        {
             log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR);
             return(OM_SYSTEM_ERROR);
        }
        extdata->evalue = (int *)evalue; 
        clr_envlext_mem (extdata->extstruct, extdata->etype);
        extdata->extstruct = NULL;
        extdata->m |= ExtensionMacroBody_evalue;
        list_append(&(recipinfo->extensions)); 
    } /* if there's extension for postal mode */
    
    return(OM_SUCCESS);
} /* end mhp_f_recipient() */



/* mhp_f_perdomain(object_header, bilatinfo)
 *
 */

int mhp_f_perdomain(object_header, bilatinfo)
OM_int_private_object_header *object_header;
P1PerDomainBilateralInformation *bilatinfo;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_value *ivalue;
	OM_value value;
	OM_uint16 value_num;
	int i, status;
	void *string, *buffer;
	OM_uint32 str_len;

	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i=TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
										/* this should never happens */
		if (object[i].count == 0) continue; 
		attribute = (OM_int_descriptor *)&object[i];
		ivalue =  attribute->attr_value;
		value = ivalue->value;

		switch (attribute->attr_type) {
			case MH_T_ADMD_NAME:
				str_len = value.string.length;
				string = (char *)value.string.elements; 
				bilatinfo->m |= PerDomainBilateralInformation_choice;
				bilatinfo->choice.t = PerDomainBilateralInformation_administration_domain_name;
				mhp_f_admdcpy(&bilatinfo->choice.v.administration_domain_name,
							string,
							str_len);
				break;
			case MH_T_COUNTRY_NAME:
				str_len = value.string.length;
				string = (char *)value.string.elements;
				bilatinfo->m |= PerDomainBilateralInformation_country_name;
		  		mhp_f_country(&bilatinfo->country_name, string, str_len);
				break;
			case MH_T_INFORMATION:
				str_len = value.string.length; 
				string = (octet *)value.string.elements;
				if ((buffer = (octet *)os_calloc(sizeof(str_len * sizeof(octet)))) == NULL){
					log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
					return(OM_MEMORY_INSUFFICIENT);
				}
				memcpy(buffer, string, str_len);
				bilatinfo->m = PerDomainBilateralInformation_bilateral_information;
				bilatinfo->bilateral_information.len = str_len;
				bilatinfo->bilateral_information.ptr = buffer;
				break;
		} /* switch attribute->attr_type */

	}  /*end for */
	
	return(OM_SUCCESS);

} /* mhp_f_perdomain


^L


/* mhp_f_admdcpy(tagptr, tag, to, from, len)  copies numeric or 
 * printable string in ADMD/PRMD into data structures.
 *
 * Input: 
 * 		to, from, len
 * Output:
 *		None.
 * Result:
 *      the values pointed by from is copied appropriately in "to".
 *
 * Called by:
 *		mhp_f_perdomain()
 * 		mhp_f_mts_id()
 *
 * Calling:
 *		sl_isdigit() in osdeps.h
 *
 * NOTE: need to fix sl_isdigit to look for the whole string instead
 *       of just the first character.
 *
 */ 

int mhp_f_admdcpy(to, from, len)
P1AdministrationDomainName *to;
char *from;
OM_uint32 len;

{

/* But per NIST
   agreements, numeric can also appear in printable as well
   and it's equivalent.
*/

	to->t = AdministrationDomainName_printable;
	strncpy(to->v.printable, from, len);
	to->v.printable[len] = '\0';
	
	return(OM_SUCCESS);
}


/* mhp_f_prmdcpy(tagptr, tag, to, from, len)  copies numeric or 
 * printable string in PRMD Identifier into P1PrivateIdentifier 
 * structure for use in P1GlobalDomainIdentifier. Note that
 * P1PrivateDomainName structure is the same, so this funciton
 * can also be used for ORName.
 *
 * Input: 
 * 		to, from, len
 * Output:
 *		None.
 * Result:
 *      the values pointed by from is copied appropriately in "to".
 *
 * Called by:
 *		mhp_f_perdomain()
 *		mhp_f_mts_id()
 *
 * Calling:
 *		sl_isdigit() in osdeps.h
 *
 */ 

int mhp_f_prmdcpy(to, from, len)
P1PrivateDomainIdentifier *to;
char *from;
OM_uint32 len;

{
/* This statement checks for only the first digit, and
   is not correct, as we might have "1prmd". But per NIST
   agreements, numeric can also appear in printable as well
   and it's equivalent.

	if (sl_isdigit(*from))
	{
		to->t = PrivateDomainName_numeric;
		strncpy(to->v.numeric, from, len);
		to->v.numeric[len] = '\0';
	} 
	else { 
*/
		to->t = PrivateDomainName_printable;
		strncpy(to->v.printable, from, len);
		to->v.printable[len] = '\0';
	/* } */
	return(OM_SUCCESS);
}




/* mhp_f_country(to, from, len) copies country name string
 * into data structure according to whether it's x121 code
 * or iso code.
 *
 * Input: 
 * 		to, from, len
 * Output:
 *		None.
 * Result:
 *      the values pointed by from is copied appropriately in "to".
 *
 * Called by:
 *		mhp_f_perdomain()
 *		mhp_f_mts_id()
 *
 * Calling:
 *		sl_isdigit() in osdeps.h
 *
 */

int mhp_f_country(to, from, len)
P1CountryName *to;
char *from; 
OM_uint32 len;

{
	if (sl_isdigit(*from)) {
		to->t = CountryName_x121_dcc_code;
	    strncpy(to->v.x121_dcc_code, from, len); 
		to->v.x121_dcc_code[len] = '\0';
	} 
	else {
	 	to->t = CountryName_iso_3166_alpha2_code;
		strncpy(to->v.iso_3166_alpha2_code, from, len);
		to->v.iso_3166_alpha2_code[len] = '\0';
	}
	return(OM_SUCCESS);
}



/*
 * mhp_f_ext_trace(object_header, etrace)  puts an External Trace Entry obbject
 * into the list of P1TraceInformationElement struacture.
 * Input:
 *			object	- the External Trace Entry object
 *			etrace  - pointer to the list of P1TraceInformation in the envelope
 * Output:
 */

int mhp_f_ext_trace(object_header, etrace)
OM_int_private_object_header *object_header;
aaListPointer etrace;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_private_object_header *subobject_header;
	OM_descriptor *omattr;
	OM_value	value;
	OM_uint16 value_num;
	char *string, *an, *pn, *cn, *an1, *cn1, *pn1;
	OM_uint32 str_len, an_len, pn_len, cn_len, an1_len, cn1_len, pn1_len;
	P1TraceInformationElement *trace;
	int i, status;
	void *handle;

	if (list_alloc(etrace, sizeof(P1TraceInformationElement)) == FALSE){
		log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		return(OM_MEMORY_INSUFFICIENT);
	}
	trace = (P1TraceInformationElement *)etrace->current->data;

	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
	{
			/* if no value, go to next attribute */
		if ((value_num = object[i].count) == 0) continue;
		attribute = (OM_int_descriptor *)&object[i];
		value = attribute->attr_value->value;
		switch (attribute->attr_type) {
			case MH_T_ADMD_NAME:
				trace->global_domain_identifier.m |=
					GlobalDomainIdentifier_administration_domain_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_admdcpy(
					trace->global_domain_identifier.administration_domain_name,
					string,
					str_len);
				break;
			case MH_T_COUNTRY_NAME:
				trace->m |= TraceInformationElement_global_domain_identifier;
				trace->global_domain_identifier.m |=
					GlobalDomainIdentifier_country_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_country(
					trace->global_domain_identifier.country_name,
					string,
					str_len);
				break;
			case MH_T_PRMD_IDENTIFIER:
				trace->global_domain_identifier.m |=
					GlobalDomainIdentifier_private_domain_identifier;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_prmdcpy(
					trace->global_domain_identifier.private_domain_identifier,
					string,
					str_len);
				break;
			case MH_T_ATTEMPTED_ADMD_NAME:
				trace->domain_supplied_information.attempted_domain.m |=
					GlobalDomainIdentifier_administration_domain_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_admdcpy(
					trace->domain_supplied_information.attempted_domain.administration_domain_name,
					string,
					str_len);
				break;
			case MH_T_ATTEMPTED_COUNTRY_NAME:
			 	trace->domain_supplied_information.m |=
					DomainSuppliedInformation_attempted_domain;
				trace->domain_supplied_information.attempted_domain.m |=
					GlobalDomainIdentifier_country_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_country(
					trace->domain_supplied_information.attempted_domain.country_name,
					string,
					str_len);
				break;
			case MH_T_ATTEMPTED_PRMD_IDENTIFIER:
				trace->domain_supplied_information.attempted_domain.m |=
					GlobalDomainIdentifier_private_domain_identifier;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_prmdcpy(
					trace->domain_supplied_information.attempted_domain.private_domain_identifier,
					string,
					str_len);
				break;
			case MH_T_ACTION:
				trace->domain_supplied_information.m |=
					DomainSuppliedInformation_routing_action;
				switch (value.enumeration) {
					case MH_AC_RELAYED:
						trace->domain_supplied_information.routing_action = ROUTING_ACTION_relayed;
						break;
					case MH_AC_REROUTED:
						trace->domain_supplied_information.routing_action = ROUTING_ACTION_rerouted;
						break;
				}
				break;
			case MH_T_ARRIVAL_TIME:
				trace->domain_supplied_information.m |= 
					DomainSuppliedInformation_arrival_time;
				str_len = value.string.length;	
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv(&trace->domain_supplied_information.						arrival_time, string, str_len)) != OM_SUCCESS){
					if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }

				break;
			case MH_T_CONVERTED_EITS:
				trace->domain_supplied_information.m |= 
					DomainSuppliedInformation_converted_encoded_information_types;
					/* attr points to 0-th descriptor, not -1-th desc */
				omattr = (OM_descriptor *)value.object.object; 
				subobject_header =(OM_int_private_object_header *) (--omattr);
				if ((status = mhp_f_eits(subobject_header, &handle)) != OM_SUCCESS)
					return(status);
				trace->domain_supplied_information.converted_encoded_information_types = (int *)handle;
				break;
			case MH_T_DEFERRED_TIME:
				trace->domain_supplied_information.m |= 
					DomainSuppliedInformation_deferred_time;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv(&trace->domain_supplied_information.
					      deferred_time, string, str_len)) != OM_SUCCESS){
					if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
				break;
		} /* End switch attribute type */
	} /* End of for */

	list_append(etrace);
	return(OM_SUCCESS);
} /* End mhp_f_ext_trace */



/*
 * mhp_f_internal1984(object_header, itrace) maps Internal Trace
 * Information 1984 object to list of PerMTATraceInfo1984 structures, and 
 * returns OM_SUCCESS or errors.
 *
 * Input:
 *		object - Internal Trace Info object
 *      itrace - address of internal1984 in the envelope, pointer to a list.
 * Output:
 * 
 * NOTE: This function will drop some info from the Internal Trace Record
 * object: eg, all Global Domain info.
 *
 */


int mhp_f_internal1984(object_header, itrace)
OM_int_private_object_header *object_header;
aaListPointer itrace;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_value	value;
	OM_uint16 value_num;
	char *string;
	OM_uint32 str_len; 
	P1PerMTATraceInfo1984 *trace;
	int i, len, status;


	if (list_alloc(itrace, sizeof(P1PerMTATraceInfo1984)) == FALSE){
		log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		return(OM_MEMORY_INSUFFICIENT);
	}
	trace = (P1PerMTATraceInfo1984 *)itrace->current->data;

	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
	{
			/* if no value, go to next attribute */
		if ((value_num = object[i].count) == 0) continue;
		attribute = (OM_int_descriptor *)&object[i];
		value = attribute->attr_value->value;
		switch (attribute->attr_type) {

/* 
 * Note that since internal1984 as defined in MOTIS 1986 or OIW/GOSIP/NIST
 * profile contains less info, some object info will not be mapped: eg
 * Global Domain information.
 */

			case MH_T_MTA_NAME:
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if (str_len > 0) {
					/* whichever length is smaller */
				 len = str_len <= MTA_NAME ? str_len : MTA_NAME;
				 trace->m |= PerMTATraceInfo1984_MTAName1984;
				 strncpy(trace->mTAName1984, string, len);
				 trace->mTAName1984[len] = '\0';
				}
				break;
			case MH_T_ATTEMPTED_MTA_NAME:
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if (str_len > 0) {
					/* whichever length is smaller */
				 len = str_len < MTA_NAME ? str_len : MTA_NAME;
				 trace->mTAInfo1984.m |= MTAInfo1984_previous;
				 strncpy(trace->mTAInfo1984.previous, string, len);
				 trace->mTAInfo1984.previous[len] = '\0';
				} 
				break;
			case MH_T_ACTION:
				trace->m |= PerMTATraceInfo1984_MTAInfo1984;
				trace->mTAInfo1984.m |= MTAInfo1984_action1984;
				switch(value.enumeration) {
					case MH_AC_RELAYED:
						trace->mTAInfo1984.action1984 = ACTION1984_relayed;
						break;
					case MH_AC_REROUTED:
						trace->mTAInfo1984.action1984 = ACTION1984_rerouted;
						break;
					case MH_AC_REDIRECTED:
						trace->mTAInfo1984.action1984 =ACTION1984_recipReassign;
						break;
				}							
				break;
			case MH_T_ARRIVAL_TIME:
				trace->m |= PerMTATraceInfo1984_MTAInfo1984;
				trace->mTAInfo1984.m |= MTAInfo1984_arrival;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv(&trace->mTAInfo1984.arrival, 
						string, str_len)) != OM_SUCCESS){
					if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
				break;

			case MH_T_DEFERRED_TIME:
				trace->mTAInfo1984.m |= MTAInfo1984_deferred;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv(&trace->mTAInfo1984.deferred, 
						string, str_len)) != OM_SUCCESS){
					if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP,
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
				break;
		} /* End switch type */
	} /* End for */
	
	list_append(itrace);
	return(OM_SUCCESS);

} /*End mhp_f_internal1984 */







/* i_ORnamePut puts ORName object into retix data structure
 * and returns handle to the structure.
 *
 * 
 * TO DO:
 *        (1) number of types = number of values for DDA?
 *
 */


int mhp_f_orname(object_header, ret_handle)
OM_int_private_object_header *object_header;
P1ORName **ret_handle;

{

    P1ORName *orname;
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    OM_uint16 value_num;
    P1StandardAttributes *std;
    P1DomainDefinedAttributes *dda;
    P1TeletexDomainDefinedAttributes *ttxDDA = NULL;
    P1TeletexPersonalName *ttxPN = NULL;
    P1TeletexOrganizationalUnitNames *ttxOU = NULL;
    P1UnformattedPostalAddress *unformAddr = NULL;
    P1ExtendedNetworkAddress *extAddr = NULL;
    P1ExtensionAttributes *extensions = NULL;        /* Extension Attributes */

    OM_boolean isExtension = OM_FALSE;
    OM_boolean isTeletex;
    OM_uint32 len; 
    sint16 ext_type, ext_type1;
    char *str;
    void *buf;
    int i, tmp, status, count; 
    P1TerminalType *termtype;

    if ((orname = (P1ORName *)os_calloc(sizeof(P1ORName))) == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    orname->m |= ORName_standard_attributes; /* at least std att must be here */
    if ((std = (P1StandardAttributes *)
                            os_calloc(sizeof(P1StandardAttributes))) == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    dda = (P1DomainDefinedAttributes *) & orname->domain_defined_attributes;
    object = (OM_int_descriptor *)object_header->context.descriptor_list;

    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
    {
        if ((value_num = object[i].count) == 0) continue ; 
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = attribute->attr_value;
        value = attribute->attr_value->value;
        /* need to mask out the high bits of syntax */
        isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
        if (value.string.length == OM_LENGTH_UNSPECIFIED)
            len = strlen(value.string.elements);
        else len = value.string.length;
        str = (char *)value.string.elements;


/* 
 * Address attributes and associated extensions takes different flavors 
 * to format. For an extension, we need to encode it first with
 * mt_encode_addr_exts().
 *
 * + single attribute -> single data structure : direct map
 *
 * + single attribute, two syntaxes/values (eg Organisational Name)
 *    + one Printable/etc syntax -> single data structure : direct map
 *    + one Teletex syntax -> single extension : map to the data structure,
 *      set the isExtension flag, and encode the extension at the end 
 *      of switch statement.
 *
 * + multiple attributes, multiple syntaxes/values (eg, Organizational Units,
 *   DDAs, PersonalName)  
 *    + each Printable syntax -> part of single data structure : direct map 
 *    + each Teletex syntax -> part of one extension
 *   For the extensions, we just collect all attributes into one data 
 *   structure first, flag them, then encode the extension at the end after
 *   the FOR-loop. 
 *
 * + single attribute, two syntaxes/values, each syntaxes results
 *   in one extension (eg, COMMON_NAME):
 *    + each Printable/etc syntax -> one extension
 *    + each Teletex syntax -> one extension
 *   This is a special case, so we will encode it in the case statement
 *   and does not set the isExtension flag.
 *
 * + single attribute, two syntaxes/values, but there's only one
 *   extension per attribute (each POSTAL attribute with two syntaxes
 *   map to ONE P1PDSParameter data structure, and result in ONE extension).
 *   We will map to the single data structure first, set isExtension flag,
 *   and encode at the end of the switch statement.
 *
 */
        switch (attribute->attr_type) {
        case MH_T_ADMD_NAME:
            std->m |= StandardAttributes_administration_domain_name;
            mhp_f_admdcpy(&std->administration_domain_name, 
                         str, len);
            break;
        

        case MH_T_COMMON_NAME:
            /*
             * Can have two values, with either Printable or Teletex
             * syntax, but can't have both value of same syntax. Each
             * value is one extension. So this is a special case: we
             * encode extension locally here.
             */

            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {/* teletex common name */
                    ext_type = EXTENSION_ATTRIBUTE_TYPE_teletex_common_name;
                    if ((buf = os_calloc(sizeof(P1TeletexCommonName)))== NULL){
                       log_error(OM_MEMORY_INSUFFICIENT, 
                                 OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                }
                xstrncpy(buf, str, len);
            }
            else /* printable common name*/

            {
                ext_type = EXTENSION_ATTRIBUTE_TYPE_common_name;
                if ((buf = os_calloc(sizeof(P1CommonName))) == NULL){
                    log_error(OM_MEMORY_INSUFFICIENT, 
                              OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                xstrncpy(buf, str, len);
            }

            /* special case for Common Name: encode each extension here */ 
            orname->m |= ORName_extension_attributes; 

            if (((P1ExtensionAttribute *)
                   mt_encode_address_ext(buf, ext_type, &extensions)) == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }

            /* get next value */
            if ( (ivalue = ivalue->next) != NULL) {
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
            } /* end while */
            break;

        case MH_T_COUNTRY_NAME:
            std->m |= StandardAttributes_country_name;
            mhp_f_country(&std->country_name, str, len);
            break;
     
        case MH_T_DOMAIN_TYPE_1:   
                /* need to check #types = #values? */
          tmp = 0; /* index to P1DomainDefinedAttributes array */

          while (value_num-- > 0)
          {
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                        os_calloc(sizeof(P1TeletexDomainDefinedAttributes)))
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->n++;
                ttxDDA->v[tmp].m |= TeletexDomainDefinedAttribute_ttxddatype;
                xstrncpy(ttxDDA->v[tmp].ttxddatype, str, len);
            }
            else 
            {
                orname->m |= ORName_domain_defined_attributes;
                dda->n++; 
                dda->v[tmp].m |= DomainDefinedAttribute_ddatype;
                xstrncpy(dda->v[tmp].ddatype, str, len);
            }

            /* get next value */
            if ( (ivalue = ivalue->next) != NULL) {
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
             }
          } /* while */
          break;    

        case MH_T_DOMAIN_TYPE_2:   /* to be fixed with loop */
                /* need to check #types = #values? */
          tmp = 1; /* index to P1DomainDefinedAttributes.v[] */

          while (value_num-- > 0)
          { 
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->n++;
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddatype;
                xstrncpy(ttxDDA->v[tmp].ttxddatype, str, len);
            }
            else 

            {
                dda->n++; 
                dda->v[tmp].m |= DomainDefinedAttribute_ddatype;
                xstrncpy(dda->v[tmp].ddatype, str, len);
                orname->m |= ORName_domain_defined_attributes;
            }

            /* get next value */
            if ( (ivalue = ivalue->next) != NULL){
               isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                       == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
               value = ivalue->value;
               if (value.string.length == OM_LENGTH_UNSPECIFIED)
                   len = strlen(value.string.elements);
               else len = value.string.length;
               str = (char *)value.string.elements;
            }
          } /* while */
          break;    
     
        case MH_T_DOMAIN_TYPE_3:   
                /* need to check #types = #values? */
          tmp = 2; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num-- > 0){
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->n++;
                ttxDDA->v[tmp].m |= TeletexDomainDefinedAttribute_ttxddatype;
                xstrncpy(ttxDDA->v[tmp].ttxddatype, str, len);
            }
            else 

            {
                dda->n++; 
                dda->v[tmp].m |= DomainDefinedAttribute_ddatype;
                xstrncpy(dda->v[tmp].ddatype, str, len);
                orname->m |= ORName_domain_defined_attributes;
            }
            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_DOMAIN_TYPE_4:   
                /* need to check #types = #values? */
          tmp = 3; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->n++;
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddatype;
                xstrncpy(ttxDDA->v[tmp].ttxddatype, str, len);
            }
            else 

            {
                dda->n++; 
                dda->v[tmp].m |= DomainDefinedAttribute_ddatype;
                xstrncpy(dda->v[tmp].ddatype, str, len);
                orname->m |= ORName_domain_defined_attributes;
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_DOMAIN_VALUE_1:   /* to be fixed with loop */
          tmp = 0; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddavalue;
                xstrncpy(ttxDDA->v[tmp].ttxddavalue, str, len);
            }
            else 

            {
                dda->v[tmp].m |= DomainDefinedAttribute_ddavalue;
                xstrncpy(dda->v[tmp].ddavalue, str, len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_DOMAIN_VALUE_2:   /* to be fixed with loop */
          tmp = 1; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddavalue;
                xstrncpy(ttxDDA->v[tmp].ttxddavalue, str, len);
            }
            else 
            {
                dda->v[tmp].m |= DomainDefinedAttribute_ddavalue;
                xstrncpy(dda->v[tmp].ddavalue, str, len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_DOMAIN_VALUE_3:   /* to be fixed with loop */
          tmp = 2; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num-- > 0){
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                /* ttxDDA->n++; */
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddavalue;
                xstrncpy(ttxDDA->v[tmp].ttxddavalue, str, len);
            }
            else 
            {
                dda->v[tmp].m |= DomainDefinedAttribute_ddavalue;
                xstrncpy(dda->v[tmp].ddavalue, str, len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_DOMAIN_VALUE_4:   /* to be fixed with loop */
          tmp = 3; /* index to P1DomainDefinedAttributes.v[] */
          while (value_num -- > 0) {
            if (isTeletex) {
                if (!ttxDDA) {
                    if ((ttxDDA = (P1TeletexDomainDefinedAttributes *) 
                           os_calloc(sizeof(P1TeletexDomainDefinedAttributes))) 
                                                                == NULL) {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                /* ttxDDA->n++; */
                ttxDDA->v[tmp].m |= 
                                TeletexDomainDefinedAttribute_ttxddavalue;
                xstrncpy(ttxDDA->v[tmp].ttxddavalue, str, len);
            }
            else 
            {
                dda->v[tmp].m |= DomainDefinedAttribute_ddavalue;
                xstrncpy(dda->v[tmp].ddavalue, str, len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;    

        case MH_T_GENERATION:
          while (value_num -- > 0) {
            if (len != 0) { 
            if (isTeletex) {
                if (!ttxPN) { 
                    if ((ttxPN = (P1TeletexPersonalName *)
                          os_calloc(sizeof(P1TeletexPersonalName))) == NULL)
                    {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxPN->m |= TeletexPersonalName_generation_qualifier;
                xstrncpy(ttxPN->generation_qualifier, str, len);
                ttxPN->generation_qualifier[len] = '\0';
            }
            else

            {
                std->personal_name.m |= PersonalName_generation_qualifier;
                xstrncpy(std->personal_name.generation_qualifier, str, len);
                std->personal_name.generation_qualifier[len] = '\0';
            }
            } /* if len != 0 */

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;

        case MH_T_GIVEN_NAME:
          while (value_num-- > 0) {          
            if (len != 0) {
            if (isTeletex) {
                if (!ttxPN) { 
                    if ((ttxPN = (P1TeletexPersonalName *)
                            os_calloc(sizeof(P1TeletexPersonalName))) 
                                                                == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxPN->m |= TeletexPersonalName_given_name;
                xstrncpy(ttxPN->given_name, str, len);
                ttxPN->given_name[len] = '\0';
            }
            else 
            {
                std->personal_name.m |= PersonalName_given_name;
                xstrncpy(std->personal_name.given_name, str, len);
                std->personal_name.given_name[len] = '\0';
            }
            } /* len != 0 */
            if ( (ivalue = ivalue->next) != NULL){
               isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
               value = ivalue->value;
               if (value.string.length == OM_LENGTH_UNSPECIFIED)
                   len = strlen(value.string.elements);
               else len = value.string.length;
               str = (char *)value.string.elements;
            }
          } /* while */
          break;

        case MH_T_INITIALS:
          while (value_num-- > 0) {
            if (len != 0) {
            if (isTeletex) {
                if (!ttxPN) { 
                    if ((ttxPN = (P1TeletexPersonalName *)
                            os_calloc(sizeof(P1TeletexPersonalName))) 
                                                                == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxPN->m |= TeletexPersonalName_generation_qualifier;
                xstrncpy(ttxPN->generation_qualifier, str, len);
                ttxPN->generation_qualifier[len] = '\0';
            }
            else 
            {
                std->personal_name.m |= PersonalName_initials;
                xstrncpy(std->personal_name.initials, str, len);
                std->personal_name.initials[len] = '\0';
            }
            } /* if len!= 0 */
            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
           }
          } /* while */
          break;

        case MH_T_ISDN_NUMBER:
	    if (!extAddr) {
	        if ((extAddr = (P1ExtendedNetworkAddress *)
		     os_calloc(sizeof(P1UnformattedPostalAddress))) == NULL){
		   log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		   return(OM_MEMORY_INSUFFICIENT);
		}
	    }
            else {
                /* we can't have this and presentation address */
                if (extAddr->t != ExtendedNetworkAddress_e163_4_address) {
                    log_error(OM_WRONG_VALUE_MAKEUP, OMP_DF_WRONG_VALUE_MAKEUP,
                              attribute->attr_type, ivalue->syntax,
                              0, value.string.elements);
                    return (OM_WRONG_VALUE_MAKEUP);
                }
            }

            extAddr->t = ExtendedNetworkAddress_e163_4_address;
            extAddr->v.e163_4_address.m |= ExtendedNetworkAddress_basenumber;
            xstrncpy(extAddr->v.e163_4_address.basenumber, str, len);
            extAddr->v.e163_4_address.basenumber[len] = '\0';
            break;

        case MH_T_ISDN_SUBADDRESS:
	    if (!extAddr) {
	        if ((extAddr = (P1ExtendedNetworkAddress *)
		     os_calloc(sizeof(P1UnformattedPostalAddress))) == NULL){
		   log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		   return(OM_MEMORY_INSUFFICIENT);
		}
	    }
            else {
                /* we can't have this and presentation address */
                if (extAddr->t != ExtendedNetworkAddress_e163_4_address) {
                    log_error(OM_WRONG_VALUE_MAKEUP, OMP_DF_WRONG_VALUE_MAKEUP,
                              attribute->attr_type, ivalue->syntax,
                              0, value.string.elements);
                    return (OM_WRONG_VALUE_MAKEUP);
                }
            }

            extAddr->t = ExtendedNetworkAddress_e163_4_address;
            extAddr->v.e163_4_address.m |= ExtendedNetworkAddress_sub_address;
            xstrncpy(extAddr->v.e163_4_address.sub_address, str, len);
            extAddr->v.e163_4_address.sub_address[len] = '\0';
            break;

        case MH_T_X121_ADDRESS: /* left: nil; right: print_string */
            std->m |= StandardAttributes_network_address;
            xstrncpy(std->network_address, str, len);
            std->network_address[len] = '\0';
            break;
     
        case MH_T_NUMERIC_USER_IDENTIFIER: 
            SQUEEZE = TRUE;
            std->m |= StandardAttributes_numeric_user_identifier;
            xstrncpy(std->numeric_user_identifier, str, len);
            std->numeric_user_identifier[len] = '\0';
            break;

        case MH_T_ORGANIZATION_NAME:
          SQUEEZE = TRUE; 
          while (value_num-- > 0) {
            if (isTeletex) {
                isExtension = OM_TRUE;
                if ((buf=os_calloc(sizeof(P1TeletexOrganizationName)))==NULL){
                    log_error(OM_MEMORY_INSUFFICIENT, 
                              OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                xstrncpy(buf, str, len);
                ext_type = EXTENSION_ATTRIBUTE_TYPE_teletex_organization_name;
            }
            else 
            {
                std->m |= StandardAttributes_organization_name;
                xstrncpy(std->organization_name, str, len);
                std->organization_name[len] = '\0';
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
         
          break;

        case MH_T_ORGANIZATIONAL_UNIT_NAME_1: 
          tmp = 0; /* use for index to organizational_unit array*/
          SQUEEZE = TRUE;
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxOU) {
                    if ((ttxOU = (P1TeletexOrganizationalUnitNames *)
                        os_calloc(sizeof(P1TeletexOrganizationalUnitNames)))
                                                            == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxOU->n++;
                xstrncpy(ttxOU->v[tmp], str, len);
            }
            else 
            {
                std->m |= StandardAttributes_organizational_unit_names;
                std->organizational_unit_names.n++; 
                xstrncpy(&std->organizational_unit_names.v[tmp][0],str,len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;

        case MH_T_ORGANIZATIONAL_UNIT_NAME_2: 
          tmp = 1; /* use for index to organizational_unit array*/
          SQUEEZE = TRUE;
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxOU) {
                    if ((ttxOU = (P1TeletexOrganizationalUnitNames *)
                        os_calloc(sizeof(P1TeletexOrganizationalUnitNames)))
                                                            == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxOU->n++;
                xstrncpy(ttxOU->v[tmp], str, len);
            }
            else 
            {
                std->m |= StandardAttributes_organizational_unit_names;
                std->organizational_unit_names.n++; 
                xstrncpy(&std->organizational_unit_names.v[tmp][0], str,len);
            }

            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;

        case MH_T_ORGANIZATIONAL_UNIT_NAME_3: 
          tmp = 2; /* use for index to organizational_unit array*/
          SQUEEZE = TRUE;
          while (value_num-- > 0) {
            if (isTeletex) {
                if (!ttxOU) {
                    if ((ttxOU = (P1TeletexOrganizationalUnitNames *)
                        os_calloc(sizeof(P1TeletexOrganizationalUnitNames)))
                                                            == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxOU->n++;
                xstrncpy(ttxOU->v[tmp], str, len);
            }
            else 
            {
                std->m |= StandardAttributes_organizational_unit_names;
                std->organizational_unit_names.n++; 
                xstrncpy(&std->organizational_unit_names.v[tmp][0],str, len);
            }
            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;

        case MH_T_ORGANIZATIONAL_UNIT_NAME_4: 
          tmp = 3; /* use for index to organizational_unit array*/
          SQUEEZE = TRUE;
          while (value_num-- > 0){
            if (isTeletex) {
                if (!ttxOU) {
                    if ((ttxOU = (P1TeletexOrganizationalUnitNames *)
                          os_calloc(sizeof(P1TeletexOrganizationalUnitNames)))
                                                            == NULL){
                        log_error(OM_MEMORY_INSUFFICIENT, 
                                  OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                }
                ttxOU->n++;
                xstrncpy(ttxOU->v[tmp], str, len);
            }
            else 
            {
                std->m |= StandardAttributes_organizational_unit_names;
                std->organizational_unit_names.n++; 
                xstrncpy(&std->organizational_unit_names.v[tmp][0], str, len);
            }
            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            }
          } /* while */
          break;


        case MH_T_POSTAL_ADDRESS_DETAILS:
            
            isExtension = OM_TRUE;
            ext_type = 
                EXTENSION_ATTRIBUTE_TYPE_extension_physical_delivery_address_components;
            if ((buf = os_calloc
                 (sizeof(P1ExtensionPhysicalDeliveryAddressComponents))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1ExtensionPhysicalDeliveryAddressComponents *)
                              buf)->teletex_string, str, len);
                    ((P1ExtensionPhysicalDeliveryAddressComponents *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1ExtensionPhysicalDeliveryAddressComponents *)
                              buf)->printable_string, str, len);
                    ((P1ExtensionPhysicalDeliveryAddressComponents *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;



        case MH_T_POSTAL_ADDRESS_IN_LINES:

	    if (!unformAddr) {
	        if ((unformAddr = (P1UnformattedPostalAddress *)
		     os_calloc(sizeof(P1UnformattedPostalAddress))) == NULL){
		   log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		   return(OM_MEMORY_INSUFFICIENT);
		}
	    }

	    unformAddr->m |= UnformattedPostalAddress_printable_address;
	    
            while (value_num-- > 0)
            { /* while */
                if (unformAddr->printable_address.n < 
                        NUM_UNFORMATTED_POSTAL_LINES) {
                    xstrncpy (unformAddr->
		      printable_address.v[unformAddr->printable_address.n++],
		      str, len);
                } /* if */
                else { /* can't have than six occurrences; object code ought
                          to catch this first, but checking here so we don't
                          overwrite memory */
                    log_error(OM_WRONG_VALUE_MAKEUP, OMP_DF_WRONG_VALUE_MAKEUP,
                              attribute->attr_type, ivalue->syntax,
                              0, value.string.elements);
                    return (OM_WRONG_VALUE_MAKEUP);
                } /* else */
                    
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                } 
            } /* end while */

            break;

        case MH_T_POSTAL_ADDRESS_IN_FULL:
	    if (!unformAddr) {
	        if ((unformAddr = (P1UnformattedPostalAddress *)
		     os_calloc(sizeof(P1UnformattedPostalAddress))) == NULL){
		   log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		   return(OM_MEMORY_INSUFFICIENT);
		}
	    }

	    unformAddr->m |= UnformattedPostalAddress_teletex_string;

            xstrncpy(unformAddr->teletex_string, str, len);
            break;

        case MH_T_POSTAL_CODE:
            isExtension = OM_TRUE;
            ext_type = EXTENSION_ATTRIBUTE_TYPE_postal_code;
            if ((buf = (P1PostalCode *)os_calloc(sizeof(P1PostalCode))) == NULL)
            {
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            if (sl_isdigit(*str)) {
                ((P1PostalCode *) buf)->t = PostalCode_numeric_code;
                xstrncpy(((P1PostalCode *)buf)->v.numeric_code, str, len);
            }
            else {
                ((P1PostalCode *)buf)->t = PostalCode_printable_code;
                xstrncpy( ((P1PostalCode *)buf)->v.printable_code, str,len);
            }
            break;

        case MH_T_POSTAL_COUNTRY_NAME:
            isExtension = TRUE;
            SQUEEZE = TRUE;
            ext_type = EXTENSION_ATTRIBUTE_TYPE_physical_delivery_country_name;
            if ((buf = os_calloc(sizeof(P1PhysicalDeliveryCountryName))) == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            if (sl_isdigit(*str)) {
                ((P1PhysicalDeliveryCountryName *)buf)->t = 
                                PhysicalDeliveryCountryName_x121_dcc_code;
                xstrncpy(
                  ((P1PhysicalDeliveryCountryName *)buf)->v.x121_dcc_code, 
                                                                 str, len);
            }
            else {
                ((P1PhysicalDeliveryCountryName *)buf)->t = 
                        PhysicalDeliveryCountryName_iso_3166_alpha2_code;
                xstrncpy( ((P1PhysicalDeliveryCountryName *)
                                    buf)->v.iso_3166_alpha2_code, str,len);
            }
            break;

        case MH_T_POSTAL_DELIVERY_POINT_NAME:
            isExtension = OM_TRUE;
            ext_type = 
                EXTENSION_ATTRIBUTE_TYPE_local_postal_attributes;
            if ((buf = os_calloc
                 (sizeof(P1LocalPostalAttributes))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1LocalPostalAttributes *)
                              buf)->teletex_string, str, len);
                    ((P1LocalPostalAttributes *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1LocalPostalAttributes *)
                              buf)->printable_string, str, len);
                    ((P1LocalPostalAttributes *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_DELIV_SYSTEM_NAME:
            isExtension = TRUE;
            ext_type = EXTENSION_ATTRIBUTE_TYPE_pds_name;
            if ((buf = os_calloc
                 (sizeof(P1PDSName))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            xstrncpy (buf, str, len);
            break;

        case MH_T_POSTAL_GENERAL_DELIV_ADDR:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_poste_restante_address;
            if ((buf = os_calloc
                 (sizeof(P1PosteRestanteAddress))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PosteRestanteAddress *)
                              buf)->teletex_string, str, len);
                    ((P1PosteRestanteAddress *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PosteRestanteAddress *)
                              buf)->printable_string, str, len);
                    ((P1PosteRestanteAddress *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_LOCALE:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_unique_postal_name;
            if ((buf = os_calloc
                 (sizeof(P1UniquePostalName))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1UniquePostalName *)
                              buf)->teletex_string, str, len);
                    ((P1UniquePostalName *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1UniquePostalName *)
                              buf)->printable_string, str, len);
                    ((P1UniquePostalName *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_OFFICE_BOX_NUMBER:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_post_office_box_address;
            if ((buf = os_calloc
                 (sizeof(P1PostOfficeBoxAddress))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PostOfficeBoxAddress *)
                              buf)->teletex_string, str, len);
                    ((P1PostOfficeBoxAddress *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PostOfficeBoxAddress *)
                              buf)->printable_string, str, len);
                    ((P1PostOfficeBoxAddress *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_OFFICE_NAME:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_physical_delivery_office_name;
            if ((buf = os_calloc
                 (sizeof(P1PhysicalDeliveryOfficeName))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PhysicalDeliveryOfficeName *)
                              buf)->teletex_string, str, len);
                    ((P1PhysicalDeliveryOfficeName *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PhysicalDeliveryOfficeName *)
                              buf)->printable_string, str, len);
                    ((P1PhysicalDeliveryOfficeName *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_OFFICE_NUMBER:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_physical_delivery_office_number;
            if ((buf = os_calloc
                 (sizeof(P1PhysicalDeliveryOfficeNumber))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PhysicalDeliveryOfficeNumber *)
                              buf)->teletex_string, str, len);
                    ((P1PhysicalDeliveryOfficeNumber *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PhysicalDeliveryOfficeNumber *)
                              buf)->printable_string, str, len);
                    ((P1PhysicalDeliveryOfficeNumber *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_ORGANIZATION_NAME:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_physical_delivery_organization_name;
            if ((buf = os_calloc
                 (sizeof(P1PhysicalDeliveryOrganizationName))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PhysicalDeliveryOrganizationName *)
                              buf)->teletex_string, str, len);
                    ((P1PhysicalDeliveryOrganizationName *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PhysicalDeliveryOrganizationName *)
                              buf)->printable_string, str, len);
                    ((P1PhysicalDeliveryOrganizationName *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_PATRON_DETAILS:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_extension_OR_address_components;
            if ((buf = os_calloc
                 (sizeof(P1ExtensionORAddressComponents))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1ExtensionORAddressComponents *)
                              buf)->teletex_string, str, len);
                    ((P1ExtensionORAddressComponents *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1ExtensionORAddressComponents *)
                              buf)->printable_string, str, len);
                    ((P1ExtensionORAddressComponents *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_PATRON_NAME:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_physical_delivery_personal_name;
            if ((buf = os_calloc
                 (sizeof(P1PhysicalDeliveryPersonalName))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1PhysicalDeliveryPersonalName *)
                              buf)->teletex_string, str, len);
                    ((P1PhysicalDeliveryPersonalName *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1PhysicalDeliveryPersonalName *)
                              buf)->printable_string, str, len);
                    ((P1PhysicalDeliveryPersonalName *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_POSTAL_STREET_ADDRESS:
            isExtension = OM_TRUE;
            ext_type = 
                 EXTENSION_ATTRIBUTE_TYPE_street_address;
            if ((buf = os_calloc
                 (sizeof(P1StreetAddress))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            
            while (value_num-- > 0)
            { /* while */
                if (isTeletex) {  /* teletex */
                    xstrncpy(((P1StreetAddress *)
                              buf)->teletex_string, str, len);
                    ((P1StreetAddress *)
                     buf)->m |= PDSParameter_teletex_string;
                } /* if */
                else { /* printable string */
                    xstrncpy(((P1StreetAddress *)
                              buf)->printable_string, str, len);
                    ((P1StreetAddress *)
                     buf)->m |= PDSParameter_printable_string;
                } /* else */
                
                /* get next value */
                if ( (ivalue = ivalue->next) != NULL) {
                    isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                 == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                    value = ivalue->value;
                    if (value.string.length == OM_LENGTH_UNSPECIFIED)
                        len = strlen(value.string.elements);
                    else len = value.string.length;
                    str = (char *)value.string.elements;
                }
            } /* end while */
            break;

        case MH_T_PRESENTATION_ADDRESS:
	    if (!extAddr) {
	        if ((extAddr = (P1ExtendedNetworkAddress *)
		     os_calloc(sizeof(P1UnformattedPostalAddress))) == NULL){
		   log_error(OM_MEMORY_INSUFFICIENT, 
                             OMP_DF_MEMORY_INSUFFICIENT);
		   return(OM_MEMORY_INSUFFICIENT);
		}
	    }
            else {
                /* we can't have this and ISDN number/address */
                if (extAddr->t != ExtendedNetworkAddress_psap_address) {
                    log_error(OM_WRONG_VALUE_MAKEUP, OMP_DF_WRONG_VALUE_MAKEUP,
                              attribute->attr_type, ivalue->syntax,
                              0, value.string.elements);
                    return (OM_WRONG_VALUE_MAKEUP);
                }
            }

            extAddr->t = ExtendedNetworkAddress_psap_address;
/* Not done yet!! This attribute is an XDS object; it's not in the package file
now; we need to figure out what to do with it - put it in our package file or
get it from xds package file.  So we'll put this off for now.
*/

            break;

        case MH_T_PRMD_NAME:
            std->m |= StandardAttributes_private_domain_name;
            mhp_f_prmdcpy(&std->private_domain_name, str, len);
            break;

        case MH_T_SURNAME: /* left: nil; right: print_string */
          while (value_num-- > 0) {
            if (len != 0) {
            if (isTeletex) {
                if (!ttxPN) { 
                    if ((ttxPN = (P1TeletexPersonalName *)
                            os_calloc(sizeof(P1TeletexPersonalName))) == NULL)
                        return(OM_MEMORY_INSUFFICIENT);
                }
                ttxPN->m |= TeletexPersonalName_surname;
                xstrncpy(ttxPN->surname, str, len);
            }
            else 
            {
                std->m |= StandardAttributes_personal_name;
                xstrncpy(std->personal_name.surname, str, len);
            }
            } /* if len != 0 */
            if ( (ivalue = ivalue->next) != NULL){
                isTeletex = ((ivalue->syntax & OM_S_SYNTAX) 
                                    == OM_S_TELETEX_STRING)?OM_TRUE:OM_FALSE;
                value = ivalue->value;
                if (value.string.length == OM_LENGTH_UNSPECIFIED)
                    len = strlen(value.string.elements);
                else len = value.string.length;
                str = (char *)value.string.elements;
            } 
          } /* while */
          break;

        case MH_T_TERMINAL_IDENTIFIER:
            std->m |= StandardAttributes_terminal_identifier;
            xstrncpy(std->terminal_identifier, str, len);
            std->terminal_identifier[len] ='\0';
            break;

        case MH_T_TERMINAL_TYPE:
            isExtension = OM_TRUE;
            ext_type = EXTENSION_ATTRIBUTE_TYPE_terminal_type;
                 
            if ((buf= (P1TerminalType *)os_calloc
                 (sizeof(P1TerminalType))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
             if ((termtype= (P1TerminalType *)os_calloc
                 (sizeof(P1TerminalType))) 
                == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
     
            *((P1TerminalType *)buf) = (P1TerminalType) value.enumeration;
            break;

        default:
            log_error(OM_NO_SUCH_TYPE, OMP_DF_NO_SUCH_TYPE,
                    attribute->attr_type,
                      object[CLASS_POS].attr_value->value.string.elements);
            return(OM_NO_SUCH_TYPE);
        } /* switch (attribute->attr_type) */

        /* 
         * encode extension matching single attribute (one or two syntaxes)
         * here. For extension that covers multiple attributes, eg ORGUNITs,
         * encode it at the end, outside the for-loop.
         */
        if (isExtension == OM_TRUE) {
            orname->m |= ORName_extension_attributes; 

            if (((P1ExtensionAttribute *)
                  mt_encode_address_ext(buf, ext_type, &extensions)) == NULL) {
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            isExtension = OM_FALSE;
        }    /* end fill in extension */

    } /* end of for (i=TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) */

    /* 
     * encode any extensions that cover more than one attribute at the end, 
     * since we must collect all the XOM attributes values into one
     * structure first before encoding: eg, must collect all ORGUNIT_n 
     * attribute values first before encode the ORGUNIT extension.
     */

    if (ttxDDA) {
        orname->m |= ORName_extension_attributes; 
        ext_type = EXTENSION_ATTRIBUTE_TYPE_teletex_domain_defined_attributes;
        if (((P1ExtensionAttribute *) 
               mt_encode_address_ext(ttxDDA, ext_type, &extensions)) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
    }

    if (ttxOU) {
        orname->m |= ORName_extension_attributes; 
        ext_type = EXTENSION_ATTRIBUTE_TYPE_teletex_organizational_unit_names;
        if (((P1ExtensionAttribute *)
	       mt_encode_address_ext(ttxOU, ext_type, &extensions)) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
     }

    if (ttxPN) {
        orname->m |= ORName_extension_attributes; 
        ext_type = EXTENSION_ATTRIBUTE_TYPE_teletex_personal_name;
        if (((P1ExtensionAttribute *)
                 mt_encode_address_ext(ttxPN, ext_type, &extensions)) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
    }

    if (unformAddr) {

        orname->m |= ORName_extension_attributes; 
        ext_type = EXTENSION_ATTRIBUTE_TYPE_unformatted_postal_address;
        if (((P1ExtensionAttribute *)
	    mt_encode_address_ext(unformAddr, ext_type, &extensions)) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
    }

    if (extAddr) {
/* !!???  must check that we have number if we have subaddress */

        orname->m |= ORName_extension_attributes; 
        ext_type = EXTENSION_ATTRIBUTE_TYPE_extended_network_address;
        if (((P1ExtensionAttribute *)
	    mt_encode_address_ext(extAddr, ext_type, &extensions)) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
    }


 /* If ADMD is not specified (in case of PRMD<-->PRMD), specify */
 /* ADMD equal to a 'blank' char.                                 */
 /* This is true always when country is present. KDH 3/7/92        */
    if (!(std->m & StandardAttributes_administration_domain_name)
            && (std->m & StandardAttributes_country_name)
            /* && (std->m & StandardAttributes_private_domain_name) */
        ) 
    {
        std->m |= StandardAttributes_administration_domain_name;
        std->administration_domain_name.t = AdministrationDomainName_printable;
        strncpy(std->administration_domain_name.v.printable, " \0", 2);
    }

    /* include standard attributes if any, as this is a pointer in orname */
    orname->standard_attributes = (int *) std;


    /* include extension attributes if any */
    /* if (orname->m && ORName_extension_attributes) */
    if (extensions)
        orname->extension_attributes = (int *)extensions;

    *ret_handle = (P1ORName *)orname;

    return(OM_SUCCESS);
}

static P1ExtensionAttribute 
*mt_encode_address_ext(value, ext_type, extensions)
void *value;
sint16 ext_type;
P1ExtensionAttributes **extensions;

{
    P1ExtensionAttribute *ext;
    struct any_type *evalue;

    if (!(*extensions)) {
        if ((*extensions = (P1ExtensionAttributes *)
	     os_calloc(sizeof(P1ExtensionAttributes))) == NULL){
	    return ((P1ExtensionAttribute *) NULL);
        }
    }

    if ((ext = (P1ExtensionAttribute *) 
                os_calloc(sizeof(P1ExtensionAttribute))) == NULL)
        return((P1ExtensionAttribute *) NULL);
            
    if ((evalue = (struct any_type *) 
                 encode_address_extensions(value, ext_type) ) == NULL)
        return((P1ExtensionAttribute *) NULL);
    ext->m |= ExtensionAttribute_extension_attribute_value;
    ext->extension_attribute_type = ext_type;
    ext->extension_attribute_value = (int *)evalue;
    clr_addrext_mem(value, ext_type);
    (*extensions)->v[(*extensions)->n++] = (int *) ext;
    return(ext);
}


/*
 * mhp_f_bcontent() maps the GENERAL CONTENT object, the binary content,
 * into a buffer. Note that the binary content is in a buffer, not in
 * a file, so there's limitation on the size.
 * 
 * Input: 
 *  object_header - the General Content object header
 * Output:
 *  content - pointer to buffer containing the binary content.
 * Result:
 *  OM_SUCCESS or otherwise
 *
 * Called by:
 *   mhp_f_msg()
 */

int mhp_f_bcontent(object_header, content)
OM_int_private_object_header    *object_header;
char **content;
{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_value    value;
    OM_uint16 value_num;
    char *string;
    OM_uint32 str_len; 
    char *buf;
    boolean isbinary=FALSE; 
    int i, status;

    object = (OM_int_descriptor *)object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
    {
            /* if no value, go to next attribute */
        if ((value_num = object[i].count) == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        value = attribute->attr_value->value;
        switch (attribute->attr_type) {
        case MH_T_BINARY_CONTENT:
            str_len = value.string.length;
            string = (char *)value.string.elements;
            if (!(attribute->attr_value->modifier & OM_INT_ONDISK) && str_len) 
            {
                if ((status = mhp_write_file(& value.string, &buf))!=OM_SUCCESS)
                {
                    return(status);
                }
            }

            else if (str_len) {
                if ((buf = (char *)os_calloc(MAXFILE + 1)) == NULL) {
                   log_error(OM_MEMORY_INSUFFICIENT,OMP_DF_MEMORY_INSUFFICIENT);
                    return (OM_MEMORY_INSUFFICIENT);
                }
                if ((status = os_uniq_name(buf, _MH_BodyPart_dir, TMP_PREFIX,
                        (char*)NULL, 0660)) == NULL) {
                    log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                        __FILE__, __LINE__, MH_INT_DF_FAILED_TO_GET_FILENAME,
                        strerror(errno), 0);
                    os_free((void*)buf);
                    return (OM_SYSTEM_ERROR);   
                }
                os_delete(buf);
                if ((status = os_link(string, buf)) != NULL)
                {
                    log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                        __FILE__, __LINE__, MH_INT_DF_FAILED_TO_LINK_UNLINK,
                        string, buf, strerror(errno));
                    os_free((void *)buf);
                    return(OM_SYSTEM_ERROR);
                }

            } /* memory-based value or disk-based value */

            else { /* gotta have some binary data */
                log_error(OM_WRONG_VALUE_NUMBER, OMP_DF_WRONG_VALUE_NUMBER,
                    MH_T_BINARY_CONTENT, 0); /* length of zero doesn't count*/
                return(OM_WRONG_VALUE_NUMBER);
            }
            isbinary = TRUE;
            break;

        default: /* just ignore other attributes */
            break;
        }   
    }
    
    if (!isbinary) {
        log_error(OM_WRONG_VALUE_NUMBER, OMP_DF_WRONG_VALUE_NUMBER,
                MH_T_BINARY_CONTENT, 0); 
        return(OM_WRONG_VALUE_NUMBER);
    }

    /* binary content, so make sure directive to ext.c to read content
    ** from a file.
    */
    x4g_process_generic_content_flag = TRUE;

    *content = buf;
    return(OM_SUCCESS);

} /* mhp_f_bcontent() */




/* mhp_f_exp_history(object_header, exp_history, value_num)
 * 	
 * maps one Expansion Record object into P1DLExpansion data structure.
 * The result of this generally goes into P1DLExpansionHistory.
 *
 */

int mhp_f_exp_history(object_header, exp_history, value_num)
OM_int_private_object_header *object_header;
P1ExtensionMacroBody         *exp_history; 
int value_num;
{
	int       status;
	void      *handle;
	OM_uint16 i;
	P1DLExpansionHistory   *ehist;

	if ((ehist =(P1DLExpansionHistory *) os_calloc (sizeof(P1DLExpansionHistory ))) == NULL)
        {
             log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
             return(OM_MEMORY_INSUFFICIENT);
	}
        exp_history->extstruct = (char *) ehist;
        list_null (ehist);
	i = 0;
 
	while (value_num > 0)
	{
		ehist->v[i] = ( int*) os_calloc (sizeof (int));
	        if ((status = mhp_f_exp_record(object_header, ehist->v[i])) 
					!=OM_SUCCESS)
		return(status);

	list_append(&(exp_history->extstruct));
	i = i + 1 ;
	value_num = value_num -1;
        } /* end while */
	return(OM_SUCCESS);
} /* mhp_f_exp_history */


/*
 * mhp_f_exp_record() allocates P1DLExpansion, maps values in 
 * ExpansionRecord object and return the address of P1DLExpansion
 * in ret_handle. Usually, the returned handle goes into the
 * P1DLExpansionHistory.v extension.
 *
 */ 
	
int mhp_f_exp_record(object_header, ret_handle) 
OM_int_private_object_header *object_header;
P1DLExpansion                **ret_handle;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_value *ivalue;
	OM_value value;
	int i, status;
	void *string, *buffer;
	OM_uint32 str_len;
	void          *handle;
	OM_descriptor *omattr;
	OM_int_private_object_header *subobject_header;
	P1DLExpansion	*exp_record;
        

	if ((exp_record=(P1DLExpansion *)os_calloc(
		sizeof(P1DLExpansion))) == NULL)
	{
		log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
		return(OM_MEMORY_INSUFFICIENT);
	}
	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i=TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
		if (object[i].count == 0) continue; 
		attribute = (OM_int_descriptor *)&object[i];
		ivalue =  attribute->attr_value;
		value = ivalue->value;

		switch (attribute->attr_type) 
		{
			case MH_T_NAME:
				exp_record->m |= 
						DLExpansion_ORAddressAndOptionalDirectoryName;
					/* attr points to 0-th descriptor, not -1-th desc */
				handle = NULL; /* init handle */
				omattr = (OM_descriptor *)value.object.object; 
				subobject_header =(OM_int_private_object_header *) (--omattr);
				if ((status = mhp_f_orname(subobject_header, &handle)) != OM_SUCCESS)
					return(status);
				exp_record->oRAddressAndOptionalDirectoryName = (int *)handle;
				break;
			case MH_T_TIME:
				exp_record->m |= DLExpansion_redirection_time;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv(
			                         &exp_record->redirection_time,
					         string, str_len))!=OM_SUCCESS)
				{
					if (status == OM_WRONG_VALUE_MAKEUP)
						log_error(OM_WRONG_VALUE_MAKEUP,
							OMP_DF_WRONG_VALUE_MAKEUP,
							attribute->attr_type, 
							attribute->attr_syntax,
							0, value.string.elements);
						return(status);
				}
				break;
		} /* end switch */
         } /* end for */
	
	*ret_handle = exp_record;
	return(OM_SUCCESS);
} /* mhp_f_exp_record */


/*
 * mhp_f_internal1988(object_header, itrace88)
 *
 * maps one InternalTraceInformation object into P1InternalTraceInfoElement
 * and include it in the P1InternalTraceInfo list. The input itrace
 * must be the address of a list header, which is P1InternalTraceInfo
 * in this case. Since itrace88 is a list header, must allocate and
 * append list element.
 *
 */


int mhp_f_internal1988(object_header, itrace) 
OM_int_private_object_header *object_header;
aaListPointer itrace;

{
	OM_int_descriptor *object;
	OM_int_descriptor *attribute;
	OM_int_value *ivalue;
	OM_value value;
	int value_num;
	int i, len, status;
	void *string, *buffer;
	OM_uint32 str_len;
	void          *handle;
	OM_descriptor *omattr;
	OM_int_private_object_header *subobject_header;
	P1InternalTraceInformationElement *trace;
	OM_boolean	isAttemptedMTA=OM_FALSE;
	OM_boolean	isAttemptedDomain=OM_FALSE;
	boolean		isRelayed = FALSE;
	boolean		isRerouted = FALSE;
        

	/* must allocate one list element first */
	if (list_alloc(itrace, sizeof(P1InternalTraceInformationElement))==FALSE){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    trace = (P1InternalTraceInformationElement*)itrace->current->data;	

	object = (OM_int_descriptor *)object_header->context.descriptor_list;
	for (i=TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
	{
		if ((value_num = object[i].count) == 0) continue; 
		attribute = (OM_int_descriptor *)&object[i];
		ivalue =  attribute->attr_value;
		value = ivalue->value;

		switch (attribute->attr_type) 
		{
			case MH_T_ADMD_NAME:
				trace->m |= 
				InternalTraceInformationElement_global_domain_identifier;
				trace->global_domain_identifier.m |=
				GlobalDomainIdentifier_administration_domain_name;
					/* attr points to 0-th descriptor, not -1-th desc */
		                str_len = value.string.length;
		                string = (char *)(value.string.elements);
		                mhp_f_admdcpy(trace->
			                      global_domain_identifier.
			                      administration_domain_name, 
					      string, str_len);
				break;
			case MH_T_COUNTRY_NAME:
				trace->m |= 
				InternalTraceInformationElement_global_domain_identifier;
				trace->global_domain_identifier.m |=
				GlobalDomainIdentifier_country_name;
				str_len = value.string.length;
				string = (char *)value.string.elements;
		                mhp_f_country(trace->
			                      global_domain_identifier.
			                      country_name, 
					      string, str_len);
				break;
			case MH_T_PRMD_IDENTIFIER:
				trace->m |= 
				InternalTraceInformationElement_global_domain_identifier;
				trace->global_domain_identifier.m |=
			       GlobalDomainIdentifier_private_domain_identifier;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_prmdcpy(trace->global_domain_identifier.
			                      private_domain_identifier, 
					      string, str_len);
				break;

			case MH_T_ATTEMPTED_ADMD_NAME:
/* 
 * All Attempted ADMD/PRMD/COUNTRY goes into attempted GlobalDomain.
 * It's a choice: either attempted MTA Name or attempted GlobalDomain.
 * Error if both are present.
 */
				if (isAttemptedMTA)
				{
					log_error(OM_TEMPORARY_ERROR, 
						OMP_DF_TEMPORARY_ERROR,"format.c",
						__LINE__, "attribute conflict","attribute",
						omp_int2str(MH_T_ATTEMPTED_ADMD_NAME),0);
        			return(OM_TEMPORARY_ERROR);
				}
				isAttemptedDomain = OM_TRUE;
				trace->m |=
					InternalTraceInformationElement_mta_supplied_information;
                trace->mta_supplied_information.m |= 
                   MTASuppliedInformation_attempted;
				trace->mta_supplied_information.attempted.v.domain.m |=
					GlobalDomainIdentifier_administration_domain_name;
				trace->mta_supplied_information.attempted.t =
				   MTASuppliedInformation_domain;
				str_len = value.string.length;
				string = (char *)(value.string.elements);
				mhp_f_admdcpy(trace-> mta_supplied_information.
					      attempted.v.domain.
					      administration_domain_name,
					      string, str_len);
				break;

			case MH_T_ATTEMPTED_COUNTRY_NAME:
				if (isAttemptedMTA)
				{
					log_error(OM_TEMPORARY_ERROR, 
						OMP_DF_TEMPORARY_ERROR,"format.c",
						__LINE__, "attribute conflict","attribute",
						omp_int2str(MH_T_ATTEMPTED_COUNTRY_NAME),0);
        			return(OM_TEMPORARY_ERROR);
				}
				isAttemptedDomain = OM_TRUE;
				trace->m |=
					InternalTraceInformationElement_mta_supplied_information;
                trace->mta_supplied_information.m |= 
                   MTASuppliedInformation_attempted;
				trace->mta_supplied_information.attempted.v.domain.m |=
					GlobalDomainIdentifier_country_name; 
				trace->mta_supplied_information.attempted.t =
					MTASuppliedInformation_domain;
				str_len = value.string.length; 
				string = (char *)value.string.elements;
				mhp_f_country(trace->mta_supplied_information.
					      	attempted.v.domain.
							country_name, 
							string, str_len);
				break;

			case MH_T_ATTEMPTED_PRMD_IDENTIFIER:
				if (isAttemptedMTA)
				{
					log_error(OM_TEMPORARY_ERROR, 
						OMP_DF_TEMPORARY_ERROR,"format.c",
						__LINE__, "attribute conflict","attribute",
						omp_int2str(MH_T_ATTEMPTED_PRMD_IDENTIFIER),0);
        			return(OM_TEMPORARY_ERROR);
				}
				isAttemptedDomain=OM_TRUE;
				trace->m |=
					InternalTraceInformationElement_mta_supplied_information;
                trace->mta_supplied_information.m |= 
                   MTASuppliedInformation_attempted;
				trace->mta_supplied_information.attempted.v.domain.m |=
					GlobalDomainIdentifier_private_domain_identifier;
				trace->mta_supplied_information.attempted.t =
				   MTASuppliedInformation_domain;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				mhp_f_prmdcpy(trace->
							mta_supplied_information.
					      	attempted.v.domain.
							private_domain_identifier, 
							string, str_len);
				break;

			case MH_T_MTA_NAME:
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if (str_len > 0) 
				{
					/* whichever length is smaller */
				len = str_len <= MTA_NAME ? str_len : MTA_NAME;
				strncpy(trace->mta_name, string, len);
				trace->mta_name[len] = '\0';
				trace->m |= 
				     InternalTraceInformationElement_mta_name;
				}
				break;

			case MH_T_ATTEMPTED_MTA_NAME:
				/* Either have attempted MTA Name, or GlobalDomain*/
				if (isAttemptedDomain)
				{
					log_error(OM_TEMPORARY_ERROR, 
						OMP_DF_TEMPORARY_ERROR,"format.c",
						__LINE__, "attribute conflict","attribute",
						omp_int2str(MH_T_ATTEMPTED_MTA_NAME),0);
        			return(OM_TEMPORARY_ERROR);
				}
				isAttemptedMTA = OM_TRUE;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if (str_len > 0) 
				{
					/* whichever length is smaller */
				len = str_len < MTA_NAME ? str_len : MTA_NAME;
				strncpy(trace->mta_supplied_information.
						attempted.v.mta,	string, len);
				trace->mta_supplied_information.
						attempted.v.mta[len] = '\0';
				trace->m |=
					InternalTraceInformationElement_mta_supplied_information;
				trace->mta_supplied_information.m =
				        MTASuppliedInformation_attempted;	
				/* must have tag for the CHOICE */
				trace->mta_supplied_information.
					attempted.t = MTASuppliedInformation_mta;
				} 
				break;

			case MH_T_ACTION:

/* 
 * In the struct, only RELAY and REROUTE goes into the routing action.
 * Others goes into other_actions: redirected, dl-operations; and they
 * are bit string.
 */
				trace->m |= InternalTraceInformationElement_mta_supplied_information;
				while (value_num-- > 0)
				{
				switch(value.enumeration) {
				case MH_AC_RELAYED:
				/* relayed and rerouted is mutually exclusive */
					if (isRerouted)
					{
						log_error(OM_TEMPORARY_ERROR, 
							OMP_DF_TEMPORARY_ERROR,
							"format.c", __LINE__, "value conflict",
							"attribute", omp_int2str(MH_T_ACTION), 0);
						return(OM_TEMPORARY_ERROR);
					}
					isRelayed = TRUE;
					trace->mta_supplied_information.
						routing_action = ROUTING_ACTION_relayed;  
					trace->mta_supplied_information.m |= 
				 		MTASuppliedInformation_routing_action;  
					break;
				case MH_AC_REROUTED:
				/* relayed and rerouted is mutually exclusive */
					if (isRelayed)
					{
						log_error(OM_TEMPORARY_ERROR, 
							OMP_DF_TEMPORARY_ERROR,
							"format.c", __LINE__, "value conflict",
							"attribute", omp_int2str(MH_T_ACTION), 0);
						return(OM_TEMPORARY_ERROR);
					}
					trace->mta_supplied_information.
						routing_action = ROUTING_ACTION_rerouted;  
					trace->mta_supplied_information.m |= 
				 		MTASuppliedInformation_routing_action;  
					isRerouted = TRUE;
					break;
				case MH_AC_REDIRECTED:
					/* bits in bit string */
					trace->mta_supplied_information.
						other_actions |= OTHER_ACTIONS_redirected;
					trace->mta_supplied_information.m |= 
				 		MTASuppliedInformation_other_actions;  
					break;
				case MH_AC_EXPANDED:
					/* bits in bit string */
					trace->mta_supplied_information.
						other_actions |= OTHER_ACTIONS_expanded;
					trace->mta_supplied_information.m |= 
				 		MTASuppliedInformation_other_actions;  
					break;
				/*
				default:
					trace->mta_supplied_information.
						routing_action = ROUTING_ACTION_relayed;  
					trace->mta_supplied_information.m |= 
				 		MTASuppliedInformation_routing_action;  
					break;
				*/
				}						
				
				/* next value */
				ivalue=ivalue->next;
				if (ivalue != NULL)
					value = ivalue->value;
				} /* while */
				break;

			case MH_T_ARRIVAL_TIME:
				trace->m |= 
					InternalTraceInformationElement_mta_supplied_information;
				trace->mta_supplied_information.m |= 
					MTASuppliedInformation_arrival_time;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv (&trace->
								mta_supplied_information.
								arrival_time , 
								string, str_len)) != OM_SUCCESS)
				{
					if (status == OM_WRONG_VALUE_MAKEUP)
						log_error(OM_WRONG_VALUE_MAKEUP,
							OMP_DF_WRONG_VALUE_MAKEUP,
							attribute->attr_type, 
							attribute->attr_syntax,
							0, value.string.elements);
						return(status);
				}
				break;

			case MH_T_DEFERRED_TIME:
				trace->m |= 
					InternalTraceInformationElement_mta_supplied_information;
				trace->mta_supplied_information.m |= 
					MTASuppliedInformation_deferred_time;
				str_len = value.string.length;
				string = (char *)value.string.elements;
				if ((status = mhp_date_conv (&trace->
								mta_supplied_information.
								deferred_time , 
								string, str_len)) != OM_SUCCESS)
				{
					if (status == OM_WRONG_VALUE_MAKEUP)
						log_error(OM_WRONG_VALUE_MAKEUP,
							OMP_DF_WRONG_VALUE_MAKEUP,
							attribute->attr_type, 
							attribute->attr_syntax,
							0, value.string.elements);
						return(status);
				}
				break;

			case MH_T_CONVERTED_EITS:
				trace->m |= 
					InternalTraceInformationElement_mta_supplied_information;
				trace->mta_supplied_information.m |= 
					MTASuppliedInformation_converted_encoded_information_types;
				/* attr points to 0-th descriptor, not -1-th desc */
				omattr = (OM_descriptor *)value.object.object;
				subobject_header =(OM_int_private_object_header *) (--omattr);
				if ((status = mhp_f_eits(subobject_header, &handle)) !=
				                            OM_SUCCESS)
                	return(status);
                trace->mta_supplied_information.converted_encoded_information_types = (int *)handle;
				break;
		} /* end switch */
         } /* end for */

	list_append(itrace);
	return(OM_SUCCESS);

} /* mhp_f_internal1988 */

/* mhp_f_origin_check(object_header, origin_check, value_num)
 *
 */

int mhp_f_origin_check(object_header, origin_check, value_num)
OM_int_private_object_header             *object_header;
P1MessageOriginAuthenticationCheck       *origin_check; 
OM_uint16                                 value_num;
{
	/*
	int       status;
	void      *handle;
        OM_uint16 i;
        P1DLExpansionHistory   *ehist;



	if (list_alloc(&(origin_check->extstruct), sizeof(P1MessageOriginAuthenticationCheck)) 
                 	== FALSE) 
        {
             log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
             return(OM_MEMORY_INSUFFICIENT);
	}

	ocheck = (P1MessageOriginAuthenticationCheck *)(origin_check->extstruct);
        ocheck->algorithm_identifier = ( int*) os_calloc (sizeof (int));  
	
	if ((status = mhp_f_algo_result (object_header, ocheck)) 
					!=OM_SUCCESS)
		return(status);

	list_append(&(origin_check->extstruct));

mhp_f_origin_check */
	return(OM_SUCCESS);
}
