#include <stdio.h>
#include <msgcat.h>
#include <xedip.h>
#include <x4cat.h>
#include <climportedi.h>
#include <xomhp.h>
#include <xmh.h>
#include <x4apifp.h>
#include <p1p2.h>
#include <xgenbody.h>

OM_return_code mhp_f_edim(
				OM_int_private_object_header *,
				int ** );
OM_return_code	mhp_f_edi_heading(
				OM_int_private_object_header *,
				P35EDIMHeading * );
OM_return_code	mhp_f_edi_id(
				OM_int_private_object_header *,
				P35EDIMIdentifier ** );
OM_return_code	mhp_f_edi_edin_receiver(
				OM_int_private_object_header *,
				P35EDIMHeading * );
OM_return_code	mhp_f_edi_app_security(
				OM_int_private_object_header *,
				P35EDIApplicationSecurityElementsField * );
OM_return_code	mhp_f_edi_cross_ref(
				OM_int_private_object_header *,
				P35CrossReferencingInformationField *,
				int );
OM_return_code	mhp_f_edi_serv_str_adv(
				OM_int_private_object_header *,
				P35EDIMHeading * );
OM_return_code	mhp_f_edi_syntax_id(
				OM_int_private_object_header *,
				P35EDIMHeading * );
OM_return_code	mhp_f_edi_ic_sender(
				OM_int_private_object_header *,
				P35EDIMHeading * );
OM_return_code	mhp_f_edi_extension(
				OM_int_private_object_header *,
				P35ExtensionField * );
OM_return_code	mhp_f_edi_notif_req(
				OM_int_private_object_header *,
				P35RecipientsSubField * );
OM_return_code	mhp_f_edi_ic_recip(
				OM_int_private_object_header *,
				P35RecipientsSubField * );
OM_return_code	mhp_f_edi_recip_ref(
				OM_int_private_object_header *,
				P35RecipientsSubField * );
OM_return_code	mhp_f_edi_auth_info(
				OM_int_private_object_header *,
				P35AuthorizationInformationField ** );
OM_return_code	mhp_f_edi_recip(
				OM_int_private_object_header *,
				P35RecipientsSubField ** );
OM_return_code	mhp_f_edi_prim_body(
				OM_int_private_object_header *,
				P35EDIMBody * );
OM_return_code	mhp_f_edi_edi_body(
				OM_int_private_object_header *,
				P35PrimaryBodyPart * );

OM_return_code mhp_f_edin_forwarded(
	OM_int_private_object_header 	*object_header,
	int 							**ret_handle);
OM_return_code mhp_f_edin_negative(
	OM_int_private_object_header 	*object_header,
	int 							**ret_handle);
OM_return_code mhp_f_edin_positive(
	OM_int_private_object_header 	*object_header,
	int 							**ret_handle);
OM_return_code mhp_f_edi_nn_reason_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_nn_ua_ms_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_nn_user_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_nn_pdau_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_fn_reason_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_fn_ua_ms_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_fn_user_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_fn_pdau_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin );
OM_return_code mhp_f_edi_common_fields(
	P35CommonFields					*common_fields,        
	OM_int_descriptor				*attribute );

#define	s1_bcopy(s,d,l)		memcpy(d,s,l)

#define IS_CLASS(string1, string2)      \
	( sl_bcmp( (string1)->elements, (string2)->elements, \
	(string1)->length)?FALSE:TRUE)


/* 
 * mhp_f_edi() maps the Content subobject, which should be either
 * an Pedi/P35 EDIM, Forwarded (EDI) Notification, Negative
 * Notification, or Positive Notification, into the appropriate asn1 
 * data structure.
 */

OM_return_code
mhp_f_edi(
  OM_int_private_object_header *object_header, 
  P35InformationObject **ret_handle)

{
  OM_string *class;
  OM_return_code rc;
  P35InformationObject *edi; 
  int *mapping;

  if ((edi = (P35InformationObject *)
	     os_calloc(sizeof(P35InformationObject))) == NULL) 
    return(OM_MEMORY_INSUFFICIENT);

  class = &(object_header->context.descriptor_list[CLASS_POS].
	  attr_value->value.string);

  if (IS_CLASS(class, &EDI_C_EDIM))
  {
    if ((rc = mhp_f_edim(object_header, &mapping)) != OM_SUCCESS)
      return(rc);
    
    edi->t = InformationObject_edim;
    edi->v.edim = mapping;
  }

  else if (IS_CLASS(class, &EDI_C_FORWARD_NOTIF))
  {
    if ((rc = mhp_f_edin_forwarded(object_header, & mapping)) != OM_SUCCESS)
      return(rc);

    edi->t = InformationObject_edin;
    edi->v.edin = mapping;
  }
  else if (IS_CLASS(class, &EDI_C_NEGATIVE_NOTIF))
  {
    if ((rc = mhp_f_edin_negative(object_header, & mapping)) != OM_SUCCESS)
      return(rc);

    edi->t = InformationObject_edin;
    edi->v.edin = mapping;
  }
  else if (IS_CLASS(class, &EDI_C_POSITIVE_NOTIF))
  {
    if ((rc = mhp_f_edin_positive(object_header, & mapping)) != OM_SUCCESS)
      return(rc);

    edi->t = InformationObject_edin;
    edi->v.edin = mapping;
  }
  else return(OM_NO_SUCH_CLASS);


  *ret_handle = edi;
  return(OM_SUCCESS);
}

/* 
 * Mapping an EDIM object into asn1 data structure. 
 * Input: the private EDIM object
 * Output: 
 */
OM_return_code mhp_f_edim(
	OM_int_private_object_header	*object_header,
	int 							**ret_handle )
{
 	P35EDIM							*p35edim;
	P35EDIMBody						*p35body;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_sint32						value_num;
	int								i, j, status;

log_error( (OM_return_code) 0, "****** Enter mhp_f_edim() ******" );

	if (( p35edim = ( P35EDIM * ) os_calloc( sizeof( P35EDIM ))) == NULL )
		return (OM_MEMORY_INSUFFICIENT);

	if (( p35body = (P35EDIMBody *) os_calloc( sizeof(P35EDIMBody))) == NULL )
		return (OM_MEMORY_INSUFFICIENT);
 
	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_HEADING:
log_error( (OM_return_code) 0, "****** mhp_f_edim() heading ******" );
				p35edim->m |= EDIM_heading;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_heading( subobject_header, 
										&p35edim->heading )) != OM_SUCCESS )
					return (status);
				break;

			case EDI_PRIMARY_BODYPART:
log_error( (OM_return_code) 0, "****** mhp_f_edim() prim bp ******" );
				p35edim->m |= EDIM_body;
				p35body->m |= EDIMBody_primary_body_part;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_prim_body( subobject_header, 
												p35body )) != OM_SUCCESS )
					return (status);
				break;

			case EDI_ADD_BODYPARTS:
log_error( (OM_return_code) 0, "****** mhp_f_edim() add bodyparts ******" );
				return ( MH_RC_FEATURE_UNAVAILABLE );
		}
	}

	p35edim->body = (int *) p35body;
 	*ret_handle = (int *) p35edim;

log_error( (OM_return_code) 0, "****** Exit  mhp_f_edim() ******" );
	
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_heading(
	OM_int_private_object_header 		*object_header,
	P35EDIMHeading						*heading )
{
	P35RecipientsField					*recips;
	P35CrossReferencingInformationField	*xrefs;
	OM_int_descriptor					*object;
	OM_int_descriptor					*attribute;
	OM_int_value						*ivalue;
	OM_value							value;
	OM_descriptor						*omattr;
	OM_int_private_object_header		*subobject_header;
	OM_sint32							value_num;
	OM_uint32							str_len;
	OM_boolean							tofile;
	P1ORName							*orname;
	char								*string;
	void								*handle;
	int									i, j, k, status;


 	object = object_header->context.descriptor_list;

	/* 
	 * Related messages must be handled specially, because the API objects
	 * RELATED_EDI_MESSAGES and RELATED_NON_EDI_MESSAGES are both included
	 * in the same ASN.1 structure.  Initialize the related_messages counter
	 * here, in case the compiler does not do it for us.
	 */

	heading->related_messages.n = 0;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_THIS_EDIM:
				heading->m |= EDIMHeading_this_EDIM;
				handle = NULL;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_id( subobject_header, 
						( P35EDIMIdentifier ** ) &handle )) != OM_SUCCESS )
					return (status);
				heading->this_EDIM = (int *) handle;
				break;
			
			case EDI_ORIG:
				heading->m |= EDIMHeading_originator;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_orname( subobject_header, &orname ))
														  != OM_SUCCESS )
					return (status);
				heading->originator = (int *) orname;
				break;
				
			case EDI_RECIPS:
				heading->m |= EDIMHeading_recipients;
				j = 0;
				if (( recips = (P35RecipientsField *) os_calloc( 
							   sizeof(P35RecipientsField))) == NULL ) {
					log_error( OM_MEMORY_INSUFFICIENT, 
							   OMP_DF_MEMORY_INSUFFICIENT );
					return (OM_MEMORY_INSUFFICIENT);
				}
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					handle = NULL;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_recip( subobject_header,
							(P35RecipientsSubField **)&handle )) != OM_SUCCESS )
						return (status);
					recips->v[j++] = (int *) handle;
					ivalue = (OM_int_value *) ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				recips->n = j;
				heading->recipients = (int *) recips;
				break;
			
			case EDI_EDIN_RECEIVER:
				heading->m |= EDIMHeading_edin_receiver;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_edin_receiver( subobject_header, 
													heading)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_RESPONS_FORWARD:
				heading->m |= EDIMHeading_responsibility_forwarded;
				heading->responsibility_forwarded = value.boolean;
				break;
				
			case EDI_EDI_BODYPART_TYPE:
				heading->m |= EDIMHeading_edi_bodypart_type;
log_error( (OM_return_code) 0, "****** before getobj() ******" );
				mhp_getobj( value.string, MAX_OBJ_ID, (struct objid *)
							&heading->edi_bodypart_type );
log_error( (OM_return_code) 0, "****** after getobj() ******" );
			
			case EDI_INC_COPY:
				heading->m |= EDIMHeading_incomplete_copy;
				heading->incomplete_copy = value.boolean;
				break;
			
			case EDI_EXPIRY_TIME:
				heading->m |= EDIMHeading_expiry_time;
				if (( status = mhp_date_conv( &heading->expiry_time,
						(char *) value.string.elements,
						value.string.length )) != OM_SUCCESS ) {
					if ( status == OM_WRONG_VALUE_MAKEUP )
						log_error( OM_WRONG_VALUE_MAKEUP,
							OMP_DF_WRONG_VALUE_MAKEUP,
							attribute->attr_type, attribute->attr_syntax,
							0, value.string.elements );
					return (status);
				}
				break;
			
			case EDI_RELATED_EDI_MSGS:
				heading->m |= EDIMHeading_related_messages;
				j = heading->related_messages.n;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					handle = NULL;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_id( subobject_header, 
							( P35EDIMIdentifier ** ) &handle )) != OM_SUCCESS )
						return (status);
					heading->related_messages.v[j].t = 
							 RelatedMessageReference_edi_message_reference;
					heading->related_messages.v[j++].v.edi_message_reference 
							 = (int *) handle;
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				heading->related_messages.n = j;
				break;
			
			case EDI_RELATED_NON_EDI_MSGS:
				heading->m |= EDIMHeading_related_messages;
				j = heading->related_messages.n;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					tofile = FALSE;
					heading->related_messages.v[j].t = 
						RelatedMessageReference_external_message_reference;
					if (( status = mhp_external( subobject_header, 
							&(heading->related_messages.v[j++].v.external_message_reference), 
							tofile )) 
							!= OM_SUCCESS )
						return (status);
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				heading->related_messages.n = j;
				break;
			
			case EDI_OBSOLETED_EDIMS:
				heading->m |= EDIMHeading_obsoleted_EDIMs;
				j = 0;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					handle = NULL;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_id( subobject_header, 
							( P35EDIMIdentifier ** ) &handle )) != OM_SUCCESS )
						return (status);
					heading->obsoleted_EDIMs.v[j++] = (int *) handle;
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				heading->obsoleted_EDIMs.n = j;
				break;
			
			case EDI_EDI_APP_SECUR_ELEMENTS:
				heading->m |= EDIMHeading_edi_application_security_elements;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_app_security( subobject_header, 
						&(heading->edi_application_security_elements)))
						!= OM_SUCCESS )
					return (status);
				break;
			
			case EDI_CROSS_REFERENCING_INFO:
				heading->m |= EDIMHeading_cross_referencing_information;
				j = 0;
				/*
				 * Create memory here since there may be multiple attribute
				 * values, but the ASN.1 encoding is an int *.
				 */
				xrefs = (P35CrossReferencingInformationField *) os_calloc( 
								sizeof( P35CrossReferencingInformationField));
				if ( xrefs == NULL ) {
					log_error( OM_MEMORY_INSUFFICIENT, 
							   OMP_DF_MEMORY_INSUFFICIENT );
					return (OM_MEMORY_INSUFFICIENT);
				}
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_cross_ref( subobject_header,
												xrefs, j++ )) != OM_SUCCESS )
						return (status);
					ivalue = (OM_int_value *) ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				xrefs->n = j;
				heading->cross_referencing_information = (int *) xrefs;
				break;
			
			case EDI_EDI_MSG_TYPE:
				heading->m |= EDIMHeading_edi_message_type;
				j = 0;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					str_len = value.string.length;
					string = (char *) value.string.elements;
					s1_bcopy( string, &heading->edi_message_type.v[j][0], 
							  str_len );
					heading->edi_message_type.v[j++][str_len] = '\0';
					ivalue = (OM_int_value *) ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				heading->edi_message_type.n = j;
				break;
			
			case EDI_SERVICE_STRING_ADVICE:
				heading->m |= EDIMHeading_service_string_advice;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_serv_str_adv( subobject_header, 
													heading)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_SYNTAX_ID:
				heading->m |= EDIMHeading_syntax_identifier;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_syntax_id( subobject_header, 
													heading)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_INTER_SENDER:
				heading->m |= EDIMHeading_interchange_sender;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_ic_sender( subobject_header, 
													heading)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_DATE_AND_TIME_OF_PREP:
				heading->m |= EDIMHeading_date_and_time_of_preparation;
				if (( status = mhp_date_conv( 
						&heading->date_and_time_of_preparation,
						(char *) value.string.elements,
						value.string.length )) != OM_SUCCESS ) {
					if ( status == OM_WRONG_VALUE_MAKEUP )
						log_error( OM_WRONG_VALUE_MAKEUP,
							OMP_DF_WRONG_VALUE_MAKEUP,
							attribute->attr_type, attribute->attr_syntax,
							0, value.string.elements );
					return (status);
				}
				break;
			
			case EDI_APP_REFERENCE:
				heading->m |= EDIMHeading_application_reference;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, heading->application_reference, str_len );
				heading->application_reference[str_len] = '\0';
				break;
			
			case EDI_HEADING_EXTENSIONS:
				heading->m |= EDIMHeading_heading_extensions;
				k = 0;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_extension( subobject_header,
						&(heading->heading_extensions.v[k++]))) != OM_SUCCESS )
						return (status);
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				break;
		}
	}
	
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_id(
	OM_int_private_object_header 	*object_header,
	P35EDIMIdentifier				**ret_handle )
{
	P35EDIMIdentifier				*id;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_uint16						value_num;
	OM_uint32						str_len;
	P1ORName						*orname;
	int								i, status;
	char							*string;


	if ( *ret_handle == NULL ) {
		if (( id = (P35EDIMIdentifier *) os_calloc( sizeof(P35EDIMIdentifier)))
																	== NULL ) {
			log_error( OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT );
			return (OM_MEMORY_INSUFFICIENT);
		}
	}
	else
		id = *ret_handle;
	
 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_USER:
				id->m |= EDIMIdentifier_user;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_orname( subobject_header, &orname ))
														  != OM_SUCCESS )
					return (status);
				id->user = (int *) orname;
				break;
				
			case EDI_USER_RELATIVE_ID:
				id->m |= EDIMIdentifier_user_relative_identifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				strncpy( id->user_relative_identifier, string, str_len );
				id->user_relative_identifier[str_len] = '\0';
				break;
		}
	}
		
	*ret_handle = (P35EDIMIdentifier *) id;
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_recip(
	OM_int_private_object_header 	*object_header,
	P35RecipientsSubField			**ret_handle)
{
	P35RecipientsSubField			*recip;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_uint16						value_num;
	OM_uint16						str_len;
	P1ORName						*orname;
	int								i, j, status;
	void							*handle;
	char							*string;


	if ( *ret_handle == NULL ) {
		if (( recip = (P35RecipientsSubField *) os_calloc( 
					   sizeof(P35RecipientsSubField))) == NULL ) {
			log_error( OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT );
			return (OM_MEMORY_INSUFFICIENT);
		}
	}
	else
		recip = *ret_handle;
	
 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_RECIP:
				recip->m |= RecipientsSubField_recipient;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_orname( subobject_header, &orname ))
														  != OM_SUCCESS )
					return (status);
				recip->recipient = (int *) orname;
				break;
			
			case EDI_ACT_REQUEST:
				recip->m |= RecipientsSubField_action_request;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				recip->action_request.length = str_len;
				mhp_getobj( value.string, MAX_OBJ_ID, &recip->action_request );
				break;
						
			case EDI_EDI_NOTIF_REQUESTS:
				recip->m |= RecipientsSubField_edi_notification_requests_field;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_notif_req( subobject_header,recip ))
														  		!= OM_SUCCESS )
					return (status);
				break;
			
			case EDI_RESPONS_PASSING_ALLOWED:
				recip->m |= RecipientsSubField_responsibility_passing_allowed;
				recip->responsibility_passing_allowed = value.boolean;
				break;
			
			case EDI_INTER_RECIP:
				recip->m |= RecipientsSubField_interchange_recipient;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_ic_recip( subobject_header,
												   recip )) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_RECIP_REFERENCE:
				recip->m |= RecipientsSubField_recipient_reference;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_recip_ref( subobject_header,
													recip )) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_INTER_CONTROL_REFERENCE:
				recip->m |= RecipientsSubField_interchange_control_reference;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, recip->interchange_control_reference, 
						  str_len );
				recip->interchange_control_reference[str_len] = '\0';
				break;
			
			case EDI_PROCESSING_PRIORITY_CODE:
				recip->m |= RecipientsSubField_processing_priority_code;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, recip->processing_priority_code, str_len );
				recip->processing_priority_code[str_len] = '\0';
				break;
			
			case EDI_ACKNOWLEDGEMENT_REQUEST:
				recip->m |= RecipientsSubField_acknowledgement_request;
				recip->acknowledgement_request = value.boolean;
				break;
			
			case EDI_COMMS_AGREEMENT_ID:
				recip->m |= RecipientsSubField_communications_agreement_id;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, recip->communications_agreement_id, 
						  str_len );
				recip->communications_agreement_id[str_len] = '\0';
				break;
			
			case EDI_TEST_INDICATOR:
				recip->m |= RecipientsSubField_test_indicator;
				recip->test_indicator = value.boolean;
				break;
			
			case EDI_AUTHORIZATION_INFO:
				recip->m |= RecipientsSubField_authorization_information;
				handle = NULL;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_auth_info( subobject_header,
						( P35AuthorizationInformationField ** ) &handle )) 
						!= OM_SUCCESS )
					return (status);
				recip->authorization_information = (int *) handle;
				break;
			
			case EDI_RECIP_EXTENSIONS:
				recip->m |= RecipientsSubField_recipient_extensions;
				j = 0;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_extension( subobject_header,
						&(recip->recipient_extensions.v[j++]))) != OM_SUCCESS )
						return (status);
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				break;
		}
	}
		
	*ret_handle = (P35RecipientsSubField *) recip;
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_edin_receiver(
	OM_int_private_object_header 	*object_header,
	P35EDIMHeading					*heading )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_uint16						value_num;
	P1ORName						*orname;
	void							*handle;
	int								i, status;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_EDIN_RECEIVER_NAME:
				heading->edin_receiver.m |= 
										EDINReceiverField_edin_receiver_name;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_orname( subobject_header, &orname ))
														  != OM_SUCCESS )
					return (status);
				heading->edin_receiver.edin_receiver_name = (int *) orname;
				break;

			case EDI_ORIGINAL_EDIM_ID:
				heading->edin_receiver.m |= 
									EDINReceiverField_original_edim_identifier;
				handle = NULL;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_id( subobject_header, 
						   ( P35EDIMIdentifier ** ) &handle )) != OM_SUCCESS )
					return (status);
				heading->edin_receiver.original_edim_identifier = 
									(int *) handle;
				break;
			
			case EDI_FIRST_RECIP:
				heading->edin_receiver.m |= 
										EDINReceiverField_first_recipient;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_orname( subobject_header, &orname ))
														  != OM_SUCCESS )
					return (status);
				heading->edin_receiver.first_recipient = (int *) orname;
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_app_security(
	OM_int_private_object_header 			*object_header,
	P35EDIApplicationSecurityElementsField	*app_secur )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_uint16						value_num;
	OM_uint32						str_len;
	P1ORName						*orname;
	int								i, j, status;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_APP_SECUR_ELEMENTS:
				app_secur->m |= EDIApplicationSecurityElementsField_edi_application_security_element;
				str_len = value.string.length;
				string = ( char * ) value.string.elements;
				s1_bcopy( string, 
						  app_secur->edi_application_security_element.data,
						  str_len );
				app_secur->edi_application_security_element.length = str_len;
				break;

			case EDI_ENCRYPTED_PRIMARY_BODYPART:
				app_secur->m |= EDIApplicationSecurityElementsField_edi_encrypted_primary_bodypart;
				app_secur->edi_encrypted_primary_bodypart = value.boolean;
				break;
			
			case EDI_APP_SECUR_EXTENSIONS:
				app_secur->m |= EDIApplicationSecurityElementsField_edi_application_security_extensions;
				j = 0;
				while ( value_num-- > 0 ) {
					omattr = (OM_descriptor *) value.object.object;
					subobject_header = 
									(OM_int_private_object_header *)--omattr;
					if (( status = mhp_f_edi_extension( subobject_header,
							&(app_secur->edi_application_security_extensions.v[j++])))
						    != OM_SUCCESS )
						return (status);
					ivalue = (OM_int_value *)ivalue->next;
					if ( ivalue != NULL )
						value = ivalue->value;
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_cross_ref(
	OM_int_private_object_header 			*object_header,
	P35CrossReferencingInformationField		*xrefs,
	int										index )
{
	OM_int_descriptor						*object;
	OM_int_descriptor						*attribute;
	OM_int_value							*ivalue;
	OM_value								value;
	OM_descriptor							*omattr;
	OM_int_private_object_header			*subobject_header;
	OM_uint16								value_num;
	OM_uint32								str_len;
	P1ORName								*orname;
	void									*handle;
	int										i, status;
	char									*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_APP_CROSS_REFERENCE:
				xrefs->v[index].m |= 
				CrossReferencingInformationSubField_application_cross_reference;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				xrefs->v[index].application_cross_reference.length = str_len;
				s1_bcopy( string, 
						  xrefs->v[index].application_cross_reference.value,
						  str_len );
				xrefs->v[index].application_cross_reference.value[str_len]='\0';
				break;
				
			case EDI_MSG_REFERENCE:
				xrefs->v[index].m |= 
						CrossReferencingInformationSubField_message_reference;
				handle = NULL;
				omattr = (OM_descriptor *) value.object.object;
				subobject_header = (OM_int_private_object_header *)--omattr;
				if (( status = mhp_f_edi_id( subobject_header, 
						 	( P35EDIMIdentifier ** ) &handle )) != OM_SUCCESS )
					return (status);
				xrefs->v[index].message_reference = (int *) handle;
				break;
				
			case EDI_BODYPART_REFERENCE:
				xrefs->v[index].m |= 
						CrossReferencingInformationSubField_body_part_reference;
				xrefs->v[index].body_part_reference = value.integer;
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_serv_str_adv(
	OM_int_private_object_header 	*object_header,
	P35EDIMHeading					*heading )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;
	OM_uint32						str_len;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_COMPONENT_DATA_ELEMENT_SEP:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_component_data_element_separator;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.component_data_element_separator.length = str_len;
				heading->service_string_advice.component_data_element_separator.value[0] = string[0];
				heading->service_string_advice.component_data_element_separator.value[str_len] = '\0';
				break;

			case EDI_DATA_ELEMENT_SEPARATOR:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_data_element_separator;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.data_element_separator.length = str_len;
				heading->service_string_advice.data_element_separator.value[0] = string[0];
				heading->service_string_advice.data_element_separator.value[str_len] = '\0';
				break;

			case EDI_DECIMAL_NOTATION:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_decimal_notation;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.decimal_notation.length = str_len;
				heading->service_string_advice.decimal_notation.value[0] = string[0];
				heading->service_string_advice.decimal_notation.value[str_len] = '\0';
				break;

			case EDI_RELEASE_INDICATOR:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_release_indicator;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.release_indicator.length = str_len;
				heading->service_string_advice.release_indicator.value[0] = string[0];
				heading->service_string_advice.release_indicator.value[str_len] = '\0';
				break;

			case EDI_RESERVED:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_reserved;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.reserved.length = str_len;
				heading->service_string_advice.reserved.value[0] = string[0];
				heading->service_string_advice.reserved.value[str_len] = '\0';
				break;

			case EDI_SEGMENT_TERMINATOR:
				heading->service_string_advice.m |=
					ServiceStringAdviceField_segment_terminator;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				heading->service_string_advice.segment_terminator.length = str_len;
				heading->service_string_advice.segment_terminator.value[0] = string[0];
				heading->service_string_advice.segment_terminator.value[str_len] = '\0';
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_syntax_id(
	OM_int_private_object_header 	*object_header,
	P35EDIMHeading					*heading )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;
	OM_uint32						str_len;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_SYNTAX_ID_STRING:
				heading->syntax_identifier.m |= 
								SyntaxIdentifierField_syntax_identifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  heading->syntax_identifier.syntax_identifier,
						  str_len );
				heading->syntax_identifier.syntax_identifier[str_len] = '\0';
				break;

			case EDI_SYNTAX_VERSION:
				heading->syntax_identifier.m |= 
								SyntaxIdentifierField_syntax_version;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				strncpy( string, heading->syntax_identifier.syntax_version,
						 str_len );
				heading->syntax_identifier.syntax_version[str_len] = '\0';
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_ic_sender(
	OM_int_private_object_header 	*object_header,
	P35EDIMHeading					*heading )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;
	OM_uint32						str_len;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_IDENTIFICATION_CODE:
				heading->interchange_sender.m |= 
								InterchangeSenderField_sender_identification;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  heading->interchange_sender.sender_identification,
						  str_len );
				heading->interchange_sender.sender_identification[str_len] 
						  = '\0';
				break;

			case EDI_IDENTIFICATION_CODE_Q:
				heading->interchange_sender.m |= 
						InterchangeSenderField_identification_code_qualifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  heading->interchange_sender.identification_code_qualifier,
						  str_len );
				heading->interchange_sender.identification_code_qualifier[str_len] 
						  = '\0';
				break;

			case EDI_ROUTING_ADDRESS:
				heading->interchange_sender.m |= 
							InterchangeSenderField_address_for_reverse_routing;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  heading->interchange_sender.address_for_reverse_routing,
						  str_len );
				heading->interchange_sender.address_for_reverse_routing[str_len] 
						  = '\0';
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_extension(
	OM_int_private_object_header 	*object_header,
	P35ExtensionField				*extension )
{
	return (MH_RC_FEATURE_UNAVAILABLE);
}

OM_return_code mhp_f_edi_notif_req(
	OM_int_private_object_header 	*object_header,
	P35RecipientsSubField			*recip )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_POSITIVE_NOTIF:
				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_notification_requests;
				recip->edi_notification_requests_field.edi_notification_requests
					|= EDI_NOTIFICATION_REQUESTS_pn;
					break;
					
			case EDI_NEGATIVE_NOTIF:
				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_notification_requests;
				recip->edi_notification_requests_field.edi_notification_requests
					|= EDI_NOTIFICATION_REQUESTS_nn;
					break;

			case EDI_FORWARD_NOTIF:
				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_notification_requests;
				recip->edi_notification_requests_field.edi_notification_requests
					|= EDI_NOTIFICATION_REQUESTS_fn;
					break;

			case EDI_PROOF_OF_RECEPTION:
				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_reception_security;
				recip->edi_notification_requests_field.edi_reception_security
					|= EDI_RECEPTION_SECURITY_proof;
				
				/* NIST PM temp hack! */

				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_notification_security;
				recip->edi_notification_requests_field.edi_notification_security
					|= EDI_NOTIFICATION_SECURITY_proof;
					break;

			case EDI_NON_REPUD_OF_RECEPTION:
				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_reception_security;
				recip->edi_notification_requests_field.edi_reception_security
					|= EDI_RECEPTION_SECURITY_non_repudiation;

				/* NIST PM temp hack! */

				recip->edi_notification_requests_field.m
					|= EDINotificationRequestsField_edi_notification_security;
				recip->edi_notification_requests_field.edi_notification_security
					|= EDI_NOTIFICATION_SECURITY_non_repudiation;
					break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_ic_recip(
	OM_int_private_object_header 	*object_header,
	P35RecipientsSubField			*recip )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;
	OM_uint32						str_len;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_IDENTIFICATION_CODE:
				recip->interchange_recipient.m |= 
							InterchangeRecipientField_recipient_identification;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  recip->interchange_recipient.recipient_identification,
						  str_len );
				recip->interchange_recipient.recipient_identification[str_len] 
						  = '\0';
				break;

			case EDI_IDENTIFICATION_CODE_Q:
				recip->interchange_recipient.m |= 
						InterchangeRecipientField_identification_code_qualifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  recip->interchange_recipient.identification_code_qualifier,
						  str_len );
				recip->interchange_recipient.identification_code_qualifier[str_len] 
						  = '\0';
				break;

			case EDI_ROUTING_ADDRESS:
				recip->interchange_recipient.m |= 
							InterchangeRecipientField_routing_address;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  recip->interchange_recipient.routing_address,
						  str_len );
				recip->interchange_recipient.routing_address[str_len] = '\0';
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_recip_ref(
	OM_int_private_object_header 	*object_header,
	P35RecipientsSubField			*recip )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_descriptor					*omattr;
	OM_uint16						value_num;
	int								i;
	OM_uint32						str_len;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_RECIP_REFERENCE:
				recip->recipient_reference.m |= 
								RecipientReferenceField_recipient_reference;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  recip->recipient_reference.recipient_reference,
						  str_len );
				recip->recipient_reference.recipient_reference[str_len] = '\0';
				break;

			case EDI_RECIP_REFERENCE_Q:
				recip->recipient_reference.m |= 
						RecipientReferenceField_recipient_reference_qualifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, 
						  recip->recipient_reference.recipient_reference_qualifier,
						  str_len );
				recip->recipient_reference.recipient_reference_qualifier[str_len] 
						  = '\0';
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_auth_info(
	OM_int_private_object_header 		*object_header,
	P35AuthorizationInformationField	**ret_handle)
{
	P35AuthorizationInformationField	*auth;
	OM_int_descriptor					*object;
	OM_int_descriptor					*attribute;
	OM_int_value						*ivalue;
	OM_value							value;
	OM_descriptor						*omattr;
	OM_uint16							value_num;
	OM_uint32							str_len;
	P1ORName							*orname;
	int									i, status;
	char								*string;


	if ( *ret_handle == NULL ) {
		if (( auth = (P35AuthorizationInformationField *) os_calloc( 
						sizeof(P35AuthorizationInformationField))) == NULL ) {
			log_error( OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT );
			return (OM_MEMORY_INSUFFICIENT);
		}
	}
	else
		auth = *ret_handle;
	
 	object = object_header->context.descriptor_list;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_AUTHORIZATION_INFO:
				auth->m |= 
					AuthorizationInformationField_authorization_information;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, auth->authorization_information, str_len );
				auth->authorization_information[str_len] = '\0';
				break;
				
			case EDI_AUTHORIZATION_INFO_Q:
				auth->m |= 
					AuthorizationInformationField_authorization_information_qualifier;
				str_len = value.string.length;
				string = (char *) value.string.elements;
				s1_bcopy( string, auth->authorization_information_qualifier, 
						  str_len );
				auth->authorization_information_qualifier[str_len] = '\0';
				break;
		}
	}
		
	*ret_handle = (P35AuthorizationInformationField *) auth;
	return (OM_SUCCESS);
}

OM_return_code mhp_f_edi_prim_body(
	OM_int_private_object_header 	*object_header,	/* primary bodypart obj */
	P35EDIMBody						*body )
{
	P35PrimaryBodyPart				*prim_body;
	OM_string 						*class;
	int								status;


	if (( prim_body = ( P35PrimaryBodyPart *) os_calloc( 
								  sizeof( P35PrimaryBodyPart ))) == NULL ) {
			log_error( OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT );
			return (OM_MEMORY_INSUFFICIENT);
	}

	class = &(object_header->context.descriptor_list[CLASS_POS].attr_value->value.string);

	if ( IS_CLASS( class, &EDI_C_EDI_BODYPART )) {
		if (( status = mhp_f_edi_edi_body( object_header, prim_body )) 
													 != OM_SUCCESS )
			return (status);
	}
	else	/* IS_CLASS( class, &EDI_C_EDIM_BODYPART ) */
		return ( MH_RC_FEATURE_UNAVAILABLE );

	body->primary_body_part = ( int * ) prim_body;
	
	return ( OM_SUCCESS );
}		

OM_return_code mhp_f_edi_edi_body(
	OM_int_private_object_header 	*object_header,
	P35PrimaryBodyPart				*prim_body )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	OM_uint32						str_len;
	int								i, status;
	Generic_bodypart				*gen_body;
	struct body_in_memory_part		*mem_body;
	char							*string;


 	object = object_header->context.descriptor_list;
	
	prim_body->t = PrimaryBodyPart_edi_body_part;
	
	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

		if (( value_num = object[i].count ) == 0 )
			continue;
		attribute = (OM_int_descriptor *) &object[i];
		ivalue = (OM_int_value *) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

			case EDI_BODY:
				if (( gen_body = (Generic_bodypart *) os_calloc( sizeof( 
												Generic_bodypart ))) == NULL )
	   				return( OM_MEMORY_INSUFFICIENT );
				if (( mem_body = (struct body_in_memory_part *) os_calloc( 
							  sizeof( struct body_in_memory_part ))) == NULL )
	   				return( OM_MEMORY_INSUFFICIENT );
				gen_body->t = BODYPART_IN_MEMORY_TAG;
				str_len = strlen( ( char * ) value.string.elements );
				if (( string = (char *) os_calloc( str_len )) == NULL)
	   				return( OM_MEMORY_INSUFFICIENT );
				s1_bcopy( (char *) value.string.elements, string, str_len );
				string[str_len] = '\0';
				mem_body->len = str_len;
				mem_body->data = string;
				gen_body->pInMemory = mem_body;
				prim_body->v.edi_body_part = (int *) gen_body; 
				break;
		}
	}
		
	
	return (OM_SUCCESS);
}

/*
 * Mapping an Positive EDIN (notification object) into asn1 data structure.
 * Input: the private forwarded EDIN object.
 * Output: 
 */
OM_return_code mhp_f_edin_positive(
	OM_int_private_object_header	*object_header,
	int 							**ret_handle )
{
	P35EDIN         				*p35edin;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	void							*handle;
	OM_value						value;
	OM_int_value					*ivalue;
	OM_sint32						value_num;
	P1ORName	      				*orname;
  	char							*string;
	OM_uint32						str_len;
	int 		      				status, i;

	if (( p35edin = ( P35EDIN * ) os_calloc( sizeof ( P35EDIN ))) == NULL )
	   	return( OM_MEMORY_INSUFFICIENT );
	
	p35edin->t = EDIN_positive_notification;

	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 	   	if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:
			if (( status = mhp_f_edi_common_fields( 
                        &p35edin->v.positive_notification.pn_common_fields,
                        attribute )) != OM_SUCCESS )
		    	return( status );
			break;

		case EDI_SUPPLEMENTARY_INFO:
           	p35edin->v.positive_notification.m |= 
		   			PositiveNotificationFields_pn_supplementary_information; 
		   	str_len = value.string.length;
			string = ( char * ) value.string.elements;
		    /* Teletex string: use binary copy. */
			sl_bcopy( string,
		      	p35edin->v.positive_notification.pn_supplementary_information, 
			 	str_len );
			p35edin->v.positive_notification.pn_supplementary_information[str_len] = '\0';
			break;
		
		/*
		 * Ignore pn_extensions.
		 */
	  }
	}

	*ret_handle = ( int *) p35edin;
	return ( OM_SUCCESS );
}

/*
 * Mapping an Negative EDIN (notification object) into asn1 data structure.
 * Input: the private forwarded EDIN object.
 * Output: 
 */
OM_return_code mhp_f_edin_negative(
	OM_int_private_object_header 	*object_header,
	int 							**ret_handle )
{
 	P35EDIN         				*p35edin;
	OM_int_private_object_header 	*subobject_header;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_descriptor					*omattr;
	void							*handle;
	OM_value						value;
	OM_int_value					*ivalue;
	OM_sint32						value_num;
	P1ORName	      				*orname;
  	char							*string;
	OM_uint32						str_len;
	int 		      				i, status;

	if (( p35edin = ( P35EDIN * ) os_calloc( sizeof ( P35EDIN ))) == NULL )
    	return( OM_MEMORY_INSUFFICIENT );
	
	p35edin->t = EDIN_negative_notification;

	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 	   	if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {
		
		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:

		if (( status = mhp_f_edi_common_fields( 
                        &p35edin->v.negative_notification.nn_common_fields,
                        attribute )) != OM_SUCCESS )
			return ( status );
		break;

		case EDI_NN_REASON_CODE:
			p35edin->v.negative_notification.m |= 
								NegativeNotificationFields_nn_reason_code;
		   	omattr = ( OM_descriptor * ) value.object.object;
		   	subobject_header = (OM_int_private_object_header *)--omattr;
		   	if (( status = mhp_f_edi_nn_reason_code(subobject_header,p35edin))
		   													   != OM_SUCCESS )
		   		return( status );
			break;

		case EDI_SUPPLEMENTARY_INFO:
       		p35edin->v.negative_notification.m |= 
					NegativeNotificationFields_nn_supplementary_information; 
		   	str_len = value.string.length;
		   	string = ( char * )value.string.elements;
		    /* Teletex string: use binary copy. */
           	sl_bcopy( string,
		      	p35edin->v.negative_notification.nn_supplementary_information,
                str_len );
			p35edin->v.negative_notification.nn_supplementary_information[str_len] = '\0';
			break;
		
			/*
		 	 * ignore nn_extensions
		  	 */
		}
  	}
  
  	*ret_handle = ( int * ) p35edin;
  	return ( OM_SUCCESS );
}

/*
 * Mapping an Forwarded EDIN (notification object) into asn1 data structure.
 * Input: the private forwarded EDIN object.
 * Output: 
 */
OM_return_code mhp_f_edin_forwarded(
	OM_int_private_object_header 	*object_header,
	int 							**ret_handle)
{
	OM_int_private_object_header 	*subobject_header;
    P35EDIN         				*p35edin;
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_descriptor					*omattr;
	void							*handle;
	OM_value						value;
	OM_int_value					*ivalue;
	OM_sint32						value_num;
	P1ORName	      				*orname;
  	char							*string;
	OM_uint32						str_len;
	int 		      				i, status;


	if (( p35edin = ( P35EDIN * ) os_calloc( sizeof ( P35EDIN ))) == NULL )
    	return( OM_MEMORY_INSUFFICIENT );
	
	p35edin->t = EDIN_forwarded_notification;

	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 	   	if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:
			if (( status = mhp_f_edi_common_fields( 
                        &p35edin->v.forwarded_notification.fn_common_fields,
                        attribute )) != OM_SUCCESS )
				return ( status );
			break;

		case EDI_SUPPLEMENTARY_INFO:
        	p35edin->v.forwarded_notification.m |= 
					ForwardedNotificationFields_fn_supplementary_information; 
		   	str_len = value.string.length;
		   	string = ( char * )value.string.elements;
		    /* Teletex string: use binary copy. */
           sl_bcopy( string,
		      	p35edin->v.forwarded_notification.fn_supplementary_information, 
				str_len );
			p35edin->v.forwarded_notification.fn_supplementary_information[str_len] = '\0';
			break;
		
		/*
		 * ignore fn_extensions
		 */

		case EDI_FORWARD_TO:
        	p35edin->v.forwarded_notification.m |=
				ForwardedNotificationFields_forwarded_to;
		   	omattr = ( OM_descriptor * ) value.object.object;
		   	subobject_header = (OM_int_private_object_header *)--omattr;
		   	if (( status = mhp_f_orname( subobject_header, &orname ))
			      									  != OM_SUCCESS )
		    	return( status );
		   	p35edin->v.forwarded_notification.forwarded_to = (int *) orname;
			break;

		case EDI_FN_REASON_CODE:
        	p35edin->v.forwarded_notification.m 
								|= ForwardedNotificationFields_fn_reason_code;
		   	omattr = ( OM_descriptor * ) value.object.object;
		   	subobject_header = (OM_int_private_object_header *)--omattr;
		   	if (( status = mhp_f_edi_fn_reason_code(subobject_header,p35edin))
		   													   != OM_SUCCESS )
		    	return( status );
			break;
		}
	}

	*ret_handle = ( int * )p35edin;
	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_nn_reason_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_string						*class;
	int								status;

	class = &( object_header->context.descriptor_list[CLASS_POS].attr_value->value.string );
	
	if ( IS_CLASS( class, &EDI_C_NN_UAMS_REASON_CODE )) {
    	p35edin->v.negative_notification.nn_reason_code.t =
									NNReasonCodeField_nn_ua_ms_reason_code;
		status = mhp_f_edi_nn_ua_ms_code( object_header, p35edin );
	}
	else if ( IS_CLASS( class, &EDI_C_NN_USER_REASON_CODE )) {
		p35edin->v.negative_notification.nn_reason_code.t =
									NNReasonCodeField_nn_user_reason_code;
		status = mhp_f_edi_nn_user_code( object_header, p35edin );
	}
	else {	/* IS_CLASS( class, &EDI_C_NN_PDAU_REASON_CODE ) */
		p35edin->v.negative_notification.nn_reason_code.t =
									NNReasonCodeField_nn_pdau_reason_code;
		status = mhp_f_edi_nn_pdau_code( object_header, p35edin );
	}

	return ( status );	
}

OM_return_code mhp_f_edi_nn_ua_ms_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_BASIC_CODE:
	        p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.m
		  					|= NNUAMSReasonCodeField_nn_ua_ms_basic_code;
            p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.nn_ua_ms_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.m 
							|= NNUAMSReasonCodeField_nn_ua_ms_diagnostic;
            p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.nn_ua_ms_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_nn_user_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_BASIC_CODE:
	        p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.m
		  					|= NNUserReasonCodeField_nn_user_basic_code;
            p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.nn_user_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.m 
							|= NNUserReasonCodeField_nn_user_diagnostic;
            p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.nn_user_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_nn_pdau_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_BASIC_CODE:
	        p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.m
		  					|= NNPDAUReasonCodeField_nn_pdau_basic_code;
            p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.nn_pdau_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.m 
							|= NNPDAUReasonCodeField_nn_pdau_diagnostic;
            p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.nn_pdau_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_fn_reason_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_string						*class;
	int								status;

	class = &( object_header->context.descriptor_list[CLASS_POS].attr_value->value.string );
	
	if ( IS_CLASS( class, &EDI_C_FN_UAMS_REASON_CODE )) {
    	p35edin->v.forwarded_notification.fn_reason_code.t =
									FNReasonCodeField_fn_ua_ms_reason_code;
		status = mhp_f_edi_fn_ua_ms_code( object_header, p35edin );
	}
	else if ( IS_CLASS( class, &EDI_C_FN_USER_REASON_CODE )) {
		p35edin->v.forwarded_notification.fn_reason_code.t =
									FNReasonCodeField_fn_user_reason_code;
		status = mhp_f_edi_fn_user_code( object_header, p35edin );
	}
	else {	/* IS_CLASS( class, &EDI_C_FN_PDAU_REASON_CODE ) */
		p35edin->v.forwarded_notification.fn_reason_code.t =
									FNReasonCodeField_fn_pdau_reason_code;
		status = mhp_f_edi_fn_pdau_code( object_header, p35edin );
	}

	return ( status );	
}

OM_return_code mhp_f_edi_fn_ua_ms_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_FN_SECUR_CHECK:
	        p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.m
		  					|= FNUAMSReasonCodeField_fn_security_check;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_security_check = 
							(sint16) value.boolean;
			break;

		case EDI_BASIC_CODE:
	        p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.m
		  					|= FNUAMSReasonCodeField_fn_ua_ms_basic_code;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_ua_ms_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.m 
							|= FNUAMSReasonCodeField_fn_ua_ms_diagnostic;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_ua_ms_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_fn_user_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_BASIC_CODE:
	        p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.m
		  					|= FNUserReasonCodeField_fn_user_basic_code;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.fn_user_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.m 
							|= FNUserReasonCodeField_fn_user_diagnostic;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.fn_user_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_fn_pdau_code(
	OM_int_private_object_header 	*object_header,
	P35EDIN							*p35edin )
{
	OM_int_descriptor				*object;
	OM_int_descriptor				*attribute;
	OM_int_value					*ivalue;
	OM_value						value;
	OM_uint16						value_num;
	int								i, status;


 	object = object_header->context.descriptor_list;

	for ( i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++ ) {

 		if (( value_num = object[i].count ) == 0 )
			continue;

		attribute = ( OM_int_descriptor * ) &object[i];
		ivalue = ( OM_int_value * ) attribute->attr_value;
		value = ivalue->value;

		switch ( attribute->attr_type ) {

		case EDI_BASIC_CODE:
	        p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.m
		  					|= FNPDAUReasonCodeField_fn_pdau_basic_code;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.fn_pdau_basic_code = 
							(sint16) value.integer;
			break;

		case EDI_DIAGNOSTIC:
       		p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.m 
							|= FNPDAUReasonCodeField_fn_pdau_diagnostic;
            p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.fn_pdau_diagnostic = 
                        	(sint16) value.integer;
			break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}

OM_return_code mhp_f_edi_common_fields(
	P35CommonFields					*common_fields,        
	OM_int_descriptor				*attribute )
{
	OM_value						value;
	OM_int_value					*ivalue;
	OM_sint32						value_num;
	OM_descriptor					*omattr;
	OM_int_private_object_header	*subobject_header;
	OM_uint32						str_len;
	P1ORName						*orname;
	int								status, i;
	char							*string;
	void							*handle;


	ivalue = ( OM_int_value * ) attribute->attr_value;
	value = ivalue->value;

	/* The following are the common fields used in P35 EDINs. */
	switch ( attribute->attr_type ) {

	case EDI_SUBJECT_EDIM:
    	common_fields->m |= CommonFields_subject_edim;
		omattr = ( OM_descriptor * ) value.object.object;
		handle = NULL;
		subobject_header = (OM_int_private_object_header *)--omattr;
		if (( status = mhp_f_edi_id( subobject_header, 
							( P35EDIMIdentifier ** ) &handle)) != OM_SUCCESS )
		      return( status );
        common_fields->subject_edim = (int *) handle;  
		break;

	case EDI_EDIN_ORIG:
		common_fields->m |= CommonFields_edin_originator; 
		omattr = ( OM_descriptor * ) value.object.object;
		subobject_header = (OM_int_private_object_header *)--omattr;
		if (( status = mhp_f_orname( subobject_header, &orname )) 
												  != OM_SUCCESS )
			return( status );
		common_fields->edin_originator = (int *) orname;		
		break;

	case EDI_FIRST_RECIP:
    	common_fields->m |= CommonFields_first_recipient;
		omattr = ( OM_descriptor * ) value.object.object;
	   	subobject_header = (OM_int_private_object_header *)--omattr;
		if (( status = mhp_f_orname( subobject_header, &orname )) 
												  != OM_SUCCESS )
			return( status );
		common_fields->first_recipient = (int *) orname;
		break;

	case EDI_NOTIF_TIME:
    	common_fields->m |= CommonFields_notification_time;
		if (( status = mhp_date_conv( &common_fields->notification_time,
						(char *) value.string.elements, 
						value.string.length )) != OM_SUCCESS ) {
			if (status == OM_WRONG_VALUE_MAKEUP )
				log_error( OM_WRONG_VALUE_MAKEUP, OMP_DF_WRONG_VALUE_MAKEUP,
				      	   attribute->attr_type, attribute->attr_syntax, 0, 
				      	   value.string.elements );
       		return( status );
		}
		break;

	case EDI_SECUR_ELEMENTS:
        /*
		 * Ignore, will never receive edi security elements.
		 */
/*		common_fields->m |= CommonFields_notification_security_elements;
 *		omattr = ( OM_descriptor * ) value.object.object
 *		subobject_header = (OM_int_private_object_header *)--omattr;
 *		if (( status = mhp_f_edi_notif_security_elements( subobject_header, 
 *						 	common_fields )) != OM_SUCCESS )
 *		      return( status );
 */		return ( MH_RC_FEATURE_UNAVAILABLE );
		break;

	case EDI_EDIN_INITIATOR:
    	common_fields->m |= CommonFields_edin_initiator;
		switch ( value.enumeration ) {
		case EDI_EI_INTERNAL_UA:
			common_fields->edin_initiator = (sint16)EDIN_INITIATOR_internal_ua;
			break;
		case EDI_EI_EX_UA:
			common_fields->edin_initiator = (sint16)EDIN_INITIATOR_external_ua;
			break;
		case EDI_EI_INTERNAL_MS:
			common_fields->edin_initiator = (sint16)EDIN_INITIATOR_internal_ms;
			break;
		}			
        break;

/* 
 * The notif extensions is defined twice, once as part of the P35 Common
 * fields, and once as an attribute of the positive notification.
 */
	case EDI_NOTIF_EXTENSIONS:
		common_fields->m |= CommonFields_notifications_extensions;
		i = 0;
		while ( value_num -- ) {
			omattr = ( OM_descriptor * ) value.object.object;
		   	subobject_header = (OM_int_private_object_header *)--omattr;
		   	if (( status = mhp_f_edi_extension( subobject_header,
		               		&common_fields->notifications_extensions.v[i++] )) 
					   										  != OM_SUCCESS )
				return( status );
			ivalue = (OM_int_value *) ivalue->next;
			value = ivalue->value;
		}
		break;
	}
		
	return (OM_SUCCESS);
}
