#if defined(MODULEID) && !defined(lint)
static char rcsid[]="$Header: formatim.c,v 3.18 93/01/18 15:34:27 trang Exp $";
#endif

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include "p1p2.h"
#include "xom.h"
#include "xmhp.h"
#include "ximp.h"
#include "xomhp.h"
#include "x4apifp.h"
#include "x4cat.h"
#include "conf.h"
#include "climport.h"
#include <osdeps.h>

extern OM_boolean mhp_is84IM;
extern OM_boolean mhp_is84MH;
extern char *_MH_BodyPart_dir;  /* tmp directory */
extern OM_return_code omp_link_str_file(char *srce, char **dest);
extern int mhp_f_orname();
extern boolean list_append();
extern boolean list_alloc();
extern void log_error();
extern char *omp_hexme(OM_string);
extern int mhp_external();

OM_return_code mhp_f_im_desc();
OM_return_code mhp_f_im_id();
/* internal static functions */
static OM_return_code mhp_f_im_recip();
static OM_return_code mhp_f_im_desc_list();
static OM_return_code mhp_f_im_body();
static OM_return_code mhp_f_im_ia5bp();
static OM_return_code mhp_f_im_binary();
static OM_return_code mhp_f_im_iso6937bp();
static OM_return_code mhp_f_im_msgbp();
static OM_return_code mhp_f_im_delenvelop();
static OM_return_code mhp_f_im_ttxbp();
static OM_return_code mhp_f_im_externalbp();

#define IS_CLASS(string1, string2)      \
    ( sl_bcmp( (string1)->elements, (string2)->elements, (string1)->length)?FALSE:TRUE)


/*********************************************************************
** this function takes a message, a probe or a report object and
** put it it into data structure for formatting.
**    int i_format_ipm(object)
** Input:
**      object: pointer to ipm message.
** Output:
**      handle: returned pointer to P22InformationObject.
**
*********************************************************************
*/

OM_return_code mhp_f_im_ipm(object_header, ret_handle)
OM_int_private_object_header *object_header;
P22InformationObject **ret_handle;

{

    int i,n, status;
    void *handle;
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_sint32 value_num;
    char *string;
    OM_uint32 str_len;
    P22IPM *impdu;
    P22Heading *heading;
    P22Body *body;
    P22InformationObject *p2;
    P22ExtensionsField   *pex;
        struct any_type  *evalue;
    P22HeadingExtension  *phex;
    /* struct bodypart *bdpart; */


    /* space for interpersonal message and pointers to heading and body */
    if ((p2 = (P22InformationObject *)os_calloc(sizeof(P22InformationObject))) == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    if ((impdu = (P22IPM*)os_calloc(sizeof(P22IPM))) == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    impdu->m |= IPM_Heading; /* mask for at least heading */
    heading = (P22Heading *)&impdu->heading;
    body = (P22Body *)&impdu->body;

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
    {
        if ((value_num = object[i].count) == 0) continue;
        attribute = (OM_int_descriptor *) & object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;

        switch (attribute->attr_type) {
            case IM_COPY_RECIPIENTS:
                heading->m |= Heading_copy_recipients;
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if (mhp_f_im_recip(subobject_header, &(heading->copy_recipients)) 
                                                            != OM_SUCCESS){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) /* value if next attribute present */
                        value = ivalue->value;
                } /* while of IM_COPY_RECIPIENT case */
                break;

            case IM_ORIGINATOR:
                heading->m |= Heading_originator;
                handle = NULL; /* init for obj_descriptor to allocate space */
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_im_desc(subobject_header, &handle)) != OM_SUCCESS)
                    return(status);
                heading->originator = (int *)handle;
                break;

            case IM_PRIMARY_RECIPIENTS:
                heading->m |= Heading_primary_recipients;
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if (mhp_f_im_recip(subobject_header, 
                                &(heading->primary_recipients)) != OM_SUCCESS){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) /* value if next attribute present */
                        value = ivalue->value;
                } /* while of IM_PRIMARY_RECIPIENT case */
                break;

            case IM_SUBJECT:
                heading->m |= Heading_subject;
                heading->subject.t = SubjectField_teletex_string;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                    /* teletex string: use binary copy. */
                sl_bcopy(string, heading->subject.v.teletex_string,str_len);
                heading->subject.v.teletex_string[str_len] = '\0';
                break;

            case IM_THIS_IPM:
                heading->m |= Heading_this_IPM;
                handle = NULL;  /* init handle */
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_im_id(subobject_header, &handle)) != OM_SUCCESS)
                    return(status);
                heading->this_IPM = (int *)handle;
                break;

            case IM_BODY: 
                impdu->m |= IPM_Body; /*option mask:body might not be present*/ 

                /* The value(s) of this attribute is bodypart objects.  */
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if ((status = mhp_f_im_body(subobject_header, body)) 
                                                        != OM_SUCCESS)
                        return(status);
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value = ivalue->value;
                }
                break;
            case IM_AUTHORIZING_USERS:
                heading->m |= Heading_authorizing_users;
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if ((status = mhp_f_im_desc_list(subobject_header, 
                                    &heading->authorizing_users)) 
                                    != OM_SUCCESS)
                        return(status);
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value = ivalue->value;
                } /* while authorizing users */
                break;

            case IM_AUTO_FORWARDED:
                heading->m |= Heading_auto_forwarded;
                heading->auto_forwarded = value.boolean;
                break;
            case IM_BLIND_COPY_RECIPIENTS:
                heading->m |= Heading_blind_copy_recipients;
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if (mhp_f_im_recip(subobject_header, 
                                     &(heading->blind_copy_recipients)) 
                                     != OM_SUCCESS){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value = ivalue->value;
                } /* while of IM_BLIND_COPY_RECIPIENT case */
                break;
            case IM_IMPORTANCE:
                heading->m |= Heading_importance;
                heading->importance = (sint16)value.enumeration;
                break;
            case IM_SENSITIVITY:
                switch (value.enumeration) {    
                    case IM_PERSONAL:
                        heading->m |= Heading_sensitivity;
                        heading->sensitivity = (sint16)SENSITIVITY_personal;
                        break;
                    case IM_PRIVATE:
                        heading->m |= Heading_sensitivity;
                        heading->sensitivity = (sint16)SENSITIVITY_private;
                        break;
                    case IM_COMPANY_CONFIDENTIAL:
                        heading->m |= Heading_sensitivity;
                        heading->sensitivity = (sint16)SENSITIVITY_company_confidential;
                        break;
                    case IM_NOT_SENSITIVE: /* do nothing */
                        break;
                } /* switch sensitivity */
                break;
            case IM_EXPIRY_TIME:
                heading->m |= Heading_expiry_time;
                if ((status = mhp_date_conv(&heading->expiry_time,
                        (char *) value.string.elements,
                        value.string.length)) != OM_SUCCESS) {
                    if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP, 
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
                
                break;
            case IM_OBSOLETED_IPMS:
                heading->m |= Heading_obsoleted_IPMs;
                while(value_num-- > 0) {
                    if (list_alloc(&heading->obsoleted_IPMs, sizeof(P22IPMIdentifier)) == FALSE){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if ((status = mhp_f_im_id(subobject_header, 
                            &heading->obsoleted_IPMs.current->data)) 
                            != OM_SUCCESS)
                        return(status);
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value =  ivalue->value;
                    list_append(&heading->obsoleted_IPMs);
                } 
                break;
            case IM_RELATED_IPMS:
                heading->m |= Heading_related_IPMs;
                while(value_num-- > 0) {
                    if (list_alloc(&heading->related_IPMs, 
                            sizeof(P22IPMIdentifier)) 
                            == FALSE){
                        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                        return(OM_MEMORY_INSUFFICIENT);
                    }
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if ((status = mhp_f_im_id(subobject_header, 
                            &heading->related_IPMs.current->data)) 
                            != OM_SUCCESS)
                        return(status);
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value =  ivalue->value;
                    list_append(&heading->related_IPMs);
                } 
                break;
            case IM_REPLIED_TO_IPM:
                heading->m |= Heading_replied_to_IPM;
                handle = NULL; /* mhp_f_im_id() will allocate space */
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_im_id(subobject_header, &handle)) != OM_SUCCESS)
                    return(status);
                heading->replied_to_IPM = (int *)handle;
                break;
            case IM_REPLY_RECIPIENTS:
                heading->m |= Heading_reply_recipients;
                while (value_num-- > 0) {
                    omattr = (OM_descriptor *)value.object.object;
                    subobject_header =(OM_int_private_object_header *)--omattr;
                    if ((status = mhp_f_im_desc_list(subobject_header, 
                            &(heading->reply_recipients))) 
                            != OM_SUCCESS)
                        return(status);
                    ivalue = (OM_int_value *)ivalue->next;
                    if (ivalue != NULL) 
                        value =  ivalue->value;
                } /* while reply recipients */
                break;

            case IM_REPLY_TIME:
                /* date_conv() returns wrong_value_makeup error */
                heading->m |= Heading_reply_time;
                if ((status = mhp_date_conv( &heading->reply_time,
                        (char *) value.string.elements,
                        value.string.length)) != OM_SUCCESS) {
                    if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP, 
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
                }
                break;
                                case IM_INCOMPLETE_COPY:
                if (value.boolean == TRUE)
                {
                heading->m |= Heading_extensions;
                            if ((pex = (P22ExtensionsField *)os_calloc
                   (sizeof(P22ExtensionsField))) == NULL)
                { 
                    log_error(OM_MEMORY_INSUFFICIENT, 
                    OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                heading->extensions = (int *)pex;

                            if ((phex = (P22HeadingExtension *)
                   os_calloc(sizeof(P22HeadingExtension))) 
                               == NULL)
                                {
                    log_error(OM_MEMORY_INSUFFICIENT, 
                    OMP_DF_MEMORY_INSUFFICIENT);
                    return(OM_MEMORY_INSUFFICIENT);
                }
                pex->v[pex->n] = (int *) phex;
                pex->n = (pex->n) +1;
                phex->m |=
                        HeadingExtension_headingextensiontype;
                phex->headingextensiontype.id[0] = 2;
                phex->headingextensiontype.id[1] = 6;
                phex->headingextensiontype.id[2] = 1;
                phex->headingextensiontype.id[3] = 5;
                phex->headingextensiontype.id[4] = 0;
                phex->headingextensiontype.length = 5; 
                phex->hdexttype = 0;
                
                evalue = (struct any_type *) encode_p2hding_extensions
                         (NULL, phex->hdexttype);
                                if (evalue == NULL)
                {
                        log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                            return(OM_SYSTEM_ERROR);
                }
                                phex->headingextensionvalue = (int *)evalue; 

                phex->m |=HeadingExtension_headingextensionvalue;
                                phex->refcnt = phex->refcnt + 1; 
                } /* if there is a value */
                                break;

         case IM_LANGUAGES:
         {
         P22Languages *lang;
           heading->m |= Heading_extensions;
           if ((pex = (P22ExtensionsField *)os_calloc
              (sizeof(P22ExtensionsField))) == NULL)
           { 
            log_error(OM_MEMORY_INSUFFICIENT, 
            OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
           }
           heading->extensions = (int *)pex;

           if ((phex = (P22HeadingExtension *)
              os_calloc(sizeof(P22HeadingExtension))) 
                   == NULL)
           {
            log_error(OM_MEMORY_INSUFFICIENT, 
            OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
           }
           pex->v[pex->n] = (int *) phex;
           pex->n = (pex->n) +1;
           phex->m |=
            HeadingExtension_headingextensiontype;
           phex->headingextensiontype.id[0] = 2;
           phex->headingextensiontype.id[1] = 6;
           phex->headingextensiontype.id[2] = 1;
           phex->headingextensiontype.id[3] = 5;
           phex->headingextensiontype.id[4] = 1;
           phex->headingextensiontype.length = 5; 
           phex->hdexttype = 1;
   
           if ((phex->extstruct = (char *)
              os_calloc(sizeof(P22Languages))) 
                      == NULL)
           {
               log_error(OM_MEMORY_INSUFFICIENT, 
               OMP_DF_MEMORY_INSUFFICIENT);
               return(OM_MEMORY_INSUFFICIENT);
           }
           lang = (P22Languages *) phex->extstruct;
           lang->n =0;
   
           while (value_num-- > 0) {
               memcpy ( lang->v[lang->n], ivalue->value.string.elements, 
                ivalue->value.string.length);
               lang->v[lang->n][ivalue->value.string.length] = '\0';
               lang->n ++;
   
               ivalue = (OM_int_value *)ivalue->next;
               if (ivalue != NULL) 
                   value =  ivalue->value;
           }
            
        
           evalue = (struct any_type *) encode_p2hding_extensions
                (NULL, phex->hdexttype);
           os_free((void*)lang);
           if (evalue == NULL)
           {
               log_error(OM_SYSTEM_ERROR, 
                      OMP_DF_SYSTEM_ERROR);
               return(OM_SYSTEM_ERROR);
           }
           phex->headingextensionvalue = (int *)evalue; 
   
           phex->m |=HeadingExtension_headingextensionvalue;
           phex->refcnt = phex->refcnt + 1; 
           break;
         } /* case IM_LANGUAGES */
   
        } /* switch attribute->attr_type */
    } /* for */
    /* set tag for IPM in the CHOICE and pointer to IPM structure */
    p2->t = InformationObject_ipm;
    p2->v.ipm = (int *)impdu;
    *ret_handle = (P22InformationObject *)p2;


    return (OM_SUCCESS);
} /* mhp_f_im_ipm() */
    



/* ********************************************************************
 * mhp_f_im_desc(object, handle) fills in data structure and
 * returns handle to the data structure. It allocates memory for
 * handle if it's NULL.
 *
 **********************************************************************
 */

OM_return_code mhp_f_im_desc(object_header, ret_handle)
OM_int_private_object_header *object_header;
P22ORDescriptor **ret_handle;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_int_value *ivalue;
    OM_value value;
    char *string;
    OM_uint32 str_len;
    OM_uint16 value_num;
    P22ORDescriptor *descriptor;
    P1ORName *orname;
    int i, status;


    if (*ret_handle == NULL) { /* allocate memory if handle is null */
        if ((descriptor = (P22ORDescriptor *)
                                os_calloc(sizeof(P22ORDescriptor))) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }
        *ret_handle = descriptor;  /* first set returned handle here */
    }
    else descriptor = *ret_handle;  /* caller allocated space already */

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
        if ((value_num = object[i].count) == 0) continue;
        attribute = (OM_int_descriptor *) & object[i];
        ivalue = (OM_int_value *)attribute->attr_value;
        value = ivalue->value;

        switch (attribute->attr_type) {
            case IM_FORMAL_NAME:
                descriptor->m |= ORDescriptor_formal_name;
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_orname(subobject_header, &orname)) != OM_SUCCESS)
                    return(status);
                descriptor->formal_name = (int *)orname;
                break;
            case IM_FREE_FORM_NAME:
                descriptor->m |= ORDescriptor_free_form_name;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                    /* teletex string. use binary copy */
                sl_bcopy(string, descriptor->free_form_name, str_len);
                descriptor->free_form_name[str_len] = '\0';
                break;
            case IM_TELEPHONE_NUMBER:
                descriptor->m |= ORDescriptor_telephone_number;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                strncpy(descriptor->telephone_number, string, str_len);
                descriptor->telephone_number[str_len] = '\0';
                break;
            default:
                log_error(OM_NO_SUCH_TYPE, OMP_DF_NO_SUCH_TYPE, 
                    attribute->attr_type, 
                    object[CLASS_POS].attr_value->value.string.elements);
                return(OM_NO_SUCH_TYPE);
        } /* switch attribute->attr_type */
    } /* for */

    return(OM_SUCCESS);

} /* mhp_f_im_desc() */



/***************************************************************************** 
 * mhp_f_im_id(object, handle) put Identifier object into data structure
 * and returns handle to the structure.
 * Input:
 *          object - IPM Identifier object pointer
 *          ret_handle - address of pointer variable for returned structure
 *                   if NULL, this function allocates space.
 * Output:
 *          ret_handle - contains the address of the IPMIdentifer structure
 *
 *************************************************************************** */

OM_return_code mhp_f_im_id(object_header, ret_handle)
OM_int_private_object_header *object_header;
P22IPMIdentifier **ret_handle;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_int_value *ivalue;
    OM_value value;
    char *string;
    OM_uint32 str_len;
    OM_uint16 value_num;
    P22IPMIdentifier *id;
    P1ORName *orname;
    int i, status;

    if (*ret_handle == NULL) { 
        if ((id = (P22IPMIdentifier *)
                                os_calloc(sizeof(P22IPMIdentifier))) == NULL){
            log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
            return(OM_MEMORY_INSUFFICIENT);
        }   
    }
    else id = *ret_handle;
    
    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
        if ((value_num = object[i].count) == 0) continue;
        attribute = &object[i];
        ivalue = attribute->attr_value;
        value = ivalue->value;
        switch (attribute->attr_type) {
            case IM_USER:
                id->m |= IPMIdentifier_user;
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_orname(subobject_header, &orname)) != OM_SUCCESS)
                    return(status);
                id->user = (int *)orname;
                break;

            case IM_USER_RELATIVE_IDENTIFIER:
                id->m |= IPMIdentifier_user_relative_identifier;
                str_len = value.string.length;
                string = (char *)value.string.elements;
                strncpy(id->user_relative_identifier, string, str_len);
                id->user_relative_identifier[str_len] = '\0';
                break;
        } /* swtich attribute->attr_type */
    } /* for */

    *ret_handle = (P22IPMIdentifier *)id;
    return(OM_SUCCESS);
} /* mhp_f_im_id() */



/**************************************************************************** 
 * mhp_f_im_recip(object, handle) allocates space in the list, 
 * puts Recipient Specifier object into data structure, 
 * adds it to a list with the given pointer.
 * Input:
 *          object - pointer of an instance of RecipientSpecifier value.
 *          handle - pointer to the start of the list as referenced in
 *                  the main structure (aaListPointer).
 * Output:
 *          a new Recipient Specifier structure is added to the list pointed 
 *          by handle. Return OM_MEMORY_INSUFFICIENT if not enough space,
 *          OM_SUCCESS otherwise.
 ****************************************************************************/

static OM_return_code mhp_f_im_recip(object_header, ret_handle)
OM_int_private_object_header *object_header;
aaListPointer ret_handle;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_int_value *ivalue;
    OM_value value;
    OM_uint16 value_num;
    P22RecipientSpecifier *specifier;
    P22ORDescriptor *descriptor;
    int i, status;


    if (list_alloc(ret_handle, sizeof(P22RecipientSpecifier)) == FALSE){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }

    specifier = (P22RecipientSpecifier *)ret_handle->current->data;

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) 
    {
        if ((value_num = object[i].count) == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;

        switch (attribute->attr_type) {
            case IM_RECIPIENT:
                descriptor = NULL; /* init handle */
                specifier->m |= RecipientSpecifier_recipient;
                omattr = (OM_descriptor *)value.object.object;
                subobject_header =(OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_im_desc(subobject_header, &descriptor)) != OM_SUCCESS)
                    return(status);
                specifier->recipient = (int *)descriptor;
                break;
            case IM_NOTIFICATION_REQUEST:
                specifier->m |= RecipientSpecifier_notification_requests;
                if (value.enumeration == IM_NON_RECEIPT) 
                    specifier->notification_requests |= NOTIFICATION_REQUESTS_nrn;
                else if (value.enumeration == IM_ALWAYS) 
                    specifier->notification_requests |= NOTIFICATION_REQUESTS_rn;
                break;
            case IM_IPM_RETURN_REQUESTED:
                specifier->m |= RecipientSpecifier_notification_requests;
                if (value.boolean == TRUE)
                    specifier->notification_requests |= NOTIFICATION_REQUESTS_ipm_return;
                break;
            case IM_REPLY_REQUESTED:
                specifier->m |= RecipientSpecifier_reply_requested;
                specifier->reply_requested = value.boolean;
                break;
        } /* switch attribute->attr_type */
    } /* for */

    list_append(ret_handle);

    return(OM_SUCCESS);
} /* mhp_f_im_recip() */



/***************************************************************************** 
 * mhp_f_im_desc_list(object, handle) allocates space in the list, 
 * puts ORDescriptor object into data structure, adds it to a list 
 * with the given pointer.
 * Input:
 *          object - pointer of an instance of ORDescriptor value.
 *          handle - pointer to the list (aaListPointer).
 * Output:
 *          a new ORDescriptor structure is added to the list 
 *          pointed by handle. Return OM_MEMORY_INSUFFICIENT if not enough space,
 *          OM_SUCCESS otherwise.
 ****************************************************************************/

static OM_return_code mhp_f_im_desc_list(object_header, handle)
OM_int_private_object_header *object_header;
aaListPointer handle;

{
    P22ORDescriptor *descriptor;
    int status;

    if (list_alloc(handle, sizeof(P22ORDescriptor)) == FALSE){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    
    descriptor = (P22ORDescriptor *)handle->current->data;
    if ((status = mhp_f_im_desc(object_header, &descriptor)) != OM_SUCCESS)
        return(status);
    list_append(handle);


    return(OM_SUCCESS);
} /* mhp_f_im_desc_list() */



/****************************************************************************
 * mhp_f_im_body(object, ret_handle) processes and switches the various body
 * parts in the BodyPart object to appropriate function calls.
 * It append the aaListType to the (P22Body *) body, which is a pointer
 * to a list of aaListTypes.
 *
 *
 ****************************************************************************/

static OM_return_code mhp_f_im_body(object_header, body)
OM_int_private_object_header *object_header;
P22Body *body;
{
    OM_int_descriptor *object;
    OM_string *class;
    struct bodypart *bdpart;
    int status;

    /* 
    The value of this attribute is bodypart object.
    Each object goes into one element of the bodypart structure
    list. The type of bodypart structure is Bodypart object class. 
    The value of bodypart structure is the filename of the data to 
    be included.
    */

        /* first allocate list of bodyparts */
    if (list_alloc(body, sizeof(bodypart)) == FALSE){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    bdpart = (bodypart *)body->current->data;

            /*the first attribute is type OM_CLASS and has 
            the class as value of type OM_uint32 ?????? */
    object = object_header->context.descriptor_list;
    class = &object[CLASS_POS].attr_value->value.string;

                /* need to check the class as object id string */
    if (IS_CLASS(class, &IM_C_IA5_TEXT_BD_PRT)) 
    {
        if ((status = mhp_f_im_ia5bp(object_header, bdpart)) != OM_SUCCESS) 
            return(status);
    }
    else if (IS_CLASS(class, &IM_C_BILAT_DEF_BD_PRT))
    {
        if ((status = mhp_f_im_binary(object_header, bdpart)) != OM_SUCCESS)
            return(status);
    }
    else if (IS_CLASS(class, &IM_C_MESSAGE_BD_PRT)) {
        if ((status = mhp_f_im_msgbp(object_header, bdpart)) != OM_SUCCESS)
            return(status);
    }
    else if (IS_CLASS(class, &IM_C_ISO_6937_TEXT_BD_PRT)) {
        if ((status = mhp_f_im_iso6937bp(object_header, bdpart)) != OM_SUCCESS)
            return(status);
    }
        /*
        case IM_C_G3_FAX_BD_PRT:
        case IM_C_G4_CLASS_1_BD_PRT:
        case IM_C_MIXED_MODE_BD_PRT:
        case IM_C_NATIONALLY_DEFINED_BD_PRT:
        case IM_C_TELETEX_BD_PRT:
        case IM_C_VIDEOTEX_BD_PRT:
        */

    else if (IS_CLASS(class, &IM_C_EXTERN_DEF_BD_PRT)) {
        if ((status = mhp_f_im_externalbp(object_header, bdpart)) != OM_SUCCESS)
            return(status);
    }   
    
    else { /* error for unsupported body part */
        log_error(OM_NO_SUCH_CLASS, OMP_DF_NO_SUCH_CLASS,
                omp_hexme(*class));
        return(OM_NO_SUCH_CLASS);
    }

    list_append(body);

    return (OM_SUCCESS);
} /* end mhp_f_im_body() */





/***************************************************************************** 
 * mhp_f_im_ia5bp(object, bodyptr) puts IA5 Text Body Part object in
 * the list element of Body (the element is bodypart). The Text value 
 * always is a file
 * name. This involves setting the type in bodypart structure as IA5, 
 * bodypart.data to be P22IA5BodyPart and P22IA5BodyPart.data to contain
 * the filename.
 * Input:
 *          object - the bodypart object.
 *          bodyptr - pointer to the current->data of the list
 *                  where IA5 Text Body Part info should be inserted
 * Output:
 *          success or failure.
 ****************************************************************************/

static OM_return_code mhp_f_im_ia5bp(object_header, partptr)
OM_int_private_object_header *object_header;
bodypart *partptr;
{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    P22IA5TextBodyPart *ia5;
    char *string;
    char *buf;
    int i;
    OM_return_code status;


    /* no longer valid, since the class is now a object id string 
    partptr->type = IM_C_IA5_TEXT_BD_PRT;  this is used by fX_Body() 
    */

    partptr->type = MH_IA5TEXTPART;
    if ((ia5 = (P22IA5TextBodyPart *)
                                os_calloc(sizeof(P22IA5TextBodyPart)))== NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    partptr->data = (int *)ia5;

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
        if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;

        switch (attribute->attr_type) {
            case IM_REPERTOIRE:
                ia5->m |= IA5TextBodyPart_parameters;
                ia5->parameters.m |= IA5TextParameters_repertoire;
                    /* set default as IA5 also */
                if (value.enumeration == IM_ITA2)
                    ia5->parameters.repertoire = REPERTOIRE_ita2;
                else ia5->parameters.repertoire = REPERTOIRE_ia5;
                break;

            case IM_TEXT: /* value should be the filename */
                ia5->m |= IA5TextBodyPart_data;
                    /* memory or disk-based value*/
                if (!(ivalue->modifier & OM_INT_ONDISK)) 
                { /* memory-based */
                    if ((status = (int) mhp_write_file(&value.string, &string)) != OM_SUCCESS)
                        return(status);
                    ia5->data = (int *)string; /* full-path filename */
                    break;
                }

                    /* value is the filename: the length however
                       is the size of real data (file size), 
                       not of the filename 
                     */
                if ((status = omp_link_str_file(value.string.elements, &buf)) 
                                        != OM_SUCCESS)
                {
                    return(status);
                }

                ia5->data = (int *)buf;
                break;

        } /* End of switch type */
    }; /* End of for */


    return (OM_SUCCESS);
} /* End of mhp_f_im_ia5bp */




/*
 * mhp_f_im_binary(object, partptr)
 */

static OM_return_code mhp_f_im_binary(object_header, partptr)
OM_int_private_object_header *object_header;
bodypart *partptr;
{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    /* P22Unidentified binary;      /* already typedef as pointer (int *) */
    P22Unidentified *binary;    /* pointer to filename is content of binary*/
    char *str;
    char *buf;
    int i, status;

    /* not used since API class is an object id string 
    partptr->type = IM_C_BILAT_DEF_BD_PRT;  used by fX_Body() 
    */

    partptr->type = MH_UNIDENTIFIED;
    if ((binary =(P22Unidentified *) os_calloc(sizeof(P22Unidentified))) 
            == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
    {
        if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *) & object[i];
        ivalue = attribute->attr_value;
        value = ivalue->value;

        switch(attribute->attr_type) {
            case IM_BILATERAL_DATA:
                if ( !(ivalue->modifier & OM_INT_ONDISK)) /* memory-based */
                {
                    if ((status = mhp_write_file(&value.string, &str)) 
                                                        != OM_SUCCESS){
                        os_free((void*)binary);
                        return(status);
                    }
                    *binary = (P22Unidentified) str;
                }
                else
                {
                    /* value is file name, length however is filesize, 
                    ** not filename length 
                    */
                    if ((status=omp_link_str_file(value.string.elements, &buf))
                                        != OM_SUCCESS)
                    {
                        os_free((void*)binary);
                        return(status);
                    }
                    *binary = (P22Unidentified ) buf;
                }
                partptr->data = (int *)binary;
                break;
                
            default:
                log_error(OM_NO_SUCH_TYPE, OMP_DF_NO_SUCH_TYPE, 
                    attribute->attr_type, 
                    object[CLASS_POS].attr_value->value.string.elements);
                return(OM_NO_SUCH_TYPE);
        }
    }

    return(OM_SUCCESS);

}   /* mhp_f_im_binary() */



/***************************************************************************** 
 * mhp_f_im_iso6937bp(object, bodyptr) puts ISO6937TextBodyPart object in
 * the list element of Body (the element is bodypart). The Text value 
 * always is a file
 * name. This involves setting the type in bodypart structure as ISO 6937, 
 * bodypart.data to be P22ISO6937BodyPart and P22ISO6937BodyPart.data to 
 * contain the filename.
 * Input:
 *          object - the bodypart object.
 *          bodyptr - pointer to the current->data of the list
 *                  where IA5 Text Body Part info should be inserted
 * Output:
 *          success or failure.
 ****************************************************************************/

static OM_return_code mhp_f_im_iso6937bp(object_header, partptr)
OM_int_private_object_header *object_header;
bodypart *partptr;
{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    P22ISO6937Text *iso;
    char *string;
    char *buf;
    int i;
    OM_return_code  status;
    
    partptr->type = MH_ISO6937PART;
    if ((iso = (P22ISO6937Text *) os_calloc(sizeof(P22ISO6937Text)))== NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    partptr->data = (int *)iso;
    
    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
    if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;
    
        switch (attribute->attr_type) {
            case IM_REPERTOIRE:
                iso->m |= ISO6937Text_params;
                iso->params.m |= ISO6937Text_repertoire;
                if (value.enumeration == IM_PART1_AND_PART2)
                    iso->params.repertoire = REPERTOIRE_part1and2;
                                        /* support only part1and2 */
                else iso->params.repertoire = REPERTOIRE_part1and2; 
                break;
    
            case IM_TEXT: /* value should be the filename */
                iso->m |= ISO6937Text_text;
                    /* memory or disk-based value*/
                if (!(ivalue->modifier & OM_INT_ONDISK)) 
                { /* memory-based */
                    if ((status = mhp_write_file(&value.string, &string)) 
                                                        != OM_SUCCESS)
                        return(status);
                    iso->text = (int *)string; /* full-path filename */
                    break;
                }
    
                /* value is the filename: the length however is the size of 
                       real data (file size), not of the filename */
                if ((status = omp_link_str_file(value.string.elements, &buf)) 
                                        != OM_SUCCESS)
                {
                    return(status);
                }
                iso->text = (int *)buf;
                break;
    
        } /* End of switch type */
    }; /* End of for */
    
    return (OM_SUCCESS);
} /* End of mhp_f_im_iso6937bp */




/***************************************************************************** 
 * mhp_f_im_msgbp(object, bodyptr) puts object into the P22MessageBodyPart
 * structure.
 * Input:
 *          object - the bodypart object.
 *          bodyptr - pointer to the current->data of the list
 *                  where IA5 Text Body Part info should be inserted
 * Output:
 *          success or failure.
 * Calling:
 *  mhp_f_im_ipm()
 *
 * Called by:
 *  mhp_f_im_body()
 ****************************************************************************/

static OM_return_code mhp_f_im_msgbp(object_header, partptr)
OM_int_private_object_header *object_header;
bodypart *partptr;
{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    OM_descriptor *omattr;
    OM_int_private_object_header *subobject_header;
    P22MessageBodyPart *msg;
    P22InformationObject *handle;
    int i, status;
    
    partptr->type = MH_FWDEDIPMSG;
    if ((msg = (P22MessageBodyPart *)os_calloc(sizeof(P22MessageBodyPart)))
                                    == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    partptr->data = (int *)msg;
    
    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
    if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;
    
        switch (attribute->attr_type) {
            case IM_ENVELOPE:
                /* passing msg in order to fill in the delivery_time 
                   in the IM_ENVELOPE as well and to get the structure type.
                */
                omattr = (OM_descriptor *)value.object.object;
                subobject_header = (OM_int_private_object_header *)--omattr;
                if ((status = mhp_f_im_delenvelop(subobject_header, 
                        msg)) != OM_SUCCESS)
                    return(status);
                msg->m |= MessageBodyPart_parameters; 
                break;
    
            case IM_IPM: 
                msg->m |= MessageBodyPart_data;
                omattr = (OM_descriptor *)value.object.object;
                subobject_header = (OM_int_private_object_header *)--omattr;

                /* mhp_f_im_ipm() returns pointer to P22InformationObject
                 * but msg->data expects P22IPM*. So, need to extract
                 * P22IPM and free P22InformationObject.
                */
                if ((status=mhp_f_im_ipm(subobject_header, &handle))
                                            != OM_SUCCESS)
                    return(status);
                msg->data =  (int *)((P22InformationObject *)handle)->v.ipm;
                os_free(handle);
                break;
            default:
                break;
        } /* End of switch type */
    } /* End of for */
    
    return (OM_SUCCESS);
} /* End of mhp_f_im_msgbp */


/**************************************************************************
 * mhp_f_im_delenvelop(object_header, handle) puts information in
 * the Delivery Envelope object into the parameters of P22MessageBodyPart.
 * The parameters has two component, the delivery time and 
 * P3OtherMessageDeliveryFields. Both are defined in a single Delivery
 * Envelope class. This can probably leveraged to use in MA interface
 *
 * NOTE: In the context of Forwarded Message Body Part,
 * either delivery time or ALL other attributes might be absent.
 * With the exception of Delivery Time, if any other attributes are
 * present, then the following are mandatory in order to construct
 * good OtherMessageDeliveryFields protocol element:
 *
 *   - content-type
 *   - originator name
 *   - this recipient name (actual recipient name)
 *   - message submission time
 *   - priority
 *   - deliery-flag (Conversion Prohibited) (1984 mandatory, 1988 optional)
 *   - original-eits (1984 mandatory, 1988 optional)
 *
 * Input:
 *  object_header - Delivery Envelope object
 *  handle - pointer to P22MessageBodyPart
 *           memory has already been allocated.
 * Output:
 *  structure pointed by handle is filled with data from object-header.
 *
 * Return:
 *  OM_SUCCESS, or otherwise.
 *
 ************************************************************************/

static OM_return_code mhp_f_im_delenvelop(object_header, msgbp)
OM_int_private_object_header *object_header;
P22MessageBodyPart *msgbp;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_value *ivalue;
    OM_value value;
    OM_syntax syntax;
    void *handle;
    OM_descriptor *omattr;
    OM_int_private_object_header *subobject_header;
    P3OtherMessageDeliveryFields *others;
    OM_boolean  isOtherMessageFields=OM_FALSE; 
    int i, value_num, status;
    P1ExtensionMacroBody   *extdata;
    aaListType   *ext;
    struct any_type  *evalue;
    P1RequestedDeliveryMethod   *edelm;
    
    
    others= (P3OtherMessageDeliveryFields*)&msgbp->parameters.delivery_envelope;
    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++) {
        if ((value_num = object[i].count) == 0) continue;
        attribute = (OM_int_descriptor *)&object[i];
        ivalue = (OM_int_value *) attribute->attr_value;
        value = ivalue->value;
        syntax = attribute->attr_syntax; /* this might change in the future */

        switch(attribute->attr_type) {
        case MH_T_ACTUAL_RECIPIENT_NAME:
            omattr = (OM_descriptor *)value.object.object;
            subobject_header = (OM_int_private_object_header *)--omattr;
            if ((status = mhp_f_orname(subobject_header, &handle))!=OM_SUCCESS)
                return(status);
            others->this_recipient_name = (int *)handle;
            others->m |=OtherMessageDeliveryFields_this_recipient_name;
            isOtherMessageFields = OM_TRUE;
            break;  
            
        case MH_T_CONTENT_TYPE: 
            /* only integer for 1984. Both integer and obj id for 1988 */
            if (syntax == OM_S_INTEGER) { 
                switch(value.enumeration){
                case MH_CTI_UNIDENTIFIED:
                    others->content_type.v.built_in = BUILT_IN_unidentified;
                    break;
                case MH_CTI_P2_1988:
                    others->content_type.v.built_in = 
                                        BUILT_IN_interpersonal_messaging_1988;
                    break;
                case MH_CTI_P2_1984:
                default:    
                    others->content_type.v.built_in = 
                                        BUILT_IN_interpersonal_messaging_1984;
                    break;
                } /* switch */
                others->content_type.t =  DeliveredContentType_built_in;
            } /* end if */
            else { /* 1988 X400 with object id */
                /* this shouldn't happen for 1984. OM should discover error */  
            }
            others->m |= OtherMessageDeliveryFields_content_type;
            isOtherMessageFields = OM_TRUE;
            break;
        case MH_T_CONVERSION_PROHIBITED: /* optional */
            if (value.boolean == OM_TRUE) {
                others->delivery_flags |= 
                     DELIVERY_FLAGS_implicit_conversion_prohibited;
                others->m |= OtherMessageDeliveryFields_delivery_flags;
            }
            isOtherMessageFields = OM_TRUE;
            break;
        case MH_T_CONVERTED_EITS:
            omattr = (OM_descriptor *)value.object.object;
            subobject_header = (OM_int_private_object_header *)--omattr;
            if ((status = mhp_f_eits(subobject_header, &handle))!=OM_SUCCESS)
                return(status);
            others->converted_encoded_information_types = (int *)handle;
            others->m |= 
                OtherMessageDeliveryFields_converted_encoded_information_types;
            isOtherMessageFields = OM_TRUE;
            break;
            
        case MH_T_DELIVERY_TIME:
            /* this does not belong to P3OtherDeliveryFields */
            if ((status = mhp_date_conv(&msgbp->parameters.delivery_time,
                    value.string.elements, value.string.length)) != OM_SUCCESS){
                if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP, 
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
            }   
            msgbp->m |= MessageBodyPart_parameters;
            msgbp->parameters.m |= MessageParameters_delivery_time;
            break;
        case MH_T_DISTINGUISHED_RECIP_ADDR:
            /* no counter part in X.400. Thus ignore */
            break;
        case MH_T_ORIGINALLY_INTENDED_RECIP:
            omattr = (OM_descriptor *)value.object.object;
            subobject_header = (OM_int_private_object_header *)--omattr;
            if ((status = mhp_f_orname(subobject_header, &handle))!=OM_SUCCESS)
                return(status);
            others->originally_intended_recipient_name = (int *)handle;
            others->m |=
                 OtherMessageDeliveryFields_originally_intended_recipient_name;
            isOtherMessageFields = OM_TRUE;
            break;  
            
        case MH_T_MTS_IDENTIFIER:
            /* this should be absent. It's available only in the
             * context of MA Interface's Delivery Envelope, but
             * not in Forwarded Msg BP. Ignore for now.
             */
            break;  

        case MH_T_ORIGINAL_EITS:
            omattr = (OM_descriptor *)value.object.object;
            subobject_header = (OM_int_private_object_header *)--omattr;
            if ((status = mhp_f_eits(subobject_header, &handle))!=OM_SUCCESS)
                return(status);
            others->original_encoded_information_types = (int *)handle;
            others->m |= 
                OtherMessageDeliveryFields_original_encoded_information_types;
            isOtherMessageFields = OM_TRUE;
            break;

        case MH_T_ORIGINATOR_NAME:
            omattr = (OM_descriptor *)value.object.object;
            subobject_header = (OM_int_private_object_header *)--omattr;
            if ((status = mhp_f_orname(subobject_header, & handle))!=OM_SUCCESS)
                return(status);
            others->originator_name = (int *) handle;
            others->m |= OtherMessageDeliveryFields_originator_name;    
            isOtherMessageFields = OM_TRUE;
            break;

        case MH_T_OTHER_RECIPIENT_NAMES:
            while (value_num-- > 0){
              /* mhp_f_orname() allocates memory, list_alloc don't have to. 
                 but set P1ORName from mhp_f_orname() to current->data
                 in the aaListType.
             */ 
              if (list_alloc(&others->other_recipient_names, 0) == FALSE)
              {
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
              } 
              omattr = (OM_descriptor *)value.object.object;
              subobject_header = (OM_int_private_object_header *)--omattr;
              if ((status =mhp_f_orname(subobject_header,&handle))!=OM_SUCCESS)
                return(status); 
              others->other_recipient_names.current->data = (int *)handle;
              list_append(&others->other_recipient_names);
            
              ivalue = (OM_int_value *)ivalue->next;
              if (ivalue != NULL) value = ivalue->value;
            } /* end while */
            others->m |= OtherMessageDeliveryFields_other_recipient_names;
            isOtherMessageFields = OM_TRUE;
            break;

        case MH_T_PRIORITY:
            switch(value.enumeration){
            case MH_PTY_LOW:
                others->priority = PRIORITY_non_urgent;
                break;
            case MH_PTY_NORMAL:
                others->priority = PRIORITY_normal;
                break;
            case MH_PTY_URGENT:
                others->priority = PRIORITY_urgent;
                break;
            default:
                others->priority = PRIORITY_normal;
                break;
            } /* end switch */
            others->m |= OtherMessageDeliveryFields_priority;
            isOtherMessageFields = OM_TRUE;
            break;

        case MH_T_SUBMISSION_TIME:
            if ((status = mhp_date_conv(&others->message_submission_time,
                value.string.elements, value.string.length)) != OM_SUCCESS){
                if (status == OM_WRONG_VALUE_MAKEUP)
                        log_error(OM_WRONG_VALUE_MAKEUP, 
                            OMP_DF_WRONG_VALUE_MAKEUP,
                            attribute->attr_type, attribute->attr_syntax,
                            0, value.string.elements);
                    return(status);
            }
            others->m |= OtherMessageDeliveryFields_message_submission_time;
            isOtherMessageFields = OM_TRUE;
            break;
        case MH_T_PREFERRED_DELIVERY_MODES:
            {    
            int i=0;    /* local variable. Don't be confused with
                i in the for loop */
            if (value_num <= 0)
                break;

            if ( ( value_num == 1 ) && (value.enumeration == MH_DM_ANY) )
                break; /* Don't create extension unless we have to */

            others->m |= OtherMessageDeliveryFields_extensions;
            if (list_alloc(&(others->extensions),
                         sizeof(P1ExtensionMacroBody)) == FALSE)
            {
                     log_error(OM_MEMORY_INSUFFICIENT, 
                           OMP_DF_MEMORY_INSUFFICIENT);
                     return(OM_MEMORY_INSUFFICIENT);
            }
                    ext = others->extensions.current;
                extdata = (P1ExtensionMacroBody *) ext->data;
            if (extdata->extstruct == NULL)
            {
                extdata->extstruct =
                   os_calloc(sizeof(P1RequestedDeliveryMethod));
                if (extdata->extstruct == NULL)
                {
                        log_error(OM_MEMORY_INSUFFICIENT, 
                               OMP_DF_MEMORY_INSUFFICIENT);
                            return(OM_MEMORY_INSUFFICIENT);
                }
            }
            extdata->etype = ETYPE_requested_delivery_method;
  
            edelm = (P1RequestedDeliveryMethod *)extdata->extstruct;
            edelm->n = 0;
            while (value_num -- > 0)
                        {
               edelm->v[i] = value.enumeration;
               switch(value.enumeration)
               {
                case MH_DM_ANY:
                case MH_DM_MTS:
                case MH_DM_PDS:
                case MH_DM_TELEX:
                case MH_DM_TELETEX:
                case MH_DM_G3_FAX:
                case MH_DM_G4_FAX:
                case MH_DM_IA5_TERMINAL:
                case MH_DM_VIDEOTEX:
                case MH_DM_TELEPHONE:
                    break;
                default:
                    edelm->v[i] = MH_DM_ANY;
                    break;
                } /* end switch */
                            i = i + 1;
                if ( i > 16 ) 
                {
                        log_error(OM_TOO_MANY_VALUES, 
                               OMP_DF_TOO_MANY_VALUES);
                            return(OM_TOO_MANY_VALUES);
                }
                ivalue = (OM_int_value *) ivalue->next;
                if (ivalue != NULL) /*value if next value present*/
                    value = ivalue->value;
            } /* end while */
            if (i > 0 )
            {
                    edelm->n = i;
                evalue = (struct any_type *) 
                            encode_envelope_extensions
                        (extdata->extstruct, extdata->etype);
                                if (evalue == NULL)
                {
                        log_error(OM_SYSTEM_ERROR, 
                               OMP_DF_SYSTEM_ERROR);
                            return(OM_SYSTEM_ERROR);
                }
                                extdata->evalue = (int *)evalue; 
                                clr_envlext_mem (extdata->extstruct,
                                 extdata->etype);
                                extdata->extstruct = NULL;
                extdata->m |= ExtensionMacroBody_etype;
                extdata->m |= ExtensionMacroBody_evalue;
                list_append(&(others->extensions)); 
                    isOtherMessageFields = OM_TRUE;
            } /* end if */
             }
            break;
        default:
            /* other 1988 fields not yet supported */
            break;
        } /* switch */
    } /* for */

    /* set the flag that at least one of P3OtherMessageDeliveryFields 
    ** is present in the delivery envelope. 4/13/92. Khiem
    ** We also check that mandatory fields must be present. See top of
    ** function for comment.
    **
    ** Include the data structure first in the msg structure, so
    ** that memory is freed as a whole PDUs by the calling program, if
    ** there's any error?
    */
    if (isOtherMessageFields) {
        msgbp->m |= MessageBodyPart_parameters;
        msgbp->parameters.m |= MessageParameters_delivery_envelope;
        /* 1988 mandatory */
        if ((others->m & OtherMessageDeliveryFields_this_recipient_name) &&
             (others->m & OtherMessageDeliveryFields_content_type) &&
             (others->m & OtherMessageDeliveryFields_originator_name) &&
             (others->m & OtherMessageDeliveryFields_message_submission_time)&&
             (others->m & OtherMessageDeliveryFields_priority))
        {
          if (mhp_is84IM == OM_TRUE) /* 1988 fields are okay */
           if (! ((others->m & 
                OtherMessageDeliveryFields_converted_encoded_information_types)
                && (others->m & OtherMessageDeliveryFields_delivery_flags)))
          { /* 1984 mandatory fields are not okay */
            log_error(OM_TEMPORARY_ERROR, OMP_DF_TEMPORARY_ERROR,
                   __FILE__, __LINE__, 
                   "missing Delivery Envelope mandatory attribute(s)",
                   0, 0, 0);
            return(OM_TEMPORARY_ERROR);
          }

          /* it it reaches here then it was 1988 and every thing okay */

        }
        else /* error in 1988/1984 mandatory fields */
        {
            log_error(OM_TEMPORARY_ERROR, OMP_DF_TEMPORARY_ERROR,
                   __FILE__, __LINE__, 
                   "missing Delivery Envelope mandatory attribute(s)",
                   0, 0, 0);
            return(OM_TEMPORARY_ERROR);
        }
    }

    return(OM_SUCCESS);
} /* mhp_f_im_delenvelop(object_header, handle) */




/***************************************************************************
 * mhp_f_im_externalbp(object_header, partptr) puts Externally Defined Body
 * Part object attributes into the P22ExternallyDefinedBodyPart structure.
 *
 *
 ***************************************************************************/

static OM_return_code mhp_f_im_externalbp(object_header, partptr)
OM_int_private_object_header *object_header;
bodypart *partptr;

{
    OM_int_descriptor *object;
    OM_int_descriptor *attribute;
    OM_int_private_object_header *subobject_header;
    OM_descriptor *omattr;
    OM_int_value *ivalue;
    OM_value value;
    P22ExternallyDefinedBodyPart *external;     
    struct ext_type *ext_data; /* same as P22ExternallDefinedData */
                   /* struct ext_type defined in           
                      include/asn1sys.h    
                       */          
    int i, status;
        OM_boolean   tofile;

    partptr->type = MH_EXTERNALPART;
    if ((external = (P22ExternallyDefinedBodyPart *) 
            os_calloc(sizeof(P22ExternallyDefinedBodyPart))) == NULL){
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }

    object = object_header->context.descriptor_list;
    for (i = TOP; object[i].attr_type != OM_NO_MORE_TYPES; i++)
    {
        if (object[i].count == 0) continue;
        attribute = (OM_int_descriptor *) & object[i];
        ivalue = attribute->attr_value;
        value = ivalue->value;

        switch(attribute->attr_type) {
        case IM_EXTERNAL_PARAMETERS:
            external->m |= ExternallyDefinedBodyPart_parameters;
            omattr = (OM_descriptor *)value.object.object;
            subobject_header =(OM_int_private_object_header *)--omattr;
            tofile = OM_FALSE;
            if ((status = mhp_external(subobject_header, 
                                        &external->parameters, tofile)) != OM_SUCCESS)
                return(status);
            break;
        case IM_EXTERNAL_DATA:
            external->m |= ExternallyDefinedBodyPart_data;
            if ((ext_data = (struct ext_type *)
                        os_calloc(sizeof(struct ext_type))) == NULL){
                log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
                return(OM_MEMORY_INSUFFICIENT);
            }
            omattr = (OM_descriptor *)value.object.object;
            subobject_header =(OM_int_private_object_header *)--omattr;
            tofile = OM_TRUE;
            if ((status = mhp_external(subobject_header, ext_data, tofile)) 
                                                                != OM_SUCCESS)
                return(status);
            external->data = (int *)ext_data;
            break;
        default:
            log_error(OM_NO_SUCH_TYPE, OMP_DF_NO_SUCH_TYPE, 
                    attribute->attr_type, 
                    object[CLASS_POS].attr_value->value.string.elements);
            return(OM_NO_SUCH_TYPE);
    
        } /* end switch */
    } /* end for */
    
    partptr->data = (int *)external;

    return(OM_SUCCESS);
}


