#ifndef lint
static char rcsid[]="$Header: mt_open.c,v 3.12 93/03/26 14:26:12 khiem Exp $";
#endif

/*
 * $Header: mt_open.c,v 3.12 93/03/26 14:26:12 khiem Exp $
 * $Revision: 3.12 $
 * $Log:	mt_open.c,v $
 * Revision 3.12  93/03/26  14:26:12  14:26:12  khiem ()
 * roll in fix C03_00_06. khiem.
 * 
 * Revision 3.11  93/03/25  15:00:37  15:00:37  khiem ()
 * Add logic for Pedi hook. Pedi is supported if gtwapi/xedip file is 
 * present. Use symbolic names for feature_selector[].  "expand -4" to
 * replace tabs with spaces and easier to read. Some corresponding 
 * changes in feature.c. khiem.
 * 
 * 
 * Revision 3.10  92/11/11  17:11:27  17:11:27  x400 ()
 * set unix_environment flag (in ext.c) to "0" for normal parsing
 * of IA5 Text BP and ISO6937 BP. For the former, preserve CRs
 * instead of stripping them. For the latter, insert CR LF instead
 * of just LF. Previously, ext.c strips CRs and insert only LFs
 * for unix file. This now can be done only with unix_env =1.
 * Khiem
 * 
 * Revision 3.9  92/11/09  15:54:15  15:54:15  khiem ()
 * reset_config() whenever there's error in mt_open() so that
 * new configuration can be re-read again, as mt_close() is not
 * called to reset_config. kdh.
 * 
 * Revision 3.8  92/10/21  13:46:12  13:46:12  khiem ()
 * misc fix for mt_mhp_get_client_or(). kdh.
 * 
 * Revision 3.7  92/10/16  20:23:07  20:23:07  khiem ()
 * Add proprietary function, mt_mhp_get_client_or(). kdh.
 * 
 * Revision 3.6  92/09/25  11:17:49  11:17:49  trang (Trang Tran)
 * changes:
 * 1) to add another package xomhp
 * 2) change names of other packages so
 *    the new names are shorter.
 * 3) external for General Content always
 *    set to 1.
 * 
 * Revision 3.5  92/09/18  00:47:10  00:47:10  khiem ()
 * Add global for negotiated package flags: MH88, MH84, etc.
 * 
 * Revision 3.4  92/09/08  20:06:15  20:06:15  khiem ()
 * Bug#   : misc fix to rcsid[].
 * 
 * Revision 3.3  92/09/08  19:24:24  19:24:24  khiem ()
 * Bug#46: priority iq file prefix -- add priority global. KDH.
 * 
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <osdeps.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>

#include "x4apifp.h"            /* parser and formatter */
#include "xom.h"               /* object management */
#include "xomhp.h"   /* internal data structures */
#include "xmh.h"               /* message handling */
#include "xmhp.h"              /* message handling */
#include "om_pkstruc.h"
#include "conf.h"              /* X4Admin interface */
#include "interr.h"            /* return codes defined internally  
                  i.e not OM or MH return codes */
#include <time.h>   /* for trace */
#include "x4client.h"   /* trace */
#include "x4cat.h"  /* trace msg catalog */
#include "mac.h"    /* trace macro */

#include "misc.h"   /* Misc #defines for reserving, locking files, etc */


static  time_t tloc; /* trace */

/************************************************************************
** declartion of global variables to be used by intrinsics and
** mta library as well as XOM/MT functions.
** (formerly from init.c).
**
************************************************************************/

/*
 * Externs used for reporting system-errors
 */
extern  int                     errno;
extern  int                     x4g_process_generic_content_flag;
extern  char                    *strerror();

/*
 * extern use to optimize body parts with cache. Set size of cached
 * body part string, and the flag for ext.c.
 */
extern int mhp_size_of_cached_bp;
extern int mhp_cached_bp_on;

/*
 * Other externs
 */
extern  void    get_prefix_letter(char *, char *);

/*
 * Static and other functions inside this file
 */
static  int     recover_pdus(char *);

/*
 * Global variables used by intrinisics library
 */
static  char                    intbuf[20]; /* Used to sprintf integers */

/*
 * Global variable used by mt_xferout.c and format.c for priority file prefix,
 * and 84MH, 88MH, 84IM, 88IM package.
 */
int priority;
boolean mhp_is84MH = FALSE;
boolean mhp_is88MH = FALSE;
boolean mhp_is84IM = FALSE;
boolean mhp_is88IM = FALSE;

/*
 * Buffer required for setjmp/longjmp.
 * Used for formatting (tofile.c)
 * and for parsing (fromfile.c).
 */
os_Jmpbuf    xenv;


char *_MH_BodyPart_dir = NULL;  /* Directory to place body parts in. */
long aafilelocation = 0;        /* location parsing error */

char neighbour_pn[PRMD_LEN +1] = "";

Sint32 in_offset;               /* Offset within file to where content is */
Sint32 in_length;               /* Length of contents within the file */
char infname[NAMESIZE] = "";    /* Name of input file  */
int direction;
boolean translate_addrs = FALSE;
boolean parse_format_p2 = TRUE;

/* set to true only if negotiated to parse Pedi. Else it's binary content */ 
boolean parse_format_p35 = FALSE; 

/*
 * Global defined in ext.c to control whether to strip off CRs of
 * IA5 and ISO6937 BP for incoming messages.
 * unix_environment = 1 means no CRs in incoming msgs for unix environment.
 * unix_environment = 0 means preserve CRs for incoming message.
 *
 * "0" is normal mode for Gateway API. For selected customers (eg OpenMail),
 * this global might be made available to them to reset to "1" 
 * AFTER mt_open(), so that they don't have to deal with CRs.
 * Khiem
 */
extern int  unix_environment;

OM_package_def    *XOM_package;

/* to check for alloc. If the DBGALLOC flag is set, all the callocs and
 * frees are logged to stderr using the functions in dbg_alloc.c
 */

#ifdef DBGALLOC
int show_allocs = TRUE;
#else
int show_allocs = FALSE;
#endif


/*
 * variables for formatting and parsing error: aaerror()
 */

Uint16 asncode=0;
int aaerrnum=0;
char *asnmsg;

/*
 * variables for Procedure tracing. Client application
 * is responsible for setting the flag and and the file pointer.
 */
int x4_gapi_trace = 0;
FILE *x4_gapi_trace_fp;




/*************************************************************************/
/*                                                                       */
/* declarations of x4_OM_functions  - for workspace parameter in mt_open */
/*                                                                       */
/*************************************************************************/

OM_return_code
(x4_OM_copy) (
    OM_private_object   original,
    OM_workspace        workspace,
    OM_private_object     * copy
);

OM_return_code
(x4_OM_copy_value) (
    OM_private_object   source,
    OM_type         source_type,
    OM_value_position   source_value_position,
    OM_private_object   destination,
    OM_type         destination_type,
    OM_value_position   destination_value_position
);

OM_return_code
(x4_OM_create) (
    OM_object_identifier    class,
    OM_boolean              initialise,
    OM_workspace            workspace,
    OM_private_object       * object
);

OM_return_code
(x4_OM_decode) (
    OM_private_object     encoding,
    OM_private_object     * original
);

OM_return_code
(x4_OM_delete) (
    OM_object       subject 
);

OM_return_code
(x4_OM_encode) (
    OM_private_object       original,
    OM_object_identifier    rules,
    OM_private_object       * encoding
);

OM_return_code
(x4_OM_get) (
    OM_private_object   original,
    OM_exclusions       exclusions,
    OM_type_list        included_types,
    OM_boolean          local_strings,
    OM_value_position   initial_value,
    OM_value_position   limiting_value,
    OM_public_object      * copy,
    OM_value_position     * total_number
);

OM_return_code
(x4_OM_instance) (
    OM_object       subject,
    OM_object_identifier    class,
    OM_boolean        * instance
);

OM_return_code
(x4_OM_put) (
    OM_private_object   destination,
    OM_modification     modification,
    OM_object           source,
    OM_type_list        included_types,
    OM_value_position   initial_value,
    OM_value_position   limiting_value
);

OM_return_code
(x4_OM_read) (
    OM_private_object   subject,
    OM_type         type,
    OM_value_position   value_position,
    OM_boolean      local_string,
    OM_element_position   * element_position,
    OM_string         * elements
);

OM_return_code
(x4_OM_remove) (
    OM_private_object   subject,
    OM_type         type,
    OM_value_position   initial_value,
    OM_value_position   limiting_value
);

OM_return_code
(x4_OM_write) (
    OM_private_object   subject,
    OM_type         type,
    OM_value_position   value_position,
    OM_syntax       syntax,
    OM_element_position   * element_position,
    OM_string       elements
);

/*************************************************************************/
/*                                                                       */
/* assign values to x4_OM_list                                           */
/*                                                                       */
/*************************************************************************/

struct OMP_functions_body  x4_OM_list = {
                   12,
                   x4_OM_copy,
                   x4_OM_copy_value,
                   x4_OM_create,
                   x4_OM_decode,
                   x4_OM_delete,
                   x4_OM_encode,
                   x4_OM_get,
                   x4_OM_instance,
                   x4_OM_put,
                   x4_OM_read,
                   x4_OM_remove,
                   x4_OM_write           
};
            
/*************************************************************************/
/*                                                                       */
/* x4_i_workspace is a handle to the workspace - assign it to point to   */
/* x4_OM_list                                                            */
/*                                                                       */
/*************************************************************************/

OMP_int_workspace       x4_i_workspace;



/*************************************************************************/
/*                                                                       */
/* declaration for X4Admin data structures here so the data returned is  */
/* global                                                                */
/*                                                                       */
/* 1) get_spec_apiclient(): struct apiclient                             */
/* 2) get_api_orname(): struct routeptr                                  */
/* 3) get_global_conf(): struct globalconfig                             */
/*                                                                       */
/* reset_config() will reset variables to allow re-reading config files  */
/* It's used in mt_close(). However, need to use it here, if there is    */
/* any error in mt_open(), as the next open won't have mt_close()        */
/* in between. Useful for the proprietary get_client_or_addr().          */
/*************************************************************************/

struct apiclient        *get_spec_apiclient();
struct routes           *get_api_orname();
struct map_global       *get_global_conf();
void                    activate_feature_list();
extern  void            reset_config();


struct apiclient *apiclient;
struct routes    *routeptr;
struct map_global *globalconfig;

/* import session class's object id */
OM_IMPORT(MH_C_SESSION)


/*************************************************************************/
/* MT_OPEN function starts here                                          */
/* 
** DESCRIPTION
**  Open a MT session between the client and the service. All MT 
**  functional features and 1984 MH and IM packages are available
**  by default. 
**  Client instance per process is not supported.
**
** INPUT
**  client_name          - the client name as configured in x4admin
**  client_instance_name - (not supported).
**  feature_list         - the functional and package features.
**
** OUTPUT
**  session - a handle to the session object, which contains 
**          Country/ADMD/PRMD as configure for the client.
**  workspace - this X400 API workspace.
**
** RETURN RESULT 
**  OM_SUCCESS if successfull, error otherwise.
**
** CALLED BY
**  the client
**
** CALLING
**  initialize_package()
**  db_update()
**
**
** NOTES:
**  (1) The session is dynamically allocated and to be deallocated at 
**      mt_close(). This object contains other session-related info, such
**      as outstanding transfer-in messages.
**  (2) The workspace's internal structure contains list of current
**      features, and the current session.  
**  
*/
/*************************************************************************/

OM_return_code    mt_open( 
    OM_string          client_name,
    OM_string          client_instance_name,
    MH_feature         feature_list[],
    OM_private_object  *session,
    OM_workspace       *workspace
)

{ /* start mt_open */

/* MY_MAP_FILE is for testing purpose only; will be global constant      */
/* MAP_CONFIG_FILE                                                       */
#define MY_MAP_FILE          "../../jamconfig/map.conf"
#define MY_ROUTE_FILE          "../../jamconfig/route.conf"
#define IM_84_ASCII          "/usr/lib/x400/gtwapi/ximp84"
#define IM_84_BINARY         "/usr/lib/x400/gtwapi/ximp84.fc"
#define IM_88_ASCII          "/usr/lib/x400/gtwapi/ximp88"
#define IM_88_BINARY         "/usr/lib/x400/gtwapi/ximp88.fc"
#define MH_84_ASCII          "/usr/lib/x400/gtwapi/xmhp84"
#define MH_84_BINARY         "/usr/lib/x400/gtwapi/xmhp84.fc"
#define MH_88_ASCII          "/usr/lib/x400/gtwapi/xmhp88"
#define MH_88_BINARY         "/usr/lib/x400/gtwapi/xmhp88.fc"
#define XOM_ASCII            "/usr/lib/x400/gtwapi/xomp"
#define XOM_BINARY           "/usr/lib/x400/gtwapi/xomp.fc"
#define XEDI_ASCII            "/usr/lib/x400/gtwapi/xedip"
#define XEDI_BINARY           "/usr/lib/x400/gtwapi/xedip.fc"

    OM_return_code        status;
    char               *country, *admd, *prmd, *buf;
    OM_int_value    *admd_val, *prmd_val, *country_val, *classid;
    int   count, i, tmp;
    OM_int_descriptor  *attribute_list;     
    OM_int_private_object_header *session_header; 
    char              route_config_file[MAXFILE];
    char              input_ascii[MAXFILE];
    char              output_binary[MAXFILE];
    char              *feature_name;
    int               feature_status;
    OM_boolean        feature_selector[MAX_FEATURES];
    int               init_value;
    int               attr_check;
    OM_object_identifier   package_identifier;
    OMP_int_workspace feature_ptr; 
    OM_return_code            init_status, update_status;
    FILE                *input, *output;
    OM_boolean          fc_exists;
    OM_int_session_info     *session_info;
    OM_return_code initialize_package(
    FILE                   *input,
    OM_object_identifier   package_identifier,
    unsigned short         len,
    int                    init_val,
    int                    attr_check,
    OM_boolean             in_order);
    OM_return_code db_update(
        FILE             *input, 
        FILE             *output);
    extern struct apiclient *apiclient;
    extern struct routes    *routeptr;
    extern struct map_global *globalconfig;
    extern char              map_config_file[];
    OM_return_code          rc;
    char                    oqpath[MAXFILE + 1]; /* Pathname of oq dir */


        
    /* To ensure that the version string shows up in the libMT.a library */
    char gtwapi_version[120] = GTWAPI_VERSION;

    PROC_ENTRY("mt_open", "client [%s]", client_name.elements, 0, 0, 0, 0);

    if ((x4_i_workspace = (OMP_int_workspace) 
            os_calloc(sizeof(struct int_OMP_workspace_struct))) == NULL)
    {
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
    }
    x4_i_workspace->functions = &x4_OM_list;
    x4g_process_generic_content_flag = OM_TRUE;

    /* set unix_environment global to normal non-unix */
    unix_environment = 0;

/**************************************************************************/
/*                                                                        */
/* call to X4Admin routine : "get_spec_apiclient"                         */
/*                                                                        */
/**************************************************************************/

/* map_config_file contains the client name and its output queue          */
/* together with other data that we are not interested in                 */

/* MY_MAP_FILE is for testing purpose only; will be global constant       */
/* MAP_CONFIG_FILE                                                        */


    strcpy (map_config_file, MAP_CONFIG_FILE);


    if (client_name.length != 0)
    {
        if ((apiclient = get_spec_apiclient(client_name.elements)) == NULL)
        /* call to get_spec_apiclient fails */
        {
            log_error(MH_RC_NO_SUCH_CLIENT, MH_RC_DF_NO_SUCH_CLIENT,
                        client_name);
            os_free((void*) x4_i_workspace);
                reset_config();
            PROC_EXIT("mt_open", 0, session, MH_RC_NO_SUCH_CLIENT);
            return (MH_RC_NO_SUCH_CLIENT);
        /* NOTE: more error handling here : two cases: no such client or 
            bad map.conf file so more meaningful to user
        */
        }     
    }
    else {
        log_error(MH_RC_NO_SUCH_CLIENT, MH_RC_DF_NO_SUCH_CLIENT,
            client_name);
        os_free((void*) x4_i_workspace);
        PROC_EXIT("mt_open", 0, session, MH_RC_NO_SUCH_CLIENT);
        return (MH_RC_NO_SUCH_CLIENT);
    }

/* NOTE:find out what the error is exactly i.e wrong client name, bad    */
/* map.conf file ...                                                     */
/* errors are : no_such_client, memory insufficient, or system error(bad */
/* map.conf file                                                         */

/**************************************************************************/
/*                                                                        */
/* call to X4Admin routine : "get_api_orname"                             */
/*                                                                        */
/**************************************************************************/

/* route_config_file contains the mta name , its links  and directory     */

/* MY_ROUTE_FILE is for testing purpose only; will be global constant       */
/* ROUTE_CONFIG_FILE                                                        */

    strcpy (route_config_file, ROUTE_CONFIG_FILE);

    if (client_name.length != 0)
    {
        if ((routeptr = get_api_orname(client_name.elements, 
                                        route_config_file)) == NULL)
        { /* call to get_api_orname fails */
            log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                    __FILE__, __LINE__, "fail to get api orname", client_name, 
                    0, 0);
            os_free((void*) x4_i_workspace);
            reset_config();
            PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
            return (OM_SYSTEM_ERROR);
            /* NOTE: more error handling here, many cases rather than one*/
        }
        else {/* call to get_api_orname succeeds */
            admd = routeptr->an;
            country = routeptr->cn;
            prmd = routeptr->pn;
        } 
  /* will change later so application program (main for now), if it wants,
     can access every field in the struct routes. That means that in
     mt_open, we do not need to use variables such as admd, country, prmd...*/
    }
    else {
        log_error(MH_RC_NO_SUCH_CLIENT, MH_RC_DF_NO_SUCH_CLIENT,
                client_name);
        os_free((void*) x4_i_workspace);
        PROC_EXIT("mt_open", 0, session, MH_RC_NO_SUCH_CLIENT);
        return (MH_RC_NO_SUCH_CLIENT); 
    }

/* NOTE add error handling ,instead of returning -4 and -3 as above      */
/* find out what the error is exactly i.e wrong client name, bad         */
/* map.conf file ...                                                     */
/* errors are : no_such_client, memory insufficient, or system error(bad */
/* route.conf file                                                       */

/**************************************************************************/
/*                                                                        */
/* call to X4Admin routine : "get_global_conf"                            */
/*                                                                        */
/**************************************************************************/

    if ((globalconfig = get_global_conf()) != NULL)
    {
#ifdef DEBUG 
        printf("Global Class Mask 0x%x\n", globalconfig->class_mask);
        printf("Global Root Path (%s)\n", globalconfig->root_path);
        printf("Global TMP Path (%s)\n", globalconfig->tmp_path);
        printf("Global IQ Path (%s)\n", globalconfig->iq_path);
        printf("Global EIQ Path (%s)\n", globalconfig->eiq_path);
        printf("Global OQ Path (%s)\n", globalconfig->oq_path);
        printf("Global DOQ Path (%s)\n", globalconfig->doq_path);
        printf("Global UQ Path (%s)\n", globalconfig->uq_path);
        printf("Global PQ Path (%s)\n", globalconfig->pq_path);
        printf("Locmta Name (%s)\n", globalconfig->locmta_name);
#endif

    }
    else {
        log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                __FILE__, __LINE__, "fail to get global config", client_name,
                0, 0);
        os_free((void*) x4_i_workspace);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
        return (OM_SYSTEM_ERROR);
        /* NOTE: add more error handling */
    }

/*************************************************************************
 * get shell environment variables for performance optimization.
 *    GAPICACHESIZE  -- size of cached string or body part. Should
 *                  be at least equal to, if not greater than, default.
 *    GAPITMPDIR -- temporary directory overriding default
 *                  supplied in configuration. Usually on another
 *                  disk drive. Used particularly when want to limit
 *                  cache size, but the normal traffic contains
 *                  particularly long messages exceeding cache size,
 *                  and I/O actitivity is high on default drive.
 *
 *    CAPICACHEOFF -- to turn off cached bodypart:
 *                  export GAPICACHEOFF=1
 *                  With this shell flag set, the CACHESIZE var is ignored
 *                  and we used internal default value of XOM_MAXSTRLEN.
 *                  --NOT SUPPORTED AT THIS MOMENT AS IT'S NOT USEFUL--
 *
 * These shell variables here require restarting the application.
 * If we also add the same in mt_start_xfer_in(), then we would have
 * dynamically configuration, if there's no other problems. Khiem
 *
 *************************************************************************/

    tmp = atoi((char*)getenv(GAPICACHE));
    if (tmp != 0)
        mhp_size_of_cached_bp = 1024 * (tmp/1024); /*multiples of 1024*/

    /* should be at least equal to, if not greater than, XOM_MAXSTRLEN */
    mhp_size_of_cached_bp = (mhp_size_of_cached_bp > XOM_MAXSTRLEN
                             ? mhp_size_of_cached_bp : XOM_MAXSTRLEN);

    if ((_MH_BodyPart_dir = (char *)getenv(GAPITMPDIR)) == (char *)NULL)
	 _MH_BodyPart_dir = globalconfig->tmp_path; /* default */
    else { /* accessible and valid directory? */
	if (os_access(_MH_BodyPart_dir, (os_R_OK | os_W_OK | os_X_OK)))
	{
            log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
		__FILE__, __LINE__, MH_INT_DF_FAILED_TO_OPEN,
		_MH_BodyPart_dir, strerror(errno), 0);
	    reset_config();
	    PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
	    return (OM_SYSTEM_ERROR);
        }
    }

    mhp_cached_bp_on = TRUE;    /* set caching by default */


/**************************************************************************/
/*                                                                        */
/* call to routine activate_feature_list                                  */
/*                                                                        */
/**************************************************************************/

     activate_feature_list(feature_list, feature_selector, &feature_status);
     if (feature_status == OM_SUCCESS)
     {   
            x4_i_workspace->feat_list = feature_list;

     }
     else {
            log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                __FILE__, __LINE__, "fail to activate features", 0, 0, 0);
            reset_config();
            PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
            return (OM_SYSTEM_ERROR);
     }

/**************************************************************************/
/*                                                                        */
/* create session private object                                          */
/* NOTE: any change to this should be checked against format.c, as this   */
/* routine use info in session to create external trace. -KDH             */
/*                                                                        */
/**************************************************************************/

/* fill in the private header: -1rst and 0th elements */
   if ((session_header = (OM_int_private_object_header *)
                os_calloc(sizeof(OM_int_private_object_header))) == NULL)
   {
        os_free((void*) x4_i_workspace);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }

    /* set magic number */
   session_header->context.ext_object_header[0].type = OMP_GOODMAGIC;
   /* this field is not used, just fill in with OM_NO_MORE_TYPES */

   session_header->context.ext_object_header[0].syntax = OM_S_NULL;
   /* this field is not used, just fill in with OM_S_NULL */

   session_header->context.ext_object_header[0].value.object.object = 
                                                     (void *) x4_i_workspace;

   session_header->context.ext_object_header[1].type = OM_PRIVATE_OBJECT;
   session_header->context.ext_object_header[1].syntax = 
                                OM_S_SERVICE_GENERATED | OM_S_PRIVATE;
   session_header->context.ext_object_header[1].value.integer = 0;
   /* this field is not used, just fill in with 0 */


/* fill in the values obtained from X4Admin configuration routines */
/* i.e ADMD name, Country name and PRMD name. Note that the Event  */
/* handle attribute is just initialized to 0 because it will not be*/
/* used.                                                           */

/* this might not be good if session object changes. In the future,
 * we might be able to use omp_template(). Any changes to this might 
 * affect format.c as this file use session object to create external 
 * trace record.
 */

   if ((attribute_list = (OM_int_descriptor_list) 
                        os_calloc(7 * sizeof(OM_int_descriptor))) == NULL)
   {
        os_free((void*) x4_i_workspace);
        os_free((void *) session_header);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   /* assign handle to the 0th descriptor of the private object now
   ** so that we can use delete_object() if error 
   */
   session_header->context.descriptor_list = attribute_list;

   /* preface */
   ((OM_int_descriptor_preface *)attribute_list)->reference_ct++;
   ((OM_int_descriptor_preface *)attribute_list)->no_of_attributes = 5;
   ((OM_int_descriptor_preface *)attribute_list)->first_OH_ptr = session_header;

   /* class id */
   if ((classid = (OM_int_value *) os_calloc(sizeof(OM_int_value))) == NULL)
   {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   attribute_list[1].attr_type = OM_CLASS;
   attribute_list[1].attr_syntax = OM_S_OBJECT_IDENTIFIER_STRING;
   if ((buf = (char*)os_calloc(MH_C_SESSION.length + 1)) == NULL)
   {
        os_free((void*) x4_i_workspace);
        os_free((void *) session_header);
        reset_config();
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   sl_bcopy(MH_C_SESSION.elements, buf, MH_C_SESSION.length);
   classid->value.string.elements = (void *)buf;
   classid->value.string.length = (OM_string_length) MH_C_SESSION.length;
   classid->syntax = attribute_list[1].attr_syntax; 
   attribute_list[1].attr_value = classid;
   attribute_list[1].count = attribute_list[1].count + 1;


   /* admd attribute */
   if ((admd_val = (OM_int_value *) os_calloc(sizeof(OM_int_value))) == NULL) 
   {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   if ((buf = (char*)os_calloc((tmp=strlen(admd)) + 1)) == NULL){
        os_free((void*) x4_i_workspace);
        os_free((void *) session_header);
        reset_config();
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   sl_bcopy(admd, buf, tmp);
   attribute_list[2].attr_type = MH_T_ADMD_NAME;
   attribute_list[2].attr_syntax = OM_S_PRINTABLE_STRING;
   admd_val->value.string.length = (OM_string_length) tmp;
   admd_val->value.string.elements = buf;
   admd_val->syntax = attribute_list[2].attr_syntax;
   attribute_list[2].attr_value = admd_val;
   attribute_list[2].count = attribute_list[2].count + 1;

   /* country attribute */
   if ((country_val = (OM_int_value *) os_calloc(sizeof(OM_int_value))) == NULL)
   {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   if ((buf = (char*)os_calloc((tmp=strlen(country)) + 1)) == NULL){
        os_free((void*) x4_i_workspace);
        os_free((void *) session_header);
        reset_config();
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   sl_bcopy(country, buf, tmp);
   attribute_list[3].attr_type = MH_T_COUNTRY_NAME;
   attribute_list[3].attr_syntax = OM_S_PRINTABLE_STRING;
   country_val->value.string.length = (OM_string_length) tmp;
   country_val->value.string.elements = buf;
   country_val->syntax = attribute_list[3].attr_syntax;
   attribute_list[3].attr_value = country_val;
   attribute_list[3].count = attribute_list[3].count + 1;
   
   /* Event Handle attribute - not used; just initialized */
   attribute_list[4].attr_type = MH_T_EVENT_HANDLE;
   attribute_list[4].attr_syntax = OM_S_INTEGER;
   attribute_list[4].attr_value = 0;
   attribute_list[4].count = attribute_list[4].count + 1;
   
   /* prmd attribute */
   if ((prmd_val = (OM_int_value *) os_calloc(sizeof(OM_int_value))) == NULL) 
   {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   if ((buf = (char*)os_calloc((tmp=strlen(prmd)) + 1)) == NULL){
        os_free((void*) x4_i_workspace);
        os_free((void *) session_header);
        reset_config();
        log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }
   sl_bcopy(prmd, buf, tmp);
   attribute_list[5].attr_type = MH_T_PRMD_IDENTIFIER;
   attribute_list[5].attr_syntax = OM_S_PRINTABLE_STRING;
   prmd_val->value.string.length = (OM_string_length) tmp; 
   prmd_val->value.string.elements = buf;
   prmd_val->syntax = attribute_list[5].attr_syntax;
   attribute_list[5].attr_value = prmd_val;
   attribute_list[5].count = attribute_list[5].count + 1;


   /* last attribute */
   attribute_list[6].attr_type = OM_NO_MORE_TYPES;
   attribute_list[6].attr_syntax = 0;



   if ((session_info = (OM_int_session_info *) 
                    os_calloc(sizeof(OM_int_session_info))) == NULL)
   {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        PROC_EXIT("mt_open", 0, session, OM_MEMORY_INSUFFICIENT);
        return(OM_MEMORY_INSUFFICIENT);
   }

   session_header->context.reserved = (void *)session_info;

   *session = (OM_private_object)
   &(session_header->context.ext_object_header[1]) ;
   *workspace = x4_i_workspace;
   
   /* set session handle to the workspace */
   x4_i_workspace->session = *session;

/***************************************************************************/
/* this is to read the ascii file that has the object table, to convert
 * it to a binary file and finally to load it in memory
 */

 if ((XOM_package=(OM_package_def *)os_calloc(sizeof(OM_package_def)))==NULL)
 {
    reset_config();
    log_error(OM_MEMORY_INSUFFICIENT, OMP_DF_MEMORY_INSUFFICIENT);
    return(OM_MEMORY_INSUFFICIENT);
 }

 for (count=0;count < MAX_FEATURES; count++)
 { /* for loop to load each package into memory */

    if (feature_selector[count])
    {
        if (count == IM84P_SET ) 
        {
            strcpy (input_ascii, IM_84_ASCII);
            strcpy (output_binary, IM_84_BINARY);
        }
        else if (count == IM88P_SET)
        {
            strcpy (input_ascii, IM_88_ASCII);
            strcpy (output_binary, IM_88_BINARY);
        }
        else if (count == MH84P_SET)
        {
            strcpy (input_ascii, MH_84_ASCII);
            strcpy (output_binary, MH_84_BINARY);
        }
        else if (count == MH88P_SET)
        {
            strcpy (input_ascii, MH_88_ASCII);
            strcpy (output_binary, MH_88_BINARY);
        }
        else if (count == XOMP_SET)
        {
            strcpy (input_ascii, XOM_ASCII);
            strcpy (output_binary, XOM_BINARY);
        }
    else if (count == XEDIP_SET)
        {
            strcpy (input_ascii, XEDI_ASCII);
            strcpy (output_binary, XEDI_BINARY);
	    parse_format_p35 = TRUE; /* Pedi is negotiated */
        }

    } else {
        continue;
    }
 
 fc_exists = OM_TRUE;

 if (os_access (output_binary, F_OK) != 0)
 {
    fc_exists = OM_FALSE;
 }
 if (!fc_exists) /* if binary file does not exist yet, read ascii file 
                    and create one */
 {
    if ((input = fopen(input_ascii, "r")) == NULL) {
        os_free((void*) x4_i_workspace);
        delete_object(session_header);
        reset_config();
        log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
                __FILE__, __LINE__, "fail to open file", input_ascii, 0, 0);
        PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
        return (OM_SYSTEM_ERROR);
    }
    if ((output = fopen(output_binary, "w+")) == NULL) {
        reset_config();
        log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
            __FILE__, __LINE__, "fail to open file", output_binary, 0, 0);
        PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
        return (OM_SYSTEM_ERROR);
    }

    update_status = 0;
    /* read the ascii file and write to a binary file */

    update_status = db_update(input, output);
    if (update_status  != 0)
    {
    /* remove package.fc before returning */
        reset_config();
        os_delete (output_binary);
        log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
            __FILE__, __LINE__, "fail to load object table", 0, 0 , 0);
        PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
        return (OM_SYSTEM_ERROR);
    }

    fclose(input);
    fclose(output);
 } /* if binary file does not exist yet, read ascii and create one */

 if ((input = fopen (output_binary, "r")) == NULL) {
    os_free((void*) x4_i_workspace);
    delete_object(session_header);
    reset_config();
    log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
            __FILE__, __LINE__, "fail to open file", output_binary, 0, 0);
    PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
    return (OM_SYSTEM_ERROR);
 }
 init_status = 0;

 /* read the binary file and load all of it or part of it 
    into memory 
 */

 init_value = 1; 
 attr_check = 1;
 package_identifier.length = 0;
 package_identifier.elements = NULL;
 init_status = initialize_package(input, package_identifier, 0, 
                                  init_value, attr_check, 0);
 fclose(input);
 if (init_status  != 0)
 {
    os_free((void*) x4_i_workspace);
    delete_object(session_header);
    reset_config();
    log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
            __FILE__, __LINE__, "fail to load object table", 0 , 0);
    PROC_EXIT("mt_open", 0, session, OM_SYSTEM_ERROR);
    return (OM_SYSTEM_ERROR);
 }
} /* for loop to load each package into memory */


    /*
     * Since everything's been successful so far, see if any recovery of
     * previous partially-processed PDUs is needed --Ram 11/14/91
     */
    
    /* Call a function that locks the directory, and goes through it,
     * unreserving every file this process is able to lock
     */
    sprintf(oqpath, "%s/%s", globalconfig->oq_path, apiclient->oq);
    if ((rc = recover_pdus(oqpath)) != OM_SUCCESS)
    {
        reset_config();    
        PROC_EXIT("mt_open", 0, session, rc);
        return(rc);
    }


   PROC_EXIT("mt_open", 0, session, OM_SUCCESS);
   return (OM_SUCCESS);
}          
 /* end of mt_open */


/************************************************************************
**
** recover_pdus() - This function reads through the given queue, and
** unreserves all reserved messages that it is able to lock 
**
** Assume that the parent dir 'dir' has been locked before this function
** is called, and that it will be unlocked afterwards
**
**
**   Calls  : os_opendir, os_readdir, os_closedir (UNIX calls)
**
*************************************************************************/
static int
recover_pdus(
    char    *dir) /* Name of directory to search */
{
    char        buf[MAXFILE+1]; /* To save name of file, if any */
    char        prefix;     /* Prefix letter of filename */
    register    os_DIR *fd; /* File descriptor for directory */
    os_Dir_entry    *dirptr;    /* Buffer to hold file info from dir */
    OM_return_code  rc;
    int             dird;   /* Directory descriptor */
    char        reserved[MAXFILE + 1];
    int         lockfd;
    char        unreserved[MAXFILE + 1]; /* To hold new filename*/
    char        resv_prefix, unresv_prefix;

    /* First, open and lock the directory to be searched */
    if ((rc = lock_directory(dir, &dird)) != OM_SUCCESS)
    {
        /* Error already logged in called function */
        unlock_directory(dir, dird);
        return(rc);
    }

    /*
     * Now open the directory and scan it for reserved files.
     * Note, we don't use the file descriptor obtained above, because
     * that actually points to a lockfile within the directory, not the
     * directory itself.
     */
    if ((fd = os_opendir(dir)) == NULL) /* Can this be empty ?? */
    {
        log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, __FILE__,
                __LINE__, MH_INT_DF_FAILED_TO_OPEN,
                dir, strerror(errno),0);
        unlock_directory(dir, dird);
        return(OM_SYSTEM_ERROR);
    }

    while ((dirptr = os_readdir(fd)) != NULL) /* Queue not yet empty */
    {   
        if (dirptr->d_ino == 0) /* Slot not in use */
            continue;

        /* verify that first character in name is our prefix. */
        if ((*dirptr->d_name != RESERVED(HIGH_PREFIX)) &&
            (*dirptr->d_name != RESERVED(NORMAL_PREFIX)) &&
            (*dirptr->d_name != RESERVED(MEDIUM_PREFIX)) &&
            (*dirptr->d_name != RESERVED(LOW_PREFIX)) )
                continue;       /* nope, try again */

        /*
         * If we reach here, we have a reserved file in the directory,
         * so copy the full path name of this file into the given
         * buffer
         */
        sprintf(reserved, "%s/%s", dir, dirptr->d_name);

        /* Let's try to lock this file. If we succeed, it's a good
         * bet that this file was being processed by a client which
         * crashed
         */
        
        /* Open the file */
        if ((lockfd = os_std_open(reserved, os_O_RDWR)) <= 0)
        {
            log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, __FILE__,
                __LINE__, MH_INT_DF_FAILED_TO_OPEN,
                reserved, strerror(errno),0);
            unlock_directory(dir, dird);
            return(OM_SYSTEM_ERROR);
        }

        /* Test the file for a lock to see if it can be locked. This won't
         * succeed (ie, will return -1) if an active client process is
         * currently processing this message
         */
        if (os_lockf(lockfd, os_F_TEST, 0) == -1) /* Can't be locked */
        {
            if ((errno == EAGAIN) || (errno == EACCES)) /* Someone's locked it*/
            {   /* Close the file, skip to next entry in directory */
                if (os_std_close(lockfd) == -1)
                {
                    sprintf(intbuf, "%d", lockfd);
                    log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, __FILE__,
                            __LINE__, MH_INT_DF_FAILED_TO_CLOSE, intbuf,
                            reserved, strerror(errno));
                    unlock_directory(dir, dird);
                    return(OM_SYSTEM_ERROR);
                }
                continue;   
            }
            else    /* Real error */
            {
                sprintf(intbuf, "%d", lockfd);
                log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, __FILE__,
                    __LINE__, MH_INT_DF_FAILED_TO_UNLOCK, intbuf,
                    reserved, strerror(errno));
                unlock_directory(dir, dird);
                return(OM_SYSTEM_ERROR);
            }
        }
        else    /* Can be locked, i.e., no other process has locked it */
        {
            /* Close the file */
            if (os_std_close(lockfd) == -1)
            {
                sprintf(intbuf, "%d", lockfd);
                log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, __FILE__,
                            __LINE__, MH_INT_DF_FAILED_TO_CLOSE, intbuf,
                            reserved, strerror(errno));
                unlock_directory(dir, dird);
                return(OM_SYSTEM_ERROR);
            }

            /*
             * Now unreserve it - the whole purpose of this function !!
             */

            /* Obtain new prefix letter to unreserve it to */
            (void)get_prefix_letter(reserved, &resv_prefix);
            unresv_prefix = UNRESERVED(resv_prefix);
    
            if (!os_untemp(unreserved, reserved, unresv_prefix))
            {
                log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,__FILE__,
                        __LINE__, MH_INT_DF_FAILED_TO_RESV_UNRESV,
                        reserved, strerror(errno),0);
                unlock_directory(dir, dird);
                return(OM_SYSTEM_ERROR);
            }
        }
    }   /* end of while-loop that reads through the directory */

    os_closedir(fd);    /* Close directory pointer */

    /* Finally, unlock and close the directory using the other descriptor */
    if ((rc = unlock_directory(dir, dird)) != OM_SUCCESS)
        return(rc);

    return(OM_SUCCESS);

}   /* recover_pdus() */


/**************************************************************************/
/*
 * OM_return_code
 * mt_mhp_get_client_oraddr(
 *          OM_private_object   session, 
 *          OM_public_object    *or_address);
 * 
 * DESCRIPTION:
 *  This function returns all the configured OR Address attributes of a 
 *  client in a given session. This function complements the mt_open() 
 *  function which returns only Country/ADMD/PRMD attributes in Session
 *  object.
 *
 *  Within a session, delimited by the mt_open() and mt_close() 
 *  pair, the configured OR Address at the time mt_open() is called 
 *  stays unchanged. This function hence does not detect changes in 
 *  configuration within a session. Any changes in configuration is 
 *  reflected in a new session. 
 *
 *  This is a proprietary API function called by a client application 
 *  to retrieve its own OR Address, for example, to form its originator
 *  name while constructing a message; or to be used within the 
 *  client's configuration to avoid duplication of configuration of 
 *  client's OR Address. It is constructed so that it hopefully can be 
 *  compatible to future extension to the Session object, which would
 *  contain all the configurable OR Address attributes. In this case,
 *  the like change would be only to replace it with 
 *      om_get(session, ...., or_address, ...);
 *  which would return the same info from the Session object into the
 *  "or_address" argument.
 *
 *  This function can be used only within a session created by
 *  mt_open(). It returns MH_RC_NO_SUCH_SESSION error otherwise. 
 *
 *  If a client has not been configured, mt_open() would have returned
 *  an MH_RC_NO_SUCH_CLIENT error and there is no session.
 * 
 * ARGUMENTS:
 *  session (Object)
 *      - an established session between the client and the service.    
 *
 * RESULT:
 *  or_address (Object) 
 *      - a service-generated public object of OR Address class,
 *      containing OR Address attributes configured for the client
 *      in the established session. This object should be deleted
 *      with om_delete() before terminating the session.
 *
 * ERROR:
 *  no-such-session, not-private, pointer-invalid, system-error, 
 *  or success.
 *
 *
 *
 * CALLED BY:
 *  client application.
 *
 * CALLING:
 *
 *
 */

/* 
 * First, let's define one utility function.
 * mhp_copy_oraddr_att(str, type, syntax, desc)
 *  copy the oraddress attribute's string into the descriptor.
 */

OM_return_code
mhp_copy_oraddr_att(char *str, 
        OM_type type, 
        OM_syntax syntax, 
        OM_descriptor *desc)
{

    int len;
    void *ptr;
    
    if ((ptr = os_calloc(len=strlen(str) + 1) ) == NULL)
    {
        return(OM_MEMORY_INSUFFICIENT);
    }   
    desc->type = type;
    desc->syntax = syntax;
    desc->value.string.length = len;
    strcpy(ptr, str);
    desc->value.string.elements = ptr;
    return(OM_SUCCESS);

} /* mhp_copy_oraddr_att */


/*
 * return with error handle function
 */

OM_return_code
mhp_oraddr_exit(
    OM_object session,
    OM_return_code rc)
{
    PROC_EXIT("mt_mhp_get_client_oraddr", 0, session, rc);
    return(rc);
}



/* 
 * mt_mhp_get_client_oraddr() here.
 */

#define MAX_ORADDR_ATTS 40  /* count from "struct routes" in Bconfig.h */

/* let's import the OR ADDRESS class name */

OM_IMPORT(MH_C_OR_ADDRESS)

OM_return_code
mt_mhp_get_client_oraddr(
    OM_private_object   session,
    OM_public_object    *or_address)
{

    OM_public_object handle;
    int i;
    OM_return_code rc = OM_SUCCESS;

/*
 * After verifying that the session handle is valid, that is the client name
 * is okay and config already read by mt_open(), we go on copying whatever
 * we have in routeptr into the public object. Multiple calls
 * to this function within the same session returns the same result.
 */

    /* Trace the procedure entry */
    PROC_ENTRY("mt_mhp_get_client_or", "session <%d>", session, 0, 0, 0, 0);

    /******************************************
     * Check if the session is a valid object
     ******************************************/

    /* Make sure session ptr is legal... */
    if (!session)
    {
        log_error(OM_POINTER_INVALID, OMP_DF_POINTER_INVALID, 0);
        return(mhp_oraddr_exit(session, OM_POINTER_INVALID));
    }

    /* then check that it's a valid object that hasn't been deleted... */
    if ((rc = omp_is_object_valid(session)) != OM_SUCCESS)
    {
        /* Error already logged in lower-level function */
            return(mhp_oraddr_exit(session, rc));
    }
        
    /* and check that it is a private object! */
    if (session->type != OM_PRIVATE_OBJECT )
    {
        log_error(OM_NOT_PRIVATE, OMP_DF_NOT_PRIVATE,
                    (session->type==OM_CLASS) ?
                    omp_hexme(session->value.string) : 0);
        return(mhp_oraddr_exit(session, OM_NOT_PRIVATE));
    }

    /* session is valid, so start copying */

    /* Since the OR address is well known, let's hard-coded the 
    ** public object for now: the max number is based from
    ** "struct routes" in Bconfig.h.
    */

    if ((handle = (OM_descriptor *)os_calloc((MAX_ORADDR_ATTS+1)*
            sizeof(OM_descriptor)))==NULL)
    {
            return(mhp_oraddr_exit(session, OM_MEMORY_INSUFFICIENT));
    }

    /* 
    ** set the -1 descriptor: workspace and number for om_delete()
    ** to be called later.
     */
        handle[0].type = OMP_GOODMAGIC;
        handle[0].value.object.object = (void *) x4_i_workspace;
    
    /* let's set the CLASS in the 0-th descriptor, actually 1st */
    handle[1].type = OM_CLASS;
    handle[1].syntax = OM_S_OBJECT_IDENTIFIER_STRING | OM_S_SERVICE_GENERATED;
    handle[1].value.string = MH_C_OR_ADDRESS;

    i=2;        
    if (routeptr->cn) 
        if ((rc = mhp_copy_oraddr_att(routeptr->cn, 
            MH_T_COUNTRY_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->an)
        if ((rc = mhp_copy_oraddr_att(routeptr->an, 
            MH_T_ADMD_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->pn)
        if ((rc = mhp_copy_oraddr_att(routeptr->pn, 
            MH_T_PRMD_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->orgName)
        if ((rc = mhp_copy_oraddr_att(routeptr->orgName, 
            MH_T_ORGANIZATION_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxorgName)   
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxorgName, 
            MH_T_ORGANIZATION_NAME, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->orgUnit.v[0])
        if ((rc = mhp_copy_oraddr_att(routeptr->orgUnit.v[0], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_1, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->orgUnit.v[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->orgUnit.v[1], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_2, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->orgUnit.v[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->orgUnit.v[2], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_3, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->orgUnit.v[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->orgUnit.v[3], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_4, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxorgUnit.v[0])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxorgUnit.v[0], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_1, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxorgUnit.v[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxorgUnit.v[1], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_2, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxorgUnit.v[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxorgUnit.v[2], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_3, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxorgUnit.v[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxorgUnit.v[3], 
            MH_T_ORGANIZATIONAL_UNIT_NAME_4, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->x121)
        if ((rc = mhp_copy_oraddr_att(routeptr->x121, 
            MH_T_X121_ADDRESS, OM_S_NUMERIC_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->uaId)
        if ((rc = mhp_copy_oraddr_att(routeptr->uaId, 
            MH_T_NUMERIC_USER_IDENTIFIER, OM_S_NUMERIC_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->termId)
        if ((rc = mhp_copy_oraddr_att(routeptr->termId, 
            MH_T_TERMINAL_IDENTIFIER, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.type[0])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.type[0], 
            MH_T_DOMAIN_TYPE_1, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.type[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.type[1], 
            MH_T_DOMAIN_TYPE_2, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));

    if (routeptr->ddas.type[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.type[2], 
            MH_T_DOMAIN_TYPE_3, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.type[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.type[3], 
            MH_T_DOMAIN_TYPE_4, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.value[0])
        if ((rc= mhp_copy_oraddr_att(routeptr->ddas.value[0], 
            MH_T_DOMAIN_VALUE_1, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.value[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.value[1], 
            MH_T_DOMAIN_VALUE_2, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
            
    if (routeptr->ddas.value[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.value[2], 
            MH_T_DOMAIN_VALUE_3, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ddas.value[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->ddas.value[3], 
            MH_T_DOMAIN_VALUE_4, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    
    if (routeptr->ttxddas.type[0])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.type[0], 
            MH_T_DOMAIN_TYPE_1, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.type[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.type[1], 
            MH_T_DOMAIN_TYPE_2, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.type[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.type[2], 
            MH_T_DOMAIN_TYPE_3, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.type[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.type[3], 
            MH_T_DOMAIN_TYPE_4, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.value[0])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.value[0], 
            MH_T_DOMAIN_VALUE_1, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.value[1])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.value[1], 
            MH_T_DOMAIN_VALUE_2, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.value[2])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.value[2], 
            MH_T_DOMAIN_VALUE_3, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxddas.value[3])
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxddas.value[3], 
            MH_T_DOMAIN_VALUE_4, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));

    if (routeptr->pds_cn)
        if ((rc = mhp_copy_oraddr_att(routeptr->pds_cn, 
            MH_T_POSTAL_COUNTRY_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->pds_code)
        if ((rc = mhp_copy_oraddr_att(routeptr->pds_code,
            MH_T_POSTAL_CODE, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->pds_name)
        if ((rc = mhp_copy_oraddr_att(routeptr->pds_name,
            MH_T_POSTAL_DELIV_SYSTEM_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));

    if (routeptr->surname)
        if ((rc = mhp_copy_oraddr_att(routeptr->surname,
            MH_T_SURNAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxsurname)
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxsurname,
            MH_T_SURNAME, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->given_name)
        if ((rc = mhp_copy_oraddr_att(routeptr->given_name,
            MH_T_GIVEN_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxgiven_name)
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxgiven_name,
            MH_T_GIVEN_NAME, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->inits)
        if ((rc = mhp_copy_oraddr_att(routeptr->inits,
            MH_T_INITIALS, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxinits)
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxinits,
            MH_T_INITIALS, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->gq)
        if ((rc = mhp_copy_oraddr_att(routeptr->gq,
            MH_T_GENERATION, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxgq)
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxgq,
            MH_T_GENERATION, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));

    if (routeptr->common)
        if ((rc = mhp_copy_oraddr_att(routeptr->common,
            MH_T_COMMON_NAME, OM_S_PRINTABLE_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));
    if (routeptr->ttxcommon)
        if ((rc = mhp_copy_oraddr_att(routeptr->ttxcommon,
            MH_T_COMMON_NAME, OM_S_TELETEX_STRING, 
            &handle[i++])) != OM_SUCCESS)
            return(mhp_oraddr_exit(session, rc));

    handle[i].type = OM_NO_MORE_TYPES;
    handle[i].syntax = OM_S_NO_MORE_SYNTAXES;

    /* the 0-th attribute to the client. The -1th attribute is workspace */
    *or_address = &handle[1]; 
    return(mhp_oraddr_exit(session, rc));

} /* mt_mhp_get_client_or */
