#ifndef lint
static char rcsid[]="$Header: mt_xferout.c,v 3.4 93/01/18 11:00:38 trang Exp $";
#endif

/*
 * $Header: mt_xferout.c,v 3.4 93/01/18 11:00:38 trang Exp $
 * $Revision: 3.4 $
 * $Locker:  $
 * $Log:	mt_xferout.c,v $
 * Revision 3.4  93/01/18  11:00:38  11:00:38  trang (Trang Tran)
 * changed all file priorities (from N,L,H,M) to M
 * due to starvation problem found with Keyword testing.
 * trang
 * 
 * Revision 3.3  92/09/08  20:06:44  20:06:44  khiem ()
 * Bug#   : misc fix to rcsid[].
 * 
 * Revision 3.2  92/09/08  20:02:44  20:02:44  khiem ()
 * Bug#104:  special appl prefix and suffix for iq filename.
 * Bug#46:   priority prefix in iq filename. KDH.
 * 
 *
 */


#include <stdio.h>
#include <string.h>
#include <pwd.h>
#include "xom.h"               /* object management */
#include "xomhp.h"   /* internal data structures */
#include "xmh.h"               /* message handling */
#include "xmhp.h"              /* message handling */
#include "conf.h"              /* X4Admin interface */
#include "interr.h"            /* internal return codes that do not
                  in OM or MH */
#include "om_pkstruc.h"
#include <time.h> 	/* for trace */
#include "x4client.h"	/* trace */
#include "x4cat.h"	/* trace msg catalog */
#include "mac.h"	/* trace macro */
#include "config.h"	/* configuration #define's: file prefixes */
static	time_t tloc; /* trace */

extern	OM_return_code omp_is_object_valid(OM_object);
extern	OM_return_code delete_object(OM_int_private_object_header *);
extern	void omp_delete_privobj_from_list(OM_int_private_object_header *);

/*************************************************************************/
/*                                                                       */
/* MT_TRANSFER_OUT function starts here                                  */
/*                                                                       */
/*************************************************************************/

OM_return_code    mt_transfer_out( 
    OM_private_object  session,
    OM_object          object 
)

/* declaration of local variables used by mt_transfer_out */


{ /* start mt_transfer_out */

    OM_return_code        status, create_status, put_status;
    int                   format_status;
    char                  xferout_iq_path[MAXFILE+1]; 
    char                  tmp_iq_path[MAXFILE+1]; 
    char                  i_filename[MAXFILE+1];
    char                  suffix[MAXSUFFIX+2]; 
    char                  *pq_dir;
    char                  *q;
    char                  prefix;
    OM_object_identifier  class;
    OM_workspace          workspace;
    extern int_OMP_workspace x4_i_workspace; /*global var in  mt_open.c*/
    OM_private_object     clone_private_object,  priv_object;
    OM_int_private_object_header  *priv_object_header;
    OM_descriptor         *tmp_object;
    OM_int_value          *attr_value;
    extern int            mhp_format( 
		 	    OM_private_object  session,
                            OM_int_private_object_header *,
                            char *, char *);
    void get_object_info (
          OM_descriptor           *object,
          OM_object_identifier    *package_identifier,
          OM_uint16               *package_id_length,
          OM_uint16               *classid,
          OM_string_length    *class_length,
          void                **class_elements);
    OM_package_def *get_package_def (
          OM_object_identifier    package_identifier,
          OM_uint16               package_id_length);
    OM_object_check  *get_object_check (
          OM_package_def          *package_ref,
          OM_uint16               class,
          OM_uint16               *size);
    OM_return_code verify_value_range (
          OM_object_check   *object_check,
          OM_syntax         syntax,
          OM_value          value,
          OM_boolean        final_flag);
    OM_return_code  verify_value_num (
          OM_object_check   *object_check,
          OM_uint16         number,
          OM_boolean        final_flag);
    uid_t               x4_uid;
    gid_t               x4_gid;
    struct passwd       *pwdp;
    int                   i, j, n;
    OM_element_position   length;
    OM_string             tmp_class;
    OM_int_descriptor     *i_object;
    OM_object_identifier    package_identifier;
    OM_uint16               package_id_length;
    OM_uint16               object_classid;
    OM_string_length        object_class_length;
    void                    *object_class_elements;
    OM_package_def          *package_ref;
    OM_object_check         *object_check;
    OM_uint16               size;
    OM_int_descriptor       *list;
    OM_boolean              is_public, final_flag;
    extern struct map_global *globalconfig;
    extern struct apiclient *apiclient;	/* to extract pq for special appl */
    extern int              priority;	/* set in format.c for iq prefix */
    OM_return_code          rc;
    int                     tmp;

	PROC_ENTRY("mt_transfer_out", "session <%d>", session,
					"object <%d>", object, 0, 0);

	/******************************************
         * Check if the session is a valid object 
	 * Code was not doing this earlier - Ram R.
         ******************************************/

        /* Make sure session ptr is legal... */
        if (!session)
        {
                log_error(OM_POINTER_INVALID, OMP_DF_POINTER_INVALID, 0);
                PROC_EXIT("mt_transfer_out", 0,session,OM_POINTER_INVALID);
                return(OM_POINTER_INVALID);
        }

        /* then check that it's a valid object that hasn't been deleted... */
        if ((rc = omp_is_object_valid(session)) != OM_SUCCESS)
        {
                /* Error already logged in lower-level function */
                PROC_EXIT("mt_transfer_out", 0, session, rc);
                return(rc);
        }

        /* and check that it is a private object! */
        if (session->type != OM_PRIVATE_OBJECT )
        {
                log_error(OM_NOT_PRIVATE, OMP_DF_NOT_PRIVATE,
                                        (session->type==OM_CLASS) ?
                                        omp_hexme(session->value.string) : 0);
                PROC_EXIT("mt_transfer_out", 0, session, OM_NOT_PRIVATE);
                return(OM_NOT_PRIVATE);
        }

	/**************************************************
	 * Now check the object pointer for validity --Ram
         **************************************************/

        /* Make sure object ptr is legal... */
        if (!object)
        {
                log_error(OM_POINTER_INVALID, OMP_DF_POINTER_INVALID, 0);
                PROC_EXIT("mt_transfer_out", 0,object,OM_POINTER_INVALID);
                return(OM_POINTER_INVALID);
        }


    strcpy (xferout_iq_path, globalconfig->iq_path);
    strcpy (tmp_iq_path, globalconfig->tmp_path);

#ifdef DEBUG
    printf ("iq path is %s\n", xferout_iq_path);
    printf ("tmp path is %s\n", tmp_iq_path);
  
#endif



/*************************************************************************/
/*                                                                       */
/* call to formatter to create and put the asn1 message into the file    */
/* input : object from mt_transfer_out and name of temp file got above   */
/* output: object from mt_transfer_out and name of temp file got above   */
/*         but with asn1 message (translated from object) in the file    */
/*                                                                       */
/*************************************************************************/

/*
 * Bug#104: For special client appls, eg. Document Conversion, the filename
 * prefix generated by the client will be different such the MTA does not
 * route the same msg to it again. The suffix will be a number to indicate
 * the order of cascading multiple applications, eg 001 or 002. This means
 * that if the application is the 2nd special application: the MTA would
 * route to the 3rd special application or route as normal the next time
 * around. The indication are in apiclient->pq (eg, no "pq" in the 
 * apiclient's pq directory string). The prefix is done later.
 */

    /* create tmp file with the right suffix first */
    suffix[0]='\0';
    pq_dir = apiclient->pq;
    if (strstr(pq_dir, PQ_PREFIX) == NULL)
    { /* there's no "pq" in string: special application. Extract suffix */
    suffix[0]=SPEC_APPL_SUFFIX_DEL; /* suffix is, eg, ".001" */
    strncpy(&suffix[1], &pq_dir[(strlen(pq_dir) - MAXSUFFIX)], MAXSUFFIX);
    suffix[MAXSUFFIX+1]='\0';
    }  

 /* create an empty pdu file in the IQ with the right suffix */
    if (os_uniq_name(i_filename, xferout_iq_path, TMP_PREFIX, suffix, 0660) 
		== NULL)
    {
	   log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR, 
			__FILE__, __LINE__, "[can't create filename]");
       return (OM_SYSTEM_ERROR);
    }

#ifdef DEBUG
  printf ("unique file name is %s\n", i_filename);
#endif

 /* since mhp_format second parameter is of type OM_int_private_object_header */
 /*                                                                        */
 /* check to see if the object is a private object or a public object      */
 /* if it is a public object, create a clone private object and copy       */ 
 /* the public object to the clone private object using om_put             */
 /*                                                                        */
 /* then transform the private object type to type OM_int_private_object   */
 /* header ready to give it as 1rst parm to mhp_format                       */
       
    if (is_public_object(object))
    { /* public object as input */
     /* first create the clone private object */
        is_public = OM_TRUE;
        workspace =  x4_i_workspace;
        class.elements = object->value.string.elements;
        class.length = object->value.string.length;

		/* turn tracing off for internal calls. Must save original */
	tmp =  x4_gapi_trace;
	x4_gapi_trace = (int) X4_GAPI_TRACE_NONE;
        if ((create_status = x4_OM_create(class, OM_TRUE,
                            workspace, &clone_private_object)) 
                        != OM_SUCCESS)
        {
		x4_gapi_trace = (int) tmp;
		PROC_EXIT("mt_transfer_out", 0, object, create_status);
            	return(create_status);
        }
   
	x4_gapi_trace = (int) X4_GAPI_TRACE_NONE; 
     	/* copy the public object to private clone object */
        if ((put_status = x4_OM_put(clone_private_object, OM_REPLACE_ALL, 
		  object,
                  (OM_type_list) 0,
                  (OM_value_position) 0,
                  (OM_value_position) 0)) != OM_SUCCESS)
        {
		x4_gapi_trace = (int) tmp;
		PROC_EXIT("mt_transfer_out", 0, object, put_status);
            	return(put_status);
        }

        priv_object = clone_private_object;
	
	/* Since we use x4_OM_create() to create private object, and
	** thus has an entry in the private object list. However,
	** since delete_object() is called immediately, and not
	** at the mt_close() function, it's okay not to take out this
	** entry from the list. Khiem
	*/  

	/* turn on tracing back since done with internal calls */ 
	/*	x4_gapi_trace = (int) X4_GAPI_TRACE_ALL; */
	x4_gapi_trace = (int) tmp;

    }  /* if public */
  
    else /* object is private object */
    {
		/* first is the object valid */
		if ((status = omp_is_object_valid(object)) != OM_SUCCESS){
			PROC_EXIT("mt_transfer_out", 0, object, status);
			return(status);
		}
        is_public = OM_FALSE;
        priv_object = object;
    }

/* check object for hi value, low value, hi value number, low value
   number bounds before transferring out 
   get object check table from pri_object by calling the following 
   procedures : get_object_info, get_package_def and get_object_check
*/

	get_object_info(priv_object,  
                    &package_identifier, 
                    &package_id_length, 
                    &object_classid, 
                    &object_class_length,
                    &object_class_elements);
	if (package_identifier.elements == NULL )
    {
   		 return (OM_NO_SUCH_OBJECT);
    }
	package_ref = get_package_def (package_identifier,
                                               package_id_length);
    if (package_ref == NULL)
    {
        return (OM_NO_SUCH_OBJECT);
    }
	object_check = get_object_check (package_ref, object_classid
                                                 , &size);

 /* transform priv_object to type OM_int_private_object_header */
 /* priv_object is always a private object
    o priv_object is given from the client and has
      the address of the 0th ext_object_header
    o priv_object_header has the address of the
      -1rst ext_object_header
 */

    tmp_object = priv_object;
    priv_object_header = (OM_int_private_object_header *)
                         ((OM_descriptor *)--tmp_object);
    list = priv_object_header->context.descriptor_list;
    final_flag = OM_TRUE;
    for (i  = 2; list[i].attr_type != OM_NO_MORE_TYPES; i++)
    { /* for i */
                
       /* check for both maximum and minimum values */
        if ((object_check[i-2].vnl != 0) ||
            (list[i].attr_value != NULL))
        {
        	if ((status = verify_value_num(&object_check[i-2],
                    list[i].count, final_flag))
                    != OM_SUCCESS)
        	{
				if (status == OM_WRONG_VALUE_NUMBER)
					log_error(OM_WRONG_VALUE_NUMBER,
						OMP_DF_WRONG_VALUE_NUMBER,
						list[i].attr_type, list[i].count);
				PROC_EXIT("mt_transfer_out", 0, object, status);
 	       		return(status);
        	}
        }
	attr_value = list[i].attr_value;
        while (attr_value != NULL)
        {
                     if (list[i].count > 0)
                     {
                        if ((status = verify_value_range(&object_check[i-2],
                                                list[i].attr_value->syntax,
                                                attr_value->value,
                                                final_flag))
                           != OM_SUCCESS)
                        {
							if (status == OM_WRONG_VALUE_LENGTH)
								log_error(OM_WRONG_VALUE_LENGTH,
									OMP_DF_WRONG_VALUE_LENGTH,
									list[i].attr_type, 
									attr_value->value.string.length);
							PROC_EXIT("mt_transfer_out", 0, object, status);
                            return (status);
                        }
		     }
           attr_value  = attr_value->next;

        } /* while */
    } /* for i */

    priority = -1; /* reset priority for each msg/report */
    tmp_object = priv_object;
    priv_object_header = (OM_int_private_object_header *)
                         ((OM_descriptor *)--tmp_object);
    if ((format_status = mhp_format (session, priv_object_header, 
								i_filename,tmp_iq_path)) != OM_SUCCESS) 
    {   
		os_delete (i_filename);
     	/* need to clean up further? */
		PROC_EXIT("mt_transfer_out", 0, object, status);
        return (format_status);
    }
 /* after returning from formatter, get the asn1 message in the file     */

 /*
 1) make sure file has ownership of x400
 2) change ownership of file
 3) make the temp file permanent (change the t prefix to m)
 */
 /* make sure file has ownership of x400 */
    
    /* Make sure file has ownership of x400 */

    /* Get UID, GID corresponding to "x400" */
    pwdp = getpwnam("x400");

    x4_uid = pwdp->pw_uid;
    x4_gid = pwdp->pw_gid;

    /* Change ownership of file */

    if (chown(i_filename, x4_uid, x4_gid) != 0)
    {
		os_delete(i_filename);
		log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
			__FILE__, __LINE__, "permission problem", "", "", "");
		PROC_EXIT("mt_transfer_out", 0, object, OM_SYSTEM_ERROR);
        return(OM_SYSTEM_ERROR);
    }

     /* Make msg file permanent so that file is to be relayed by MTA */
     /* If special application, then use a different prefix. The suffix
     ** already is part of tmp file name. If not, then prefix depends on 
     ** the priority. (Bug#104 and #46).
     */

    if (strstr(pq_dir, PQ_PREFIX) == NULL)
    { /* special application prefix */
    if (!(os_untemp(i_filename, i_filename, SPEC_APPL_PREFIX))) 
    {
	os_delete (i_filename);
	log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
		__FILE__, __LINE__, "untemp filename problem", i_filename, 
		"", "");
	PROC_EXIT("mt_transfer_out", 0, object, OM_SYSTEM_ERROR);
        return(OM_SYSTEM_ERROR);
    }
    }

    else 
    {
	switch(priority) {	/* prefixes in retix/x400/include/config.h */
	/* due to starvation problem found, change priority to be all M */
	case MH_PTY_NORMAL:	/* N prefix */
		prefix = MTAFILE;
		break;
	case MH_PTY_LOW:	/* L prefix */
		prefix = MTAFILE;
		break;
        case MH_PTY_URGENT:	/* H prefix */
		prefix = MTAFILE;
		break;
	default:		/* M prefix: reports/etc */
		prefix = MTAFILE;
		break;
	}
	if (!(os_untemp(i_filename, i_filename, prefix)))
	{
		os_delete (i_filename);
		log_error(OM_SYSTEM_ERROR, OMP_DF_SYSTEM_ERROR,
		  	__FILE__, __LINE__, "untemp filename problem", 
			i_filename, "", "");
		PROC_EXIT("mt_transfer_out", 0, object, OM_SYSTEM_ERROR);
   	     	return(OM_SYSTEM_ERROR);
	}
    }

	/* now make the object inaccessible */
	delete_object(priv_object_header);
	PROC_EXIT("mt_transfer_out", 0, object, OM_SUCCESS);
    return(OM_SUCCESS);

} /* end mt_transfer_out */


