// FILE:  or_name.C

#include	<iostream.h>
#include	<fstream.h>
#include	<assert.h>
#include	"../../../include/platform.h"
#include	"../../../include/or_name.h"

//
// PUBLICL:  Log any attribute for which a value is present to the log file.
//

void ORName::log_name( ofstream  *logfile ) {

	*logfile << "OR NAME:" << endl;

	if ( dir_name != NULL )
		*logfile << TAB << "DIR=" << dir_name << endl;

	if ( country != NULL )
		*logfile << TAB << "COUNTRY=" << country << endl;
	if ( admd != NULL )
		*logfile << TAB << "ADMD=" << admd << endl;
	if ( prmd != NULL )
		*logfile << TAB << "PRMD=" << prmd << endl;
	if ( org != NULL )
		*logfile << TAB << "ORG=" << org << endl;
	if ( unit1 != NULL )
		*logfile << TAB << "UNIT1=" << unit1 << endl;
	if ( unit2 != NULL )
		*logfile << TAB << "UNIT2=" << unit2 << endl;
	if ( unit3 != NULL )
		*logfile << TAB << "UNIT3=" << unit3 << endl;
	if ( unit4 != NULL )
		*logfile << TAB << "UNIT4=" << unit4 << endl;
	if ( sur != NULL )
		*logfile << TAB << "SUR=" << sur << endl;
	if ( given != NULL )
		*logfile << TAB << "GIVEN=" << given << endl;
	if ( init != NULL )
		*logfile << TAB << "INIT=" << init << endl;
	if ( gen != NULL )
		*logfile << TAB << "GEN=" << gen << endl;
	if ( common != NULL )
		*logfile << TAB << "COMM=" << common << endl;
	if ( ddat1 != NULL )
		*logfile << TAB << "DT1=" << ddat1 << " / ";
	if ( ddav1 != NULL )
		*logfile << "DV1=" << ddav1 << endl;
	if ( ddat2 != NULL )
		*logfile << TAB << "DT2=" << ddat2 << " / ";
	if ( ddav2 != NULL )
		*logfile << "DV2=" << ddav2 << endl;
	if ( ddat3 != NULL )
		*logfile << TAB << "DT3=" << ddat3 << " / ";
	if ( ddav3 != NULL )
		*logfile << "DV3=" << ddav3 << endl;
	if ( ddat4 != NULL )
		*logfile << TAB << "DT4=" << ddat4 << " / ";
	if ( ddav4 != NULL )
		*logfile << "DV4=" << ddav4 << endl << endl;
}

#ifdef	DEBUG

//
// PUBLICL:  Display any attribute for which a value is present to the screen.
//

void ORName::display_name() {

	cout << "OR NAME:" << endl;
	cout << TAB << "DIR=" << dir_name << endl;
	cout << TAB << "COUNTRY=" << country << endl;
	if ( ! strcmp( admd, " " ) )
		cout << TAB << "ADMD=(single space)" << endl;
	else
		cout << TAB << "ADMD=" << admd << endl;
	cout << TAB << "PRMD=" << prmd << endl;
	cout << TAB << "ORG=" << org << endl;
	cout << TAB << "UNIT1=" << unit1 << endl;
	cout << TAB << "UNIT2=" << unit2 << endl;
	cout << TAB << "UNIT3=" << unit3 << endl;
	cout << TAB << "UNIT4=" << unit4 << endl;
	cout << TAB << "SUR=" << sur << endl;
	cout << TAB << "GIVEN=" << given << endl;
	cout << TAB << "INIT=" << init << endl;
	cout << TAB << "GEN=" << gen << endl;
	cout << TAB << "COMM=" << common << endl;
	cout << TAB << "DT1=" << ddat1 << " / ";
	cout << "DV1=" << ddav1 << endl;
	cout << TAB << "DT2=" << ddat2 << " / ";
	cout << "DV2=" << ddav2 << endl;
	cout << TAB << "DT3=" << ddat3 << " / ";
	cout << "DV3=" << ddav3 << endl;
	cout << TAB << "DT4=" << ddat4 << " / ";
	cout << "DV4=" << ddav4 << endl << endl;
}

#endif	// DEBUG


//
// PUBLIC:  Get O/R Name attributes from the user.
//

void ORName::build_or_name() {
	BOOL	valid_addr = FALSE;

	char *buf = new char[ COUNTRY_NAME_LEN ];
	assert( buf != 0 );

	cout << endl << "Enter the values for an  O/R  address.   Country has";
	cout << " a default value of US.";
	cout << endl << "ADMD Name has a default value of a single space.   At";
	cout << " least one other X.400";
	cout << endl << "attribute must be entered." << endl << endl;

	cout << "Enter Country Name [US]:     ";
	cin.getline( buf, COUNTRY_NAME_LEN+1 );
	if ( buf[ 0 ] == '\0' )
		strcpy( buf, "US" );
	set_country_name( buf );
	buf = new char[ ADMD_NAME_LEN ];

	cout << "Enter ADMD Name [space]:     ";
	cin.getline( buf, ADMD_NAME_LEN+1 );
	if ( buf[ 0 ] == '\0' )
		strcpy( buf, " " );
	set_admd_name( buf );
	buf = new char[ PRMD_NAME_LEN ];

	cout << "Enter PRMD Name:             ";
	cin.getline( buf, PRMD_NAME_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_prmd_name( buf );
		buf = new char[ ORG_NAME_LEN ];
	}
	
	cout << "Enter Organization Name:     ";
	cin.getline( buf, ORG_NAME_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_org_name( buf );
		buf = new char[ ORG_UNIT_LEN ];
	}

	cout << "Enter Organization Unit #1:  ";
	cin.getline( buf, ORG_UNIT_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_org_unit1( buf );
		buf = new char[ ORG_UNIT_LEN ];
	
		cout << "Enter Organization Unit #2:  ";
		cin.getline( buf, ORG_UNIT_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_org_unit2( buf );
			buf = new char[ ORG_UNIT_LEN ];
	
			cout << "Enter Organization Unit #3:  ";
			cin.getline( buf, ORG_UNIT_LEN+1 );
			if ( buf[ 0 ] != '\0' ) {
				set_org_unit3( buf );
				buf = new char[ ORG_UNIT_LEN ];
	
				cout << "Enter Organization Unit #4:  ";
				cin.getline( buf, ORG_UNIT_LEN+1 );
				if ( buf[ 0 ] != '\0' ) {
					set_org_unit4( buf );
					buf = new char[ SURNAME_LEN ];
				}
			}
		}
	}
	
	cout << "Enter SurName:               ";
	cin.getline( buf, SURNAME_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_surname( buf );
		buf = new char[ GIVEN_NAME_LEN ];
	
		cout << "Enter Given Name:            ";
		cin.getline( buf, GIVEN_NAME_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_given_name( buf );
			buf = new char[ INITIALS_LEN ];
		}
	
		cout << "Enter Initials:              ";
		cin.getline( buf, INITIALS_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_initials( buf );
			buf = new char[ GENERATION_LEN ];
		}
	
		cout << "Enter Generation Qualifier:  ";
		cin.getline( buf, GENERATION_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_generation( buf );
			buf = new char[ COMMON_NAME_LEN ];
		}
	}
	
	cout << "Enter Common Name:           ";
	cin.getline( buf, COMMON_NAME_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_common_name( buf );
		buf = new char[ DDA_TYPE_LEN ];
	}

	cout << "Enter DDA Type #1:           ";
	cin.getline( buf, DDA_TYPE_LEN+1 );
	if ( buf[ 0 ] != '\0' ) {
		valid_addr = TRUE;
		set_dda_type1( buf );
		buf = new char[ DDA_VALUE_LEN ];
	
		cout << "Enter DDA Value #1:          ";
		cin.getline( buf, DDA_VALUE_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_dda_value1( buf );
			buf = new char[ DDA_TYPE_LEN ];
		}
	
		cout << "Enter DDA Type #2:           ";
		cin.getline( buf, DDA_TYPE_LEN+1 );
		if ( buf[ 0 ] != '\0' ) {
			set_dda_type2( buf );
			buf = new char[ DDA_VALUE_LEN ];
	
			cout << "Enter DDA Value #2:          ";
			cin.getline( buf, DDA_VALUE_LEN+1 );
			if ( buf[ 0 ] != '\0' ) {
				set_dda_value2( buf );
				buf = new char[ DDA_TYPE_LEN ];
			}
	
			cout << "Enter DDA Type #3:           ";
			cin.getline( buf, DDA_TYPE_LEN+1 );
			if ( buf[ 0 ] != '\0' ) {
				set_dda_type3( buf );
				buf = new char[ DDA_VALUE_LEN ];
	
				cout << "Enter DDA Value #3:          ";
				cin.getline( buf, DDA_VALUE_LEN+1 );
				if ( buf[ 0 ] != '\0' ) {
					set_dda_value3( buf );
					buf = new char[ DDA_TYPE_LEN ];
				}
	
				cout << "Enter DDA Type #4:           ";
				cin.getline( buf, DDA_TYPE_LEN+1 );
				if ( buf[ 0 ] != '\0' ) {
					set_dda_type4( buf );
					buf = new char[ DDA_VALUE_LEN ];
	
					cout << "Enter DDA Value #4:          ";
					cin.getline( buf, DDA_VALUE_LEN+1 );
					if ( buf[ 0 ] != '\0' ) 
						set_dda_value4( buf );
				}
			}
		}
	}

	if ( ! valid_addr )
		cout << endl << "Address not complete!  This may cause "
		     "future problems!" << endl << endl;
}


//
// PUBLIC:  Compare all the attributes of 2 O/R Names.
//

BOOL ORName::compare_or_name( ORName *arg ) {

	if ( strcasecmp(  directory_name(), arg->directory_name() ) )
		return FALSE;
	if ( strcasecmp(  admd_name(), arg->admd_name() ) )
		return FALSE;
	if ( strcasecmp(  common_name(), arg->common_name() ) )
		return FALSE;
	if ( strcasecmp(  country_name(), arg->country_name() ) )
		return FALSE;
	if ( strcasecmp(  dda_type1(), arg->dda_type1() ) )
		return FALSE;
	if ( strcasecmp(  dda_type2(), arg->dda_type2() ) )
		return FALSE;
	if ( strcasecmp(  dda_type3(), arg->dda_type3() ) )
		return FALSE;
	if ( strcasecmp(  dda_type4(), arg->dda_type4() ) )
		return FALSE;
	if ( strcasecmp(  dda_value1(), arg->dda_value1() ) )
		return FALSE;
	if ( strcasecmp(  dda_value2(), arg->dda_value2() ) )
		return FALSE;
	if ( strcasecmp(  dda_value3(), arg->dda_value3() ) )
		return FALSE;
	if ( strcasecmp(  dda_value4(), arg->dda_value4() ) )
		return FALSE;
	if ( strcasecmp(  generation(), arg->generation() ) )
		return FALSE;
	if ( strcasecmp(  given_name(), arg->given_name() ) )
		return FALSE;
	if ( strcasecmp(  initials(), arg->initials() ) )
		return FALSE;
	if ( strcasecmp(  org_name(), arg->org_name() ) )
		return FALSE;
	if ( strcasecmp(  org_unit1(), arg->org_unit1() ) )
		return FALSE;
	if ( strcasecmp(  org_unit2(), arg->org_unit2() ) )
		return FALSE;
	if ( strcasecmp(  org_unit3(), arg->org_unit3() ) )
		return FALSE;
	if ( strcasecmp(  org_unit4(), arg->org_unit4() ) )
		return FALSE;
	if ( strcasecmp(  prmd_name(), arg->prmd_name() ) )
		return FALSE;
	if ( strcasecmp(  surname(), arg->surname() ) )
		return FALSE;

	return TRUE;
}


//
// PRIVATE:  read one O/R address.
//

void ORName::read_x400_address( ifstream *i_file ) {

	char	tag[ TAG_SIZE ];
	
	tag[ 0 ] = i_file->get();		// read the slash
	if ( tag[ 0 ] == '/' ) {
		i_file->getline( tag, TAG_SIZE );
		while ( tag[ 0 ] != NULL ) {
			read_attribute( i_file, tag );
			i_file->getline( tag, TAG_SIZE );
		}	
	}
}


//
// PRIVATE:  read one O/R address attribute.
//

void ORName::read_attribute( ifstream *i_file, char *tag ) {
	char	*buf;

	( void ) i_file->get();	// read equal sign

	if ( ! strcmp( tag, "ad" ) ) {
		buf = new char[ ADMD_NAME_LEN ];
		assert( buf != 0 );	// will always be first
		i_file->getline( buf, ADMD_NAME_LEN+1, ADDR_DELIMITER );
		set_admd_name( buf );
	}
	else if ( ! strcmp( tag, "cm" ) ) {
		buf = new char[ COMMON_NAME_LEN ];
		i_file->getline( buf, COMMON_NAME_LEN+1, ADDR_DELIMITER );
		set_common_name( buf );
	}
	else if ( ! strcmp( tag, "co" ) ) {
		buf = new char[ COUNTRY_NAME_LEN ];
		i_file->getline( buf,COUNTRY_NAME_LEN+1,ADDR_DELIMITER );
		set_country_name( buf );
	}
	else if ( ! strcmp( tag, "t1" ) ) {
		buf = new char[ DDA_TYPE_LEN ];
		i_file->getline( buf, DDA_TYPE_LEN+1, ADDR_DELIMITER );
		set_dda_type1( buf );
	}
	else if ( ! strcmp( tag, "t2" ) ) {
		buf = new char[ DDA_TYPE_LEN ];
		i_file->getline( buf, DDA_TYPE_LEN+1, ADDR_DELIMITER );
		set_dda_type2( buf );
	}
	else if ( ! strcmp( tag, "t3" ) ) {
		buf = new char[ DDA_TYPE_LEN ];
		i_file->getline( buf, DDA_TYPE_LEN+1, ADDR_DELIMITER );
		set_dda_type3( buf );
	}
	else if ( ! strcmp( tag, "t4" ) ) {
		buf = new char[ DDA_TYPE_LEN ];
		i_file->getline( buf, DDA_TYPE_LEN+1, ADDR_DELIMITER );
		set_dda_type4( buf );
	}
	else if ( ! strcmp( tag, "v1" ) ) {
		buf = new char[ DDA_VALUE_LEN ];
		i_file->getline( buf, DDA_VALUE_LEN+1, ADDR_DELIMITER );
		set_dda_value1( buf );
	}
	else if ( ! strcmp( tag, "v2" ) ) {
		buf = new char[ DDA_VALUE_LEN ];
		i_file->getline( buf, DDA_VALUE_LEN+1, ADDR_DELIMITER );
		set_dda_value2( buf );
	}
	else if ( ! strcmp( tag, "v3" ) ) {
		buf = new char[ DDA_VALUE_LEN ];
		i_file->getline( buf, DDA_VALUE_LEN+1, ADDR_DELIMITER );
		set_dda_value3( buf );
	}
	else if ( ! strcmp( tag, "v4" ) ) {
		buf = new char[ DDA_VALUE_LEN ];
		i_file->getline( buf, DDA_VALUE_LEN+1, ADDR_DELIMITER );
		set_dda_value4( buf );
	}
	else if ( ! strcmp( tag, "gn" ) ) {
		buf = new char[ GENERATION_LEN ];
		i_file->getline( buf, GENERATION_LEN+1, ADDR_DELIMITER );
		set_generation( buf );
	}
	else if ( ! strcmp( tag, "gv" ) ) {
		buf = new char[ GIVEN_NAME_LEN ];
		i_file->getline( buf, GIVEN_NAME_LEN+1, ADDR_DELIMITER );
		set_given_name( buf );
	}
	else if ( ! strcmp( tag, "in" ) ) {
		buf = new char[ INITIALS_LEN ];
		i_file->getline( buf, INITIALS_LEN+1, ADDR_DELIMITER );
		set_initials( buf );
	}
	else if ( ! strcmp( tag, "og" ) ) {
		buf = new char[ ORG_NAME_LEN ];
		i_file->getline( buf, ORG_NAME_LEN+1, ADDR_DELIMITER );
		set_org_name( buf );
	}
	else if ( ! strcmp( tag, "u1" ) ) {
		buf = new char[ ORG_UNIT_LEN ];
		i_file->getline( buf, ORG_UNIT_LEN+1, ADDR_DELIMITER );
		set_org_unit1( buf );
	}
	else if ( ! strcmp( tag, "u2" ) ) {
		buf = new char[ ORG_UNIT_LEN ];
		i_file->getline( buf, ORG_UNIT_LEN+1, ADDR_DELIMITER );
		set_org_unit2( buf );
	}
	else if ( ! strcmp( tag, "u3" ) ) {
		buf = new char[ ORG_UNIT_LEN ];
		i_file->getline( buf, ORG_UNIT_LEN+1, ADDR_DELIMITER );
		set_org_unit3( buf );
	}
	else if ( ! strcmp( tag, "u4" ) ) {
		buf = new char[ ORG_UNIT_LEN ];
		i_file->getline( buf, ORG_UNIT_LEN+1, ADDR_DELIMITER );
		set_org_unit4( buf );
	}
	else if ( ! strcmp( tag, "pd" ) ) {
		buf = new char[ PRMD_NAME_LEN ];
		i_file->getline( buf, PRMD_NAME_LEN+1, ADDR_DELIMITER );
		set_prmd_name( buf );
	}
	else if ( ! strcmp( tag, "su" ) ) {
		buf = new char[ SURNAME_LEN ];
		i_file->getline( buf, SURNAME_LEN+1, ADDR_DELIMITER );
		set_surname( buf );
	}
}


//
// PRIVATE:  Write the O/R Name to a file.
//

void ORName::write_or_name( ofstream *o_file ) {

	if ( admd_name() != NULL ) 
		*o_file << "/ad=" << admd_name();
	if ( common_name() != NULL ) 
		*o_file << "/cm=" << common_name();
	if ( country_name() != NULL ) 
		*o_file << "/co=" << country_name();
	if ( dda_type1() != NULL ) 
		*o_file << "/t1=" << dda_type1();
	if ( dda_type2() != NULL ) 
		*o_file << "/t2=" << dda_type2();
	if ( dda_type3() != NULL ) 
		*o_file << "/t3=" << dda_type3();
	if ( dda_type4() != NULL ) 
		*o_file << "/t4=" << dda_type4();
	if ( dda_value1() != NULL ) 
		*o_file << "/v1=" << dda_value1();
	if ( dda_value2() != NULL ) 
		*o_file << "/v2=" << dda_value2();
	if ( dda_value3() != NULL ) 
		*o_file << "/v3=" << dda_value3();
	if ( dda_value4() != NULL ) 
		*o_file << "/v4=" << dda_value4();
	if ( generation() != NULL ) 
		*o_file << "/gn=" << generation();
	if ( given_name() != NULL ) 
		*o_file << "/gv=" << given_name();
	if ( initials() != NULL ) 
		*o_file << "/in=" << initials();
	if ( org_name() != NULL ) 
		*o_file << "/og=" << org_name();
	if ( org_unit1() != NULL ) 
		*o_file << "/u1=" << org_unit1();
	if ( org_unit2() != NULL ) 
		*o_file << "/u2=" << org_unit2();
	if ( org_unit3() != NULL ) 
		*o_file << "/u3=" << org_unit3();
	if ( org_unit4() != NULL ) 
		*o_file << "/u4=" << org_unit4();
	if ( prmd_name() != NULL ) 
		*o_file << "/pd=" << prmd_name();
	if ( surname() != NULL ) 
		*o_file << "/su=" << surname();
	
	*o_file << ADDR_DELIMITER << endl;
}
