#include <stdio.h>
#include <msgcat.h>
#include <climportedi.h>
#include <xedip.h>
#include <xomhp.h>
#include "/usr/lib/x400/gtwapi/include/nist_xmh.h"
#include "/usr/lib/x400/gtwapi/include/x4apifp.h"
#include <p1p2.h>
#include <xgenbody.h>


#define	OMP_DF_MEMORY_INSUFFICIENT	-1
#define	OMP_DF_WRONG_VALUE_MAKEUP	-2
/* OM_return_code mhp_get_attr_criticality( P1ExtensionMacroBody *xd, int i ) {
	return (OM_SUCCESS ); }
*/
OM_return_code 	mhp_p_edim( 
					P35EDIM *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_heading( 
					P35EDIMHeading *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_id( 
					P35EDIMIdentifier *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_edin_receiver( 
					P35EDIMHeading *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_app_security( 
					P35EDIApplicationSecurityElementsField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_cross_ref( 
					P35CrossReferencingInformationField *, 
					OM_int_private_object_header **,
					int );
OM_return_code	mhp_p_edi_serv_str_adv( 
					P35EDIMHeading *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_syntax_id( 
					P35EDIMHeading *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_ic_sender( 
					P35EDIMHeading *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_extension( 
					P35ExtensionField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_notif_req( 
					P35RecipientsSubField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_ic_recip( 
					P35RecipientsSubField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_recip_ref( 
					P35RecipientsSubField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_auth_info( 
					P35AuthorizationInformationField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_recip( 
					P35RecipientsSubField *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_prim_body( 
					P35EDIMBody *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_edi_body( 
					P35PrimaryBodyPart *, 
					OM_int_private_object_header ** );
OM_return_code	mhp_p_edi_add_body( 
					P35EDIM_ExternallyDefinedBodyPart *, 
					OM_int_private_object_header ** );

OM_return_code mhp_p_edin(int *edin,
    OM_int_private_object_header **object);
OM_return_code mhp_p_edin_forwarded( P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edin_negative( P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edin_positive( P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_nn_reason_code( P35EDIN    *p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_nn_ua_ms_code( P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_nn_user_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_nn_pdau_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_fn_reason_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_fn_ua_ms_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_fn_user_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_fn_pdau_code(P35EDIN	*p35edin,
	OM_int_private_object_header 	**object_header);
OM_return_code mhp_p_edi_common_fields(
	P35CommonFields					*common_fields,        
	OM_int_private_object_header	**attribute,
    OM_int_descriptor				*desc );



/*
 * Parsing Pedi asn1 content into an approprriate private object, which
 * is either of EDIM, Forwarded Notification, Positive Notification,
 * or Negative Notification class.
 *
 * Input:
 *   content    -- the P35InformationObject 
 * Output:
 *   object_header -- the resulting private object
 */

OM_return_code mhp_p_edi(
        int *content, 
	OM_int_private_object_header **object)
{
  OM_return_code rc;
  P35InformationObject *edi = (P35InformationObject *)content;
log_error((OM_return_code) 0, "**** in mhp_p_edi() **** " );
  
  switch (edi->t){
  case InformationObject_edim:
log_error((OM_return_code) 0, "**** in edim case **** " );
    if ((rc = mhp_p_edim((P35EDIM *)edi->v.edim, object)) != OM_SUCCESS)
      return(rc);
    break;
  case InformationObject_edin:
log_error((OM_return_code) 0, "**** in edin case **** " );
    if ((rc = mhp_p_edin(edi->v.edin, object)) != OM_SUCCESS)
      return(rc);
    break;
  default:
log_error((OM_return_code) 0, "**** in default **** " );
    return(OM_NO_SUCH_OBJECT); /* error */
  }
  return(OM_SUCCESS);
}

OM_return_code mhp_p_edim(
    P35EDIM							*edim,
	OM_int_private_object_header	**object )
{
	P35EDIMBody						*p35body;
	P35EDIMHeading					*heading;
	OM_int_private_object_header	*subobject;
	OM_int_descriptor				*desc;
	OM_int_value					*baseval, *curval, *nextval;
	int								i, j, count, status;

log_error((OM_return_code) 0, "**** in mhp_p_edim **** " );

	if ((status = omp_template( EDI_C_EDIM, object )) != OM_SUCCESS )
		return (status);

	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_HEADING:
log_error((OM_return_code) 0, "**** in edi heading case **** " );
				/* the heading must be present */
				if (( status = mhp_p_edi_heading( ( P35EDIMHeading * )
								&edim->heading, &subobject )) != OM_SUCCESS )
					return (status);
				if (( status = putvalue( desc, &desc->attr_value, EDI_HEADING,
									  OM_S_OBJECT, subobject )) != OM_SUCCESS )
					return (status);
				break;

			case EDI_PRIMARY_BODYPART:
log_error((OM_return_code) 0, "**** in edi primary bp case **** " );
				/* the primary bodypart must be present */
				p35body = ( P35EDIMBody * ) edim->body;
/*				if ( p35body->m & EDIMBody_primary_body_part ) {  */
log_error((OM_return_code) 0, "**** found EDIMBody_primary_bp **** " );
					if (( status = mhp_p_edi_prim_body( p35body,
									&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value,
							EDI_PRIMARY_BODYPART, OM_S_OBJECT, subobject ))
																!= OM_SUCCESS )
						return ( status );
/*				}  */
				break;

			case EDI_ADD_BODYPARTS:
				if ( edim->m & EDIM_body ) {
					p35body = ( P35EDIMBody * ) edim->body;
					if ( p35body->m & EDIMBody_additional_body_parts ) {
						for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
							  j<heading->obsoleted_EDIMs.n; 
							  j++ ) {
							if (( status = mhp_p_edi_add_body( 
										&p35body->additional_body_parts.v[j],
										&subobject )) != OM_SUCCESS )
								return (status);
							if (( status = putvalue( desc, &desc->attr_value,
												EDI_ADD_BODYPARTS, OM_S_OBJECT,
												subobject )) != OM_SUCCESS )
								return ( status );
							append_struct( &baseval,&curval,nextval,&count );
						}
						desc->attr_value = baseval;
						desc->count = count;
					}
				}
				break;
		}
	}

	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_heading(
	P35EDIMHeading						*heading,
	OM_int_private_object_header 		**object )
{
	Uint32								len;
	OM_int_descriptor					*desc;
	OM_int_private_object_header		*subobject;
	OM_int_value						*baseval, *curval, *nextval;
	OM_boolean							flag;
	OM_string							string;
	P35RecipientsField					*recips;
	P35CrossReferencingInformationField	*xrefs;
	char								*buf;
	int									i, j, count, related_msg_index, status;


log_error((OM_return_code) 0, "**** in edi heading() **** " );
	if ((status = omp_template( EDI_C_HEADING, object )) != OM_SUCCESS )
		return (status);
	
	related_msg_index = heading->related_messages.n;

	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_THIS_EDIM:
log_error((OM_return_code) 0, "**** in edi this edim case **** " );
				/* THIS EDIM must be present */
				if (( status = mhp_p_edi_id( ( P35EDIMIdentifier * )
							heading->this_EDIM, &subobject )) != OM_SUCCESS )
					return (status);
				if (( status = putvalue( desc, &desc->attr_value, EDI_THIS_EDIM,
									   OM_S_OBJECT, subobject )) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_ORIG:
log_error((OM_return_code) 0, "**** in edi orig case **** " );
				if ( heading->m & EDIMHeading_originator ) {
					if (( status = mhp_p_orname( heading->originator, 
												 &subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_ORIG, OM_S_OBJECT, subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
				
			case EDI_RECIPS:
log_error((OM_return_code) 0, "**** in edi recips case **** " );
				if ( heading->m & EDIMHeading_recipients ) {
log_error((OM_return_code) 0, "**** found recipients **** " );
					recips = ( P35RecipientsField * ) heading->recipients;
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<recips->n; 
						  j++ ) {
						if (( status = mhp_p_edi_recip((P35RecipientsSubField *)
									recips->v[j], &subobject )) != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &nextval, EDI_RECIPS, 
									OM_S_OBJECT, subobject )) != OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count ); 
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
			
			case EDI_EDIN_RECEIVER:
log_error((OM_return_code) 0, "**** in edi edin receiver case **** " );
				if ( heading->m & EDIMHeading_edin_receiver ) {
					if (( status = mhp_p_edi_edin_receiver( heading,
												&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_EDIN_RECEIVER, OM_S_OBJECT, subobject )) 
							!= OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_RESPONS_FORWARD:
log_error((OM_return_code) 0, "**** in edi respons forwarded case **** " );
				flag = OM_FALSE;
				if ( heading->responsibility_forwarded )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_RESPONS_FORWARD, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
						return (status);
				break;
				
			case EDI_EDI_BODYPART_TYPE:
				mhp_addobj( &string, &heading->edi_bodypart_type );
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_EDI_BODYPART_TYPE, 
								OM_S_OBJECT_IDENTIFIER_STRING, 
								(void *) string.elements,
								string.length )) != OM_SUCCESS )
					return (status );
				break;
			
			case EDI_INC_COPY:
log_error((OM_return_code) 0, "**** in edi inc copy case **** " );
				flag = OM_FALSE;
				if ( heading->incomplete_copy )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_INC_COPY, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
						return (status);
				break;
			
			case EDI_EXPIRY_TIME:
log_error((OM_return_code) 0, "**** in edi expiry time case **** " );
				if ( heading->m & EDIMHeading_expiry_time ) {
					if (( buf = (char *) mhp_to_utc( &heading->expiry_time ))
																	== NULL )
						return ( OM_MEMORY_INSUFFICIENT );
					if (( status = putvalue( desc, &desc->attr_value,
								EDI_EXPIRY_TIME, OM_S_UTC_TIME_STRING, buf )) 
															  != OM_SUCCESS )
						return ( status );
				}
				break;
			
			case EDI_RELATED_EDI_MSGS:
log_error((OM_return_code) 0, "**** in edi realted edi msgs case **** " );
			case EDI_RELATED_NON_EDI_MSGS:
				if ( heading->m & EDIMHeading_related_messages ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<related_msg_index; 
						  j++ ) {
						if ( heading->related_messages.v[j].t ==
							 RelatedMessageReference_edi_message_reference ) {
							if (( status = mhp_p_edi_id( (P35EDIMIdentifier * )
									heading->related_messages.v[j].v.edi_message_reference,
									&subobject )) != OM_SUCCESS )
								return (status);
							if (( status = putvalue( desc, &nextval,
								EDI_RELATED_EDI_MSGS, OM_S_OBJECT, subobject)) 
															   != OM_SUCCESS )
								return (status);
						}
						else {
							if (( status = mhp_p_external( 
									heading->related_messages.v[j].v.external_message_reference,
									OM_FALSE, &subobject )) != OM_SUCCESS )
								return (status);
							if (( status = putvalue( desc, &nextval,
									EDI_RELATED_NON_EDI_MSGS, OM_S_OBJECT, 
									subobject)) != OM_SUCCESS )
							return (status);
						}
						append_struct( &baseval, &curval, nextval, &count ); 
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				related_msg_index -= j;
				break;
			
			case EDI_OBSOLETED_EDIMS:
log_error((OM_return_code) 0, "**** in edi obsoleted edims case **** " );
				if ( heading->m & EDIMHeading_obsoleted_EDIMs ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<heading->obsoleted_EDIMs.n; 
						  j++ ) {
						if (( status = mhp_p_edi_id( ( P35EDIMIdentifier * )
								heading->obsoleted_EDIMs.v[j], &subobject )) 
															 != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &nextval,
								EDI_OBSOLETED_EDIMS, OM_S_OBJECT, subobject)) 
															  != OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count ); 
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
			
			case EDI_EDI_APP_SECUR_ELEMENTS:
log_error((OM_return_code) 0, "**** in edi app secur ele case **** " );
				if (heading->m & EDIMHeading_edi_application_security_elements){
					if (( status = mhp_p_edi_app_security( 
								&heading->edi_application_security_elements,
								&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_EDI_APP_SECUR_ELEMENTS,OM_S_OBJECT,subobject )) 
																!= OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_CROSS_REFERENCING_INFO:
log_error((OM_return_code) 0, "**** in edi xref case **** " );
				if ( heading->m & EDIMHeading_cross_referencing_information ) {
					xrefs = ( P35CrossReferencingInformationField * ) 
						   	heading->cross_referencing_information;
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<xrefs->n; 
						  j++ ) {
						if (( status = mhp_p_edi_cross_ref( xrefs, 
												&subobject, j )) != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &nextval,
								EDI_CROSS_REFERENCING_INFO, OM_S_OBJECT,
								subobject)) != OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count ); 
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
			
			case EDI_EDI_MSG_TYPE:
log_error((OM_return_code) 0, "**** in edi msg type case **** " );
				if ( heading->m & EDIMHeading_edi_message_type ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<heading->edi_message_type.n; 
						  j++ ) {
						if (( status = p_strcpy( desc, &nextval,
								EDI_EDI_MSG_TYPE, OM_S_TELETEX_STRING,
								&heading->edi_message_type.v[j][0],
								strlen( &heading->edi_message_type.v[j][0] )))
													 	   	  != OM_SUCCESS )
							return (status );
						append_struct( &baseval, &curval, nextval, &count );
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
				
			case EDI_SERVICE_STRING_ADVICE:
log_error((OM_return_code) 0, "**** in edi serv string case **** " );
				if ( heading->m & EDIMHeading_service_string_advice ) {
					if (( status = mhp_p_edi_serv_str_adv( heading,
												&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_SERVICE_STRING_ADVICE, OM_S_OBJECT,subobject )) 
																!= OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_SYNTAX_ID:
log_error((OM_return_code) 0, "**** in edi syntax id case **** " );
				if ( heading->m & EDIMHeading_syntax_identifier ) {
					if (( status = mhp_p_edi_syntax_id( heading,
												&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
									EDI_SYNTAX_ID, OM_S_OBJECT, subobject )) 
															 != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_INTER_SENDER:
log_error((OM_return_code) 0, "**** in edi inter sender case **** " );
				if ( heading->m & EDIMHeading_interchange_sender ) {
					if (( status = mhp_p_edi_ic_sender( heading,
												&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
									EDI_INTER_SENDER, OM_S_OBJECT, subobject )) 
																!= OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_DATE_AND_TIME_OF_PREP:
log_error((OM_return_code) 0, "**** in edi date and time case **** " );
				if ( heading->m & EDIMHeading_date_and_time_of_preparation ) {
					if (( buf = (char *) mhp_to_utc( 
							&heading->date_and_time_of_preparation )) == NULL )
						return ( OM_MEMORY_INSUFFICIENT );
					if (( status = putvalue( desc, &desc->attr_value,
								EDI_DATE_AND_TIME_OF_PREP, OM_S_UTC_TIME_STRING,
								buf )) != OM_SUCCESS )
						return ( status );
				}
				break;
			
			case EDI_APP_REFERENCE:
log_error((OM_return_code) 0, "**** in edi app ref case **** " );
				if ( heading->m & EDIMHeading_application_reference ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_APP_REFERENCE, OM_S_TELETEX_STRING,
								heading->application_reference,
								strlen( heading->application_reference )))
													 	   != OM_SUCCESS )
							return ( status );
				}
				break;
			
			case EDI_HEADING_EXTENSIONS:
log_error((OM_return_code) 0, "**** in edi exte case **** " );
				if ( heading->m & EDIMHeading_heading_extensions ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<heading->heading_extensions.n; 
						  j++ ) {
						if (( status = mhp_p_edi_extension( 
											&heading->heading_extensions.v[j],
											&subobject )) != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &desc->attr_value, 
							EDI_HEADING_EXTENSIONS, OM_S_OBJECT, subobject )) 
															  != OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count );
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
		}
	}
	
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_id(
	P35EDIMIdentifier				*id,
	OM_int_private_object_header 	**object )
{
	Uint32							len;
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


log_error((OM_return_code) 0, "**** in mhp_p_edi_id() **** " );
	if ((status = omp_template( EDI_C_EDIM_ID, object )) 
											   != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_USER:
				/* The EDI User must be present */
				if (( status = mhp_p_orname( id->user, &subobject )) 
														 != OM_SUCCESS )
					return (status);
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_USER, OM_S_OBJECT, subobject )) != OM_SUCCESS )
					return (status);
				break;
				
			case EDI_USER_RELATIVE_ID:
				/* The EDI User Relative Identifier must be present */
				if ( len = strlen( id->user_relative_identifier ))
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_USER_RELATIVE_ID, OM_S_PRINTABLE_STRING,
							id->user_relative_identifier, len )) != OM_SUCCESS )
						return (status );
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_recip(
	P35RecipientsSubField			*recip,
	OM_int_private_object_header 	**object )
{
	Uint32							len;
	int								i, j, count, status;
	OM_boolean						flag;
	OM_string						string;
	OM_int_value					*baseval, *curval, *nextval;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;

log_error((OM_return_code) 0, "**** in edi recips() **** " );
	if ((status = omp_template( EDI_C_RECIPS, object )) != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_RECIP:
				if (( status = mhp_p_orname( recip->recipient,&subobject )) 
														 		!= OM_SUCCESS )
					return (status);
				if (( status = putvalue( desc, &desc->attr_value, 
						EDI_RECIP, OM_S_OBJECT, subobject )) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_ACT_REQUEST:
				mhp_addobj( &string, recip->action_request.id );
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_ACT_REQUEST, OM_S_OBJECT_IDENTIFIER_STRING,
								string.elements, string.length )) 
								!= OM_SUCCESS )
					return (status );
				break;
						
			case EDI_EDI_NOTIF_REQUESTS:
				if ( recip->m & 
						RecipientsSubField_edi_notification_requests_field ) {
					if (( status = mhp_p_edi_notif_req( recip, &subobject )) 
															 != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
										EDI_EDI_NOTIF_REQUESTS, OM_S_OBJECT, 
										subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_RESPONS_PASSING_ALLOWED:
				flag = OM_FALSE;
				if ( recip->responsibility_passing_allowed )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_RESPONS_PASSING_ALLOWED, 
							OM_S_BOOLEAN, (void *) flag)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_INTER_RECIP:
				if ( recip->m & RecipientsSubField_interchange_recipient ) {
					if (( status = mhp_p_edi_ic_recip( recip, &subobject )) 
															 != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
										EDI_INTER_RECIP, OM_S_OBJECT, 
										subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_RECIP_REFERENCE:
				if ( recip->m & RecipientsSubField_recipient_reference ) {
					if (( status = mhp_p_edi_recip_ref( recip, &subobject )) 
															 != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
										EDI_RECIP_REFERENCE, OM_S_OBJECT, 
										subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_INTER_CONTROL_REFERENCE:
				if ( recip->m & 
					 		RecipientsSubField_interchange_control_reference ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_INTER_CONTROL_REFERENCE, 
								OM_S_TELETEX_STRING,
								recip->interchange_control_reference,
								strlen( recip->interchange_control_reference )))
													 	   		 != OM_SUCCESS )
						return (status );
				}
				break;
			
			case EDI_PROCESSING_PRIORITY_CODE:
				if ( recip->m & RecipientsSubField_processing_priority_code ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_PROCESSING_PRIORITY_CODE, 
								OM_S_TELETEX_STRING,
								recip->processing_priority_code,
								strlen( recip->processing_priority_code )))
													 	   	!= OM_SUCCESS )
						return (status );
				}
				break;
			
			case EDI_ACKNOWLEDGEMENT_REQUEST:
				flag = OM_FALSE;
				if ( recip->acknowledgement_request )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_ACKNOWLEDGEMENT_REQUEST, 
							OM_S_BOOLEAN, (void *) flag)) != OM_SUCCESS )
					return (status);
				break;
			
			case EDI_COMMS_AGREEMENT_ID:
				if ( recip->m & 
						RecipientsSubField_communications_agreement_id) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_COMMS_AGREEMENT_ID, 
								OM_S_TELETEX_STRING,
								recip->communications_agreement_id,
								strlen( recip->communications_agreement_id )))
													 	   	   != OM_SUCCESS )
						return (status );
				}
				break;
			
			case EDI_TEST_INDICATOR:
				flag = OM_FALSE;
				if ( recip->test_indicator )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_TEST_INDICATOR, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
					return (status);
				break;
			
			case EDI_AUTHORIZATION_INFO:
				if ( recip->m & RecipientsSubField_authorization_information) {
					if (( status = mhp_p_edi_auth_info(
							( P35AuthorizationInformationField * )
							recip->authorization_information, &subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
									EDI_AUTHORIZATION_INFO, OM_S_OBJECT, 
									subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_RECIP_EXTENSIONS:
				if ( recip->m & RecipientsSubField_recipient_extensions ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<recip->recipient_extensions.n; 
						  j++ ) {
						if (( status = mhp_p_edi_extension( 
											&recip->recipient_extensions.v[j],
											&subobject )) != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &desc->attr_value, 
							EDI_RECIP_EXTENSIONS, OM_S_OBJECT, subobject )) 
															!= OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count );
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_edin_receiver(
	P35EDIMHeading					*heading,
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


	if ((status = omp_template( EDI_C_EDIN_RECEIVER, object )) 
													 != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_EDIN_RECEIVER_NAME:
				if (( status = mhp_p_orname( 
									heading->edin_receiver.edin_receiver_name, 
									&subobject )) != OM_SUCCESS )
					return (status);
				if (( status = putvalue( desc, &desc->attr_value, 
						EDI_EDIN_RECEIVER_NAME, OM_S_OBJECT, subobject )) 
															  != OM_SUCCESS )
					return (status);
				break;
				
			case EDI_ORIGINAL_EDIM_ID:
				if ( heading->edin_receiver.m & 
							EDINReceiverField_original_edim_identifier ) {
					if (( status = mhp_p_edi_id( (P35EDIMIdentifier *)
							heading->edin_receiver.original_edim_identifier, 
							&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
									EDI_ORIGINAL_EDIM_ID, OM_S_OBJECT, 
									subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_FIRST_RECIP:
				if ( heading->edin_receiver.m & 
									EDINReceiverField_first_recipient ) {
					if (( status = mhp_p_orname( 
								heading->edin_receiver.first_recipient, 
								&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_FIRST_RECIP, OM_S_OBJECT, subobject )) 
													   != OM_SUCCESS )
						return (status);
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_app_security(
	P35EDIApplicationSecurityElementsField	*app_secur,
	OM_int_private_object_header 			**object )
{
	int								i, j, count, status;
	OM_boolean						flag;
	OM_int_value					*baseval, *curval, *nextval;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


	if ((status = omp_template( EDI_C_EDI_APP_SECUR_ELEMENTS, object )) 
														  	  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_APP_SECUR_ELEMENTS:
				if ( app_secur->m & EDIApplicationSecurityElementsField_edi_application_security_element ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_APP_SECUR_ELEMENTS, OM_S_BIT_STRING,
						app_secur->edi_application_security_element.data, 
						app_secur->edi_application_security_element.length )) 
															   != OM_SUCCESS )
						return (status );
				}
				break;

			case EDI_ENCRYPTED_PRIMARY_BODYPART:
				if ( app_secur->m & EDIApplicationSecurityElementsField_edi_encrypted_primary_bodypart ) {
					if ( app_secur->edi_encrypted_primary_bodypart )
						flag = OM_TRUE;
					else
						flag = OM_FALSE;
					if (( status = putvalue( desc, &desc->attr_value, 
							EDI_ENCRYPTED_PRIMARY_BODYPART, OM_S_BOOLEAN, 
							(void *) flag)) != OM_SUCCESS )
						return (status);
				}
				break;
			
			case EDI_APP_SECUR_EXTENSIONS:
				if ( app_secur->m & EDIApplicationSecurityElementsField_edi_application_security_extensions ) {
					for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
						  j<app_secur->edi_application_security_extensions.n; 
						  j++ ) {
						if (( status = mhp_p_edi_extension( 
							&app_secur->edi_application_security_extensions.v[j],
							&subobject )) != OM_SUCCESS )
							return (status);
						if (( status = putvalue( desc, &desc->attr_value, 
							EDI_APP_SECUR_EXTENSIONS, OM_S_OBJECT, subobject )) 
																!= OM_SUCCESS )
							return (status);
						append_struct( &baseval, &curval, nextval, &count );
					}
					desc->attr_value = baseval;
					desc->count = count;
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_cross_ref(
	P35CrossReferencingInformationField		*xrefs,
	OM_int_private_object_header 			**object,
	int										index )
{
	Uint32							len;
	int								i, status;
	octet							*app_xref;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


	if ((status = omp_template( EDI_C_CROSS_REFERENCING_INFO, object )) 
															  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_APP_CROSS_REFERENCE:
				app_xref=xrefs->v[index].application_cross_reference.value;
				len = xrefs->v[index].application_cross_reference.length;
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_APP_CROSS_REFERENCE, OM_S_OCTET_STRING,
								app_xref, len )) != OM_SUCCESS )
					return (status );
				break;
				
			case EDI_MSG_REFERENCE:
				if ( xrefs->v[index].m & 
						CrossReferencingInformationSubField_message_reference) {
					if (( status = mhp_p_edi_id( (P35EDIMIdentifier *) 
							xrefs->v[index].message_reference,
							&subobject )) != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
									EDI_MSG_REFERENCE, OM_S_OBJECT, 
									subobject )) != OM_SUCCESS )
						return (status);
				}
				break;
				
			case EDI_BODYPART_REFERENCE:
				if (( status = putvalue( desc, &desc->attr_value, 
						EDI_BODYPART_REFERENCE, OM_S_INTEGER, 
						&xrefs->v[index].body_part_reference )) != OM_SUCCESS )
					return (status);
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_serv_str_adv(
	P35EDIMHeading					*heading,
	OM_int_private_object_header 	**object ) 
{
	Uint32							len;
	int								i, status;
	octet							*string;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


log_error((OM_return_code) 0, "**** in edi ssa() **** " );
	if ((status = omp_template( EDI_C_SERVICE_STRING_ADVICE, object )) 
															 != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_COMPONENT_DATA_ELEMENT_SEP:
				string =
					heading->service_string_advice.component_data_element_separator.value;
				len = 
					heading->service_string_advice.component_data_element_separator.length;
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_COMPONENT_DATA_ELEMENT_SEP, 
								OM_S_OCTET_STRING, string, len ))!=OM_SUCCESS )
					return (status);
				break;

			case EDI_DATA_ELEMENT_SEPARATOR:
				string =
					heading->service_string_advice.data_element_separator.value;
				len = 
					heading->service_string_advice.data_element_separator.length;
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_DATA_ELEMENT_SEPARATOR, OM_S_OCTET_STRING, 
								string, len )) != OM_SUCCESS )
					return (status);
				break;

			case EDI_DECIMAL_NOTATION:
				string = heading->service_string_advice.decimal_notation.value;
				len = heading->service_string_advice.decimal_notation.length;
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_DECIMAL_NOTATION, OM_S_OCTET_STRING, 
								string, len )) != OM_SUCCESS )
					return (status);
				break;

			case EDI_RELEASE_INDICATOR:
				if ( heading->service_string_advice.m &
							ServiceStringAdviceField_release_indicator ) {
					string =
						heading->service_string_advice.release_indicator.value;
					len = 
						heading->service_string_advice.release_indicator.length;
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_RELEASE_INDICATOR, OM_S_OCTET_STRING, 
								string, len )) != OM_SUCCESS )
						return (status);
				}
				break;

			case EDI_RESERVED:
				if ( heading->service_string_advice.m &
									ServiceStringAdviceField_reserved ) {
					string =
						heading->service_string_advice.reserved.value;
					len = 
						heading->service_string_advice.reserved.length;
					if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_RESERVED, OM_S_OCTET_STRING, 
								string, len )) != OM_SUCCESS )
						return (status);
				}
				break;

			case EDI_SEGMENT_TERMINATOR:
				string = heading->service_string_advice.segment_terminator.value;
				len = heading->service_string_advice.segment_terminator.length;
				if (( status = p_strcpy( desc, &desc->attr_value, 
								EDI_SEGMENT_TERMINATOR, OM_S_OCTET_STRING, 
								string, len )) != OM_SUCCESS )
					return (status);
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_syntax_id(
	P35EDIMHeading					*heading,
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;

log_error((OM_return_code) 0, "**** in edi syntax id() **** " );

	if ((status = omp_template( EDI_C_SYNTAX_ID, object )) != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_SYNTAX_ID_STRING:
				if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_SYNTAX_ID, OM_S_TELETEX_STRING,
						heading->syntax_identifier.syntax_identifier,
						strlen( heading->syntax_identifier.syntax_identifier )))
														 	     != OM_SUCCESS )
					return (status );
				break;

			case EDI_SYNTAX_VERSION:
				if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_SYNTAX_VERSION, OM_S_PRINTABLE_STRING,
						heading->syntax_identifier.syntax_version,
						strlen( heading->syntax_identifier.syntax_version )))
															 	 != OM_SUCCESS )
					return (status );
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_ic_sender(
	P35EDIMHeading					*heading,
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


log_error((OM_return_code) 0, "**** in edi ic sender() **** " );
	if ((status = omp_template( EDI_C_INTER_SENDER_RECIP, object )) 
														  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_IDENTIFICATION_CODE:
				if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_IDENTIFICATION_CODE, OM_S_TELETEX_STRING,
						heading->interchange_sender.sender_identification,
						strlen( heading->interchange_sender.sender_identification )))
														 	 != OM_SUCCESS )
					return (status );
				break;

			case EDI_IDENTIFICATION_CODE_Q:
				if ( heading->interchange_sender.m &
					InterchangeSenderField_identification_code_qualifier ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_IDENTIFICATION_CODE_Q, OM_S_TELETEX_STRING,
							heading->interchange_sender.identification_code_qualifier,
							strlen( heading->interchange_sender.identification_code_qualifier )))
														 	  != OM_SUCCESS )
						return (status );
				}
				break;

			case EDI_ROUTING_ADDRESS:
				if ( heading->interchange_sender.m &
						InterchangeSenderField_address_for_reverse_routing ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_ROUTING_ADDRESS, OM_S_TELETEX_STRING,
							heading->interchange_sender.address_for_reverse_routing,
							strlen( heading->interchange_sender.address_for_reverse_routing )))
														 	  != OM_SUCCESS )
						return (status );
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_extension(
	P35ExtensionField				*extension,
	OM_int_private_object_header 	**object )
{
	return (MH_RC_FEATURE_UNAVAILABLE);
}

OM_return_code mhp_p_edi_notif_req(
	P35RecipientsSubField			*recip, 
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_boolean						flag;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;

log_error((OM_return_code) 0, "**** in edi notif req() **** " );

	if ((status = omp_template( EDI_C_EDI_NOTIF_REQUESTS, object )) 
														  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_POSITIVE_NOTIF:
				flag = OM_FALSE;
				if ( recip->edi_notification_requests_field.edi_notification_requests & EDI_NOTIFICATION_REQUESTS_pn ) 
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_POSITIVE_NOTIF, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
						return (status);
				break;
					
			case EDI_NEGATIVE_NOTIF:
				flag = OM_FALSE;
				if ( recip->edi_notification_requests_field.edi_notification_requests & EDI_NOTIFICATION_REQUESTS_nn )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_NEGATIVE_NOTIF, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
						return (status);
				break;

			case EDI_FORWARD_NOTIF:
				flag = OM_FALSE;
				if ( recip->edi_notification_requests_field.edi_notification_requests & EDI_NOTIFICATION_REQUESTS_fn ) 	
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_FORWARD_NOTIF, OM_S_BOOLEAN, (void *) flag)) 
							!= OM_SUCCESS )
						return (status);
					break;

			case EDI_PROOF_OF_RECEPTION:
				flag = OM_FALSE;
				if ( recip->edi_notification_requests_field.edi_reception_security & EDI_RECEPTION_SECURITY_proof )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
						EDI_PROOF_OF_RECEPTION, OM_S_BOOLEAN, (void *)flag)) 
							!= OM_SUCCESS )
						return (status);
					break;

			case EDI_NON_REPUD_OF_RECEPTION:
				flag = OM_FALSE;
				if ( recip->edi_notification_requests_field.edi_reception_security & EDI_RECEPTION_SECURITY_non_repudiation )
					flag = OM_TRUE;
				if (( status = putvalue( desc, &desc->attr_value, 
							EDI_NON_REPUD_OF_RECEPTION, OM_S_BOOLEAN, 
							(void *) flag)) != OM_SUCCESS )
						return (status);
					break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_ic_recip(
	P35RecipientsSubField			*recip, 
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;


log_error((OM_return_code) 0, "**** in edi ic recip() **** " );
	if ((status = omp_template( EDI_C_INTER_SENDER_RECIP, object )) 
														  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_IDENTIFICATION_CODE:
				if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_IDENTIFICATION_CODE, OM_S_TELETEX_STRING,
						recip->interchange_recipient.recipient_identification,
						strlen( recip->interchange_recipient.recipient_identification )))
														 	 != OM_SUCCESS )
					return (status );
				break;

			case EDI_IDENTIFICATION_CODE_Q:
				if ( recip->interchange_recipient.m & 
					InterchangeRecipientField_identification_code_qualifier ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_IDENTIFICATION_CODE_Q, OM_S_TELETEX_STRING,
							recip->interchange_recipient.identification_code_qualifier,
							strlen( recip->interchange_recipient.identification_code_qualifier )))
														 	  != OM_SUCCESS )
						return (status );
				}
				break;

			case EDI_ROUTING_ADDRESS:
				if ( recip->interchange_recipient.m & 
							InterchangeRecipientField_routing_address ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_ROUTING_ADDRESS, OM_S_TELETEX_STRING,
							recip->interchange_recipient.routing_address,
							strlen( 
							 recip->interchange_recipient.routing_address )))
														 	  != OM_SUCCESS )
						return (status );
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_recip_ref(
	P35RecipientsSubField			*recip,
	OM_int_private_object_header 	**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;

log_error((OM_return_code) 0, "**** in edi recip ref() **** " );

	if ((status = omp_template( EDI_C_RECIP_REFERENCE, object )) 
													   != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_RECIP_REFERENCE:
				if (( status = p_strcpy( desc, &desc->attr_value, 
						EDI_RECIP_REFERENCE, OM_S_TELETEX_STRING,
						recip->recipient_reference.recipient_reference,
						strlen( 
							  recip->recipient_reference.recipient_reference )))
																 != OM_SUCCESS )
					return (status );
				break;

			case EDI_RECIP_REFERENCE_Q:
				if ( recip->recipient_reference.m & 
					RecipientReferenceField_recipient_reference_qualifier ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_RECIP_REFERENCE_Q, OM_S_TELETEX_STRING,
							recip->recipient_reference.recipient_reference_qualifier,
							strlen( recip->recipient_reference.recipient_reference_qualifier )))
																 != OM_SUCCESS )
						return (status );
				}
				break;
		}				
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_auth_info(
	P35AuthorizationInformationField	*auth,
	OM_int_private_object_header 		**object )
{
	int								i, status;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;

log_error((OM_return_code) 0, "**** in edi auth info() **** " );

	if ((status = omp_template( EDI_C_AUTHORIZATION_INFO, object )) 
														  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_AUTHORIZATION_INFO:
				if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_AUTHORIZATION_INFO, OM_S_TELETEX_STRING,
							auth->authorization_information,
							strlen( auth->authorization_information )))
														!= OM_SUCCESS )
					return (status );
				break;
				
			case EDI_AUTHORIZATION_INFO_Q:
				if ( auth->m &
						AuthorizationInformationField_authorization_information_qualifier ) {
					if (( status = p_strcpy( desc, &desc->attr_value, 
							EDI_AUTHORIZATION_INFO_Q, OM_S_TELETEX_STRING,
							auth->authorization_information_qualifier,
							strlen( auth->authorization_information_qualifier )))
																  != OM_SUCCESS )
						return (status );
				}
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_prim_body(
	P35EDIMBody						*body,
	OM_int_private_object_header 	**object )
{
	P35PrimaryBodyPart				*prim_body;
	int								status;


log_error((OM_return_code) 0, "**** in mhp_p_edi_prim_body **** " );
	prim_body = ( P35PrimaryBodyPart * ) body->primary_body_part;

	switch ( prim_body->t ) {
	
		case PrimaryBodyPart_edi_body_part:
			if (( status = mhp_p_edi_edi_body( prim_body, object )) 
													!= OM_SUCCESS )
				return (status);
			break;
		
		case PrimaryBodyPart_forwarded_EDIM:
			return (MH_RC_FEATURE_UNAVAILABLE);
	}
	
	return ( OM_SUCCESS );
}		

OM_return_code mhp_p_edi_edi_body(
	P35PrimaryBodyPart				*prim_body,
	OM_int_private_object_header 	**object )
{
	int								i, status;
	char							*body;
	Uint32							len;
	OM_int_descriptor				*desc;
	OM_int_private_object_header	*subobject;
	Generic_bodypart				*gen_body;


log_error((OM_return_code) 0, "**** in mhp_p_edi_edi_body **** " );
	if ((status = omp_template( EDI_C_EDI_BODYPART, object )) 
													!= OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_BODY:
				gen_body = ( Generic_bodypart * ) prim_body->v.edi_body_part;
				/* This is the reverse of what it should be, tell HP! NIST PH */
				if ( gen_body->t == BODYPART_IN_FILE_TAG ) {
					if (( status = write_str( desc, &desc->attr_value,
							EDI_BODY, OM_S_OCTET_STRING, 
							(char *)gen_body->pInMemory )) != OM_SUCCESS )
						return (status);
				}
				else {
					body = gen_body->pInMemory->data;
					len = strlen( body );
					if (( status = p_strcpy( desc, &desc->attr_value, EDI_BODY, 
							OM_S_OCTET_STRING, body, len )) != OM_SUCCESS )
						return (status );
				}
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code mhp_p_edi_add_body(
	P35EDIM_ExternallyDefinedBodyPart	*ext_body,
	OM_int_private_object_header 		**object )
{
	struct bodypart						bp;
	int									i, status;
	OM_int_descriptor					*desc;
	OM_int_private_object_header		*subobject;


	if ((status = omp_template(EDI_C_EDIM_EX_DEFINED_BODYPART, object)) 
											   				  != OM_SUCCESS )
		return (status);
	
	for ( i = TOP; 
		  (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
		  i++ ) 
	{
		desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

		switch ( desc->attr_type ) {

			case EDI_BODYPART_REFERENCE:
				if ( ext_body->m & 
						EDIM_ExternallyDefinedBodyPart_body_part_reference ) {
					if (( status = putvalue( desc, &desc->attr_value, 
								EDI_BODYPART_REFERENCE, OM_S_INTEGER, 
								&ext_body->body_part_reference ))!=OM_SUCCESS )
						return (status);
				}
				break;
				
			case EDI_EX_BODYPART:
				if ( ext_body->m & 
						EDIM_ExternallyDefinedBodyPart_external_body_part ) {
					/* Use the P22 external parse function */
					bp.data = ext_body->external_body_part;
/*					if (( status = mhp_p_im_external( &bp, &subobject )) 
														 != OM_SUCCESS )
						return (status);
					if (( status = putvalue( desc, &desc->attr_value, 
										EDI_EX_BODYPART, OM_S_OBJECT, 
										subobject )) != OM_SUCCESS )
						return (status);
*/				}
				break;
		}
	}
		
	return (OM_SUCCESS);
}

OM_return_code
mhp_p_edin( int  						 *edin,
            OM_int_private_object_header **object)
{
	P35EDIN							*p35edin;
    OM_int_private_object_header	*subobject;
	OM_int_descriptor				*desc;
	int								i, status = OM_SUCCESS;

	p35edin = (P35EDIN *) edin;

    switch ( p35edin->t ) {

	case EDIN_positive_notification:
	    if (( status = 
               mhp_p_edin_positive( p35edin, object) ) != OM_SUCCESS )
      		return( status );
/*	    if (( status = putvalue( desc, &desc->attr_value, 
                EDI_POSITIVE_NOTIF, OM_S_OBJECT, object )) != OM_SUCCESS )
		return( status );
*/    	break;

  	case EDIN_negative_notification:
	    if (( status = 
                mhp_p_edin_negative(p35edin, object) ) != OM_SUCCESS )
                 return( status );
/*	    if (( status = putvalue( desc, &desc->attr_value, 
               EDI_NEGATIVE_NOTIF, OM_S_OBJECT, object )) != OM_SUCCESS )
                 return( status );
*/    	break;

  	case EDIN_forwarded_notification:
	    if (( status = 
                mhp_p_edin_forwarded(p35edin, object) ) != OM_SUCCESS )
		 return( status );
/*	    if (( status = putvalue( desc, &desc->attr_value, 
                EDI_FORWARD_NOTIF, OM_S_OBJECT, object )) != OM_SUCCESS )
		 return( status );
*/    	break;

  	default:
	    return(OM_NO_SUCH_OBJECT); /* error */
    } /* switch */
    return( status ); 
}




OM_return_code
mhp_p_edin_positive(
        P35EDIN 			*p35edin,
	OM_int_private_object_header 	**object    )
{

	OM_int_private_object_header	*subobject;
	OM_int_descriptor		*desc;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_POSITIVE_NOTIF, object )) != OM_SUCCESS )
            return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list) &((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:

		if (( status = mhp_p_edi_common_fields( &p35edin->v.positive_notification.pn_common_fields, object,
				desc )) != OM_SUCCESS )
		   return( status );

		break;

		case EDI_SUPPLEMENTARY_INFO:

		    if ( p35edin->v.positive_notification.m & 
                PositiveNotificationFields_pn_supplementary_information )  {
			if (( status = p_strcpy( desc, &desc->attr_value,
				EDI_SUPPLEMENTARY_INFO,
				OM_S_TELETEX_STRING,
				p35edin->v.positive_notification.pn_supplementary_information,
				strlen( p35edin->v.positive_notification.pn_supplementary_information )))
					!= OM_SUCCESS )
			    return( status );
		      }
		
		break;

		/* 
		 * ignore pn extensions 
		 */
/*     	default:
	            return(OM_NO_SUCH_OBJECT);  error */

	} /* switch */

	} /* for */

   return ( status );
}


OM_return_code
mhp_p_edin_negative(
        P35EDIN 			*p35edin,
	OM_int_private_object_header 	**object    )
{

	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_NEGATIVE_NOTIF, object )) != OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:

		if (( status = mhp_p_edi_common_fields( &p35edin->v.negative_notification.nn_common_fields, object,
				desc )) != OM_SUCCESS )
		   return( status );

		break;

		case EDI_NN_REASON_CODE:

/*        if (( status = mhp_p_edi_nn_reason_code( p35edin,
					&subobject )) != OM_SUCCESS )
				return ( status );

        if (( status = putvalue( desc, &desc->attr_value,
				EDI_NN_REASON_CODE, OM_S_OBJECT,
				subobject )) != OM_SUCCESS )
                                return( status );
*/		break;

		case EDI_SUPPLEMENTARY_INFO:

		    if ( p35edin->v.negative_notification.m & 
                NegativeNotificationFields_nn_supplementary_information )  {
			if (( status = p_strcpy( desc, &desc->attr_value,
				EDI_SUPPLEMENTARY_INFO,
				OM_S_TELETEX_STRING,
				p35edin->v.negative_notification.nn_supplementary_information,
				strlen( p35edin->v.negative_notification.nn_supplementary_information )))
					!= OM_SUCCESS )
			    return( status );
		      }
		
		break;

		/*
		 * Ignore nn extensions.
		 */
/*          	default:
	             return(OM_NO_SUCH_OBJECT); error */

	        } /* Switch */
	} /* for */
  return( status );
}




OM_return_code
mhp_p_edin_forwarded(
        P35EDIN 			*p35edin,
	OM_int_private_object_header 	**object    )
{

	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_FORWARD_NOTIF, object )) != OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_SUBJECT_EDIM:
		case EDI_EDIN_ORIG:
		case EDI_FIRST_RECIP:
		case EDI_NOTIF_TIME:
		case EDI_SECUR_ELEMENTS:
		case EDI_EDIN_INITIATOR:
		case EDI_NOTIF_EXTENSIONS:

		if (( status = mhp_p_edi_common_fields( &p35edin->v.forwarded_notification.fn_common_fields, object,
				desc )) != OM_SUCCESS );

		   return( status );
		break;

		case EDI_FORWARD_TO:

			if (( status = mhp_p_orname( 
                            &p35edin->v.forwarded_notification.forwarded_to,
					&subobject )) != OM_SUCCESS )
				return ( status );

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_FORWARD_TO, OM_S_INTEGER,
				subobject )) != OM_SUCCESS )
			    return( status );
		break;

		case EDI_FN_REASON_CODE:

			if (( status = mhp_p_edi_fn_reason_code( p35edin,
					&subobject )) != OM_SUCCESS )
				return ( status );

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_FN_REASON_CODE, OM_S_OBJECT,
				subobject )) != OM_SUCCESS )
			    return( status );
		break;

		case EDI_SUPPLEMENTARY_INFO:

		if ( p35edin->v.forwarded_notification.m & 
                ForwardedNotificationFields_fn_supplementary_information )  {
			if (( status = p_strcpy( desc, &desc->attr_value,
				EDI_SUPPLEMENTARY_INFO,
				OM_S_TELETEX_STRING,
				p35edin->v.forwarded_notification.fn_supplementary_information,
				strlen( p35edin->v.forwarded_notification.fn_supplementary_information )))
					!= OM_SUCCESS )
			    return( status );
		      }
		
		break;

	/*
	 * Ignore FN extensions.
	 */

/*          	default:
	            return(OM_NO_SUCH_OBJECT);  error */

	        } /* Switch */
	} /* for */
  return ( status );


}



OM_return_code mhp_p_edi_nn_reason_code(
	P35EDIN				*p35edin,
	OM_int_private_object_header 	**object)
{

	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_NN_REASON_CODE, object )) != OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

           switch ( p35edin->v.negative_notification.nn_reason_code.t ) {

	   case NNReasonCodeField_nn_ua_ms_reason_code:

		if ((status = mhp_p_edi_nn_ua_ms_code( p35edin, &subobject ))
				!= OM_SUCCESS ) 
			return ( status );
		if ((status = putvalue( desc, &desc->attr_value,
				EDI_C_NN_UAMS_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	
           break;

	   case NNReasonCodeField_nn_user_reason_code:

		if ( (status = mhp_p_edi_nn_user_code( p35edin, &subobject ))
				!= OM_SUCCESS ) 
			return ( status );
		if ( (status = putvalue( desc, &desc->attr_value,
				EDI_C_NN_USER_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	
	   break;

	   case NNReasonCodeField_nn_pdau_reason_code:

		if ( (status = mhp_p_edi_nn_pdau_code( p35edin, &subobject ))
				!= OM_SUCCESS ) 
			return ( status );
		if ( (status = putvalue( desc, &desc->attr_value,
				EDI_C_NN_PDAU_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	
	   break;

       	   default:
               return(OM_NO_SUCH_OBJECT);  /* error */

           } /* switch */

    } /* for */
  return ( status );
}




OM_return_code mhp_p_edi_nn_ua_ms_code(
	P35EDIN				*p35edin,
	OM_int_private_object_header 	**object)

{
	OM_int_descriptor		*desc;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_FN_UAMS_REASON_CODE, object )) 
													  != OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_BASIC_CODE:
 
			if (( status = putvalue( desc, &desc->attr_value,
				EDI_BASIC_CODE, OM_S_INTEGER,
                                p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.nn_ua_ms_basic_code ))
				 != OM_SUCCESS )
			    return( status );
		break;

		case EDI_DIAGNOSTIC:

       		if ( p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.m
		       & NNUAMSReasonCodeField_nn_ua_ms_diagnostic ) {

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_DIAGNOSTIC, OM_S_INTEGER,
                                p35edin->v.negative_notification.nn_reason_code.v.nn_ua_ms_reason_code.nn_ua_ms_diagnostic ))
				 != OM_SUCCESS )
			    return( status );
		      }

		break;

/*       	   default:
                return(OM_NO_SUCH_OBJECT);  error */

        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}




OM_return_code mhp_p_edi_nn_user_code(
	P35EDIN				*p35edin,
	OM_int_private_object_header 	**object)

{
	OM_int_descriptor		*desc;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_NN_USER_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {

		case EDI_BASIC_CODE:
			if (( status = putvalue( desc, &desc->attr_value,
				EDI_BASIC_CODE, OM_S_INTEGER,
                                p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.nn_user_basic_code ))
				 != OM_SUCCESS )
			    return( status );
		break;

		case EDI_DIAGNOSTIC:

       		if ( p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.m
                     & NNUserReasonCodeField_nn_user_diagnostic ) {

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_DIAGNOSTIC, OM_S_INTEGER,
				p35edin->v.negative_notification.nn_reason_code.v.nn_user_reason_code.nn_user_diagnostic ))
				 != OM_SUCCESS )
			    return( status );

			}

		break;


/*         	default:
	                return(OM_NO_SUCH_OBJECT);  error */

        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}




OM_return_code mhp_p_edi_nn_pdau_code(
	P35EDIN				*p35edin, 
	OM_int_private_object_header 	**object )
{
	OM_int_descriptor		*desc;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_NN_PDAU_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );


	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {

		case EDI_BASIC_CODE:

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_BASIC_CODE, OM_S_INTEGER,
                                p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.nn_pdau_basic_code ))
				 != OM_SUCCESS )
			    return( status );
		break;

		case EDI_DIAGNOSTIC:

		if ( p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.m 
                           & NNPDAUReasonCodeField_nn_pdau_diagnostic ) {

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_DIAGNOSTIC, OM_S_INTEGER,
                                p35edin->v.negative_notification.nn_reason_code.v.nn_pdau_reason_code.nn_pdau_diagnostic )) 
				!= OM_SUCCESS )
			    return( status );

		}
		break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}



OM_return_code mhp_p_edi_fn_reason_code(
	P35EDIN				*p35edin,
	OM_int_private_object_header 	**object )

{
	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_FN_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) {

	desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	switch ( p35edin->v.forwarded_notification.fn_reason_code.t ) {

	case FNReasonCodeField_fn_ua_ms_reason_code:
		if ((status = mhp_p_edi_fn_ua_ms_code( p35edin, &subobject ))
				!= OM_SUCCESS ) {
			return ( status );
		if ((status = putvalue( desc, &desc->attr_value,
				EDI_C_FN_UAMS_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	}
	break;

	case FNReasonCodeField_fn_user_reason_code:
		if ((status = mhp_p_edi_fn_user_code( p35edin, &subobject ))
				!= OM_SUCCESS ) {
			return ( status );
         	    if ((status = putvalue( desc, &desc->attr_value,
				EDI_C_FN_USER_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	}
	break;

	case FNReasonCodeField_fn_pdau_reason_code:
		if ((status = mhp_p_edi_fn_pdau_code( p35edin, &subobject ))
				!= OM_SUCCESS ) {
			return ( status );
		if ((status = putvalue( desc, &desc->attr_value,
				EDI_C_FN_PDAU_REASON_CODE, OM_S_OBJECT, 
				subobject )) != OM_SUCCESS )
			return( status );
        	}
	break;

        default:
             return(OM_NO_SUCH_OBJECT); /* error */

     } /* switch */
   } /* for */
   return ( status );	
}



OM_return_code mhp_p_edi_fn_ua_ms_code(
	P35EDIN				*p35edin,
	OM_int_private_object_header 	**object )

{
	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	OM_boolean		flag;           
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_NN_UAMS_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_FN_SECUR_CHECK:
        flag = OM_FALSE;
        if ( p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_security_check )
              flag = OM_TRUE;
		if (( status = putvalue ( desc, &desc->attr_value,
			EDI_FN_SECUR_CHECK, OM_S_BOOLEAN, 
			(void *) flag )) != OM_SUCCESS )
			return( status );
		break;

		case EDI_BASIC_CODE:
                     if (( status =  putvalue( desc, &desc->attr_value,
			   EDI_BASIC_CODE, OM_S_INTEGER,
                           p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_ua_ms_basic_code )) != OM_SUCCESS )
			return( status );
		break;

		case EDI_DIAGNOSTIC:
       		  if (p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.m
			& FNUAMSReasonCodeField_fn_ua_ms_diagnostic ) {
                     if (( status = putvalue( desc, &desc->attr_value,
                           EDI_DIAGNOSTIC, OM_S_INTEGER,
                          p35edin->v.forwarded_notification.fn_reason_code.v.fn_ua_ms_reason_code.fn_ua_ms_diagnostic )) != OM_SUCCESS )
			return( status );
		}
		break;

        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}



OM_return_code mhp_p_edi_fn_user_code(
	P35EDIN				*p35edin, 
	OM_int_private_object_header 	**object )
{
	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, j, status = OM_SUCCESS;
	OM_boolean			flag;

	if (( status = omp_template( EDI_C_FN_USER_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );

	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {
        
		case EDI_BASIC_CODE:
			if (( status = putvalue( desc, &desc->attr_value,
				EDI_BASIC_CODE, OM_S_INTEGER,
                             p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.fn_user_basic_code )) != OM_SUCCESS )
				return ( status );
		break;

		case EDI_DIAGNOSTIC:
       		if (p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.m 
				& FNUserReasonCodeField_fn_user_diagnostic) {

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_DIAGNOSTIC, OM_S_INTEGER,
                             p35edin->v.forwarded_notification.fn_reason_code.v.fn_user_reason_code.fn_user_diagnostic )) != OM_SUCCESS )
				return ( status );
		}
		break;
        } /* switch */
	} /* for */

	return ( OM_SUCCESS );
}


OM_return_code mhp_p_edi_fn_pdau_code(
	P35EDIN							*p35edin, 
	OM_int_private_object_header 	**object )
{
	OM_int_descriptor		*desc;
	OM_int_private_object_header	*subobject;
	int				i, status = OM_SUCCESS;

	if (( status = omp_template( EDI_C_FN_PDAU_REASON_CODE, object ))
		!= OM_SUCCESS )
	   return ( status );


	for ( i = TOP; 
         (*object)->context.descriptor_list[i].attr_type != OM_NO_MORE_TYPES; 
              i++ ) 
	{
           desc = (OM_int_descriptor_list)&((*object)->context.descriptor_list[i]);

	   switch ( desc->attr_type ) {

		case EDI_BASIC_CODE:

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_BASIC_CODE, OM_S_INTEGER,
                                p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.fn_pdau_basic_code ))
				 != OM_SUCCESS )
				return ( status );
		break;

		case EDI_DIAGNOSTIC:

		if ( p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.m 
			& FNPDAUReasonCodeField_fn_pdau_diagnostic ) {

			if (( status = putvalue( desc, &desc->attr_value,
                           EDI_DIAGNOSTIC, OM_S_INTEGER,
                           p35edin->v.forwarded_notification.fn_reason_code.v.fn_pdau_reason_code.fn_pdau_diagnostic )) 
				!= OM_SUCCESS )
                     	  return( status );
		}
		break;

	} /* switch */
	} /* for */

	return ( OM_SUCCESS );
}




OM_return_code
mhp_p_edi_common_fields(
        P35CommonFields 		*common_fields,
	OM_int_private_object_header 	**object,
	OM_int_descriptor		*desc )

{

	OM_int_private_object_header	*subobject;
	OM_enumeration		enumer;
	char				*buf;	
	int					i, j, count = 0, status = OM_SUCCESS;
	OM_int_value			*baseval, *curval, *nextval;

	/* The following are the common fields used in P35 EDINs. */
        switch ( desc->attr_type ) {

	case EDI_SUBJECT_EDIM:

		if (( status = mhp_p_edi_id( (P35EDIMIdentifier *)common_fields->subject_edim, &subobject)) 
                    != OM_SUCCESS )
		      return( status );
		if (( status = putvalue( desc, &desc->attr_value,
				EDI_SUBJECT_EDIM, OM_S_OBJECT, subobject ))
			!= OM_SUCCESS )
		   return ( status );
	break;

	case EDI_EDIN_ORIG:

		if (( status = mhp_p_orname( common_fields->edin_originator,
			&subobject )) != OM_SUCCESS ) 
			return( status );

		if (( status = putvalue( desc, &desc->attr_value,
			EDI_EDIN_ORIG, OM_S_OBJECT, subobject ))
				!= OM_SUCCESS )
				return( status );
	break;

	case EDI_FIRST_RECIP:

	if ( common_fields->m & CommonFields_first_recipient ) {
		if (( status = mhp_p_orname( common_fields->first_recipient,
			&subobject )) != OM_SUCCESS ) 
			return( status );

		if (( status = putvalue( desc, &desc->attr_value,
			EDI_FIRST_RECIP, OM_S_OBJECT, subobject ))
				!= OM_SUCCESS )
			return (status);
	}
	break;

	case EDI_NOTIF_TIME:

		if ( ( buf = (char *) mhp_to_utc( &common_fields->notification_time ) )
    				 == NULL )
			return( OM_MEMORY_INSUFFICIENT );
		if (( status = putvalue( desc, &desc->attr_value,
				EDI_NOTIF_TIME, OM_S_UTC_TIME_STRING, buf ) )
				!= OM_SUCCESS )
			return( status );
	break;

	case EDI_SECUR_ELEMENTS:
        /*
	 * Ignore, will never receive edi security elements.
	 */
		if ( common_fields->m & 
                    CommonFields_notification_security_elements) 
/*		{	if (( status = 
 *      	       	   mhp_p_edi_notif_security_elements( 
 *							&common_fields->notification_security_elements, 
 *							&subobject )) != OM_SUCCESS )
 *							return ( status );
 *             		 if (( status = putvalue( desc, &desc->attr_value,
 *       			EDI_SECUR_ELEMENTS, OM_S_OBJECT, subobject ))
 *				!= OM_SUCCESS )
 *				return( status );
 *		}
 */
 		return ( MH_RC_FEATURE_UNAVAILABLE );
	break;

	case EDI_EDIN_INITIATOR:

		switch ( common_fields->edin_initiator )  /* ??? (e.g. enumeration) */ {
		case EDIN_INITIATOR_internal_ua:
			enumer = EDI_EI_INTERNAL_UA;
			break;

		case EDIN_INITIATOR_external_ua:
			enumer = EDI_EI_EX_UA;
			break;

		case EDIN_INITIATOR_internal_ms:
			enumer = EDI_EI_INTERNAL_MS;
			break;
		}

		if (( status = putvalue( desc, &desc->attr_value, EDI_EDIN_INITIATOR, 
					OM_S_ENUMERATION, (void *)enumer )) != OM_SUCCESS )
			return( status );
        break;

/* 
 * The notif extensions is defined twice, once as part of the P35 Common
 * fields, and once as an attribute of the positive notification.
 */
	case EDI_NOTIF_EXTENSIONS:

		if (common_fields->m & CommonFields_notifications_extensions) {
			for ( j=0, count=0, baseval=curval=nextval=desc->attr_value;
				j < common_fields->notifications_extensions.n;
				j++ ) {

			   	if (( status = mhp_p_edi_extension( 
		               		&common_fields->notifications_extensions.v[j], 
					&subobject )) != OM_SUCCESS )
					return( status );

			if (( status = putvalue( desc, &desc->attr_value,
				EDI_NOTIF_EXTENSIONS, OM_S_OBJECT, subobject ))
					!= OM_SUCCESS )
				return( status );
				append_struct( &baseval, &curval, nextval, &count );
			} /* for */
			desc->attr_value = baseval; 
			desc->count = count;
		}
		break;
	} /* switch  */
			
  return (OM_SUCCESS);
}

