// FILE:  x400ipm.C

#include	<fstream.h>
#include	<sys/types.h>
#include	<sys/unistd.h>
#include	<dirent.h>
#include	<xom.h>
#include	<assert.h>
#include	<xedip.h>
extern "C" {
#include	"/usr/lib/x400/gtwapi/include/nist_xmh.h"
}
#include	"/usr/lib/x400/gtwapi/include/xmhp.h"
#include	"/usr/lib/x400/gtwapi/include/ximp.h"
#include	"../../../include/platform.h"
#include	"../../../include/log.h"
#include	"../../../include/subject.h"
#include	"../../../include/interchange.h"
#include	"../../../include/linklist.h"
#include	"../../../include/or_name.h"
#include	"../../../include/edi_user.h"
#include	"../../../include/config.h"
#include	"../../../include/platfile.h"
#include	"../../../include/tpfile.h"
#include	"../../../include/api_obj.h"
#include	"../../../include/x400api.h"



STATUS X400Message::build_this_ipm( APIObject	*ipm_content,
				    APIObject	*originator,
				    APIObject   *this_ipm ) {
 
     STATUS		status = SUCCESS;

#ifdef	DEBUG
	cout << "In build_this_edim()" << endl;
#endif

//     status |= this_ipm->api_create( OMP_O_IM_C_IPM_IDENTIFIER );

     this_ipm->make_class( OMP_O_IM_C_IPM_IDENTIFIER );
     this_ipm->put_desc( IM_USER, originator->pub_object() );
     current_time( this_ipm->time_buf() );
     this_ipm->put_desc( IM_USER_RELATIVE_IDENTIFIER, OM_S_PRINTABLE_STRING,
			 this_ipm->time_buf() );
     this_ipm->end_object();

//     status |= this_ipm->api_put();
//     ipm_content->put_desc( IM_THIS_IPM, OM_S_OBJECT, this_ipm );
     ipm_content->put_desc( IM_THIS_IPM, this_ipm->pub_object() );

#ifdef	DEBUG
	cout << "status = " << status << endl;
#endif
     
     return status;  
}


STATUS X400Message::build_ipm_recipient(APIObject	*ipm_content,
					APIObject	*rcpt_spec,
				        APIObject	*recipient,
					APIObject	*rcpt_desc ) {

     STATUS	status = SUCCESS;
       
#ifdef	DEBUG
	cout << "In build_ipm_recipient()" << endl;
#endif
    
//     status |= rcpt_spec->api_create( OMP_O_IM_C_RECIPIENT_SPECIFIER );
 
     rcpt_spec->make_class( OMP_O_IM_C_RECIPIENT_SPECIFIER );
     rcpt_spec->put_desc( IM_IPM_RETURN_REQUESTED, OM_S_BOOLEAN, OM_FALSE );
     rcpt_spec->put_desc( IM_NOTIFICATION_REQUEST, OM_S_ENUMERATION, IM_NEVER );
     rcpt_spec->put_desc( IM_REPLY_REQUESTED, OM_S_BOOLEAN, OM_FALSE );
     or_descriptor( rcpt_desc, recipient );
//     rcpt_spec->put_desc( IM_RECIPIENT, OM_S_OBJECT, rcpt_desc );
     rcpt_spec->put_desc( IM_RECIPIENT, rcpt_desc->pub_object() );
     rcpt_spec->end_object();

//     status |= rcpt_spec->api_put();
//     ipm_content->put_desc( IM_PRIMARY_RECIPIENTS, OM_S_OBJECT, rcpt_spec );
     ipm_content->put_desc( IM_PRIMARY_RECIPIENTS, rcpt_spec->pub_object() );

#ifdef	DEBUG
	cout << "status = " << status << endl;
#endif
     
     return status;
}

STATUS X400Message::build_ia5_bodypart(APIObject	*ipm_content,
				       APIObject	*bodypart)  {

     STATUS	status = SUCCESS;
       
#ifdef	DEBUG
	cout << "In build_ia5_bodypart()" << endl;
#endif
    
//     status |= bodypart->api_create( OMP_O_IM_C_IA5_TEXT_BD_PRT );
 
     bodypart->make_class( OMP_O_IM_C_IA5_TEXT_BD_PRT );
     bodypart->put_desc( IM_REPERTOIRE, OM_S_ENUMERATION, IM_IA5 );
     bodypart->put_desc( IM_TEXT, OM_S_IA5_STRING, interchange->content() );
     bodypart->end_object();

//     status |= bodypart->api_put();
//     ipm_content ->put_desc( IM_BODY, OM_S_OBJECT, bodypart );
     ipm_content ->put_desc( IM_BODY, bodypart->pub_object() );

#ifdef	DEBUG
	cout << "status = " << status << endl;
#endif
     
     return status;
}

STATUS X400Message::build_ipm_content(APIObject  *content,
				      APIObject	 *originator,
				      APIObject  *recipient, 
   				      APIObject  *this_ipm,
   				      APIObject  *bodypart,
   				      APIObject  *ipm_originator,
   				      APIObject  *ipm_recipient,
   				      APIObject  *rcpt_desc ) {
   STATUS	     status = SUCCESS;

#ifdef	DEBUG
	cout << "In build_ipm_content()" << endl;
#endif

//     status |= content->api_create( OMP_O_IM_C_INTERPERSONAL_MSG );

     content->make_class( OMP_O_IM_C_INTERPERSONAL_MSG );

     content->put_desc( IM_AUTO_FORWARDED, OM_S_BOOLEAN, OM_FALSE );
     content->put_desc( IM_IMPORTANCE, OM_S_ENUMERATION, IM_ROUTINE );
     content->put_desc( IM_INCOMPLETE_COPY, OM_S_BOOLEAN, OM_FALSE );
     content->put_desc( IM_SENSITIVITY, OM_S_ENUMERATION, IM_NOT_SENSITIVE );
     
     status |= build_this_ipm( content, originator, this_ipm );
     status |= build_ia5_bodypart( content, bodypart );
     
     or_descriptor( ipm_originator, originator );
//     content->put_desc( IM_ORIGINATOR, OM_S_OBJECT, &ipm_originator );
     content->put_desc( IM_ORIGINATOR, ipm_originator->pub_object() );
     
     status |= build_ipm_recipient( content, ipm_recipient, 
				    recipient, rcpt_desc );
     content->put_desc( IM_SUBJECT, OM_S_TELETEX_STRING, " " );
     
     content->end_object();
//     status |= content->api_put(); 

     return status;
}


X400Message::parse_ipm_bodypart( OM_public_object	body,
	                         EDIUser   		*edi_user ) {

	STATUS		status = SUCCESS;
        ofstream        *inbound_interchange_file;
        char		*inbound_file;
	char		filename[ MAX_TIME_BUF ]; // temp file to put the 
						  // interchange in.
#ifdef	DEBUG
	cout << "In parse_ipm_bodypart()" << endl;
#endif

        while ( body->type != OM_NO_MORE_TYPES ) {
		if ( body->type == IM_TEXT )
			break;
		body++;
	}
	
	// Write the interchange to either a file directory   
        // or the TSDS.
        
	if ( edi_user->tsds_queue() )
        	;  // Write the interchange to TSDS input queue.
        else { 
	
	  // Write interchange to a file in local input-directory.
	  inbound_file = edi_user->input_directory( );
          strcat( inbound_file, "/" );
	 
	  // Create a file (using a system call which returns the time of
	  // day and append it onto the full path name.  TIMESTAMP error??
          timestamp( filename );
	  strcat( inbound_file, filename );

          // Open the file to contain the incoming interchange.
	  inbound_interchange_file = new ofstream( inbound_file, ios::out );
          
	  // Make sure the file was properly opened.
	  if ( !inbound_interchange_file ) {
	     log->log_event( "parse_ipm_bodypart", FILE_NOT_CREATED, EXITING );
             return( status |= ERROR );
	  }

#ifdef DEBUG
	  cout << "Inbound interchange file: " << inbound_file << endl;
#endif
         
	 // Write the value to the interchange file and close it.
	 *inbound_interchange_file << ( char * ) body->value.string.elements;
         inbound_interchange_file->close();
      }

      return ( status );
}


STATUS X400Message::parse_ipm_content(APIObject  *ipm_message,
				      EDIUser    *edi_user ) {
        OM_value    value;
	APIObject   ipm_originator( ipm_message );
        STATUS      status = SUCCESS;
	
	OM_exclusions	exclusions = OM_EXCLUDE_ALL_BUT_CERTAIN_TYPES;
        static OM_type   types[ 6 ] = 
	{ IM_THIS_IPM, IM_RECIPIENT, IM_BODY, IM_ORIGINATOR, IM_SUBJECT,  
	  OM_NO_MORE_TYPES };

#ifdef	DEBUG
	cout << "In parse_ipm_content()" << endl;
#endif
        
	// Copy private-object to public-object.
        // exlude all but certain types.
        
//	status |= ipm_message->api_get( exclusions, types );
//	if ( ! OK( status ) )
//		return status;

        while ( ipm_message->more_types() ) {

	   value = ipm_message->value();

#ifdef	DEBUG
	   cout << "type = " << ipm_message->type() << endl;
#endif

           switch( ipm_message->type() ) {

              case IM_BODY:	
		   // Parse the (IA5 text body part) body (interchange).
		   status |= parse_ipm_bodypart( value.object.object,edi_user );
		   return status;
	  }
         
	 // Increment to next type
	 ipm_message->get_next_type();
     }
  
     return status;
}	
