// FILE:  x500.C

#include	<fstream.h>
#include	<assert.h>
#include	<xom.h>
#include	<xedip.h>
extern "C" {
#include	"/usr/lib/x400/gtwapi/include/nist_xmh.h"
}
#include	"/usr/lib/x400/gtwapi/include/xmhp.h"
#include	"../../../include/platform.h"
#include	"../../../include/log.h"
#include	"../../../include/subject.h"
#include	"../../../include/interchange.h"
#include	"../../../include/linklist.h"
#include	"../../../include/or_name.h"
#include	"../../../include/edi_user.h"
#include	"../../../include/config.h"
#include	"../../../include/x500.h"
#include	"../../../include/api_obj.h"
#include	"../../../include/x400api.h"


STATUS X500Entry::read_communication_attributes( char *scode, char *squal,
						 char *rcode, char *rqual ) {

	char	*buf;

	send_id_code = scode;
	send_id_code_qualifier = squal;
	rcpt_id_code = rcode;
	rcpt_id_code_qualifier = rqual;

	if ( ! strcmp( rcode, "USER-MHS-EDI" ) ) 
		protocol_id = MHS_EDI;
	else if ( ! strcmp( rcode, "USER-MHS-IPM" ) ) 
		protocol_id = MHS_IPM;
	else if ( ! strcmp( rcode, "USER-FTAM" ) ) 
		protocol_id = FTAM;
	else if ( ! strcmp( rcode, "USER-VAN" ) ) 
		protocol_id = DIAL_UP;
	else if ( ! strcmp( rcode, "KEN1" ) ) 
		protocol_id = DIAL_UP;
	else if ( ! strcmp( rcode, "KEN2" ) ) 
		protocol_id = DIAL_UP;
	
	//
	// X.400 Attributes
	//
	
	orig_security = NO_SECURITY;
	positive_notif = TRUE;
	negative_notif = TRUE;
	forwarded_notif = TRUE;
	resp_passing = TRUE;
	prior = MH_PTY_NORMAL;

	this_recip = new ORName;
	assert( this_recip != 0 );

	buf = new char[ ADMD_NAME_LEN ];
	assert( buf != 0 );
	strcpy( buf, "ATTMAIL" );
	this_recip->set_admd_name( buf );
	
	buf = new char[ COUNTRY_NAME_LEN ];
	strcpy( buf, "US" );
	this_recip->set_country_name( buf );
	
	if ( ! strcmp( rcode, "USER-MHS-EDI" ) ) {
		buf = new char[ PRMD_NAME_LEN ];
		strcpy( buf, "GOV+NIST-EC" );
		this_recip->set_prmd_name( buf );
	
		buf = new char[ SURNAME_LEN ];
		strcpy( buf, "USER-MHS-EDI" );
		this_recip->set_surname( buf );
	}
	else if ( ! strcmp( rcode, "USER-MHS-IPM" ) ) {
		buf = new char[ PRMD_NAME_LEN ];
		strcpy( buf, "GOV+NIST-EC" );
//		strcpy( buf, "GOV+NIST" );
		this_recip->set_prmd_name( buf );
	
		buf = new char[ ORG_NAME_LEN ];
		strcpy( buf, "sendmail" );
//		strcpy( buf, "csl" );
		this_recip->set_org_name( buf );
	
		buf = new char[ SURNAME_LEN ];
		strcpy( buf, "markovit" );
//		strcpy( buf, "markovitz" );
		this_recip->set_surname( buf );
	}
	
	//
	// FTAM Attributes
	//
	
	strcpy( name, "markovit" );
	strcpy( password, "opuscroakus" );
	strcpy( x500_name,"/O=org_name/OU=org_unit/OU=OSI/AP=ftam/AE=resp" );
	strcpy( dir_name, "/home/osi/nag/markovit/ftam" );

	//
	// VAN Attributes
	//
	
	strcpy( vanname, "called_trans" );
	return SUCCESS;
}


BOOL X500Entry::validate_partner( ORName *or_name ) {
	return TRUE;
}

BOOL X500Entry::validate_partner( char *, char * ) {
	return TRUE;
}
