/*				FILE = ft_copy.c			*/

#include	<osi/map.h>
#include	<osi/mapftam.h>
/* debug: tracing	*/
#include	<stdio.h>
#include	<api_trace.h>
#include	"xmit_file.h"

extern	int	ft_trace;
extern	int	ft_trace_max_udata;
extern	FILE	*ft_trace_fp;

void	delete_ddn(), print_ddn();

void	clean_up_files();
extern	char	*pfile,*pdir,*gfile,*gdir,*error_dir,*ctrl_file,*lock_file;
extern	int	mode,delete_files,result,keep_log;

main(argc,argv)
int	argc;
char	*argv[];
{
	Ae_dir_name		source_dirname;
	Ft_filename		source_filename;
	Ae_dir_name		destination_dirname;
	Ft_filename		destination_filename;
	Ae_label		ae_label;
	Local_event_name	return_event_name;
	struct Ft_fcopy_in_dcb	*input_dcb;
	struct Ft_fcopy_out_dcb	*inout_dcb;

	Return_code		res;
	Api_rc			outcome;
	struct	Ft_diagnostic	*diag = NULL;

	if (argc < 3)	{
		logit("uasage: ft_copy pfile=transaction_file ctrl=control_file [lock_file]\n");
		exit(0);
	}

	get_log(argv[0]);
	result = FALSE;
	mode = XMIT_PUT;
/* debug: tracing	*/
/*	ft_trace_fp=fopen("/mnt2/users/wallace/osi/edi/ftam/ft_trace","a");
	if (ft_trace_fp <= 0)	{
		logit("Unable to open trace log file\n");
		ft_trace = API_TR_INPUT;
		ft_trace_max_udata = 256;
	}	else	*END-COMMENT-OUT* */
		ft_trace = 0;

	if (ft_copy_parms(argc, argv, &source_dirname, &source_filename,
			&destination_dirname, &destination_filename,
			&ae_label, &return_event_name, &input_dcb,
			&inout_dcb) != TRUE)	{
		logit("Unable to set parameters for ft_fcopy - abort\n");
		clean_up_files();
		exit(1);
	}

	res = ft_fcopy(source_dirname, source_filename,
		destination_dirname, destination_filename, &ae_label,
		return_event_name,input_dcb, &inout_dcb);

	if (res != SUCCESS)
		error_handler(inout_dcb->result, inout_dcb->diagnostic);

	if (ft_dfdcb((Octet *)input_dcb, &outcome) != SUCCESS)
		error_handler(outcome,diag);

	if (ft_dfdcb((Octet *)inout_dcb, &outcome) != SUCCESS)
		error_handler(outcome,diag);

	result = TRUE;
	logit("Ft_copy finished successfully\n");
	clean_up_files();
}
