
#ifndef lint
static char ModuleId[] = "@(#)FTAM: ftm_util.c $Revision: 8.3 $ $Date: 90/06/15 09:49:50 $";
#endif

#include	<osi/map.h>
#include	<osi/mapftam.h>
#include	"xmit_file.h"

void exit(), clean_up_files();
/*
**			error_handler
**
** DESCRIPTION:
**     This routine is an example of handling failures experienced
**     during the FTAM functions. This routine will display the
**     error messages. 
**
**  PARAMETERS:
**    INPUT:
**	result :	the MAP and HP error information
**	diag :		the ISO error information
**    
*/
void
error_handler(result, diag)

Api_rc				result;
struct	Ft_diagnostic		*diag;

{

Return_code			res;
Api_rc				outcome;
Octet				*return_string;
Octet				*vendor_string;
struct	Ft_diagnostic		*ft_diag = NULL;

	/*
	**	Initialize variables.
	*/
	return_string = NULL;
	vendor_string = NULL;

	/*
	**	Call ft_gperror to get the printable strings for
	**	the return_code and vendor_code.  Print the
	**	strings returned from ft_gperror.
	*/
	res = ft_gperror(&result, &return_string, &vendor_string, &outcome);
	if (res == SUCCESS)	{
		if (return_string != NULL)	{
			sprintf(log_str," FTAM failure: return_code = %s\n",
				return_string);
			logit(log_str);
			res = ft_fdmemory(return_string, &outcome);
			if (res != SUCCESS)
				error_handler(outcome, ft_diag);
		}
		/*
		**	Print the vendor_code if it exists.
		*/
		if (vendor_string != NULL)	{
			sprintf(log_str," FTAM failure: vendor_code = %s\n",
				vendor_string);
			logit(log_str);
			res = ft_fdmemory(vendor_string, &outcome);
			if (res != SUCCESS)
				error_handler(outcome, ft_diag);
		}
	}
	/*
	**	Traverse the diagnostic list and print the further_details
	**	strings.
	*/
	while (diag != NULL)	{
		sprintf(log_str," FTAM failure: diagnostic number = %d\n", 
			diag->error_id);
		logit(log_str);
		if (diag->further_details != NULL)
		sprintf(log_str," FTAM failure: diagnostic = %s\n", 
			diag->further_details);
		logit(log_str);
		diag = diag->next;
	}

	clean_up_files();
	exit(-1);
}
