/*				FILE = bld_tt.c				*/

/*	This function will read commands from a file, from 'start' to	*/
/*	to 'end', and build the 'tt_struct' structures.			*/

#include	"xmit_file.h"
#include	"dial.h"
#include	"edi_control_defs.h"
#include	"van_control_defs.h"

struct	tt_struct	*tt_merge();

	FUNCTION bld_tt(fd,start,end,buf,strings,number)
int	fd,number;
long	start,end;
char	*buf,**strings;
{
	char	*p, *host_id, *ttname;
	struct	tt_struct *tt, *tt_ptr;
	int	skip, mdm_index, index, len, num, i, j, k;
	int	host_index, in_use, default_speed, modem_type;
	short	oflags;

	if ((start <= 0) || (end <= 0) || ((end - start ) <= 0))
		return(0);
	lseek(fd,start,0);
	if ((len = read(fd,buf,(int)(end - start))) < 0)	{
		logit("bld_tt: Unable to read tt_construct file\n");
		return(0);
	}
/* sprintf(log_str,"bld_tt: start = %d. end = %d. len = %d.\n",start,end,len); */
/* logit(log_str); */
	if ((num = lines_to_strings(buf,len,strings,number)) == 0)	{
		logit("bld_tt: No tt_structs definitions\n");
		return(0);
	}
	if ((i = count_target(strings,TT_BEGIN_DEFINITION)) < 1)	{
		logit("bld_tt: No tt_structs defined\n");
		return(0);
	}
/*sprintf(log_str,"%d. begins found in %d. strings\n",i,num);*/
/*logit(log_str);*/
	tt_ptr=(struct tt_struct *)calloc((i+1),sizeof(struct tt_struct));
	for (k = 0, j = 0, index = 0; j < i; j++)	{
		if (strncmp(TT_BEGIN_DEFINITION,strings[index], sizeof(TT_BEGIN_DEFINITION) -1) != 0)	{
			logit("bld_tt: TT_BEGIN_DEFINITION not first entry\n");
			return(0);
		}
		skip = FALSE;
		/* set defaults for a tt_struct, the rest are zero	*/
		ttname = strings[index] + sizeof(TT_BEGIN_DEFINITION) -1;
		if (*ttname == '\0')	{
			logit("bld_tt: ttname not specified, definition skipped\n");
			skip = TRUE;
		}
		host_id = 0;
		in_use = FALSE;
		default_speed = DEFAULT_TT_DEFAULT_SPEED;
		modem_type = DEFAULT_TT_MDM_INDEX;
		oflags = DEFAULT_TT_OFLAGS;
		while (1)	{
			if ( ++index >= num)	{
				logit("bld_tt: warning: command ended without  TT_END_DEFINITION\n");
				break;
			}
			if (strncmp(strings[index],TT_HOST,sizeof(TT_HOST) - 1) == 0)	{
				host_id=strings[index]+sizeof(TT_HOST)-1;
				continue;
			}
			if (strncmp(strings[index],TT_IN_USE, sizeof(TT_IN_USE)-1) == 0)	{
				p = strings[index]+sizeof(TT_IN_USE)-1;
				if (strcmp(p,"TRUE") == 0)
					in_use = TRUE;
				else	if (strcmp(p,"FALSE") == 0)
					in_use = FALSE;
				else	logit("bld_tt: warning invalid value, TT:IN_USE skipped\n");
				continue;
			}
			if (strncmp(strings[index],TT_DEFAULT_SPEED, sizeof(TT_DEFAULT_SPEED) - 1) == 0)	{
				p = strings[index] + sizeof(TT_DEFAULT_SPEED) - 1;
				if (strcmp(p,"B9600") == 0)
					default_speed = B9600;
				else	if (strcmp(p,"B4800") == 0)
					default_speed = B4800;
				else	if (strcmp(p,"B2400") == 0)
					default_speed = B2400;
				else	if (strcmp(p,"B1200") == 0)
					default_speed = B1200;
				else	if (strcmp(p,"B300") == 0)
					default_speed = B300;
				else	if (strcmp(p,"-1") == 0)
					default_speed = -1;
				else	{
					sprintf(log_str,"bld_tt: warning: unknown default speed '%s'- ignored\n",p);
					logit(log_str);
				}
				continue;
			}
			if (strncmp(strings[index],TT_MDM_INDEX, sizeof(TT_MDM_INDEX) - 1) == 0)	{
				p = strings[index]+sizeof(TT_MDM_INDEX)-1;
				/* not all supported modem types	*/
				/* checked here, add types as needed.	*/
				if (strcmp(p,"HAYES") == 0)
					mdm_index = n_HAYES;
				else	if (strcmp(p,"RACAL") == 0)
					mdm_index = n_RACAL;
				else	if (strcmp(p,"UNKNOWN") == 0)
					mdm_index = n_UNKNOWN;
				else	{
					sprintf(log_str,"bld_tt: warning: modem not supported  '%s'- unknown used\n",p);
					logit(log_str);
					mdm_index = n_UNKNOWN;
				}
				continue;
			}
			if (strncmp(strings[index],TT_OFLAGS, sizeof(TT_OFLAGS) - 1) == 0)	{
				/* not needed at this time	*/
				continue;
			}
			if (strncmp(strings[index],TT_END_DEFINITION, sizeof(TT_END_DEFINITION) - 1) == 0)	{
				index++;
				break;
			}
			if (strncmp(strings[index],END_TT_DEFINITION, sizeof(END_TT_DEFINITION) - 1) == 0)	{
				/* this ends all TT definitions	*/
				index++;
				break;
			}
			if (strncmp(TT_BEGIN_DEFINITION,strings[index], sizeof(TT_BEGIN_DEFINITION) - 1) == 0)	{
				logit("bld_tt: warning: no TT_END_DEFINITION, TT_BEGIN_DEFINITION encountered\n");
				break;
			}
			sprintf(log_str,"bld_tt: Unknown string '%s'\n", strings[index]);
			logit(log_str);
		}
/*logit("Start building a structure\n");*/
		if (skip == TRUE)	continue;
		/* fill tt_struct with default and supplied values	*/
/*sprintf(log_str,"j = %d. ttname = '%s' ttp = %o\n",j,ttname,ttp);*/
/*logit(log_str);*/
		tt = tt_ptr + k++;
		tt->tty_fd = -1;
/*sprintf(log_str,"j = %d. tt = %o ttname = '%s'\n",j,tt,ttname);*/
/*logit(log_str);*/
		tt->ttname = (char *)malloc(strlen(ttname)+1);
		atos(tt->ttname,ttname);
		tt->in_use = in_use;
		tt->default_speed = default_speed;
		tt->real_speed = -1;
		tt->oflags = oflags;
		tt->mdm_index = mdm_index;
		if (host_id != 0)	{
			tt->host_id = (char *)malloc(strlen (host_id)+1);
			atos(tt->host_id,host_id);
		}
/* debug 	prt_tt(tt); */
	}
/*	for (tt = tt_ptr; tt->tty_fd != 0; tt++)	prt_tt(tt);*/
	if ((ttp = tt_merge(ttp,tt_ptr)) == 0)	return(-1);
/*	for (tt = ttp; tt->tty_fd != 0; tt++)		prt_tt(tt);*/
	return(1);
}
