/*				FILE = lines_to_strings.c		*/

#include	"com_defs.h"
#include	"edi_control_defs.h"

void	print_strings();
extern	char	log_str[];

/*	Take the string of newline terminted lines and make null	*/
/*	terminated strings.  Each string will have a pointer to it in	*/
/*	'strings'.  Lines starting with the '#' character and lines	*/
/*	between BEGIN_COMMENT_SECTION and END_COMMENT_SECTION lines are	*/
/*	ignored.							*/
	FUNCTION lines_to_strings(buf, len, strings, number)
char	*buf, *strings[];
int	len, number;
{
	char	*p1, *p2;
	int	num_lines = 0, comment = FALSE;
	int	comment_section = FALSE, num = 0;
	for (p1 = p2 = buf; p1 < buf+len; p1++)	{
		if (num == 0)
			if (*p1 == '#')	comment = TRUE;
			else		comment = FALSE;
		if (*p1 == '\n')	{
			num = 0;
			if (comment == FALSE)	{
				*p1 = '\0';
				if (comment_section == TRUE)	{
					if (strcmp(p2,END_COMMENT_SECTION) == 0)
						comment_section = FALSE;
				}	else	if (strcmp(p2, BEGIN_COMMENT_SECTION) == 0)
						comment_section = TRUE;
					else	{
						if (num_lines > number)	{
							logit( "lines_to_strings: overflow, too many strings\n");
							return(0);
						}
						strings[num_lines++] = p2;
					}
			}
			p2 = p1 + 1;	/* set start of next line	*/
		}	else	num++;
	}
	strings[num_lines] = 0;
/* sprintf(log_str,"num_lines = %d. \n",num_lines); */
/* logit(log_str); */
/* debug print_strings(strings);*/
	return(num_lines);
}

	FUNCTION count_target(strings,target)
char	*strings[], *target;
{
	int	j, i = 0;
	char	**p;
	j = strlen(target);
	for (p = strings; *p != 0; p++)
		if (strncmp(*p,target,j) == 0)	i++;
	return(i);
}

char	FUNCTION *find_target(strings,target)
char	*strings[], *target;
{
	int	j;
	char	**p;
	j = strlen(target);
	for (p = strings; *p != 0; p++)
		if (strncmp(*p,target,j) == 0)	return(*p);
	return(0);
}

	FUNCTION index_target(strings,target)
char	*strings[], *target;
{
	int j, i = 0;
	char **p;
	j = strlen(target);
	for (p = strings; *p != 0; p++, i++)
		if (strncmp(*p,target,j) == 0)	return(i);
	return(-1);
}

void	FUNCTION print_strings(strings)
char	*strings[];
{
	char	**p;
	logit("Print_strings: Dump of control file strings\n");
	for (p = strings; *p; p++)	{
		sprintf(log_str,"	string = '%s'\n",*p);
		logit(log_str);
	}
}
