/*				FILE = log_ops.c			*/

#include	<sys/time.h>
#include	"xmit_file.h"
#include	"xmodem.h"

int	log_fd = 1;
char	log_str[MAX_LOG_MSG +1];
char	log_name[MAX_FILENAME +1];
char	*stamptime();

	FUNCTION get_log(prog)
char	*prog;
{
	if (log_fd > 1)	return(TRUE);
	strcpy(log_name,PROTO_LOG_NAME);
	if ((log_fd = mkstemp(log_name)) < 0)	{
		log_name[0] = '\0';
		return(ERROR);
	}	else	{
		chmod(log_name,0666);
		if (prog && *prog)
			sprintf(log_str,"log: program = '%s' filename = '%s' created at %s\n",
			prog,log_name,stamptime());
		else	sprintf(log_str,"log: filename = '%s' created at %s\n",
			log_name,stamptime());
		logit(log_str);
		return(TRUE);
	}
	return(TRUE);
}

	FUNCTION release_log(purge)
int	purge;
{
	if (DEBUGGING)	logit("release_log called\n");
	if (log_fd > 1)	{
		if (close(log_fd) < 0)	return(ERROR);
		log_fd = 1;
		if ((purge == TRUE) && (log_name[0] != '\0'))
			if (unlink(log_name) < 0)	return(ERROR);
		log_name[0] = '\0';
	}
	return(TRUE);
}

	FUNCTION logit(str)
char	*str;
{
	if (str && *str && (log_fd != -1))
		if (write(log_fd,str,strlen(str)) != strlen(str))
			return(ERROR);
	return(TRUE);
}

/* create string with a timestamp for log file */
char	*stamptime()
{
	char	*asctime();		/* stuff to get timestamp */
	struct	tm *localtime(), *tp;
	struct	timeval tv;
	struct	timezone tz;

	gettimeofday(&tv, &tz);		/* fill in timestamp */
	tp = localtime((time_t *)&tv.tv_sec);
	return(asctime(tp));
}
