/*				FILE = modem_ops.c			*/

#include	"xmit_file.h"
#include	"dial.h"
#include	"xmodem.h"

	FUNCTION hangup(host)
struct	host	*host;
{
	struct	tt_struct	*tt;
	unsigned long mflag;
	if (DEBUGGING)	{
		sprintf(log_str,"hangup called: host = %s tt_index = %d.\n",host->host_id,host->tt_index);
		logit(log_str);
	}
	if (!host->tt_index)	return(0);
	tt = ttp + (host->tt_index -1);
	if ((tt->tty_fd < 0) || (tt->mdm_index == 0))	return(0);
#ifdef	SUNOS
	/* clear DTR	*/
	if (ioctl(tt->tty_fd,TIOCCDTR,0) < 0)	{
		sprintf(log_str,"hangup: TIOCCDTR  errno = %d. '%s'\n", errno,sys_errlist[errno]);
		logit(log_str);
	}
	napms(500);
	/* restore DTR	*/
	if (ioctl(tt->tty_fd,TIOCSDTR,0) < 0)	{
		sprintf(log_str,"hangup: TIOCSDTR  errno = %d. '%s'\n", errno,sys_errlist[errno]);
		logit(log_str);
	}
#endif	SUNOS
#ifdef	HPUX
	/* This line must be defined as an HP 'simple' modem and not a	*/
	/* CCITT modem.  CCITT modems do not allow the user to change	*/
	/* the CONTROL or STATUS lines.					*/
	/* get modem control and status lines	*/
	if (ioctl(tt->tty_fd,MCGETA,&mflag) < 0)	{
		sprintf(log_str,"hangup: MSGETA  errno = %d. '%s'\n", errno,sys_errlist[errno]);
		logit(log_str);
	}
	if (mflag & MDTR)	{
		/* clear DTR	*/
		mflag &= ~MDTR;
		if (ioctl(tt->tty_fd,MCSETAW,&mflag) < 0)	{
			sprintf(log_str,"hangup: MSSETAW  errno = %d. '%s'\n", errno,sys_errlist[errno]);
			logit(log_str);
		}
		napms(500);
	}
	/* restore DTR	*/
	mflag |= MDTR;
	if (ioctl(tt->tty_fd,MCSETAW,&mflag) < 0)	{
		sprintf(log_str,"hangup: MCSETA  errno = %d. '%s'\n", errno,sys_errlist[errno]);
		logit(log_str);
	}
	if (DEBUGGING)	logit("hangup: (hp) DTR restored\n");
#endif	HPUX
	sleep(10);		/* wait for DTR to come back up	*/
	return(0);
}

	FUNCTION flush(tt)
struct	tt_struct	*tt;
{
#ifdef	SUNOS
	int	 n = FREAD;	/* specify read queue	*/
	ioctl(tt->tty_fd,TIOCFLUSH,&n);
#endif	SUNOS
#ifdef	HPUX
	ioctl(tt->tty_fd,TCFLSH,0);	/* specify read queue	*/
#endif	HPUX
	return(0);
}


	FUNCTION reset_modem(host)
struct	host	*host;
{
	struct	tt_struct	*tt;
	if (DEBUGGING)	{
		sprintf(log_str,"reset_modem called: host = '%s'\n", host->host_id);
		logit(log_str);
	}
	if (host->connected & CONNECTED_MODEM)	{
		host->connected &= ~CONNECTED_MODEM;
		if (!host->tt_index)	return;
		tt = ttp + (host->tt_index - 1);
		if (tt->mdm_index == n_HAYES)
			if (write(tt->tty_fd,hayes_reset,
					strlen(hayes_reset)) <= 0)
				logit("reset_modem: error writing hayes_reset\n");
		hangup(host);
	}
	return;
}
