/*				FILE = prt_ops.c			*/

#include	"xmit_file.h"
#include	"dial.h"

	FUNCTION prt_hosts(ptt)
int	ptt;			/* print associated tt_struct - T/F	*/
{
	struct	host	*p;
	if (hostp)
		for (p = hostp; p->host_id; p++)
			prt_host(p,ptt);
}

	FUNCTION prt_tts()
{
	struct	tt_struct	*p;
	if (ttp)
		for (p = ttp; p->ttname; p++)
			prt_tt(p);
}

	FUNCTION prt_host(host,ptt)
struct	host	*host;
int	ptt;			/* print associated tt_struct - T/F	*/
{
	if (!host)	return(FALSE);
	sprintf(log_str,"prt_host: called for host = %o\n",host);
	logit(log_str);
	sprintf(log_str,"	host_id = '%s' def_flags = '%s'\n", host->host_id,host->def_flags);
	logit(log_str);
	sprintf(log_str,"	pdir = '%s' gdir = '%s'\n",
		host->pdir,host->gdir);
	logit(log_str);
	sprintf(log_str,"	null_file = '%s' rec_len = %d.\n",
		host->null_file,host->rec_len);
	logit(log_str);
	sprintf(log_str,"	connected = %o calling = %d defaults = %o\n",
		host->connected,host->calling,host->defaults);
	logit(log_str);
	prt_respond(host->login,"LOGIN");
	prt_respond(host->start,"START");
	prt_respond(host->p_st,"PUT_START");
	prt_respond(host->p_btwn,"PUT_BETWEEN");
	prt_respond(host->p_end,"PUT_END");
	prt_respond(host->g_st,"GET_START");
	prt_respond(host->g_btwn,"GET_BETWEEN");
	prt_respond(host->g_end,"GET_END");
	prt_respond(host->end,"END");
	prt_respond(host->exit,"EXIT");
	sprintf(log_str,"	telnbr = '%s' tt_index = %d.\n", host->telnbr?host->telnbr:" ",host->tt_index);
	logit(log_str);
	if (ptt && (host->tt_index > 0))
		prt_tt(ttp + (host->tt_index - 1));
	logit("prt_host: end\n");
	return(TRUE);
}

	FUNCTION prt_tt(tt)
struct	tt_struct	*tt;
{
	if (!tt || !tt->ttname)	return(FALSE);
	sprintf(log_str,"prt_tt: called for tt = %o\n",tt);
	logit(log_str);
	sprintf(log_str,"	tty_fd = %d.	ttname = '%s'\n", tt->tty_fd,tt->ttname);
	logit(log_str);
	sprintf(log_str,"	in_use = %d. tty_modes = %d.\n", tt->in_use,tt->tty_modes);
	logit(log_str);
	prt_termio(&tt->tty_old,"old");
	prt_termio(&tt->tty_new,"new");
	prt_stat(&tt->statbuf);
	sprintf(log_str,"	wason = %d. host_index = %d.\n", tt->wason,tt->host_index);
	logit(log_str);
	sprintf(log_str,"	default_speed = %o real_speed = %o\n", tt->default_speed,tt->real_speed);
	logit(log_str);
	sprintf(log_str,"	oflags = %o mdm_index = %d.\n", tt->oflags,tt->mdm_index);
	logit(log_str);
	sprintf(log_str,"	host_id = '%s'\n",tt->host_id);
	logit(log_str);
	logit("prt_tt: end\n");
	return(TRUE);
}

	FUNCTION prt_termio(tty,type)
struct	termio	*tty;
char	*type;			/* "old" or "new" termio	*/
{
	if (!tty)	return(FALSE);
	sprintf(log_str,"prt_termio: called for %s termio = %o\n",type,tty);
	logit(log_str);
	sprintf(log_str,"	c_iflag = %o c_oflag = %o\n", tty->c_iflag,tty->c_oflag);
	logit(log_str);
	sprintf(log_str,"	c_cflag = %o c_lflag = %o c_line = %o\n", (int)tty->c_cflag,(int)tty->c_lflag,tty->c_line);
	logit(log_str);
	logit("prt_termio: end\n");
	return(TRUE);
}

	FUNCTION prt_stat(stat)
struct	stat	*stat;
{
	sprintf(log_str,"prt_stat: st_mode = %o st_size = %d. st_ino = %lo\n", stat->st_mode,stat->st_size,stat->st_ino);
	logit(log_str);
	return(TRUE);
}

	FUNCTION prt_respond(ptr,type)
struct	respond	*ptr;
char	*type;	/* which struct ptr points to (e.g. "LOGIN" or "EXIT")	*/
{
	if (!ptr || !ptr->attempts)	return(FALSE);
	sprintf(log_str,"prt_respond: called for %s response\n",type);
	logit(log_str);
	while (ptr->attempts)	{
		sprintf(log_str,
			"	respond_time = %d.  cmd_str = '%s'\n",
 			ptr->respond_time,ptr->cmd_str);
		logit(log_str);
		sprintf(log_str,"	no_response = %d. response = '%s'\n",ptr->no_response,ptr->response);
		logit(log_str);
		sprintf(log_str,"	alt1_action = %d. alternate1 = '%s'\n",ptr->alt1_action,ptr->alternate1);
		logit(log_str);
		sprintf(log_str,"	alt2_action = %d. alternate2 = '%s'\n",ptr->alt2_action,ptr->alternate2);
		logit(log_str);
		sprintf(log_str,"	attempts = %d. lower = %d.\n", ptr->attempts,ptr->lower);
		logit(log_str);
		ptr++;
	}
	logit("prt_respond: end\n");
	return(TRUE);
}


	FUNCTION prt_mdminf(pmdminf)
struct	mdminf	*pmdminf;
{
	sprintf(log_str,"prt_mdminf: called with pmdminf = %o\n",pmdminf);
	logit(log_str);
	sprintf(log_str,"	dial_time = %d. pause_chars = '%s'\n", pmdminf->dial_time,pmdminf->pause_chars);
	logit(log_str);
	sprintf(log_str,"	pause_time = %d. wake_str = '%s'\n", pmdminf->pause_time,pmdminf->wake_str);
	logit(log_str);
	sprintf(log_str,"	wake_rate = %d. wake_prompt = '%s'\n", pmdminf->wake_rate,pmdminf->wake_prompt);
	logit(log_str);
	sprintf(log_str,"	dmode_str = '%s' dmode_prompt = '%s'\n", pmdminf->dmode_str,pmdminf->dmode_prompt);
	logit(log_str);
	sprintf(log_str,"	dial_str = '%s' dial_rate = %d.\n", pmdminf->dial_str,pmdminf->dial_rate);
	logit(log_str);
	logit("prt_mdminf: end\n");
	return(TRUE);
}

	FUNCTION prt_keytab(pkeytab)
struct	keytab	*pkeytab;
{
	sprintf(log_str,"prt_keytab: called with pkeytab = %o\n",pkeytab);
	logit(log_str);
	sprintf(log_str,"	kwd = '%s' val = %d. flgs = %d.\n", pkeytab->kwd,pkeytab->val,pkeytab->flgs);
	logit(log_str);
	logit("prt_keytab: end\n");
	return(TRUE);
}
