/*				FILE = struct_merge.c			*/

#include	"xmit_file.h"

extern	int	this_host_index;
extern	struct	host	*hostp;

struct tt_struct *tt_merge(tt1,tt2)
struct tt_struct *tt1,*tt2;
{
	struct	tt_struct	*ttp1,*ttp2,*ttp3,*tt_result;
	int	num = 0, skip;

/*sprintf(log_str,"tt_merge: tt1 = %o tt2 = %o\n",tt1,tt2);
logit(log_str); */
	if (tt1 == 0)	return(tt2);
	if (tt2 == 0)	return(tt1);
	/* get tt_struct array big enough for both	*/
	if ((tt_result=(struct tt_struct *)calloc((tt_count(tt1)+ tt_count(tt2)+1), sizeof(struct tt_struct)))==0)
		return(0);
	/* copy all tt_struct entries from tt1 that are not in tt2	*/
	for(ttp1=tt1,ttp2=tt2,ttp3=tt_result;ttp1->ttname;ttp1++,ttp2=tt2) {
		for(skip = 0; ttp2->ttname; ttp2++)
			if (strcmp(ttp1->ttname, ttp2->ttname) == 0)	{
				skip = 1;
				break;
			}
		if (skip == 0)	{
			*ttp3 = *ttp1;
			ttp3++;
			num++;
		}	else	if (static_tt)	delete_tt(ttp1);
	}
	/* copy all tt2 tt_struct entries		*/
	for (ttp2 = tt2; ttp2->ttname; ttp2++, ttp3++)	{
		num++;
		*ttp3 = *ttp2;
	}
	if (static_tt)	static_tt = FALSE;
	else		free(tt1);
	free(tt2);
/*sprintf(log_str,"tt_merge: num = %d. tt_result = %o\n",num,tt_result);
logit(log_str); */
	return(tt_result);
}

	tt_count(ptr)
struct	tt_struct	*ptr;
{
	int num = 0;
	for (; ptr->ttname; ptr++)	num++;
	return(num);
}

struct host *host_merge(h1,h2)
struct host *h1,*h2;
{
	struct	host	*hp1,*hp2,*hp3,*host_result;
	char	this_host[256];		/* host_id of this_host_index	*/
	int	num = 0, skip;

/*sprintf(log_str,"host_merge: h1 = %o h2 = %o\n",h1,h2);
logit(log_str); */
	if (h1 == 0)	return(h2);
	if (h2 == 0)	return(h1);
	/* get host array big enough for both	*/
	if ((host_result = (struct host *)calloc((host_count(h1) + host_count(h2) + 1), sizeof(struct host))) == 0)
		return(0);
	if (this_host_index > 0)
		strcpy(this_host,(hostp + this_host_index - 1)->host_id);
	/* copy all host entries from h1 that are not in h2	*/
	for (hp1=h1,hp2=h2,hp3=host_result;hp1->host_id;hp1++,hp2=h2)	{
		for(skip = 0; hp2->host_id; hp2++)
			if (strcmp(hp1->host_id, hp2->host_id) == 0)	{
				skip = 1;
				break;
			}
		if (skip == 0)	{
			num++;
			*hp3 = *hp1;
			hp3++;
		}	else	if (static_host)	delete_host(hp1);
	}
	/* copy all h2 host entries			*/
	for (hp2 = h2; hp2->host_id; hp2++, hp3++)	{
		num++;
		*hp3 = *hp2;
	}
	/* regenerate this_host_index			*/
	if (this_host_index > 0)	{
		this_host_index = 0;
		for (skip=0, hp1=host_result; hp1->host_id; hp1++, skip++)
			if (strcmp(hp1->host_id,this_host) == 0)	{
				this_host_index = skip + 1;
				break;
			}
		if (this_host_index == 0)
			logit("struct_merge: warning - unable to find new this_host_index\n");
	}
	if (static_host)	static_host = FALSE;
	else			free(h1);
	free(h2);
/*sprintf(log_str,"host_merge: num = %d. host_result = %o\n",num, host_result);
logit(log_str); */
	return(host_result);
}


	host_count(ptr)
struct	host	*ptr;
{
	int num = 0;
	for (; ptr->host_id; ptr++)	num++;
	return(num);
}

	delete_host(hp)
struct host *hp;
{
	if (hp)	{
		if (hp->host_id)	free(hp->host_id);
		if (hp->def_flags)	free(hp->def_flags);
		if (hp->pdir)		free(hp->pdir);
		if (hp->gdir)		free(hp->gdir);
		if (hp->separator)	free(hp->separator);
		if (hp->terminator)	free(hp->terminator);
		if (hp->null_file)	free(hp->null_file);
		if (hp->login)		free(hp->login);
		if (hp->start)		free(hp->start);
		if (hp->p_st)		free(hp->p_st);
		if (hp->p_btwn)		free(hp->p_btwn);
		if (hp->p_end)		free(hp->p_end);
		if (hp->g_st)		free(hp->g_st);
		if (hp->g_btwn)		free(hp->g_btwn);
		if (hp->g_end)		free(hp->g_end);
		if (hp->end)		free(hp->end);
		if (hp->exit)		free(hp->exit);
		if (hp->telnbr)		free(hp->telnbr);
		free(hp);
	}
	return(1);
}

	delete_tt(tt_ptr)
struct tt_struct *tt_ptr;
{
	if (tt_ptr)	{
		if (tt_ptr->ttname)	free(tt_ptr->ttname);
		if (tt_ptr->host_id)	free(tt_ptr->host_id);
		free(tt_ptr);
	}
	return(1);
}

	delete_respond(rp)
struct respond *rp;
{
	if (rp)	{
		if (rp->cmd_str)	free(rp->cmd_str);
		if (rp->response)	free(rp->response);
		if (rp->alternate1)	free(rp->alternate1);
		if (rp->alternate2)	free(rp->alternate2);
		if (rp->reresponse)	free(rp->reresponse);
		free(rp);
	}
	return(1);
}
