/*				FILE = xmit_ops.c			*/

#include	"xmit_file.h"
#include	"xmodem.h"

char	*files();

/* xfer_ascii(host,filename,direction)					*/
/*	Transfer a file from (XMIT_GET) or to (XMIT_PUT) the net in an	*/
/*	ASCII bast mode.  For GET, do not over write if 'filename' is	*/
/*	specified and create a temporary file if 'filename' is null or	*/
/*	points to a null string.  For PUT, if 'filename' is specified	*/
/*	the file must exist, if 'filename' is null or points to a null	*/
/*	string all files in the current directory will be sent.		*/
	FUNCTION xfer_ascii(host,filename,direction)
struct	host	*host;
char	*filename;
int	direction;
{
	int	i, fd = 0, ret = FALSE, l1, l2, count = 1;
	char	dir_buf[1024], name_buf[64], buf[1024], ch, *p, *dir;
	struct	tt_struct *tt;

	if (!host || (host->tt_index <= 0))	return(ERROR);
	tt = ttp + (host->tt_index - 1);
/* debug */ sprintf(log_str,"xfer_ascii: host = %o tt = %o file = %s direction = %d.\n",host,tt,filename,direction);
/* debug */ logit(log_str);
	if (direction == XMIT_PUT)	{
		if ((filename == 0) || (*filename == 0))	{
			if ((dir = getcwd(dir_buf,1024)) == 0)
				return(error("Unable to get current directory\n",FALSE,tt));
			while (p = files(dir,0))	{
				if ((fd = open(p,O_RDONLY)) < 0)	{
					sprintf(buf,"Unable to open file '%s' for PUT\n",p);
					return(error(buf,FALSE,tt));
				}
				while ((l1 = l2 = read(fd,buf,1024)) > 0)
					if ((l1 = write(tt->tty_fd,buf,l2)) != l1)
						break;
					else	sleep(3);
				if ((l1 == 0) && (l2 == 0))	ret = TRUE;
				else	{
					ret = FALSE;
					break;
				}
				close(fd);
				fd = 0;
			}
		}	else	{
			if ((fd = open(filename,O_RDONLY)) < 0)	{
				sprintf(buf,"Unable to open file '%s' for PUT\n",filename);
				return(error(buf,FALSE,tt));
			}
			while ((l1 = l2 = read(fd,buf,1024)) > 0)
				if ((l1 = write(tt->tty_fd,buf,l2)) != l2)
					break;
				else	{
					count += l2;
					sleep(3);
				}
			if ((l1 == 0) && (l2 == 0))	ret = TRUE;
/* debug */ sprintf(log_str,"xfer_ascii: PUT %d. bytes, return = %d. (%d. , %d.)\n",count-1,ret,l1,l2);
/* debug */ logit(log_str);
		}
	}	else	{	/* direction == XMIT_GET	*/
		if ((filename == 0) || (*filename == 0))	{
			strcpy(name_buf,DEFAULT_XGET_PROTO);
			if ((fd = mkstemp(name_buf)) < 0)	{
				sprintf(buf,"Unable to create temporary file for GET\n",p);
				return(error(buf,FALSE,tt));
			}
			filename = &name_buf[0];
		}	else
			if ((fd = open(filename,O_RDWR | O_CREAT | O_EXCL, 0755)) < 0)	{
				sprintf(buf,"Unable to create specified file '%s' for GET\n",filename);
				return(error(buf,FALSE,tt));
			}
		ret = TRUE;
		count = 0;
		l1 = 0;
		if (host->null_file)
			l2 = strlen(host->null_file);
		else	l2 = 0;
		while ((i = readbyte(tt,20)) != TIMEOUT)	{
			ch = i & 0177;
			if (ch == EOT)	break;
			if (count == -1)	continue;
			buf[l1++] = ch;
			/* check for string indicating null file	*/
			if ((count == (l2 - 1)) && (l2 == l1))
				if (strncmp(buf,host->null_file,l2) == 0) {
					/* no data - read to end of	*/
					/* file, throw away everything	*/
logit("xfer_ascii: null file indicator found, file will be unlinked\n");
					count = -1;
					l1 = 0;
					ret = NULL_FILE;
					continue;
				}
			if (l1 == 1024)	/* buffer full	*/
				if (write(fd,buf,1024) != 1024)	{
					sprintf(log_str,"xfer_ascii: error writing buffer to file = '%s' - %s\n",filename,sys_errlist[errno]);
					logit(log_str);
					l1 = 0;
					count = 0;
					ret = FALSE;
					break;
				}	else	l1 = 0;
			count++;
		}
		if (l1 != 0)	/* write out whatever is left	*/
			if (write(fd,buf,l1) != l1)	{
				sprintf(log_str,"xfer_ascii: error writing %d. bytes to file = '%s' - %s\n",l1,filename,sys_errlist[errno]);
				logit(log_str);
				count = 0;
				ret = FALSE;
			}
		sprintf(log_str,"xfer_ascii: %d. bytes written to file '%s'\n",count,filename);
		logit(log_str);
	}
	if (fd > 0)	close(fd);
	if (count <= 0)	unlink(filename);
	return(ret);
}

