/*				FILE = xmit_help.c			*/

#include	"xmit_file.h"

/*  Print Help Message for XMODEM	*/
	FUNCTION xmit_help()
{
	logit("\nUsage:\txtransfer [options] [flags] [remote:options/flags] [mode]");
	logit("\n\nTransfer a file(s) to/from, depending on 'mode', a remote host using either ASCII");
	logit("\nor XMODEM/YMODEM protocol, depending on information about host in internal table");
	logit("\n\nwhere:");

	logit("\noptions   --");
	logit("\n\tctrl=filename    <-- Contains commands to build host, tty, and response tables");
	logit("\n\tdefault          <-- Use defaults for all options");
	logit("\n\tDELETE_FILES     <-- Delete control and sent file");
	logit("\n\tDELETE_LOG       <-- Delete log if transfer OK");
	logit("\n\terror=dir_name   <-- Error directory name");
	logit("\n\tgdir=dir_name    <-- Directory name to retrieve files to");
	logit("\n\tgfile=filename   <-- Name of file retrieved (get)");
	logit("\n\thost=host_id     <-- Remote host identifier");
	logit("\n\tid=value         <-- Unique id to distinguish this instance of xtransfer, unused");
	logit("\n\tKEEP_FILES       <-- Keep control and sent file");
	logit("\n\tKEEP_LOG         <-- Keep the log file");
	logit("\n\tlock=dir_name    <-- Lock directory name");
	logit("\n\tpdir=dir_name    <-- Directory name to send files from");
	logit("\n\tpfile=filename   <-- Name of file to send (put)");
	logit("\n\tresponse=string  <-- String remote host is to echo, used in 'remote'");
	logit("\n\tstartup=filename <-- Same as ctrl=filename, but executed first");
	logit("\n\tXMIT_BOTH        <-- Define");
	logit("\n\tXMIT_GET         <--   transfer");
	logit("\n\tXMIT_PUT         <--      mode");
	logit("\n\n\toption=default => use default value for option");

	logit("\n\n\tFor receiving files:");
	logit("\n\tfilename = file name for all received files,");
	logit("\n\t           null => If batch mode and 'm' flag set use the");
	logit("\n\t                         first 9 characters of sent file name");
	logit("\n\t                   else generate name for each received file (xget__XXXXXX)");
	logit("\n\t           'default' => use the default get filename for all received files");
	logit("\n\tFor sending files:");
	logit("\n\tfilename = name of file to send,");
	logit("\n\t           null => all files in directory");
	logit("\n\t           'default' => send the default put file");

	logit("\n\nflags   --");
	logit("\n\t-  <-- Turn following options off");
	logit("\n\t+  <-- Turn following options on");
/*	logit("\n\tr  <-- Receive one or more files");		*/
/*	logit("\n\ts  <-- Send a file");			*/
	logit("\n\tb  <-- Binary Mode");
	logit("\n\tt  <-- Text Mode");
	logit("\n\tu  <-- UNIX Text Mode (NL instead of CR-LF)");
	logit("\n\tY  <-- Use YMODEM Batch Mode on transmit");
	logit("\n\tB  <-- Use MODEM7 Batch Mode on transmit");
	logit("\n\tK  <-- Use 1K packets on transmit");
	logit("\n\tc  <-- Select CRC mode on receive");
/*	logit("\n\td  <-- Delete log file before starting");	*/
	logit("\n\tl  <-- Log xmodem header and trailer information");
	logit("\n\tm  <-- Use sent file names in batch mode");
	logit("\n\tx  <-- Include xmodem debugging information in log file");
	logit("\n\tdefault flags are: +ctl-x");

	logit("\n\nremote:options/flags <-- Pass options/flags to remote program as");
	logit("\n\tcommand parameters, remote option not allowed in parameter");

	logit("\n\nmode = XMIT_GET, XMIT_PUT, or XMIT_BOTH");
	logit("\n\tIdentifies direction of file transfer, not required if 'pfile'");
	logit("\n\tor 'gfile' specified.");

	logit("\n\nExample: xtransfer host=nist pfile=send.file remote:gfile=recv.file -l pdir=./dirout\n");
}
