/*				FILE = xmit_ops.c			*/

#include	"xmit_file.h"
#include	"xmodem.h"

char	*getcwd(), *files(), *strchr();

struct	host	FUNCTION *find_host(host_id)
char	*host_id;
{
	struct	host	*host = 0;
	if (get_log("find_host") == TRUE)
		host = get_tty(host_id);
	return(host);
}

	FUNCTION connect_host(host,response)
struct	host	*host;
char	*response;
{
	struct	tt_struct *tt;
	int	l, ret = TRUE;
	/* skip if we were called	*/
	if (host->calling)	{
		if(host->telnbr)	{
			/* skip if no phone number	*/
			if (dial(host) != TRUE)	goto	err1;
		}	else	hangup(host);
		if (host->login)
			if (responses(host,RESPOND_LOGIN) == ERROR)
				goto	err2;
		host->connected |= CONNECTED_HOST;
		if (host->start)
			if (responses(host,RESPOND_START) == ERROR)	{
err2:				reset_modem(host);
err1:				release_tty(host);
				ret = FALSE;
				goto	fini;
			}
	}	else	if (response && (l = strlen(response)))
			/* called - send any response	*/
				if (host->tt_index)	{
					tt = ttp + (host->tt_index -1);
					if (write(tt->tty_fd,response,l)!=l)
						goto	err2;
				}	else	goto	err2;
	host->connected |= CONNECTED_PROG;
	if (DEBUGGING)	logit("connect_host: successful\n");
fini:	return(ret);
}

	FUNCTION xmit_file(host,gfile,pfile,gdir,pdir,flags,direction)
struct	host	*host;
char	*gfile;
char	*pfile;
char	*gdir;
char	*pdir;
char	*flags;
int	direction;	/* XMIT_GET, XMIT_PUT, or XMIT_BOTH	*/
{
/* debug */	struct	tt_struct	*tt;
	int	i, ret = FALSE;
	char	*p;
	if (DEBUGGING)	{
		sprintf(log_str,"xmit_file: host = %o gfile = '%s' pfile = '%s' flags = '%s' direction = %o\n",
			host,gfile,pfile,flags,direction);
		logit(log_str);
/* debug 	prt_host(host,TRUE); */
	}
	if (!host)	goto	fini;
	if (host->def_flags)	strcat(flags,host->def_flags);
	strcat(flags,"+s");
	if ((direction == XMIT_PUT) || (direction == XMIT_BOTH))	{
		while (p = strchr(flags,'r'))	*p = 's';
		if (pdir)	{
			if (chdir(pdir) < 0)	goto fini;
		}	else
			if (host->pdir)
				if (chdir(host->pdir) < 0)	goto fini;
		if (host->calling)	{
			if ((i=responses(host,RESPOND_PUT_START)) == ERROR)
				goto	fini;
			if (i == NONFATAL)	goto	end1;
		}
		if (host->defaults & P_XMODEM)	{
			if (xmodem(host,pfile,flags) != TRUE)
				goto	fini;
		}	else	{	/* protocol == P_ASCII	*/
			if (xfer_ascii(host,pfile,XMIT_PUT) != TRUE)
				goto	fini;
		}
end1:		if (host->calling && (responses(host,RESPOND_PUT_END) == ERROR))
			goto	fini;
	}
	if ((direction == XMIT_GET) || (direction == XMIT_BOTH))	{
		while (p = strchr(flags,'s'))	*p = 'r';
		if (gdir)	{
			if (chdir(gdir) < 0)	goto fini;
		}	else
			if (host->gdir)
				if (chdir(host->gdir) < 0)	goto fini;
		if (host->calling)	{
			if ((i=responses(host,RESPOND_GET_START)) == ERROR)
				goto	fini;
			if (i == NONFATAL)	goto	end2;
		}
		if (host->defaults & G_ASCII)	{
			if ((i = xfer_ascii(host,gfile,XMIT_GET)) != TRUE)
				if (i != NULL_FILE)	goto	fini;
		}	else	{	/* protocol == G_XMODEM	*/
			if (xmodem(host,gfile,flags) != TRUE)
				goto	fini;
		}
end2:		if (host->calling && (responses(host,RESPOND_GET_END) == ERROR))
			goto	fini;
	}
	ret = TRUE;
fini:	if (DEBUGGING)	{
		sprintf(log_str,"xmit_file: returned %d\n",ret);
		logit(log_str);
	}
	return(ret);
}

	FUNCTION disconnect_host(host,log)
struct	host	*host;
int	log;
{
	struct	tt_struct	*tt = 0;
	int	set;
	if (DEBUGGING)	{
		sprintf(log_str,"disconnect_host: called with host = %o log = %d connected = %o\n",host,log,host->connected);
		logit(log_str);
	}
#ifdef	SUNOS
	if (host->tt_index && host->telnbr)	{
		tt = ttp + (host->tt_index - 1);
		set = 1;
		/* enable software carrier mode				*/
		/* retain tty control even if remote host drops carrier	*/
		if (ioctl(tt->tty_fd,TIOCSSOFTCAR,&set) < 0)
			logit("release_host: Unable to enable software carrier mode\n");
	}
#endif	SUNOS
	if (release_host(host) == ERROR)	log = FALSE;
#ifdef	SUNOS
	if (host->tt_index && host->telnbr)	{
		set = 0;
		/* disable software carrier mode	*/
		if (ioctl(tt->tty_fd,TIOCSSOFTCAR,&set) < 0)
			logit("release_host: Unable to disable software carrier mode\n");
	}
#endif	SUNOS
	if (reset_modem(host) == ERROR)		log = FALSE;
	if (release_tty(host) == ERROR)		log = FALSE;
	host->connected = 0;
	return(log);
}

	FUNCTION release_host(host)
struct	host	*host;
{
	int	ret = FALSE;
	if (DEBUGGING)	logit("release_host: called\n");
	if (host->end && (host->connected & CONNECTED_PROG))
		if (responses(host,RESPOND_END,0) == ERROR)
			goto	fini;
	if (host->exit && (host->connected & CONNECTED_HOST))
		if (responses(host,RESPOND_EXIT,0) == ERROR)	goto fini;
	ret = TRUE;
fini:	host->connected &= ~(CONNECTED_PROG | CONNECTED_HOST);
	return(ret);
}

	FUNCTION sendtime()
{	
	logit("sendtime: timeout\n");
	longjmp(sjbuf,1);
}

	FUNCTION responses(host,type)
struct	host	*host;
int	type;
{
	struct	tt_struct	*tt;
	struct	respond		*rptr = 0;
	int	index, len, err, ret = FALSE, i, j, restarts = 0;
	char	*cp;

	if (DEBUGGING)	{
		sprintf(log_str,"responses called: host = %s type = %d.\n",
			host->host_id,type);
		logit(log_str);
	}
	if (host->tt_index < 0)		return(ERROR);
	if ((host->tt_index == 0) || (!host->calling))	goto	fini;
	tt = ttp + (host->tt_index - 1);
start:	if (type == RESPOND_LOGIN)	rptr = host->login;
	if (type == RESPOND_START)	rptr = host->start;
	if (type == RESPOND_PUT_START)	rptr = host->p_st;
	if (type == RESPOND_PUT_BTWN)	rptr = host->p_btwn;
	if (type == RESPOND_PUT_END)	rptr = host->p_end;
	if (type == RESPOND_GET_START)	rptr = host->g_st;
	if (type == RESPOND_GET_BTWN)	rptr = host->g_btwn;
	if (type == RESPOND_GET_END)	rptr = host->g_end;
	if (type == RESPOND_END)	rptr = host->end;
	if (type == RESPOND_EXIT)	rptr = host->exit;
	if (!rptr || !rptr->attempts)	goto	fini;
	if ((ret = setmodes(tt,FLAG_XMIT)) != TRUE)	goto	fini;
	err = FALSE;
	if (setjmp(sjbuf))	{
		err = TRUE;
		index++;
	}
#ifdef	SUNOS
	else	/* SUN does not reset the handler when called (HP does)	*/
#endif	SUNOS
	signal(SIGALRM,sendtime);
send:	for ( ; rptr->attempts; rptr++)	{
		if (err == FALSE)	{
			index = 0;
			cp = rptr->cmd_str;
			if (cp)	len = strlen(cp);
			else	len = 0;
		}
		for ( ; index < rptr->attempts; index++)	{
			if (cp && *cp)	{
				if (rptr->respond_flags & QUIET_LINE)
					/* line SHOULD be quiet	*/
					sleep(QUIET_LINE_TIME);
				if (!(rptr->respond_flags & NO_FLUSH))
					flush(tt);
				if (DEBUGGING)	{
					sprintf(log_str,"responses: sending '%s'\n	len = %d., will wait %d. seconds\n",cp,len,rptr->respond_time);
					logit(log_str);
				}
				if (write(tt->tty_fd,cp,len) != len) {
bad:					sprintf(log_str,"responses: bad write - %s\n",sys_errlist[errno]);
					logit(log_str);
					return(ERROR);
				}
				if ((rptr->respond_flags & REMOTE_ECHO) && (hostp->remote_echo != FALSE))
					if((i=str_match(tt,rptr->cmd_str,0, 0,0,10)) == ERROR)	{
						if (hostp->remote_echo == NOT_KNOWN)
							hostp->remote_echo = FALSE;
						else	{
							ret = ERROR;
							goto	clean;
						}
					}	else	hostp->remote_echo = TRUE;
			}
respond:		if ((rptr->response && *rptr->response) ||
				(rptr->alternate1 && *rptr->alternate1) ||
				(rptr->alternate2 && *rptr->alternate2)) {
				if (DEBUGGING)	{
					sprintf(log_str,"respones: waiting %d. seconds for primary = '%s'\n	alt1 = '%s'\n	alt2 = '%s'\n", rptr->respond_time,rptr->response,rptr->alternate1,rptr->alternate2);
					logit(log_str);
				}
				alarm(rptr->respond_time);
				i = str_match(tt,rptr->response,rptr->alternate1,rptr->alternate2,rptr->lower,-1);
				alarm(0);
				if (i == ERROR)	{    /* treat as timeout */
					err = TRUE;
					index++;
					goto	send;
				}
				if (DEBUGGING)	{
					if (i == 1)
						sprintf(log_str, "responses: received '%s'\n",rptr->response);
					if (i == 2)
						sprintf(log_str, "responses: received '%s'\n",rptr->alternate1);
					if (i == 3)
						sprintf(log_str, "responses: received '%s'\n",rptr->alternate2);
					logit(log_str);
				}
				if (i > 1)	{
					if (i == 2)	i = rptr->alt1_action;
					else		i = rptr->alt2_action;
					switch (i)	{
						case ACTION_DONE:
							ret = TRUE;
							goto	clean;
						case ACTION_EXIT:
							ret = ERROR;
							goto	clean;
						case ACTION_IGNORE:
							continue;
						case ACTION_SKIP:
							ret = NONFATAL;
							goto	clean;
						case ACTION_RESET_TIME:
							if(rptr->reresponse)
								j = strlen (rptr->reresponse);
							else	j = 0;
							if (j && (write (tt->tty_fd,rptr->reresponse,j) != j))
								goto bad;
							goto	respond;
						case  ACTION_RESTART:
							if (restarts++ < RESTART_LIMIT)
								goto start;
							ret = FALSE;
							goto	clean;
						case ACTION_ASCII_DONE:
							unlink(RESULT_FILE);
							ret = xfer_ascii (host,RESULT_FILE,XMIT_GET);
							goto	clean;
						case ACTION_ASCII_IGNORE:
							unlink(RESULT_FILE);
							if ((ret=xfer_ascii (host,RESULT_FILE,XMIT_GET)) != TRUE)
								goto clean;
							continue;
						case ACTION_ASCII_RESET:
							unlink(RESULT_FILE);
							if ((ret=xfer_ascii (host,RESULT_FILE,XMIT_GET)) != TRUE)
								goto clean;
							goto respond;;
						case ACTION_OK:
						default:
							break;
					}
				}
				err = FALSE;
				break;
			}	else
				if (rptr->no_response == ACTION_ASCII_IGNORE)	{
					unlink(RESULT_FILE);
					ret = xfer_ascii(host,RESULT_FILE, XMIT_GET);
				}
					
		}
		if (err == TRUE)	{
			/* no specified response received	*/
			logit("responses: requested response not received\n");
			switch (rptr->no_response)	{
				case ACTION_DONE:
					ret = TRUE;
					goto	clean;
				case ACTION_IGNORE:
					err = FALSE;
					break;
				case ACTION_SKIP:
					ret = NONFATAL;
					goto	clean;
				case ACTION_EXIT:
				default:
					ret = ERROR;
					goto	clean;
			}
		}
	}
clean:	signal(SIGALRM,SIG_DFL);
	if (DEBUGGING)	{
		sprintf(log_str,"respond: returned %d.\n",ret);
		logit(log_str);
	}
fini:	return(ret);
}
