/*				FILE = xtransfer.c			*/

#include	"xmodem.h"
#include	"xmit_file.h"
#include	"xmit_allocate.h"
#include	"edi_control_defs.h"
#include	"edi_transfer_defs.h"

char	*strchr();
struct	host	*find_host();

void	clean_up_files();
extern	int	delete_files,result,mode,keep_log;
extern	char	*pfile,*ctrl_file,*lock_file,*gfile,*gdir,*pdir,*error_dir;

#define	DELETE_FILES	1
#define	DELETE_LOG	2
#define	KEEP_FILES	4
#define	KEEP_LOG	8

main(argc,argv)
int	argc;
char	*argv[];
{
	struct	host	*host;
	char	*host_id = 0, *response = DEFAULT_XFER_RESPONSE;
	char	*r_default = 0, *r_gdir = 0, *r_pdir = 0, *r_gfile = 0;
	char	*r_pfile = 0, *r_mode = 0, *r_flags = 0, *r_response = 0;
	char	*r_ctrl = 0, *r_g_cmd, *r_p_cmd, g_buff[512], p_buff[512];
	struct	respond	*r_g_st, *r_p_st;
	int	i, ind = 0, defaults = DEFAULTS, r_cmds = 0, value = TRUE;
	char	*p, *sep, *term, flags[MAX_FLAGS + 1];
	char	*startup_file = 0;

	if (argc == 1)	{
		sprintf(log_str,"%s [options] [flags] [remote:options/flags]\n",argv[0]);
		logit(log_str);
		sprintf(log_str,"\t'%s help' for more help\n",argv[0]);
		logit(log_str);
		exit(0);
	}
	if (strcmp(argv[1],"help") == 0)	{
		xmit_help();
		exit(0);
	}

	if (get_log(argv[0]) != TRUE)	{
		logit("xtransfer: Unable to open log file - abort\n");
		goto	fini;
	}

	/* initialize the flags						*/
	strcpy(flags,DEFAULT_XTRANSFER_FLAGS);

	for (i = 1; i < argc; i++)	{
		if ((*argv[i] == '-') || (*argv[i] == '+'))	{
			/* concatenate specified to default flags	*/
			strcat(flags,argv[i]);
			continue;
		}
		if ((strcmp(argv[i],"default") == 0) && defaults)	{
			gfile = DEFAULT_XGET_FILENAME;
			pfile = DEFAULT_XPUT_FILENAME;
			gdir = DEFAULT_XGET_DIRECTORY;
			pdir = DEFAULT_XPUT_DIRECTORY;
			mode = DEFAULT_XFER_MODE;
			continue;
		}
		if (strncmp(argv[i],CTRL_DEF,sizeof(CTRL_DEF)-1) == 0)	{
			ctrl_file = argv[i] + sizeof(CTRL_DEF) -1;
			continue;
		}
		if (strcmp(argv[i],"DELETE_FILES") == 0)	{
			delete_files = TRUE;
			continue;
		}
		if (strcmp(argv[i],"DELETE_LOG") == 0)	{
			keep_log = FALSE;
			continue;
		}
		if (strncmp(argv[i],ERROR_DEF,sizeof(ERROR_DEF)-1) == 0) {
			error_dir = argv[i]+sizeof(ERROR_DEF)-1;
			continue;
		}
		if (strncmp(argv[i],GDIR_DEF,sizeof(GDIR_DEF)-1) == 0)	{
			if ((strcmp(argv[i]+sizeof(GDIR_DEF)-1,"default") == 0) ||
					(*(argv[i]+sizeof(GDIR_DEF)-1) == '\0'))
				if (defaults)
					gdir = DEFAULT_XGET_DIRECTORY;
				else	gdir = 0;
			else	gdir = argv[i]+sizeof(GDIR_DEF)-1;
			continue;
		}
		if (strncmp(argv[i],GFILE_DEF,sizeof(GFILE_DEF)-1) == 0) {
			if ((strcmp(argv[i]+sizeof(GFILE_DEF)-1,"default") == 0) ||
					(*(argv[i]+sizeof(GFILE_DEF)-1) == '\0'))
				if (defaults)
					gfile = DEFAULT_XGET_FILENAME;
				else	gfile = 0;
			else	gfile = argv[i]+sizeof(GFILE_DEF)-1;
			continue;
		}
		if (strncmp(argv[i],HOST_DEF,sizeof(HOST_DEF)-1) == 0)	{
			if (*(argv[i]+sizeof(HOST_DEF)-1) == '\0')
				logit("No default host identifier\n");
			else	host_id = argv[i]+sizeof(HOST_DEF)-1;
			continue;
		}
		if (strcmp(argv[i],"KEEP_FILES") == 0)	{
			delete_files = FALSE;
			continue;
		}
		if (strcmp(argv[i],"KEEP_LOG") == 0)	{
			keep_log = TRUE;
			continue;
		}
		if (strncmp(argv[i],LOCK_DEF,sizeof(LOCK_DEF)-1) == 0)	{
			lock_file = argv[i] + sizeof(LOCK_DEF) -1;
			continue;
		}
		if (strncmp(argv[i],PDIR_DEF,sizeof(PDIR_DEF)-1) == 0)	{
			if ((strcmp(argv[i]+sizeof(PDIR_DEF)-1,"default") == 0) ||
					(*(argv[i]+sizeof(PDIR_DEF)-1) == '\0'))
				if (defaults)
					pdir = DEFAULT_XPUT_DIRECTORY;
				else	pdir = 0;
			else	pdir = argv[i]+sizeof(PDIR_DEF)-1;
			continue;
		}
		if (strncmp(argv[i],PFILE_DEF,sizeof(PFILE_DEF)-1) == 0)	{
			if ((strcmp(argv[i]+sizeof(PFILE_DEF)-1,"default") == 0) ||
					(*(argv[i]+sizeof(PFILE_DEF)-1) == '\0'))
				if (defaults)
					pfile = DEFAULT_XPUT_FILENAME;
				else	pfile = 0;
			else	pfile = argv[i]+sizeof(PFILE_DEF)-1;
			continue;
		}
		if (strncmp(argv[i],"remote:",7) == 0)	{
			if ((*(argv[i]+7) == '-')||(*(argv[i]+7) == '+')) {
				r_flags = argv[i]+7;
				continue;
			}
			if (strcmp(argv[i]+7,"default") == 0)	{
				r_default = argv[i]+7;
				continue;
			}
			if (strcmp(argv[i]+7,"DELETE_FILES") == 0)	{
				r_cmds |= DELETE_FILES;
				continue;
			}
			if (strcmp(argv[i]+7,"DELETE_LOG") == 0)	{
				r_cmds |= DELETE_LOG;
				continue;
			}
			if (strcmp(argv[i]+7,"KEEP_FILES") == 0)	{
				r_cmds |= KEEP_FILES;
				continue;
			}
			if (strcmp(argv[i]+7,"KEEP_FILES") == 0)	{
				r_cmds |= KEEP_FILES;
				continue;
			}
			if (strncmp(argv[i]+7,GDIR_DEF,sizeof(GDIR_DEF)-1) == 0)	{
				r_gdir = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i]+7,PDIR_DEF,sizeof(PDIR_DEF)-1) == 0)	{
				r_pdir = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i]+7,CTRL_DEF,sizeof(CTRL_DEF)-1) == 0)	{
				r_ctrl = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i]+7,GFILE_DEF, sizeof(GFILE_DEF)-1) == 0)	{
				r_gfile = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i]+7,PFILE_DEF, sizeof(PFILE_DEF)-1) == 0)	{
				r_pfile = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i]+7,RESPONSE_DEF, sizeof(RESPONSE_DEF)-1) == 0)	{
				r_response = argv[i]+7;
				continue;
			}
			if (strncmp(argv[i],STARTUP_DEF,sizeof(STARTUP_DEF) -1) == 0) {
				startup_file=argv[i]+sizeof(STARTUP_DEF)-1;
				continue;
			}
			if((*(argv[i]+7) == '+') || (*(argv[i]+7) == '-')) {
				r_flags = argv[i]+7;
				continue;
			}
			if (*(argv[i]+7) == '\0')	{
				r_default = "default";
				continue;
			}
			sprintf(log_str,"Bad remote parameter '%s' - ignored\n",argv[i]);
			logit(log_str);
			continue;
		}
		if (strncmp(argv[i],RESPONSE_DEF,sizeof(RESPONSE_DEF)-1) == 0)	{
			if ((strcmp(argv[i]+9,"default") == 0) ||
					(*(argv[i]+9) == '\0'))
				response = DEFAULT_XFER_RESPONSE;
			else	if (strncmp(argv[i]+9,"null") == 0)
				response = 0;
				else	response = argv[i]+9;
			continue;
		}
		if (strncmp(argv[i],STARTUP_DEF,sizeof(STARTUP_DEF)-1) == 0) {
			startup_file = argv[i] + sizeof(STARTUP_DEF) -1;
			continue;
		}
		if (strncmp(argv[i],UNIQUE_ID_DEF,sizeof(UNIQUE_ID_DEF)-1) == 0)	{
			/* parameter not currently used	*/
			continue;
		}
		if (strcmp(argv[i],"XMIT_GET") == 0)	{
			mode = XMIT_GET;
			continue;
		}
		if (strcmp(argv[i],"XMIT_PUT") == 0)	{
			mode = XMIT_PUT;
			continue;
		}
		if (strcmp(argv[i],"XMIT_BOTH") == 0)	{
			mode = XMIT_BOTH;
			continue;
		}
		sprintf(log_str,"Bad parameter '%s' - ignored\n",argv[i]);
		logit(log_str);
	}

	if ((startup_file != 0) && (*startup_file != '\0'))	{
		sprintf(log_str,"xtransfer: startup_file = '%s'\n", startup_file);
		logit(log_str);
		if (bld_structs(startup_file, &host_id) < 0)	{
			logit("xtransfer: bld_structs (startup_file) failed - exit\n");
			goto	fini;
		}
	}

	if ((ctrl_file != 0) && (*ctrl_file != '\0'))	{
		sprintf(log_str,"xtransfer: ctrl_file = '%s'\n",ctrl_file);
		logit(log_str);
		if (bld_structs(ctrl_file, &host_id) < 0)	{
			logit("xtransfer: bld_structs (ctrl_file) failed -exit\n");
			goto	fini;
		}
	}

	if (hostp == 0)	{
		logit("xtransfer: error - no hosts defined\n");
		goto	fini;
	}
	if (ttp == 0)	{
		logit("xtransfer: error - no ttys defined\n");
		goto	fini;
	}

	/* check for DEBUGGING flag now, moved from xmodem		*/
	for (i = 0; flags[i] != '\0'; i++)
		if (flags[i] == '+')	value = TRUE;
		else	if (flags[i] == '-')	value = FALSE;
		else	if (flags[i] == 'x')	DEBUGGING = value;

	if (mode == 0)	{
		if (gfile)	mode = XMIT_GET;
		if (pfile)	mode = XMIT_PUT;
	}
	if (mode == 0)	{
		logit("Transfer mode not specified - abort\n");
		goto	fini;
	}

	if ((host = find_host(host_id)) == 0)	goto	fini;
	if ((mode & host->defaults) == 0)	{
		logit("Transfer mode not allowed - abort\n");
		goto	fini;
	}

	if (!host->calling)	goto	no_mod;

	if (host->defaults & SET_REMOTE_MODE)	{
		if (mode == XMIT_GET)	r_mode = "XMIT_PUT";
		if (mode == XMIT_PUT)	r_mode = "XMIT_GET";
		if (mode == XMIT_BOTH)	r_mode = "XMIT_BOTH";
	}

	sep = host->separator;
	term = host->terminator;

	/* handle remote GET first	*/
	if ((mode == XMIT_BOTH) || (mode == XMIT_PUT))
		if((host->defaults&MOD_P_ST)&&((r_p_st=host->p_st) != 0)) {
			while ((r_p_st->cmd_str != 0) && !(r_p_st->respond_flags & MOD_CMD) && r_p_st->attempts)
				r_p_st++;
			if ((r_p_cmd = r_p_st->cmd_str) != 0)	{
				p = p_buff + cat_field(p_buff,0,r_p_cmd,0);
				/* if terminator at end, remove it 	*/
				if (term&&(strcmp(term,p-strlen(term))==0))
					*(p -= strlen(term)) = '\0';
				if (r_cmds & DELETE_FILES)
					p += cat_field(p,sep,"DELETE_FILES", 0);
				if (r_cmds & DELETE_LOG)
					p += cat_field(p,sep,"DELETE_LOG", 0);
				if (r_cmds & KEEP_FILES)
					p += cat_field(p,sep,"KEEP_FILES", 0);
				if (r_cmds & KEEP_LOG)
					p += cat_field(p,sep,"KEEP_LOG",0);
				if (r_gdir)
					p += cat_field(p,sep,r_gdir,0);
				if (r_ctrl)
					p += cat_field(p,sep,r_ctrl,0);
				if (r_gfile)
					p += cat_field(p,sep,r_gfile,0);
				if (r_flags)
					p += cat_field(p,sep,r_flags,0);
				if (r_response)
					p += cat_field(p,sep,r_response,0);
				if (r_mode)	{
					if ((mode == XMIT_BOTH) &&
					    (host->defaults&SPLIT_BOTH))
						r_mode = "XMIT_GET";
					p += cat_field(p,sep,r_mode,0);
				}
				/* add terminator to end of cmd	*/
				if (term)	cat_field(p,0,term,0);
				r_p_st->cmd_str = p_buff;
			}	else	r_p_st = 0;
		}
	/* handle remote PUT next	*/
	if ((mode == XMIT_BOTH) || (mode == XMIT_GET))
		if((host->defaults&MOD_G_ST)&&((r_g_st=host->g_st) != 0)) {
			while ((r_g_st->cmd_str != 0) && !(r_g_st->respond_flags & MOD_CMD) && r_g_st->attempts)
				r_g_st++;
			if ((r_g_cmd = r_g_st->cmd_str) != 0)	{
				p = g_buff + cat_field(g_buff,0,r_g_cmd,0);
				/* remove terminator at end of cmd	*/
				if (term&&(strcmp(term,p-strlen(term))==0))
					*(p -= strlen(term)) = '\0';
				if (r_cmds & DELETE_FILES)
					p += cat_field(p,sep,"DELETE_FILES", 0);
				if (r_cmds & DELETE_LOG)
					p += cat_field(p,sep,"DELETE_LOG", 0);
				if (r_cmds & KEEP_FILES)
					p += cat_field(p,sep,"KEEP_FILES", 0);
				if (r_cmds & KEEP_LOG)
					p += cat_field(p,sep,"KEEP_LOG",0);
				if (r_pdir)
					p += cat_field(p,sep,r_pdir,0);
				if (r_pfile)
					p += cat_field(p,sep,r_pfile,0);
				if (r_ctrl)
					p += cat_field(p,sep,r_ctrl,0);
				if (r_flags)
					p += cat_field(p,sep,r_flags,0);
				if (r_response)
					p += cat_field(p,sep,r_response,0);
				if (r_mode)	{
					if ((mode == XMIT_BOTH) &&
					    (host->defaults&SPLIT_BOTH))
						r_mode = "XMIT_PUT";
					p += cat_field(p,sep,r_mode,0);
				}
				/* add terminator to cmd	*/
				if (term)	cat_field(p,0,term,0);
				r_g_st->cmd_str = g_buff;
			}	else	r_g_st = 0;
		}

no_mod:	if (connect_host(host,response) == TRUE)
		result = xmit_file(host,gfile,pfile,gdir,pdir,flags,mode);
	result = disconnect_host(host,result);
	if (r_g_st)	r_g_st->cmd_str = r_g_cmd;
	if (r_p_st)	r_p_st->cmd_str = r_p_cmd;
	if (result == TRUE)	logit("Transfer successful\n");
fini:	clean_up_files();
	exit(0);
}
