//////////////////////////////////////////////////////////////////////////////
//
//      FUNCTION NAME : harness.C
//
//      AUTHOR : John Tebbutt
//
//      PURPOSE : To serve as a test harness for x500 access functions of the
//					NIST EDI comms platform.
//
//      DESCRIPTION : Prompt user for RDNs of entries in question, call
//					appropriate function, display the structure returned.
//
//////////////////////////////////////////////////////////////////////////////

#include    <iostream.h>
#include    <fstream.h>
#include    <string.h>
#include    <malloc.h>
#include    <assert.h>
#include    <memory.h>
#include    <xom.h>
#include 	<xds.h>                // Directory Service header
extern "C"{
#include 	<xat.h>                // X/Open application tool kit header
}
#include 	<xdsbdcp.h>            // Basic Directory Contents Package header  
#include 	<xdsmdup.h>            // MHS Directory User Package header        

extern "C" {
#include	"/usr/lib/x400/gtwapi/include/nist_xmh.h"
}
#include	"/usr/lib/x400/gtwapi/include/xmhp.h"
#include	"/usr/lib/x400/gtwapi/include/ximp.h"
#include    "platform.h"
#include    "log.h"
#include    "interchange.h"
#include    "linklist.h"
#include    "or_name.h"
#include    "edi_user.h"
//
// Temporary include file name: xdsedup.h
//
#include "xdsedup.h"                // EDI Directory User Package header        
#include "jtx500.h"                 // Type, class and constant defs for X.500  
#include "rcaMacros.h"
#include "x5exports.h"				// miscellaneous definitions & declarations
#include "x5externs.h"				// miscellaneous definitions & declarations

// STATUS X500Entry::read_communication_attributes( char *, char *,
//                                                   char *, char * );

// STATUS X500Entry::validateTPByORName( char *, char *, OM_public_object )

// STATUS X500Entry::validateTPByLocalName( char *, char *, char *, char *)

// void X500Entry::printEntry();

ORName *inputORName();

OM_return_code	return_code;	// return value from OM functions

extern int	xds_trace;
extern FILE	*xds_trace_fp;

main(argc, argv)
int		argc;
char	*argv[];
{

X500Entry	entry;
char		c;
char		send_id_code[80],
			send_id_qualifier[80],
			rcpt_id_code[80],
			rcpt_id_qualifier[80];	
ORName		*this_recip;
char		*myname = "uh";

tellme( myname, "Gimme some dat UH!\n\n" );

if( ( argc == 2 ) && ( strcmp( argv[1], "-t" ) == 0 ) ){

	tellme( myname, "Turning on API tracing\n" );
	xds_trace = 1;
	xds_trace_fp = fopen( "uh.log", "w" );
}

cout << "Please select READ (r) or VALIDATE (v): ";

cin >> c;

if( c == 'r' || c == 'R' ){

//
// Read the entry from the Directory
//
	cout << "Enter User Code: ";
	cin >> send_id_code;
	cout << "Enter User Qualifier: ";
	cin >> send_id_qualifier;
	cout << "Enter Trading Partner Code: ";
	cin >> rcpt_id_code;
	cout << "Enter Trading Partner Qualifier: ";
	cin >> rcpt_id_qualifier;

	tellme( myname, "Calling read_communications_attributes()\n" );

	if( entry.read_communication_attributes(	send_id_code,
												send_id_qualifier,
												rcpt_id_code,
												rcpt_id_qualifier )
					!= SUCCESS ){

		tellme( myname, "read_communication_attributes() has goofed...\n" );
	}
	else{

	//
	// Print out the contents of the entry!
	//
	tellme( myname, "About to print contents of entry\n" );
	entry.printEntry();
	}
	
}
else{

//
// Validate the supplied name against information held in the Directory
//
	cout << "Please select validation by ORNAME (o) or LOCAL NAME (l): ";

	cin >> c;

	if( c == 'o' || c == 'O' ){

		//
		// Validate by O/R Name
		//
    	cout << "Enter User Code: ";
    	cin >> send_id_code;
    	cout << "Enter User Qualifier: ";
    	cin >> send_id_qualifier;
		this_recip = inputORName();

		tellme( myname, "Calling validateTPByORName()\n" );

		if( entry.validateTPByORName(	send_id_code,
								send_id_qualifier,
								this_recip ) == SUCCESS ){

			cout << "Entry exists\n";
		}
		else{

			cout << "No such entry\n";
		}
	}
	else{

		//
		// Validate by Local Name
		//
    	cout << "Enter User Code: ";
    	cin >> send_id_code;
    	cout << "Enter User Qualifier: ";
    	cin >> send_id_qualifier;
    	cout << "Enter Trading Partner Code: ";
    	cin >> rcpt_id_code;
    	cout << "Enter Trading Partner Qualifier: ";
    	cin >> rcpt_id_qualifier;

		tellme( myname, "Calling validateTPByLocalName\n" );

		if( entry.validateTPByLocalName(	send_id_code,
											send_id_qualifier,
											rcpt_id_code,
											rcpt_id_qualifier ) == SUCCESS ){

			cout << "Entry exists\n";
		}
		else{

			cout << "Entree n'existe pas\n";
		}
	}
		
}

}

void X500Entry::printEntry()
{
char *myname = "printEntry";

	tellme( myname, "Not implemented, but I bet the entry's OK\n" );

	return;
}

ORName *inputORName()
{
char *myname = "inputORName";

	tellme ( myname, "Pitiful shadow of a function. ie it doesn't work\n" );

	return( (ORName *) 0 );
}
